function read_packet_sw_diag_data_j1_55_005(fid)

% Copyright (c) 2007-2014 University of Wisconsin Regents.
%
% This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.

% GENERATED CODE -- DO NOT EDIT

set_globals

g_metadata.packet_stats.num_packets.sw_diag = g_metadata.packet_stats.num_packets.sw_diag + 1;
packet_idx = g_metadata.packet_stats.num_packets.sw_diag;
g_metadata.packets.sw_diag.dim.sw_diag_packet = packet_idx;
g_metadata.packets.sw_diag.header_time.dim = {'sw_diag_packet'};
g_packets.sw_diag.header_time(packet_idx)=g_header.time;
g_metadata.packets.sw_diag.start_byte.dim = {'sw_diag_packet'};
g_packets.sw_diag.start_byte(packet_idx)=g_header.start_byte;
first_file_position=ftell(fid);

% first time through: set packet attributes
if packet_idx == 1

    g_metadata.packets.sw_diag.att.xml_database_version_applied = 'j1_55_005';
    g_metadata.packets.sw_diag.att.xml_file_name = 'Diag_SW_RDR.xml';
    g_metadata.packets.sw_diag.att.xml_file_md5sum = 'ec9536f65a479d8124f4f49b24442dd7';
    g_metadata.packets.sw_diag.att.description = 'Shortwave Diagnostic RDR';
    g_metadata.packets.sw_diag.att.scene = 'NONE';
    g_metadata.packets.sw_diag.att.apid = '510';
    g_metadata.packets.sw_diag.att.band = 'shortwave';
    g_metadata.packets.sw_diag.att.version = '4';
    g_metadata.packets.sw_diag.att.detector = '0';

    % id 8916: SW_PCEAppFSWVer
    g_metadata.packets.sw_diag.PCEAppFSWVer.att.telemetry_point_id = '8916';
    g_metadata.packets.sw_diag.PCEAppFSWVer.att.mnemonic = 'SW_PCEAppFSWVer';
    g_metadata.packets.sw_diag.PCEAppFSWVer.att.start_bit = '0';
    g_metadata.packets.sw_diag.PCEAppFSWVer.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.PCEAppFSWVer.att.num_bits = '11';
    g_metadata.packets.sw_diag.PCEAppFSWVer.att.description = 'PCE Application FSW Version';
    g_metadata.packets.sw_diag.PCEAppFSWVer.dim = {'sw_diag_packet'};

    % id 8917: SW_Instrument ID
    g_metadata.packets.sw_diag.Instrument_ID.att.telemetry_point_id = '8917';
    g_metadata.packets.sw_diag.Instrument_ID.att.mnemonic = 'SW_Instrument ID';
    g_metadata.packets.sw_diag.Instrument_ID.att.start_bit = '11';
    g_metadata.packets.sw_diag.Instrument_ID.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.Instrument_ID.att.num_bits = '5';
    g_metadata.packets.sw_diag.Instrument_ID.att.description = 'Instrument ID';
    g_metadata.packets.sw_diag.Instrument_ID.dim = {'sw_diag_packet'};

    % id 8918: SW_ScnInfo(FOR)
    g_metadata.packets.sw_diag.ScnInfo_FOR.att.telemetry_point_id = '8918';
    g_metadata.packets.sw_diag.ScnInfo_FOR.att.mnemonic = 'SW_ScnInfo(FOR)';
    g_metadata.packets.sw_diag.ScnInfo_FOR.att.start_bit = '16';
    g_metadata.packets.sw_diag.ScnInfo_FOR.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.ScnInfo_FOR.att.num_bits = '6';
    g_metadata.packets.sw_diag.ScnInfo_FOR.att.description = 'Scan Information(Field of Regard)';
    g_metadata.packets.sw_diag.ScnInfo_FOR.dim = {'sw_diag_packet'};

    % id 8919: SW_ScnInfo(Sweep Dir)
    g_metadata.packets.sw_diag.ScnInfo_Sweep_Dir.att.telemetry_point_id = '8919';
    g_metadata.packets.sw_diag.ScnInfo_Sweep_Dir.att.mnemonic = 'SW_ScnInfo(Sweep Dir)';
    g_metadata.packets.sw_diag.ScnInfo_Sweep_Dir.att.start_bit = '22';
    g_metadata.packets.sw_diag.ScnInfo_Sweep_Dir.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.ScnInfo_Sweep_Dir.att.num_bits = '2';
    g_metadata.packets.sw_diag.ScnInfo_Sweep_Dir.att.description = 'Scan Information(Sweep Direction)';
    g_metadata.packets.sw_diag.ScnInfo_Sweep_Dir.dim = {'sw_diag_packet'};

    % id 8920: SW_ScnInfo(Diag Chan Err)
    g_metadata.packets.sw_diag.ScnInfo_Diag_Chan_Err.att.telemetry_point_id = '8920';
    g_metadata.packets.sw_diag.ScnInfo_Diag_Chan_Err.att.mnemonic = 'SW_ScnInfo(Diag Chan Err)';
    g_metadata.packets.sw_diag.ScnInfo_Diag_Chan_Err.att.start_bit = '24';
    g_metadata.packets.sw_diag.ScnInfo_Diag_Chan_Err.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.ScnInfo_Diag_Chan_Err.att.num_bits = '1';
    g_metadata.packets.sw_diag.ScnInfo_Diag_Chan_Err.att.description = 'Scan Information(Diagnostic Chan. Error)';
    g_metadata.packets.sw_diag.ScnInfo_Diag_Chan_Err.dim = {'sw_diag_packet'};

    % id 8921: SW_ScnInfo(Impls Tbl Mem Err)
    g_metadata.packets.sw_diag.ScnInfo_Impls_Tbl_Mem_Err.att.telemetry_point_id = '8921';
    g_metadata.packets.sw_diag.ScnInfo_Impls_Tbl_Mem_Err.att.mnemonic = 'SW_ScnInfo(Impls Tbl Mem Err)';
    g_metadata.packets.sw_diag.ScnInfo_Impls_Tbl_Mem_Err.att.start_bit = '25';
    g_metadata.packets.sw_diag.ScnInfo_Impls_Tbl_Mem_Err.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.ScnInfo_Impls_Tbl_Mem_Err.att.num_bits = '1';
    g_metadata.packets.sw_diag.ScnInfo_Impls_Tbl_Mem_Err.att.description = 'Scan Information(Impulse Table Memory Error)';
    g_metadata.packets.sw_diag.ScnInfo_Impls_Tbl_Mem_Err.dim = {'sw_diag_packet'};

    % id 8922: SW_ScnInfo(End of PCI Sys reached w/o EOD)
    g_metadata.packets.sw_diag.ScnInfo_End_of_PCI_Sys_reached_w_o_EOD.att.telemetry_point_id = '8922';
    g_metadata.packets.sw_diag.ScnInfo_End_of_PCI_Sys_reached_w_o_EOD.att.mnemonic = 'SW_ScnInfo(End of PCI Sys reached w/o EOD)';
    g_metadata.packets.sw_diag.ScnInfo_End_of_PCI_Sys_reached_w_o_EOD.att.start_bit = '26';
    g_metadata.packets.sw_diag.ScnInfo_End_of_PCI_Sys_reached_w_o_EOD.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.ScnInfo_End_of_PCI_Sys_reached_w_o_EOD.att.num_bits = '1';
    g_metadata.packets.sw_diag.ScnInfo_End_of_PCI_Sys_reached_w_o_EOD.att.description = 'Scan Info(End PCI Sys reached w/o EOD)';
    g_metadata.packets.sw_diag.ScnInfo_End_of_PCI_Sys_reached_w_o_EOD.dim = {'sw_diag_packet'};

    % id 8923: SW_ScnInfo(Spare)
    g_metadata.packets.sw_diag.ScnInfo_Spare.att.telemetry_point_id = '8923';
    g_metadata.packets.sw_diag.ScnInfo_Spare.att.mnemonic = 'SW_ScnInfo(Spare)';
    g_metadata.packets.sw_diag.ScnInfo_Spare.att.start_bit = '27';
    g_metadata.packets.sw_diag.ScnInfo_Spare.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.ScnInfo_Spare.att.num_bits = '5';
    g_metadata.packets.sw_diag.ScnInfo_Spare.att.description = 'Spare';
    g_metadata.packets.sw_diag.ScnInfo_Spare.dim = {'sw_diag_packet'};

    % id 8924: SW_ImplsNoiseCnt(Spare)
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Spare.att.telemetry_point_id = '8924';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Spare.att.mnemonic = 'SW_ImplsNoiseCnt(Spare)';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Spare.att.start_bit = '32';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Spare.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Spare.att.num_bits = '6';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Spare.att.description = 'Impulse Noise Count(Spare)';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Spare.dim = {'sw_diag_packet'};

    % id 8925: SW_ImplsNoiseCnt(Num impulses detected)
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Num_impulses_detected.att.telemetry_point_id = '8925';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Num_impulses_detected.att.mnemonic = 'SW_ImplsNoiseCnt(Num impulses detected)';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Num_impulses_detected.att.start_bit = '38';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Num_impulses_detected.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Num_impulses_detected.att.num_bits = '10';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Num_impulses_detected.att.description = 'Impulse Noise Count(Num impulses detected)';
    g_metadata.packets.sw_diag.ImplsNoiseCnt_Num_impulses_detected.dim = {'sw_diag_packet'};

    % id 8928: SW_ZPDLocChan(ZPD Loc)
    g_metadata.packets.sw_diag.ZPDLocChan_ZPD_Loc.att.telemetry_point_id = '8928';
    g_metadata.packets.sw_diag.ZPDLocChan_ZPD_Loc.att.mnemonic = 'SW_ZPDLocChan(ZPD Loc)';
    g_metadata.packets.sw_diag.ZPDLocChan_ZPD_Loc.att.start_bit = '48';
    g_metadata.packets.sw_diag.ZPDLocChan_ZPD_Loc.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.ZPDLocChan_ZPD_Loc.att.num_bits = '16';
    g_metadata.packets.sw_diag.ZPDLocChan_ZPD_Loc.att.description = 'ZPD Location Channel(ZPD Location)';
    g_metadata.packets.sw_diag.ZPDLocChan_ZPD_Loc.dim = {'sw_diag_packet'};

    % id 8926: SW_ZPDAmpChan(Spare)
    g_metadata.packets.sw_diag.ZPDAmpChan_Spare.att.telemetry_point_id = '8926';
    g_metadata.packets.sw_diag.ZPDAmpChan_Spare.att.mnemonic = 'SW_ZPDAmpChan(Spare)';
    g_metadata.packets.sw_diag.ZPDAmpChan_Spare.att.start_bit = '64';
    g_metadata.packets.sw_diag.ZPDAmpChan_Spare.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.ZPDAmpChan_Spare.att.num_bits = '6';
    g_metadata.packets.sw_diag.ZPDAmpChan_Spare.att.description = 'ZPD Amplitude Channel(Spare)';
    g_metadata.packets.sw_diag.ZPDAmpChan_Spare.dim = {'sw_diag_packet'};

    % id 8927: SW_ZPDAmpChan(ZPD Amp bits 4-13 of A/D)
    g_metadata.packets.sw_diag.ZPDAmpChan_ZPD_Amp_bits_4_13_of_A_D.att.telemetry_point_id = '8927';
    g_metadata.packets.sw_diag.ZPDAmpChan_ZPD_Amp_bits_4_13_of_A_D.att.mnemonic = 'SW_ZPDAmpChan(ZPD Amp bits 4-13 of A/D)';
    g_metadata.packets.sw_diag.ZPDAmpChan_ZPD_Amp_bits_4_13_of_A_D.att.start_bit = '70';
    g_metadata.packets.sw_diag.ZPDAmpChan_ZPD_Amp_bits_4_13_of_A_D.att.data_type = 'signed';
    g_metadata.packets.sw_diag.ZPDAmpChan_ZPD_Amp_bits_4_13_of_A_D.att.coeffs = '0 16';
    g_metadata.packets.sw_diag.ZPDAmpChan_ZPD_Amp_bits_4_13_of_A_D.att.num_bits = '10';
    g_metadata.packets.sw_diag.ZPDAmpChan_ZPD_Amp_bits_4_13_of_A_D.att.eu_type = 'polynomial';
    g_metadata.packets.sw_diag.ZPDAmpChan_ZPD_Amp_bits_4_13_of_A_D.att.description = 'ZPD Amp (Bits 4-13 of the A/D Converter)';
    g_metadata.packets.sw_diag.ZPDAmpChan_ZPD_Amp_bits_4_13_of_A_D.dim = {'sw_diag_packet'};

    % id 8929: SW_NumConvPulse(Total num Interf Conv Pulses Rcv)
    g_metadata.packets.sw_diag.NumConvPulse_Total_num_Interf_Conv_Pulses_Rcv.att.telemetry_point_id = '8929';
    g_metadata.packets.sw_diag.NumConvPulse_Total_num_Interf_Conv_Pulses_Rcv.att.mnemonic = 'SW_NumConvPulse(Total num Interf Conv Pulses Rcv)';
    g_metadata.packets.sw_diag.NumConvPulse_Total_num_Interf_Conv_Pulses_Rcv.att.start_bit = '80';
    g_metadata.packets.sw_diag.NumConvPulse_Total_num_Interf_Conv_Pulses_Rcv.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.NumConvPulse_Total_num_Interf_Conv_Pulses_Rcv.att.num_bits = '16';
    g_metadata.packets.sw_diag.NumConvPulse_Total_num_Interf_Conv_Pulses_Rcv.att.description = 'Num Interferometer Convert Pulses Recv';
    g_metadata.packets.sw_diag.NumConvPulse_Total_num_Interf_Conv_Pulses_Rcv.dim = {'sw_diag_packet'};

    % id 8930: SW_FilterStatUpperReg(Not Used1)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used1.att.telemetry_point_id = '8930';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used1.att.mnemonic = 'SW_FilterStatUpperReg(Not Used1)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used1.att.start_bit = '96';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used1.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used1.att.num_bits = '4';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used1.att.description = 'Filter Status Upper Reg.(Not Used1)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used1.dim = {'sw_diag_packet'};

    % id 16361: SW_FilterStatUpperReg(Diagnostic Data Type)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Diagnostic_Data_Type.att.telemetry_point_id = '16361';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Diagnostic_Data_Type.att.mnemonic = 'SW_FilterStatUpperReg(Diagnostic Data Type)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Diagnostic_Data_Type.att.start_bit = '100';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Diagnostic_Data_Type.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Diagnostic_Data_Type.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Diagnostic_Data_Type.att.description = 'Filter Status Upper Reg.(Diagnostic Data Type)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Diagnostic_Data_Type.dim = {'sw_diag_packet'};

    % id 8931: SW_FilterStatUpperReg(Num Output Filter Smple err)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Num_Output_Filter_Smple_err.att.telemetry_point_id = '8931';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Num_Output_Filter_Smple_err.att.mnemonic = 'SW_FilterStatUpperReg(Num Output Filter Smple err)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Num_Output_Filter_Smple_err.att.start_bit = '101';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Num_Output_Filter_Smple_err.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Num_Output_Filter_Smple_err.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Num_Output_Filter_Smple_err.att.description = 'Filter Status Upper Reg.(Number Output Filter Sample Error)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Num_Output_Filter_Smple_err.dim = {'sw_diag_packet'};

    % id 8932: SW_FilterStatUpperReg(Not Used2)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used2.att.telemetry_point_id = '8932';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used2.att.mnemonic = 'SW_FilterStatUpperReg(Not Used2)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used2.att.start_bit = '102';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used2.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used2.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used2.att.description = 'Filter Status Upper Reg.(Not Used2)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Not_Used2.dim = {'sw_diag_packet'};

    % id 8933: SW_FilterStatUpperReg(Busy TO AD#9)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_9.att.telemetry_point_id = '8933';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_9.att.mnemonic = 'SW_FilterStatUpperReg(Busy TO AD#9)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_9.att.start_bit = '103';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_9.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_9.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_9.att.description = 'Filter Status Upper Reg.(Busy TO AD#9)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_9.dim = {'sw_diag_packet'};

    % id 8934: SW_FilterStatUpperReg(Busy TO AD#8)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_8.att.telemetry_point_id = '8934';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_8.att.mnemonic = 'SW_FilterStatUpperReg(Busy TO AD#8)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_8.att.start_bit = '104';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_8.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_8.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_8.att.description = 'Filter Status Upper Reg.(Busy TO AD#8)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_8.dim = {'sw_diag_packet'};

    % id 8935: SW_FilterStatUpperReg(Busy TO AD#7)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_7.att.telemetry_point_id = '8935';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_7.att.mnemonic = 'SW_FilterStatUpperReg(Busy TO AD#7)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_7.att.start_bit = '105';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_7.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_7.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_7.att.description = 'Filter Status Upper Reg.(Busy TO AD#7)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_7.dim = {'sw_diag_packet'};

    % id 8936: SW_FilterStatUpperReg(Busy TO AD#6)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_6.att.telemetry_point_id = '8936';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_6.att.mnemonic = 'SW_FilterStatUpperReg(Busy TO AD#6)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_6.att.start_bit = '106';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_6.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_6.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_6.att.description = 'Filter Status Upper Reg.(Busy TO AD#6)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_6.dim = {'sw_diag_packet'};

    % id 8937: SW_FilterStatUpperReg(Busy TO AD#5)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_5.att.telemetry_point_id = '8937';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_5.att.mnemonic = 'SW_FilterStatUpperReg(Busy TO AD#5)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_5.att.start_bit = '107';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_5.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_5.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_5.att.description = 'Filter Status Upper Reg.(Busy TO AD#5)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_5.dim = {'sw_diag_packet'};

    % id 8938: SW_FilterStatUpperReg(Busy TO AD#4)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_4.att.telemetry_point_id = '8938';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_4.att.mnemonic = 'SW_FilterStatUpperReg(Busy TO AD#4)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_4.att.start_bit = '108';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_4.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_4.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_4.att.description = 'Filter Status Upper Reg.(Busy TO AD#4)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_4.dim = {'sw_diag_packet'};

    % id 8939: SW_FilterStatUpperReg(Busy TO AD#3)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_3.att.telemetry_point_id = '8939';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_3.att.mnemonic = 'SW_FilterStatUpperReg(Busy TO AD#3)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_3.att.start_bit = '109';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_3.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_3.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_3.att.description = 'Filter Status Upper Reg.(Busy TO AD#3)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_3.dim = {'sw_diag_packet'};

    % id 8940: SW_FilterStatUpperReg(Busy TO AD#2)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_2.att.telemetry_point_id = '8940';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_2.att.mnemonic = 'SW_FilterStatUpperReg(Busy TO AD#2)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_2.att.start_bit = '110';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_2.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_2.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_2.att.description = 'Filter Status Upper Reg.(Busy TO AD#2)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_2.dim = {'sw_diag_packet'};

    % id 8941: SW_FilterStatUpperReg(Busy TO AD#1)
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_1.att.telemetry_point_id = '8941';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_1.att.mnemonic = 'SW_FilterStatUpperReg(Busy TO AD#1)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_1.att.start_bit = '111';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_1.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_1.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_1.att.description = 'Filter Status Upper Reg.(Busy TO AD#1)';
    g_metadata.packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_1.dim = {'sw_diag_packet'};

    % id 8942: SW_FilterStatLowerReg(FIR Revision Reg)
    g_metadata.packets.sw_diag.FilterStatLowerReg_FIR_Revision_Reg.att.telemetry_point_id = '8942';
    g_metadata.packets.sw_diag.FilterStatLowerReg_FIR_Revision_Reg.att.mnemonic = 'SW_FilterStatLowerReg(FIR Revision Reg)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_FIR_Revision_Reg.att.start_bit = '112';
    g_metadata.packets.sw_diag.FilterStatLowerReg_FIR_Revision_Reg.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatLowerReg_FIR_Revision_Reg.att.num_bits = '3';
    g_metadata.packets.sw_diag.FilterStatLowerReg_FIR_Revision_Reg.att.description = 'Filter Status Lower Reg.(FIR Revision Reg.)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_FIR_Revision_Reg.dim = {'sw_diag_packet'};

    % id 8943: SW_FilterStatLowerReg(Sys Proc Lst Bnk Filled))
    g_metadata.packets.sw_diag.FilterStatLowerReg_Sys_Proc_Lst_Bnk_Filled.att.telemetry_point_id = '8943';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Sys_Proc_Lst_Bnk_Filled.att.mnemonic = 'SW_FilterStatLowerReg(Sys Proc Lst Bnk Filled))';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Sys_Proc_Lst_Bnk_Filled.att.start_bit = '115';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Sys_Proc_Lst_Bnk_Filled.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Sys_Proc_Lst_Bnk_Filled.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Sys_Proc_Lst_Bnk_Filled.att.description = 'Filter Status Lower Reg.(System Processor Last Bank Filled)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Sys_Proc_Lst_Bnk_Filled.dim = {'sw_diag_packet'};

    % id 8944: SW_FilterStatLowerReg(Reserved)
    g_metadata.packets.sw_diag.FilterStatLowerReg_Reserved.att.telemetry_point_id = '8944';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Reserved.att.mnemonic = 'SW_FilterStatLowerReg(Reserved)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Reserved.att.start_bit = '116';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Reserved.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Reserved.att.description = 'Filter Status Lower Reg.(Reserved)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Reserved.dim = {'sw_diag_packet'};

    % id 8945: SW_FilterStatLowerReg(Diag Mode Chan Sel)
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_Chan_Sel.att.telemetry_point_id = '8945';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_Chan_Sel.att.mnemonic = 'SW_FilterStatLowerReg(Diag Mode Chan Sel)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_Chan_Sel.att.start_bit = '117';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_Chan_Sel.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_Chan_Sel.att.num_bits = '5';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_Chan_Sel.att.description = 'Filter Status Lower Reg.(Diag Mode Chan. Select)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_Chan_Sel.dim = {'sw_diag_packet'};

    % id 8946: SW_FilterStatLowerReg(Diag Mode En/Disable)
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_En_Disable.att.telemetry_point_id = '8946';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_En_Disable.att.mnemonic = 'SW_FilterStatLowerReg(Diag Mode En/Disable)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_En_Disable.att.start_bit = '122';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_En_Disable.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_En_Disable.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_En_Disable.att.description = 'Filter Status Lower Reg.(Diag Mode Enable/Disable)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Diag_Mode_En_Disable.dim = {'sw_diag_packet'};

    % id 8947: SW_FilterStatLowerReg(Byte Swap Mode)
    g_metadata.packets.sw_diag.FilterStatLowerReg_Byte_Swap_Mode.att.telemetry_point_id = '8947';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Byte_Swap_Mode.att.mnemonic = 'SW_FilterStatLowerReg(Byte Swap Mode)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Byte_Swap_Mode.att.start_bit = '123';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Byte_Swap_Mode.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Byte_Swap_Mode.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Byte_Swap_Mode.att.description = 'Filter Status Lower Reg.(Byte Swap Mode)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Byte_Swap_Mode.dim = {'sw_diag_packet'};

    % id 8948: SW_FilterStatLowerReg(Num of Sample Pulse Err)
    g_metadata.packets.sw_diag.FilterStatLowerReg_Num_of_Sample_Pulse_Err.att.telemetry_point_id = '8948';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Num_of_Sample_Pulse_Err.att.mnemonic = 'SW_FilterStatLowerReg(Num of Sample Pulse Err)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Num_of_Sample_Pulse_Err.att.start_bit = '124';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Num_of_Sample_Pulse_Err.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Num_of_Sample_Pulse_Err.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Num_of_Sample_Pulse_Err.att.description = 'Filter Status Lower Reg.(Number Sample Pulse Error)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Num_of_Sample_Pulse_Err.dim = {'sw_diag_packet'};

    % id 8949: SW_FilterStatLowerReg(Coef Set 2 Chksum Err)
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_2_Chksum_Err.att.telemetry_point_id = '8949';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_2_Chksum_Err.att.mnemonic = 'SW_FilterStatLowerReg(Coef Set 2 Chksum Err)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_2_Chksum_Err.att.start_bit = '125';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_2_Chksum_Err.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_2_Chksum_Err.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_2_Chksum_Err.att.description = 'Filter Status Lower Reg.(Coef Set 2 Checksum Error)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_2_Chksum_Err.dim = {'sw_diag_packet'};

    % id 8950: SW_FilterStatLowerReg(Coef Set 1 Chksum Err)
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_1_Chksum_Err.att.telemetry_point_id = '8950';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_1_Chksum_Err.att.mnemonic = 'SW_FilterStatLowerReg(Coef Set 1 Chksum Err)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_1_Chksum_Err.att.start_bit = '126';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_1_Chksum_Err.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_1_Chksum_Err.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_1_Chksum_Err.att.description = 'Filter Status Lower Reg.(Coef Set 1 Checksum Error)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Coef_Set_1_Chksum_Err.dim = {'sw_diag_packet'};

    % id 8951: SW_FilterStatLowerReg(Impul Msk Err)
    g_metadata.packets.sw_diag.FilterStatLowerReg_Impul_Msk_Err.att.telemetry_point_id = '8951';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Impul_Msk_Err.att.mnemonic = 'SW_FilterStatLowerReg(Impul Msk Err)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Impul_Msk_Err.att.start_bit = '127';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Impul_Msk_Err.att.data_type = 'unsigned';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Impul_Msk_Err.att.num_bits = '1';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Impul_Msk_Err.att.description = 'Filter Status Lower Reg.(Impulse Mask Error)';
    g_metadata.packets.sw_diag.FilterStatLowerReg_Impul_Msk_Err.dim = {'sw_diag_packet'};

    % id 8952: SW_DIA_DetectorData
    g_metadata.packets.sw_diag.DIA_DetectorData.att.telemetry_point_id = '8952';
    g_metadata.packets.sw_diag.DIA_DetectorData.att.mnemonic = 'SW_DIA_DetectorData';
    g_metadata.packets.sw_diag.DIA_DetectorData.att.start_bit = '128';
    g_metadata.packets.sw_diag.DIA_DetectorData.att.data_type = 'signed';
    g_metadata.packets.sw_diag.DIA_DetectorData.att.num_bits = '16';
    g_metadata.packets.sw_diag.DIA_DetectorData.att.description = 'Diagnostic Detector Data';
    g_metadata.packets.sw_diag.dim.DIA_DetectorData_point = (g_header.packet_length-24)/2;
    g_metadata.packets.sw_diag.DIA_DetectorData.dim = {'DIA_DetectorData_point', 'sw_diag_packet'};

end     %if packet_idx == 1

% read packet
g_packets.sw_diag.PCEAppFSWVer(packet_idx) = fread(fid, 1, '*ubit11');
g_packets.sw_diag.Instrument_ID(packet_idx) = fread(fid, 1, '*ubit5');
g_packets.sw_diag.ScnInfo_FOR(packet_idx) = fread(fid, 1, '*ubit6');
g_packets.sw_diag.ScnInfo_Sweep_Dir(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.sw_diag.ScnInfo_Diag_Chan_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.ScnInfo_Impls_Tbl_Mem_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.ScnInfo_End_of_PCI_Sys_reached_w_o_EOD(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.ScnInfo_Spare(packet_idx) = fread(fid, 1, '*ubit5');
g_packets.sw_diag.ImplsNoiseCnt_Spare(packet_idx) = fread(fid, 1, '*ubit6');
g_packets.sw_diag.ImplsNoiseCnt_Num_impulses_detected(packet_idx) = fread(fid, 1, '*ubit10');
g_packets.sw_diag.ZPDLocChan_ZPD_Loc(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.sw_diag.ZPDAmpChan_Spare(packet_idx) = fread(fid, 1, '*ubit6');
g_packets.sw_diag.ZPDAmpChan_ZPD_Amp_bits_4_13_of_A_D(packet_idx) = cast(fread(fid, 1, '*bit10'), 'double') * 16 + 0;
g_packets.sw_diag.NumConvPulse_Total_num_Interf_Conv_Pulses_Rcv(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.sw_diag.FilterStatUpperReg_Not_Used1(packet_idx) = fread(fid, 1, '*ubit4');
g_packets.sw_diag.FilterStatUpperReg_Diagnostic_Data_Type(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Num_Output_Filter_Smple_err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Not_Used2(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_9(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_8(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_7(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_6(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_5(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_4(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_3(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_2(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatUpperReg_Busy_TO_AD_1(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatLowerReg_FIR_Revision_Reg(packet_idx) = fread(fid, 1, '*ubit3');
g_packets.sw_diag.FilterStatLowerReg_Sys_Proc_Lst_Bnk_Filled(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatLowerReg_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatLowerReg_Diag_Mode_Chan_Sel(packet_idx) = fread(fid, 1, '*ubit5');
g_packets.sw_diag.FilterStatLowerReg_Diag_Mode_En_Disable(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatLowerReg_Byte_Swap_Mode(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatLowerReg_Num_of_Sample_Pulse_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatLowerReg_Coef_Set_2_Chksum_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatLowerReg_Coef_Set_1_Chksum_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.FilterStatLowerReg_Impul_Msk_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.sw_diag.DIA_DetectorData(:, packet_idx) = fread(fid, g_metadata.packets.sw_diag.dim.DIA_DetectorData_point, '*bit16'); %read to end of packet

