function read_packet_instr_hk8_data_j1_55_005(fid)

% Copyright (c) 2007-2014 University of Wisconsin Regents.
%
% This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.

% GENERATED CODE -- DO NOT EDIT

set_globals

g_metadata.packet_stats.num_packets.instr_hk8 = g_metadata.packet_stats.num_packets.instr_hk8 + 1;
packet_idx = g_metadata.packet_stats.num_packets.instr_hk8;
g_metadata.packets.instr_hk8.dim.hk8_packet = packet_idx;
g_metadata.packets.instr_hk8.header_time.dim = {'hk8_packet'};
g_packets.instr_hk8.header_time(packet_idx)=g_header.time;
g_metadata.packets.instr_hk8.start_byte.dim = {'hk8_packet'};
g_packets.instr_hk8.start_byte(packet_idx)=g_header.start_byte;
first_file_position=ftell(fid);

% first time through: set packet attributes
if packet_idx == 1

    g_metadata.packets.instr_hk8.att.xml_database_version_applied = 'j1_55_005';
    g_metadata.packets.instr_hk8.att.xml_file_name = 'TLM_TelemetryRDR_8.xml';
    g_metadata.packets.instr_hk8.att.xml_file_md5sum = '615dc26823fa00900ead95ad54385741';
g_metadata.packets.instr_hk8.dim.da_tilt_err_sample = 12;
g_metadata.packets.instr_hk8.dim.porchswing_velocity_sample = 12;
g_metadata.packets.instr_hk8.dim.spacecraft_bus_voltage_sample = 4;
g_metadata.packets.instr_hk8.dim.axis_motor_current_sample = 3;
g_metadata.packets.instr_hk8.dim.band = 3;
g_metadata.packets.instr_hk8.dim.servo_err_sample = 20;
g_metadata.packets.instr_hk8.dim.ssm_bus_current_sample = 13;
g_metadata.packets.instr_hk8.dim.input_current_sample = 4;
g_metadata.packets.instr_hk8.dim.porchswing_motor_current_sample = 10;
g_metadata.packets.instr_hk8.dim.stage = 4;
g_metadata.packets.instr_hk8.dim.da_motor_current_sample = 2;
    g_metadata.packets.instr_hk8.att.description = 'Telemetry RDR (Packet#8)';
    g_metadata.packets.instr_hk8.att.scene = 'NONE';
    g_metadata.packets.instr_hk8.att.apid = '507';
    g_metadata.packets.instr_hk8.att.band = 'none';
    g_metadata.packets.instr_hk8.att.version = '4';
    g_metadata.packets.instr_hk8.att.detector = '0';

    % id 2752: TLM8_SubFrameCounter
    g_metadata.packets.instr_hk8.SubFrameCounter.att.telemetry_point_id = '2752';
    g_metadata.packets.instr_hk8.SubFrameCounter.att.mnemonic = 'TLM8_SubFrameCounter';
    g_metadata.packets.instr_hk8.SubFrameCounter.att.start_bit = '0';
    g_metadata.packets.instr_hk8.SubFrameCounter.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SubFrameCounter.att.num_bits = '16';
    g_metadata.packets.instr_hk8.SubFrameCounter.att.description = 'Sub Frame Counter';
    g_metadata.packets.instr_hk8.SubFrameCounter.dim = {'hk8_packet'};

    % id 2753: TLM8_PCEAppFswVer
    g_metadata.packets.instr_hk8.PCEAppFswVer.att.telemetry_point_id = '2753';
    g_metadata.packets.instr_hk8.PCEAppFswVer.att.mnemonic = 'TLM8_PCEAppFswVer';
    g_metadata.packets.instr_hk8.PCEAppFswVer.att.start_bit = '16';
    g_metadata.packets.instr_hk8.PCEAppFswVer.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PCEAppFswVer.att.num_bits = '11';
    g_metadata.packets.instr_hk8.PCEAppFswVer.att.description = 'PCE Application Version';
    g_metadata.packets.instr_hk8.PCEAppFswVer.dim = {'hk8_packet'};

    % id 2754: TLM8_InstrumentID
    g_metadata.packets.instr_hk8.InstrumentID.att.telemetry_point_id = '2754';
    g_metadata.packets.instr_hk8.InstrumentID.att.mnemonic = 'TLM8_InstrumentID';
    g_metadata.packets.instr_hk8.InstrumentID.att.start_bit = '27';
    g_metadata.packets.instr_hk8.InstrumentID.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.InstrumentID.att.num_bits = '5';
    g_metadata.packets.instr_hk8.InstrumentID.att.description = 'Instrument ID';
    g_metadata.packets.instr_hk8.InstrumentID.dim = {'hk8_packet'};

    % id 2755: TLM8_MMInterStat (Spare)
    g_metadata.packets.instr_hk8.MMInterStat_Spare.att.telemetry_point_id = '2755';
    g_metadata.packets.instr_hk8.MMInterStat_Spare.att.mnemonic = 'TLM8_MMInterStat (Spare)';
    g_metadata.packets.instr_hk8.MMInterStat_Spare.att.start_bit = '32';
    g_metadata.packets.instr_hk8.MMInterStat_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.MMInterStat_Spare.att.description = 'Manage Memory I/F Status(Spare)';
    g_metadata.packets.instr_hk8.MMInterStat_Spare.dim = {'hk8_packet'};

    % id 2756: TLM8_MMInterStat (Mem Partinal Create Err)
    g_metadata.packets.instr_hk8.MMInterStat_Mem_Partinal_Create_Err.att.telemetry_point_id = '2756';
    g_metadata.packets.instr_hk8.MMInterStat_Mem_Partinal_Create_Err.att.mnemonic = 'TLM8_MMInterStat (Mem Partinal Create Err)';
    g_metadata.packets.instr_hk8.MMInterStat_Mem_Partinal_Create_Err.att.start_bit = '34';
    g_metadata.packets.instr_hk8.MMInterStat_Mem_Partinal_Create_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_Mem_Partinal_Create_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.MMInterStat_Mem_Partinal_Create_Err.att.description = 'Manage Memory I/F Status(Memory Partition Create Error)';
    g_metadata.packets.instr_hk8.MMInterStat_Mem_Partinal_Create_Err.dim = {'hk8_packet'};

    % id 2757: TLM8_MMInterStat (MQ Create Error)
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Create_Error.att.telemetry_point_id = '2757';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Create_Error.att.mnemonic = 'TLM8_MMInterStat (MQ Create Error)';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Create_Error.att.start_bit = '35';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Create_Error.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Create_Error.att.num_bits = '1';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Create_Error.att.description = 'Manage Memory I/F Status(Message Queue Create Error)';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Create_Error.dim = {'hk8_packet'};

    % id 2758: TLM8_MMInterStat (Default Case Reached)
    g_metadata.packets.instr_hk8.MMInterStat_Default_Case_Reached.att.telemetry_point_id = '2758';
    g_metadata.packets.instr_hk8.MMInterStat_Default_Case_Reached.att.mnemonic = 'TLM8_MMInterStat (Default Case Reached)';
    g_metadata.packets.instr_hk8.MMInterStat_Default_Case_Reached.att.start_bit = '36';
    g_metadata.packets.instr_hk8.MMInterStat_Default_Case_Reached.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_Default_Case_Reached.att.num_bits = '1';
    g_metadata.packets.instr_hk8.MMInterStat_Default_Case_Reached.att.description = 'Manage Memory I/F Status(Default Case Reached)';
    g_metadata.packets.instr_hk8.MMInterStat_Default_Case_Reached.dim = {'hk8_packet'};

    % id 2759: TLM8_MMInterStat (MM Free Err)
    g_metadata.packets.instr_hk8.MMInterStat_MM_Free_Err.att.telemetry_point_id = '2759';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Free_Err.att.mnemonic = 'TLM8_MMInterStat (MM Free Err)';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Free_Err.att.start_bit = '37';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Free_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Free_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Free_Err.att.description = 'Manage Memory I/F Status(Memory Manager Free Error)';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Free_Err.dim = {'hk8_packet'};

    % id 2760: TLM8_MMInterStat (MM Alloc Err)
    g_metadata.packets.instr_hk8.MMInterStat_MM_Alloc_Err.att.telemetry_point_id = '2760';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Alloc_Err.att.mnemonic = 'TLM8_MMInterStat (MM Alloc Err)';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Alloc_Err.att.start_bit = '38';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Alloc_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Alloc_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Alloc_Err.att.description = 'Manage Memory I/F Status(Memory Manager Allocation Error)';
    g_metadata.packets.instr_hk8.MMInterStat_MM_Alloc_Err.dim = {'hk8_packet'};

    % id 2761: TLM8_MMInterStat (MQ Rcv Err)
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Rcv_Err.att.telemetry_point_id = '2761';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Rcv_Err.att.mnemonic = 'TLM8_MMInterStat (MQ Rcv Err)';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Rcv_Err.att.start_bit = '39';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Rcv_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Rcv_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Rcv_Err.att.description = 'Manage Memory I/F Status(Message Queue Receive Error)';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Rcv_Err.dim = {'hk8_packet'};

    % id 2762: TLM8_MMInterStat (MQ Send Err)
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Send_Err.att.telemetry_point_id = '2762';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Send_Err.att.mnemonic = 'TLM8_MMInterStat (MQ Send Err)';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Send_Err.att.start_bit = '40';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Send_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Send_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Send_Err.att.description = 'Manage Memory I/F Status(Message Queue Send Error)';
    g_metadata.packets.instr_hk8.MMInterStat_MQ_Send_Err.dim = {'hk8_packet'};

    % id 2763: TLM8_MMInterStat (Two Sec Buff Cap Used)
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_Cap_Used.att.telemetry_point_id = '2763';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_Cap_Used.att.mnemonic = 'TLM8_MMInterStat (Two Sec Buff Cap Used)';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_Cap_Used.att.start_bit = '41';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_Cap_Used.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_Cap_Used.att.num_bits = '4';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_Cap_Used.att.description = 'Manage Memory I/F Status(Two Second Buffer Capacity Used)';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_Cap_Used.dim = {'hk8_packet'};

    % id 2764: TLM8_MMInterStat (Two Sec Buff VF)
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_VF.att.telemetry_point_id = '2764';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_VF.att.mnemonic = 'TLM8_MMInterStat (Two Sec Buff VF)';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_VF.att.start_bit = '45';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_VF.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_VF.att.num_bits = '1';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_VF.att.description = 'Manage Memory I/F Status(Two Second Buffer Overflow)';
    g_metadata.packets.instr_hk8.MMInterStat_Two_Sec_Buff_VF.dim = {'hk8_packet'};

    % id 2765: TLM8_MMInterStat (CmdQueue Empty)
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_Empty.att.telemetry_point_id = '2765';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_Empty.att.mnemonic = 'TLM8_MMInterStat (CmdQueue Empty)';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_Empty.att.start_bit = '46';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_Empty.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_Empty.att.num_bits = '1';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_Empty.att.description = 'Manage Memory I/F Status(Cmd Queue Empty)';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_Empty.dim = {'hk8_packet'};

    % id 2766: TLM8_MMInterStat (CmdQueue VF)
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_VF.att.telemetry_point_id = '2766';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_VF.att.mnemonic = 'TLM8_MMInterStat (CmdQueue VF)';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_VF.att.start_bit = '47';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_VF.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_VF.att.num_bits = '1';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_VF.att.description = 'Manage Memory I/F Status(Cmd Queue Overflow)';
    g_metadata.packets.instr_hk8.MMInterStat_CmdQueue_VF.dim = {'hk8_packet'};

    % id 2767: TLM8_SCInterStat (Spare)
    g_metadata.packets.instr_hk8.SCInterStat_Spare.att.telemetry_point_id = '2767';
    g_metadata.packets.instr_hk8.SCInterStat_Spare.att.mnemonic = 'TLM8_SCInterStat (Spare)';
    g_metadata.packets.instr_hk8.SCInterStat_Spare.att.start_bit = '48';
    g_metadata.packets.instr_hk8.SCInterStat_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SCInterStat_Spare.att.num_bits = '4';
    g_metadata.packets.instr_hk8.SCInterStat_Spare.att.description = 'S/C I/F Status(Spare)';
    g_metadata.packets.instr_hk8.SCInterStat_Spare.dim = {'hk8_packet'};

    % id 2768: TLM8_SCInterStat (VxWorks watchdog timer failure)
    g_metadata.packets.instr_hk8.SCInterStat_VxWorks_watchdog_timer_failure.att.telemetry_point_id = '2768';
    g_metadata.packets.instr_hk8.SCInterStat_VxWorks_watchdog_timer_failure.att.mnemonic = 'TLM8_SCInterStat (VxWorks watchdog timer failure)';
    g_metadata.packets.instr_hk8.SCInterStat_VxWorks_watchdog_timer_failure.att.start_bit = '52';
    g_metadata.packets.instr_hk8.SCInterStat_VxWorks_watchdog_timer_failure.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SCInterStat_VxWorks_watchdog_timer_failure.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SCInterStat_VxWorks_watchdog_timer_failure.att.description = 'S/C I/F Status(VxWorks watchdog timer failure)';
    g_metadata.packets.instr_hk8.SCInterStat_VxWorks_watchdog_timer_failure.dim = {'hk8_packet'};

    % id 2769: TLM8_SCInterStat (Spare2)
    g_metadata.packets.instr_hk8.SCInterStat_Spare2.att.telemetry_point_id = '2769';
    g_metadata.packets.instr_hk8.SCInterStat_Spare2.att.mnemonic = 'TLM8_SCInterStat (Spare2)';
    g_metadata.packets.instr_hk8.SCInterStat_Spare2.att.start_bit = '53';
    g_metadata.packets.instr_hk8.SCInterStat_Spare2.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SCInterStat_Spare2.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SCInterStat_Spare2.att.description = 'S/C I/F Status(Spare2)';
    g_metadata.packets.instr_hk8.SCInterStat_Spare2.dim = {'hk8_packet'};

    % id 2770: TLM8_SCInterStat (CmdPktCRCFailure)
    g_metadata.packets.instr_hk8.SCInterStat_CmdPktCRCFailure.att.telemetry_point_id = '2770';
    g_metadata.packets.instr_hk8.SCInterStat_CmdPktCRCFailure.att.mnemonic = 'TLM8_SCInterStat (CmdPktCRCFailure)';
    g_metadata.packets.instr_hk8.SCInterStat_CmdPktCRCFailure.att.start_bit = '54';
    g_metadata.packets.instr_hk8.SCInterStat_CmdPktCRCFailure.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SCInterStat_CmdPktCRCFailure.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SCInterStat_CmdPktCRCFailure.att.description = 'S/C I/F Status(Cmd Packet CRC Failure)';
    g_metadata.packets.instr_hk8.SCInterStat_CmdPktCRCFailure.dim = {'hk8_packet'};

    % id 2771: TLM8_SCInterStat (S/C to CrIS Invalid/Unrecog Cmd)
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Invalid_Unrecog_Cmd.att.telemetry_point_id = '2771';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Invalid_Unrecog_Cmd.att.mnemonic = 'TLM8_SCInterStat (S/C to CrIS Invalid/Unrecog Cmd)';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Invalid_Unrecog_Cmd.att.start_bit = '55';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Invalid_Unrecog_Cmd.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Invalid_Unrecog_Cmd.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Invalid_Unrecog_Cmd.att.description = 'S/C I/F Status(S/C to CrIS Invalid/Unrecognized Cmd)';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Invalid_Unrecog_Cmd.dim = {'hk8_packet'};

    % id 2772: TLM8_SCInterStat (S/C to CrIS Cmd ID Rcv)
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Cmd_ID_Rcv.att.telemetry_point_id = '2772';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Cmd_ID_Rcv.att.mnemonic = 'TLM8_SCInterStat (S/C to CrIS Cmd ID Rcv)';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Cmd_ID_Rcv.att.start_bit = '56';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Cmd_ID_Rcv.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Cmd_ID_Rcv.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Cmd_ID_Rcv.att.description = 'S/C I/F Status(S/C to CrIS Cmd ID that was received)';
    g_metadata.packets.instr_hk8.SCInterStat_S_C_to_CrIS_Cmd_ID_Rcv.dim = {'hk8_packet'};

    % id 2773: TLM8_SsmInterStat (Spare)
    g_metadata.packets.instr_hk8.SsmInterStat_Spare.att.telemetry_point_id = '2773';
    g_metadata.packets.instr_hk8.SsmInterStat_Spare.att.mnemonic = 'TLM8_SsmInterStat (Spare)';
    g_metadata.packets.instr_hk8.SsmInterStat_Spare.att.start_bit = '64';
    g_metadata.packets.instr_hk8.SsmInterStat_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SsmInterStat_Spare.att.num_bits = '4';
    g_metadata.packets.instr_hk8.SsmInterStat_Spare.att.description = 'SSM I/F Status(Spare)';
    g_metadata.packets.instr_hk8.SsmInterStat_Spare.dim = {'hk8_packet'};

    % id 2774: TLM8_SsmInterStat(Diag Mode Setting)
    g_metadata.packets.instr_hk8.SsmInterStat_Diag_Mode_Setting.att.telemetry_point_id = '2774';
    g_metadata.packets.instr_hk8.SsmInterStat_Diag_Mode_Setting.att.mnemonic = 'TLM8_SsmInterStat(Diag Mode Setting)';
    g_metadata.packets.instr_hk8.SsmInterStat_Diag_Mode_Setting.att.start_bit = '68';
    g_metadata.packets.instr_hk8.SsmInterStat_Diag_Mode_Setting.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SsmInterStat_Diag_Mode_Setting.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SsmInterStat_Diag_Mode_Setting.att.description = 'SSM I/F Status(Diag Dwell Mode Setting)';
    g_metadata.packets.instr_hk8.SsmInterStat_Diag_Mode_Setting.dim = {'hk8_packet'};

    % id 2775: TLM8_SsmInterStat (SSM Tele Valid Bit - Tele OK)
    g_metadata.packets.instr_hk8.SsmInterStat_SSM_Tele_Valid_Bit_Tele_OK.att.telemetry_point_id = '2775';
    g_metadata.packets.instr_hk8.SsmInterStat_SSM_Tele_Valid_Bit_Tele_OK.att.mnemonic = 'TLM8_SsmInterStat (SSM Tele Valid Bit - Tele OK)';
    g_metadata.packets.instr_hk8.SsmInterStat_SSM_Tele_Valid_Bit_Tele_OK.att.start_bit = '69';
    g_metadata.packets.instr_hk8.SsmInterStat_SSM_Tele_Valid_Bit_Tele_OK.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SsmInterStat_SSM_Tele_Valid_Bit_Tele_OK.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SsmInterStat_SSM_Tele_Valid_Bit_Tele_OK.att.description = 'SSM I/F Status(SSM Tlm Valid Bit)';
    g_metadata.packets.instr_hk8.SsmInterStat_SSM_Tele_Valid_Bit_Tele_OK.dim = {'hk8_packet'};

    % id 2776: TLM8_SsmInterStat (Failed SSm Cmd Wd at PCE/SSM Inter)
    g_metadata.packets.instr_hk8.SsmInterStat_Failed_SSm_Cmd_Wd_at_PCE_SSM_Inter.att.telemetry_point_id = '2776';
    g_metadata.packets.instr_hk8.SsmInterStat_Failed_SSm_Cmd_Wd_at_PCE_SSM_Inter.att.mnemonic = 'TLM8_SsmInterStat (Failed SSm Cmd Wd at PCE/SSM Inter)';
    g_metadata.packets.instr_hk8.SsmInterStat_Failed_SSm_Cmd_Wd_at_PCE_SSM_Inter.att.start_bit = '70';
    g_metadata.packets.instr_hk8.SsmInterStat_Failed_SSm_Cmd_Wd_at_PCE_SSM_Inter.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SsmInterStat_Failed_SSm_Cmd_Wd_at_PCE_SSM_Inter.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SsmInterStat_Failed_SSm_Cmd_Wd_at_PCE_SSM_Inter.att.description = 'SSM I/F Status(Failed SSM Cmd Word At PCE/SSM I/F)';
    g_metadata.packets.instr_hk8.SsmInterStat_Failed_SSm_Cmd_Wd_at_PCE_SSM_Inter.dim = {'hk8_packet'};

    % id 2777: TLM8_SsmInterStat (SSm Tele Cmd Err - Cmd not Recog by SSM PCE tried three times)
    g_metadata.packets.instr_hk8.SsmInterStat_SSm_Tele_Cmd_Err_Cmd_not_Recog_by_SSM_PCE_tried_th.att.telemetry_point_id = '2777';
    g_metadata.packets.instr_hk8.SsmInterStat_SSm_Tele_Cmd_Err_Cmd_not_Recog_by_SSM_PCE_tried_th.att.mnemonic = 'TLM8_SsmInterStat (SSm Tele Cmd Err - Cmd not Recog by SSM PCE tried three times)';
    g_metadata.packets.instr_hk8.SsmInterStat_SSm_Tele_Cmd_Err_Cmd_not_Recog_by_SSM_PCE_tried_th.att.start_bit = '78';
    g_metadata.packets.instr_hk8.SsmInterStat_SSm_Tele_Cmd_Err_Cmd_not_Recog_by_SSM_PCE_tried_th.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SsmInterStat_SSm_Tele_Cmd_Err_Cmd_not_Recog_by_SSM_PCE_tried_th.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SsmInterStat_SSm_Tele_Cmd_Err_Cmd_not_Recog_by_SSM_PCE_tried_th.att.description = 'SSM I/F Status(SSM Tlm Cmd Error)';
    g_metadata.packets.instr_hk8.SsmInterStat_SSm_Tele_Cmd_Err_Cmd_not_Recog_by_SSM_PCE_tried_th.dim = {'hk8_packet'};

    % id 2778: TLM8_SsmInterStat (Reserved)
    g_metadata.packets.instr_hk8.SsmInterStat_Reserved.att.telemetry_point_id = '2778';
    g_metadata.packets.instr_hk8.SsmInterStat_Reserved.att.mnemonic = 'TLM8_SsmInterStat (Reserved)';
    g_metadata.packets.instr_hk8.SsmInterStat_Reserved.att.start_bit = '79';
    g_metadata.packets.instr_hk8.SsmInterStat_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SsmInterStat_Reserved.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SsmInterStat_Reserved.att.description = 'SSM I/F Status(Reserved)';
    g_metadata.packets.instr_hk8.SsmInterStat_Reserved.dim = {'hk8_packet'};

    % id 2779: TLM8_IfmInterStat (Spare)
    g_metadata.packets.instr_hk8.IfmInterStat_Spare.att.telemetry_point_id = '2779';
    g_metadata.packets.instr_hk8.IfmInterStat_Spare.att.mnemonic = 'TLM8_IfmInterStat (Spare)';
    g_metadata.packets.instr_hk8.IfmInterStat_Spare.att.start_bit = '80';
    g_metadata.packets.instr_hk8.IfmInterStat_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmInterStat_Spare.att.num_bits = '3';
    g_metadata.packets.instr_hk8.IfmInterStat_Spare.att.description = 'IFM I/F Status(Spare)';
    g_metadata.packets.instr_hk8.IfmInterStat_Spare.dim = {'hk8_packet'};

    % id 2780: TLM8_IfmInterStat (Diag Mode Setting)
    g_metadata.packets.instr_hk8.IfmInterStat_Diag_Mode_Setting.att.telemetry_point_id = '2780';
    g_metadata.packets.instr_hk8.IfmInterStat_Diag_Mode_Setting.att.mnemonic = 'TLM8_IfmInterStat (Diag Mode Setting)';
    g_metadata.packets.instr_hk8.IfmInterStat_Diag_Mode_Setting.att.start_bit = '83';
    g_metadata.packets.instr_hk8.IfmInterStat_Diag_Mode_Setting.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmInterStat_Diag_Mode_Setting.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmInterStat_Diag_Mode_Setting.att.description = 'IFM I/F Status(Diag Dwell Mode Setting)';
    g_metadata.packets.instr_hk8.IfmInterStat_Diag_Mode_Setting.dim = {'hk8_packet'};

    % id 2781: TLM8_IfmInterStat (Possible Porchswing Sweep Dir Err)
    g_metadata.packets.instr_hk8.IfmInterStat_Possible_Porchswing_Sweep_Dir_Err.att.telemetry_point_id = '2781';
    g_metadata.packets.instr_hk8.IfmInterStat_Possible_Porchswing_Sweep_Dir_Err.att.mnemonic = 'TLM8_IfmInterStat (Possible Porchswing Sweep Dir Err)';
    g_metadata.packets.instr_hk8.IfmInterStat_Possible_Porchswing_Sweep_Dir_Err.att.start_bit = '84';
    g_metadata.packets.instr_hk8.IfmInterStat_Possible_Porchswing_Sweep_Dir_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmInterStat_Possible_Porchswing_Sweep_Dir_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmInterStat_Possible_Porchswing_Sweep_Dir_Err.att.description = 'IFM I/F Status(Possible Porchswing Sweep Direction Error)';
    g_metadata.packets.instr_hk8.IfmInterStat_Possible_Porchswing_Sweep_Dir_Err.dim = {'hk8_packet'};

    % id 2782: TLM8_IfmInterStat (IFM Tele Valid Bit - IFM Tele OK)
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Valid_Bit_IFM_Tele_OK.att.telemetry_point_id = '2782';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Valid_Bit_IFM_Tele_OK.att.mnemonic = 'TLM8_IfmInterStat (IFM Tele Valid Bit - IFM Tele OK)';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Valid_Bit_IFM_Tele_OK.att.start_bit = '85';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Valid_Bit_IFM_Tele_OK.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Valid_Bit_IFM_Tele_OK.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Valid_Bit_IFM_Tele_OK.att.description = 'IFM I/F Status(IFM Tlm Valid Bit)';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Valid_Bit_IFM_Tele_OK.dim = {'hk8_packet'};

    % id 2783: TLM8_IfmInterStat (Failed IFM Wd at PCE/IFM Inter)
    g_metadata.packets.instr_hk8.IfmInterStat_Failed_IFM_Wd_at_PCE_IFM_Inter.att.telemetry_point_id = '2783';
    g_metadata.packets.instr_hk8.IfmInterStat_Failed_IFM_Wd_at_PCE_IFM_Inter.att.mnemonic = 'TLM8_IfmInterStat (Failed IFM Wd at PCE/IFM Inter)';
    g_metadata.packets.instr_hk8.IfmInterStat_Failed_IFM_Wd_at_PCE_IFM_Inter.att.start_bit = '86';
    g_metadata.packets.instr_hk8.IfmInterStat_Failed_IFM_Wd_at_PCE_IFM_Inter.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmInterStat_Failed_IFM_Wd_at_PCE_IFM_Inter.att.num_bits = '8';
    g_metadata.packets.instr_hk8.IfmInterStat_Failed_IFM_Wd_at_PCE_IFM_Inter.att.description = 'IFM I/F Status(Failed IFM Cmd Word At PCE/IFM I/F)';
    g_metadata.packets.instr_hk8.IfmInterStat_Failed_IFM_Wd_at_PCE_IFM_Inter.dim = {'hk8_packet'};

    % id 2784: TLM8_IfmInterStat (IFM Tele Cmd Err - Cmd not Recog by IFM PCE tried three times)
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Cmd_Err_Cmd_not_Recog_by_IFM_PCE_tried_th.att.telemetry_point_id = '2784';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Cmd_Err_Cmd_not_Recog_by_IFM_PCE_tried_th.att.mnemonic = 'TLM8_IfmInterStat (IFM Tele Cmd Err - Cmd not Recog by IFM PCE tried three times)';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Cmd_Err_Cmd_not_Recog_by_IFM_PCE_tried_th.att.start_bit = '94';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Cmd_Err_Cmd_not_Recog_by_IFM_PCE_tried_th.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Cmd_Err_Cmd_not_Recog_by_IFM_PCE_tried_th.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Cmd_Err_Cmd_not_Recog_by_IFM_PCE_tried_th.att.description = 'IFM I/F Status(IFM Tlm Cmd Error)';
    g_metadata.packets.instr_hk8.IfmInterStat_IFM_Tele_Cmd_Err_Cmd_not_Recog_by_IFM_PCE_tried_th.dim = {'hk8_packet'};

    % id 2785: TLM8_IfmInterStat (Reserved)
    g_metadata.packets.instr_hk8.IfmInterStat_Reserved.att.telemetry_point_id = '2785';
    g_metadata.packets.instr_hk8.IfmInterStat_Reserved.att.mnemonic = 'TLM8_IfmInterStat (Reserved)';
    g_metadata.packets.instr_hk8.IfmInterStat_Reserved.att.start_bit = '95';
    g_metadata.packets.instr_hk8.IfmInterStat_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmInterStat_Reserved.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmInterStat_Reserved.att.description = 'IFM I/F Status(Reserved)';
    g_metadata.packets.instr_hk8.IfmInterStat_Reserved.dim = {'hk8_packet'};

    % id 2786: TLM8_SenStatReg1 (Quiet Converter SP Power Side Select Pulsed Command)
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Converter_SP_Power_Side_Select_Pulsed_Command.att.telemetry_point_id = '2786';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Converter_SP_Power_Side_Select_Pulsed_Command.att.mnemonic = 'TLM8_SenStatReg1 (Quiet Converter SP Power Side Select Pulsed Command)';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Converter_SP_Power_Side_Select_Pulsed_Command.att.start_bit = '96';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Converter_SP_Power_Side_Select_Pulsed_Command.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Converter_SP_Power_Side_Select_Pulsed_Command.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Converter_SP_Power_Side_Select_Pulsed_Command.att.description = 'Sensor Status Reg. 1(Quiet Converter SP Power Side Select Pulsed Command)';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Converter_SP_Power_Side_Select_Pulsed_Command.dim = {'hk8_packet'};

    % id 2787: TLM8_SenStatReg1 (Cooler Door Cmds Software Acknowledgement)
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_Cmds_Software_Acknowledgement.att.telemetry_point_id = '2787';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_Cmds_Software_Acknowledgement.att.mnemonic = 'TLM8_SenStatReg1 (Cooler Door Cmds Software Acknowledgement)';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_Cmds_Software_Acknowledgement.att.start_bit = '97';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_Cmds_Software_Acknowledgement.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_Cmds_Software_Acknowledgement.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_Cmds_Software_Acknowledgement.att.description = 'Sensor Status Reg. 1(Cooler Door Cmds Software Acknowledgement)';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_Cmds_Software_Acknowledgement.dim = {'hk8_packet'};

    % id 2788: TLM8_SenStatReg1 (PCE Side Sel)
    g_metadata.packets.instr_hk8.SenStatReg1_PCE_Side_Sel.att.telemetry_point_id = '2788';
    g_metadata.packets.instr_hk8.SenStatReg1_PCE_Side_Sel.att.mnemonic = 'TLM8_SenStatReg1 (PCE Side Sel)';
    g_metadata.packets.instr_hk8.SenStatReg1_PCE_Side_Sel.att.start_bit = '98';
    g_metadata.packets.instr_hk8.SenStatReg1_PCE_Side_Sel.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_PCE_Side_Sel.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_PCE_Side_Sel.att.description = 'Sensor Status Reg. 1(PCE Side Selected)';
    g_metadata.packets.instr_hk8.SenStatReg1_PCE_Side_Sel.dim = {'hk8_packet'};

    % id 2789: TLM8_SenStatReg1 (SSM Prime PW Relay)
    g_metadata.packets.instr_hk8.SenStatReg1_SSM_Prime_PW_Relay.att.telemetry_point_id = '2789';
    g_metadata.packets.instr_hk8.SenStatReg1_SSM_Prime_PW_Relay.att.mnemonic = 'TLM8_SenStatReg1 (SSM Prime PW Relay)';
    g_metadata.packets.instr_hk8.SenStatReg1_SSM_Prime_PW_Relay.att.start_bit = '99';
    g_metadata.packets.instr_hk8.SenStatReg1_SSM_Prime_PW_Relay.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_SSM_Prime_PW_Relay.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_SSM_Prime_PW_Relay.att.description = 'Sensor Status Reg. 1(SSM Prime Power Relay On/Off)';
    g_metadata.packets.instr_hk8.SenStatReg1_SSM_Prime_PW_Relay.dim = {'hk8_packet'};

    % id 2790: TLM8_SenStatReg1 (Reserved)
    g_metadata.packets.instr_hk8.SenStatReg1_Reserved.att.telemetry_point_id = '2790';
    g_metadata.packets.instr_hk8.SenStatReg1_Reserved.att.mnemonic = 'TLM8_SenStatReg1 (Reserved)';
    g_metadata.packets.instr_hk8.SenStatReg1_Reserved.att.start_bit = '100';
    g_metadata.packets.instr_hk8.SenStatReg1_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_Reserved.att.num_bits = '3';
    g_metadata.packets.instr_hk8.SenStatReg1_Reserved.att.description = 'Sensor Status Reg. 1(Reserved)';
    g_metadata.packets.instr_hk8.SenStatReg1_Reserved.dim = {'hk8_packet'};

    % id 2791: TLM8_SenStatReg1 (Quiet Conv on/off)
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Conv_on_off.att.telemetry_point_id = '2791';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Conv_on_off.att.mnemonic = 'TLM8_SenStatReg1 (Quiet Conv on/off)';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Conv_on_off.att.start_bit = '103';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Conv_on_off.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Conv_on_off.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Conv_on_off.att.description = 'Sensor Status Reg. 1(Quiet converter On/Off)';
    g_metadata.packets.instr_hk8.SenStatReg1_Quiet_Conv_on_off.dim = {'hk8_packet'};

    % id 2792: TLM8_SenStatReg1 (Spare)
    g_metadata.packets.instr_hk8.SenStatReg1_Spare.att.telemetry_point_id = '2792';
    g_metadata.packets.instr_hk8.SenStatReg1_Spare.att.mnemonic = 'TLM8_SenStatReg1 (Spare)';
    g_metadata.packets.instr_hk8.SenStatReg1_Spare.att.start_bit = '104';
    g_metadata.packets.instr_hk8.SenStatReg1_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_Spare.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_Spare.att.description = 'Sensor Status Reg. 1(Spare)';
    g_metadata.packets.instr_hk8.SenStatReg1_Spare.dim = {'hk8_packet'};

    % id 7455: TLM8_SenStatReg1 (Signal Proc on/off)
    g_metadata.packets.instr_hk8.SenStatReg1_Signal_Proc_on_off.att.telemetry_point_id = '7455';
    g_metadata.packets.instr_hk8.SenStatReg1_Signal_Proc_on_off.att.mnemonic = 'TLM8_SenStatReg1 (Signal Proc on/off)';
    g_metadata.packets.instr_hk8.SenStatReg1_Signal_Proc_on_off.att.start_bit = '105';
    g_metadata.packets.instr_hk8.SenStatReg1_Signal_Proc_on_off.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_Signal_Proc_on_off.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_Signal_Proc_on_off.att.description = 'Sensor Status Reg. 1(Signal Processor On/Off)';
    g_metadata.packets.instr_hk8.SenStatReg1_Signal_Proc_on_off.dim = {'hk8_packet'};

    % id 2793: TLM8_SenStatReg1 (DetPwr)
    g_metadata.packets.instr_hk8.SenStatReg1_DetPwr.att.telemetry_point_id = '2793';
    g_metadata.packets.instr_hk8.SenStatReg1_DetPwr.att.mnemonic = 'TLM8_SenStatReg1 (DetPwr)';
    g_metadata.packets.instr_hk8.SenStatReg1_DetPwr.att.start_bit = '106';
    g_metadata.packets.instr_hk8.SenStatReg1_DetPwr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_DetPwr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_DetPwr.att.description = 'Sensor Status Reg. 1(Detector Power On/Off)';
    g_metadata.packets.instr_hk8.SenStatReg1_DetPwr.dim = {'hk8_packet'};

    % id 2794: TLM8_SenStatReg1 (Cooler Door 28V Actuator PW App)
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_28V_Actuator_PW_App.att.telemetry_point_id = '2794';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_28V_Actuator_PW_App.att.mnemonic = 'TLM8_SenStatReg1 (Cooler Door 28V Actuator PW App)';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_28V_Actuator_PW_App.att.start_bit = '107';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_28V_Actuator_PW_App.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_28V_Actuator_PW_App.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_28V_Actuator_PW_App.att.description = 'Sensor Status Reg. 1(Cooler Door 28V Actuator Power Application)';
    g_metadata.packets.instr_hk8.SenStatReg1_Cooler_Door_28V_Actuator_PW_App.dim = {'hk8_packet'};

    % id 2795: TLM8_SenStatReg1 (+150V Conv on/off)
    g_metadata.packets.instr_hk8.SenStatReg1_150V_Conv_on_off.att.telemetry_point_id = '2795';
    g_metadata.packets.instr_hk8.SenStatReg1_150V_Conv_on_off.att.mnemonic = 'TLM8_SenStatReg1 (+150V Conv on/off)';
    g_metadata.packets.instr_hk8.SenStatReg1_150V_Conv_on_off.att.start_bit = '108';
    g_metadata.packets.instr_hk8.SenStatReg1_150V_Conv_on_off.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_150V_Conv_on_off.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_150V_Conv_on_off.att.description = 'Sensor Status Reg. 1(+150V converter On/Off)';
    g_metadata.packets.instr_hk8.SenStatReg1_150V_Conv_on_off.dim = {'hk8_packet'};

    % id 2796: TLM8_SenStatReg1 (Therm/Neon Ctrl - PCE PS Stat)
    g_metadata.packets.instr_hk8.SenStatReg1_Therm_Neon_Ctrl_PCE_PS_Stat.att.telemetry_point_id = '2796';
    g_metadata.packets.instr_hk8.SenStatReg1_Therm_Neon_Ctrl_PCE_PS_Stat.att.mnemonic = 'TLM8_SenStatReg1 (Therm/Neon Ctrl - PCE PS Stat)';
    g_metadata.packets.instr_hk8.SenStatReg1_Therm_Neon_Ctrl_PCE_PS_Stat.att.start_bit = '109';
    g_metadata.packets.instr_hk8.SenStatReg1_Therm_Neon_Ctrl_PCE_PS_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_Therm_Neon_Ctrl_PCE_PS_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_Therm_Neon_Ctrl_PCE_PS_Stat.att.description = 'Sensor Status Reg. 1(Thermal/Neon Ctrl - PCE Power Supply Status)';
    g_metadata.packets.instr_hk8.SenStatReg1_Therm_Neon_Ctrl_PCE_PS_Stat.dim = {'hk8_packet'};

    % id 2797: TLM8_SenStatReg1 (HK Mux Enable/Disable)
    g_metadata.packets.instr_hk8.SenStatReg1_HK_Mux_Enable_Disable.att.telemetry_point_id = '2797';
    g_metadata.packets.instr_hk8.SenStatReg1_HK_Mux_Enable_Disable.att.mnemonic = 'TLM8_SenStatReg1 (HK Mux Enable/Disable)';
    g_metadata.packets.instr_hk8.SenStatReg1_HK_Mux_Enable_Disable.att.start_bit = '110';
    g_metadata.packets.instr_hk8.SenStatReg1_HK_Mux_Enable_Disable.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_HK_Mux_Enable_Disable.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_HK_Mux_Enable_Disable.att.description = 'Sensor Status Reg. 1(HK Mux Enable/Disable)';
    g_metadata.packets.instr_hk8.SenStatReg1_HK_Mux_Enable_Disable.dim = {'hk8_packet'};

    % id 2798: TLM8_SenStatReg1 (Inferferometer on/off - PCE PS stat)
    g_metadata.packets.instr_hk8.SenStatReg1_Inferferometer_on_off_PCE_PS_stat.att.telemetry_point_id = '2798';
    g_metadata.packets.instr_hk8.SenStatReg1_Inferferometer_on_off_PCE_PS_stat.att.mnemonic = 'TLM8_SenStatReg1 (Inferferometer on/off - PCE PS stat)';
    g_metadata.packets.instr_hk8.SenStatReg1_Inferferometer_on_off_PCE_PS_stat.att.start_bit = '111';
    g_metadata.packets.instr_hk8.SenStatReg1_Inferferometer_on_off_PCE_PS_stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg1_Inferferometer_on_off_PCE_PS_stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg1_Inferferometer_on_off_PCE_PS_stat.att.description = 'Sensor Status Reg. 1(Interferometer On/Off - PCE Power Supply Status)';
    g_metadata.packets.instr_hk8.SenStatReg1_Inferferometer_on_off_PCE_PS_stat.dim = {'hk8_packet'};

    % id 2799: TLM8_SenStatReg2 (HK 200ms Sync Enabled/Disabled)
    g_metadata.packets.instr_hk8.SenStatReg2_HK_200ms_Sync_Enabled_Disabled.att.telemetry_point_id = '2799';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_200ms_Sync_Enabled_Disabled.att.mnemonic = 'TLM8_SenStatReg2 (HK 200ms Sync Enabled/Disabled)';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_200ms_Sync_Enabled_Disabled.att.start_bit = '112';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_200ms_Sync_Enabled_Disabled.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_200ms_Sync_Enabled_Disabled.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_200ms_Sync_Enabled_Disabled.att.description = 'Sensor Status Reg. 2(HK 200ms Sync Enbl/Dsbl)';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_200ms_Sync_Enabled_Disabled.dim = {'hk8_packet'};

    % id 2800: TLM8_SenStatReg2 (Reserved1)
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved1.att.telemetry_point_id = '2800';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved1.att.mnemonic = 'TLM8_SenStatReg2 (Reserved1)';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved1.att.start_bit = '113';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved1.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved1.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved1.att.description = 'Sensor Status Reg. 2(Reserved)';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved1.dim = {'hk8_packet'};

    % id 2801: TLM8_SenStatReg2 (Sig Proc 200ms Sync Enabled/Disabled)
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_200ms_Sync_Enabled_Disabled.att.telemetry_point_id = '2801';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_200ms_Sync_Enabled_Disabled.att.mnemonic = 'TLM8_SenStatReg2 (Sig Proc 200ms Sync Enabled/Disabled)';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_200ms_Sync_Enabled_Disabled.att.start_bit = '114';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_200ms_Sync_Enabled_Disabled.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_200ms_Sync_Enabled_Disabled.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_200ms_Sync_Enabled_Disabled.att.description = 'Sensor Status Reg. 2(Signal Processor 200ms Sync Enbl/Dsbl)';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_200ms_Sync_Enabled_Disabled.dim = {'hk8_packet'};

    % id 2802: TLM8_SenStatReg2 (Sig Proc 8 Sec Sync Enabled/Disabled)
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_8_Sec_Sync_Enabled_Disabled.att.telemetry_point_id = '2802';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_8_Sec_Sync_Enabled_Disabled.att.mnemonic = 'TLM8_SenStatReg2 (Sig Proc 8 Sec Sync Enabled/Disabled)';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_8_Sec_Sync_Enabled_Disabled.att.start_bit = '115';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_8_Sec_Sync_Enabled_Disabled.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_8_Sec_Sync_Enabled_Disabled.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_8_Sec_Sync_Enabled_Disabled.att.description = 'Sensor Status Reg. 2(Signal Processor 8 sec sync Enbl/Dsbl)';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_8_Sec_Sync_Enabled_Disabled.dim = {'hk8_packet'};

    % id 2803: TLM8_SenStatReg2 (Sig Proc 3 Rst)
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_3_Rst.att.telemetry_point_id = '2803';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_3_Rst.att.mnemonic = 'TLM8_SenStatReg2 (Sig Proc 3 Rst)';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_3_Rst.att.start_bit = '116';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_3_Rst.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_3_Rst.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_3_Rst.att.description = 'Sensor Status Reg. 2(Signal Processor 3 Reset)';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_3_Rst.dim = {'hk8_packet'};

    % id 2804: TLM8_SenStatReg2 (Sig Proc 2 Rst)
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_2_Rst.att.telemetry_point_id = '2804';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_2_Rst.att.mnemonic = 'TLM8_SenStatReg2 (Sig Proc 2 Rst)';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_2_Rst.att.start_bit = '117';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_2_Rst.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_2_Rst.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_2_Rst.att.description = 'Sensor Status Reg. 2(Signal Processor 2 Reset)';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_2_Rst.dim = {'hk8_packet'};

    % id 2805: TLM8_SenStatReg2 (Sig Proc 1 Rst)
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_1_Rst.att.telemetry_point_id = '2805';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_1_Rst.att.mnemonic = 'TLM8_SenStatReg2 (Sig Proc 1 Rst)';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_1_Rst.att.start_bit = '118';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_1_Rst.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_1_Rst.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_1_Rst.att.description = 'Sensor Status Reg. 2(Signal Processor 1 Reset)';
    g_metadata.packets.instr_hk8.SenStatReg2_Sig_Proc_1_Rst.dim = {'hk8_packet'};

    % id 2806: TLM8_SenStatReg2 (HK Rst)
    g_metadata.packets.instr_hk8.SenStatReg2_HK_Rst.att.telemetry_point_id = '2806';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_Rst.att.mnemonic = 'TLM8_SenStatReg2 (HK Rst)';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_Rst.att.start_bit = '119';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_Rst.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_Rst.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_Rst.att.description = 'Sensor Status Reg. 2(HK Reset)';
    g_metadata.packets.instr_hk8.SenStatReg2_HK_Rst.dim = {'hk8_packet'};

    % id 2809: TLM8_SenStatReg2 (Reserved2)
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved2.att.telemetry_point_id = '2809';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved2.att.mnemonic = 'TLM8_SenStatReg2 (Reserved2)';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved2.att.start_bit = '120';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved2.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved2.att.num_bits = '4';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved2.att.description = 'Sensor Status Reg. 2(Reserved)';
    g_metadata.packets.instr_hk8.SenStatReg2_Reserved2.dim = {'hk8_packet'};

    % id 2810: TLM8_SenStatReg2 (SCC2 DMA Err Intrpt)
    g_metadata.packets.instr_hk8.SenStatReg2_SCC2_DMA_Err_Intrpt.att.telemetry_point_id = '2810';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC2_DMA_Err_Intrpt.att.mnemonic = 'TLM8_SenStatReg2 (SCC2 DMA Err Intrpt)';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC2_DMA_Err_Intrpt.att.start_bit = '124';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC2_DMA_Err_Intrpt.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC2_DMA_Err_Intrpt.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC2_DMA_Err_Intrpt.att.description = 'Sensor Status Reg. 2(Serial Comm Controller 2 DMA Error Interrupt)';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC2_DMA_Err_Intrpt.dim = {'hk8_packet'};

    % id 2811: TLM8_SenStatReg2 (SCC1 DMA Err Intrpt)
    g_metadata.packets.instr_hk8.SenStatReg2_SCC1_DMA_Err_Intrpt.att.telemetry_point_id = '2811';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC1_DMA_Err_Intrpt.att.mnemonic = 'TLM8_SenStatReg2 (SCC1 DMA Err Intrpt)';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC1_DMA_Err_Intrpt.att.start_bit = '125';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC1_DMA_Err_Intrpt.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC1_DMA_Err_Intrpt.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC1_DMA_Err_Intrpt.att.description = 'Sensor Status Reg. 2(Serial Comm Controller 1 DMA Error Interrupt)';
    g_metadata.packets.instr_hk8.SenStatReg2_SCC1_DMA_Err_Intrpt.dim = {'hk8_packet'};

    % id 2812: TLM8_SenStatReg2 (Aux FPGA Brdg Spur Intrpt)
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Spur_Intrpt.att.telemetry_point_id = '2812';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Spur_Intrpt.att.mnemonic = 'TLM8_SenStatReg2 (Aux FPGA Brdg Spur Intrpt)';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Spur_Intrpt.att.start_bit = '126';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Spur_Intrpt.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Spur_Intrpt.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Spur_Intrpt.att.description = 'Sensor Status Reg. 2(Auxiliary FPGA Bridgee Spurious Interrupt)';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Spur_Intrpt.dim = {'hk8_packet'};

    % id 2813: TLM8_SenStatReg2 (Aux FPGA Brdg Invalid Intrpt)
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Invalid_Intrpt.att.telemetry_point_id = '2813';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Invalid_Intrpt.att.mnemonic = 'TLM8_SenStatReg2 (Aux FPGA Brdg Invalid Intrpt)';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Invalid_Intrpt.att.start_bit = '127';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Invalid_Intrpt.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Invalid_Intrpt.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Invalid_Intrpt.att.description = 'Sensor Status Reg. 2(Auxiliary FPGA Bridge Invalid Interrupt)';
    g_metadata.packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Invalid_Intrpt.dim = {'hk8_packet'};

    % id 2814: TLM8_FswExErrStatReg1 (Reserved)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Reserved.att.telemetry_point_id = '2814';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Reserved.att.mnemonic = 'TLM8_FswExErrStatReg1 (Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Reserved.att.start_bit = '128';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Reserved.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Reserved.att.description = 'FSW Exc. Error Status Reg. 1(Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Reserved.dim = {'hk8_packet'};

    % id 2815: TLM8_FswExErrStatReg1 (Cmd Rejected)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cmd_Rejected.att.telemetry_point_id = '2815';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cmd_Rejected.att.mnemonic = 'TLM8_FswExErrStatReg1 (Cmd Rejected)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cmd_Rejected.att.start_bit = '129';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cmd_Rejected.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cmd_Rejected.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cmd_Rejected.att.description = 'FSW Exc. Error Status Reg. 1(Cmd Rejected)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cmd_Rejected.dim = {'hk8_packet'};

    % id 2816: TLM8_FswExErrStatReg1 (Module Not Powered On)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Module_Not_Powered_On.att.telemetry_point_id = '2816';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Module_Not_Powered_On.att.mnemonic = 'TLM8_FswExErrStatReg1 (Module Not Powered On)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Module_Not_Powered_On.att.start_bit = '130';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Module_Not_Powered_On.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Module_Not_Powered_On.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Module_Not_Powered_On.att.description = 'FSW Exc. Error Status Reg. 1(Module Not Powered On)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Module_Not_Powered_On.dim = {'hk8_packet'};

    % id 2817: TLM8_FswExErrStatReg1 (Cannot Auton Enter Safe Mode)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cannot_Auton_Enter_Safe_Mode.att.telemetry_point_id = '2817';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cannot_Auton_Enter_Safe_Mode.att.mnemonic = 'TLM8_FswExErrStatReg1 (Cannot Auton Enter Safe Mode)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cannot_Auton_Enter_Safe_Mode.att.start_bit = '131';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cannot_Auton_Enter_Safe_Mode.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cannot_Auton_Enter_Safe_Mode.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cannot_Auton_Enter_Safe_Mode.att.description = 'FSW Exc. Error Status Reg. 1(Cannot Autonomously Enter Safe Mode)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Cannot_Auton_Enter_Safe_Mode.dim = {'hk8_packet'};

    % id 2818: TLM8_FswExErrStatReg1 (Sftw UL EN)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_EN.att.telemetry_point_id = '2818';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_EN.att.mnemonic = 'TLM8_FswExErrStatReg1 (Sftw UL EN)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_EN.att.start_bit = '132';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_EN.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_EN.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_EN.att.description = 'FSW Exc. Error Status Reg. 1(Software Upload Is Enabled)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_EN.dim = {'hk8_packet'};

    % id 2819: TLM8_FswExErrStatReg1 (Sftw UL success)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_success.att.telemetry_point_id = '2819';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_success.att.mnemonic = 'TLM8_FswExErrStatReg1 (Sftw UL success)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_success.att.start_bit = '133';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_success.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_success.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_success.att.description = 'FSW Exc. Error Status Reg. 1(Software Upload Successful )';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_success.dim = {'hk8_packet'};

    % id 2820: TLM8_FswExErrStatReg1 (Sftw UL CRC Failed)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_CRC_Failed.att.telemetry_point_id = '2820';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_CRC_Failed.att.mnemonic = 'TLM8_FswExErrStatReg1 (Sftw UL CRC Failed)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_CRC_Failed.att.start_bit = '134';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_CRC_Failed.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_CRC_Failed.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_CRC_Failed.att.description = 'FSW Exc. Error Status Reg. 1(Software Upload CRC Failed)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_CRC_Failed.dim = {'hk8_packet'};

    % id 2821: TLM8_FswExErrStatReg1 (Sftw UL Aborted)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Aborted.att.telemetry_point_id = '2821';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Aborted.att.mnemonic = 'TLM8_FswExErrStatReg1 (Sftw UL Aborted)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Aborted.att.start_bit = '135';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Aborted.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Aborted.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Aborted.att.description = 'FSW Exc. Error Status Reg. 1(Software Upload Aborted)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Aborted.dim = {'hk8_packet'};

    % id 2822: TLM8_FswExErrStatReg1 (Sftw UL Img Not Pres)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Img_Not_Pres.att.telemetry_point_id = '2822';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Img_Not_Pres.att.mnemonic = 'TLM8_FswExErrStatReg1 (Sftw UL Img Not Pres)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Img_Not_Pres.att.start_bit = '136';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Img_Not_Pres.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Img_Not_Pres.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Img_Not_Pres.att.description = 'FSW Exc. Error Status Reg. 1(Software Upload Image Not Present)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Img_Not_Pres.dim = {'hk8_packet'};

    % id 2823: TLM8_FswExErrStatReg1 (illegal Neon Calib Time)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_illegal_Neon_Calib_Time.att.telemetry_point_id = '2823';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_illegal_Neon_Calib_Time.att.mnemonic = 'TLM8_FswExErrStatReg1 (illegal Neon Calib Time)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_illegal_Neon_Calib_Time.att.start_bit = '137';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_illegal_Neon_Calib_Time.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_illegal_Neon_Calib_Time.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_illegal_Neon_Calib_Time.att.description = 'FSW Exc. Error Status Reg. 1(Illegal Neon Cal. Time)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_illegal_Neon_Calib_Time.dim = {'hk8_packet'};

    % id 2824: TLM8_FswExErrStatReg1 (En Cooler Door Before Releasing)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_En_Cooler_Door_Before_Releasing.att.telemetry_point_id = '2824';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_En_Cooler_Door_Before_Releasing.att.mnemonic = 'TLM8_FswExErrStatReg1 (En Cooler Door Before Releasing)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_En_Cooler_Door_Before_Releasing.att.start_bit = '138';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_En_Cooler_Door_Before_Releasing.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_En_Cooler_Door_Before_Releasing.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_En_Cooler_Door_Before_Releasing.att.description = 'FSW Exc. Error Status Reg. 1(Enable Cooler Door Before Releasing)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_En_Cooler_Door_Before_Releasing.dim = {'hk8_packet'};

    % id 2825: TLM8_FswExErrStatReg1 (Invld Cmd Par)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Invld_Cmd_Par.att.telemetry_point_id = '2825';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Invld_Cmd_Par.att.mnemonic = 'TLM8_FswExErrStatReg1 (Invld Cmd Par)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Invld_Cmd_Par.att.start_bit = '139';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Invld_Cmd_Par.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Invld_Cmd_Par.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Invld_Cmd_Par.att.description = 'FSW Exc. Error Status Reg. 1(Invalid Cmd Parameters)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Invld_Cmd_Par.dim = {'hk8_packet'};

    % id 2826: TLM8_FswExErrStatReg1 (Default Case Reached)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Default_Case_Reached.att.telemetry_point_id = '2826';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Default_Case_Reached.att.mnemonic = 'TLM8_FswExErrStatReg1 (Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Default_Case_Reached.att.start_bit = '140';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Default_Case_Reached.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Default_Case_Reached.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Default_Case_Reached.att.description = 'FSW Exc. Error Status Reg. 1(Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_Default_Case_Reached.dim = {'hk8_packet'};

    % id 2827: TLM8_FswExErrStatReg1 (MQ Rcv Error)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Rcv_Error.att.telemetry_point_id = '2827';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Rcv_Error.att.mnemonic = 'TLM8_FswExErrStatReg1 (MQ Rcv Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Rcv_Error.att.start_bit = '141';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Rcv_Error.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Rcv_Error.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Rcv_Error.att.description = 'FSW Exc. Error Status Reg. 1(Message Queue Receive Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Rcv_Error.dim = {'hk8_packet'};

    % id 2828: TLM8_FswExErrStatReg1 (MQ Snd Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Snd_Err.att.telemetry_point_id = '2828';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Snd_Err.att.mnemonic = 'TLM8_FswExErrStatReg1 (MQ Snd Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Snd_Err.att.start_bit = '142';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Snd_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Snd_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Snd_Err.att.description = 'FSW Exc. Error Status Reg. 1(Message Queue Send Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_MQ_Snd_Err.dim = {'hk8_packet'};

    % id 2829: TLM8_FswExErrStatReg1 (OS Func Call Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg1_OS_Func_Call_Err.att.telemetry_point_id = '2829';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_OS_Func_Call_Err.att.mnemonic = 'TLM8_FswExErrStatReg1 (OS Func Call Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_OS_Func_Call_Err.att.start_bit = '143';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_OS_Func_Call_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_OS_Func_Call_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_OS_Func_Call_Err.att.description = 'FSW Exc. Error Status Reg. 1(Operating System Function Call Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg1_OS_Func_Call_Err.dim = {'hk8_packet'};

    % id 2830: TLM8_FswExErrStatReg2 (Sub Patch Temp Thres Monitor)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sub_Patch_Temp_Thres_Monitor.att.telemetry_point_id = '2830';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sub_Patch_Temp_Thres_Monitor.att.mnemonic = 'TLM8_FswExErrStatReg2 (Sub Patch Temp Thres Monitor)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sub_Patch_Temp_Thres_Monitor.att.start_bit = '144';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sub_Patch_Temp_Thres_Monitor.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sub_Patch_Temp_Thres_Monitor.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sub_Patch_Temp_Thres_Monitor.att.description = 'FSW Exc. Error Status Reg. 2(Sub Patch Temp Threshold Monitoring)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sub_Patch_Temp_Thres_Monitor.dim = {'hk8_packet'};

    % id 2831: TLM8_FswExErrStatReg2 (Patch Temp Thres Monitor)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Patch_Temp_Thres_Monitor.att.telemetry_point_id = '2831';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Patch_Temp_Thres_Monitor.att.mnemonic = 'TLM8_FswExErrStatReg2 (Patch Temp Thres Monitor)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Patch_Temp_Thres_Monitor.att.start_bit = '145';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Patch_Temp_Thres_Monitor.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Patch_Temp_Thres_Monitor.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Patch_Temp_Thres_Monitor.att.description = 'FSW Exc. Error Status Reg. 2(Patch Temp Threshold Monitoring)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Patch_Temp_Thres_Monitor.dim = {'hk8_packet'};

    % id 2832: TLM8_FswExErrStatReg2 ( Sig Proc 5V OverVoltage Thresh Monitor)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sig_Proc_5V_OverVoltage_Thresh_Monitor.att.telemetry_point_id = '2832';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sig_Proc_5V_OverVoltage_Thresh_Monitor.att.mnemonic = 'TLM8_FswExErrStatReg2 ( Sig Proc 5V OverVoltage Thresh Monitor)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sig_Proc_5V_OverVoltage_Thresh_Monitor.att.start_bit = '146';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sig_Proc_5V_OverVoltage_Thresh_Monitor.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sig_Proc_5V_OverVoltage_Thresh_Monitor.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sig_Proc_5V_OverVoltage_Thresh_Monitor.att.description = 'FSW Exc. Error Status Reg. 2(Signal Processing +/- 5V OV Threshold Monitoring)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Sig_Proc_5V_OverVoltage_Thresh_Monitor.dim = {'hk8_packet'};

    % id 2833: TLM8_FswExErrStatReg2 (SwNotPettingWatchdog)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwNotPettingWatchdog.att.telemetry_point_id = '2833';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwNotPettingWatchdog.att.mnemonic = 'TLM8_FswExErrStatReg2 (SwNotPettingWatchdog)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwNotPettingWatchdog.att.start_bit = '147';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwNotPettingWatchdog.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwNotPettingWatchdog.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwNotPettingWatchdog.att.description = 'FSW Exc. Error Status Reg. 2(SwNotPettingWatchdog)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwNotPettingWatchdog.dim = {'hk8_packet'};

    % id 15896: TLM8_FswExErrStatReg2 (SwTaskNotResponding)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwTaskNotResponding.att.telemetry_point_id = '15896';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwTaskNotResponding.att.mnemonic = 'TLM8_FswExErrStatReg2 (SwTaskNotResponding)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwTaskNotResponding.att.start_bit = '148';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwTaskNotResponding.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwTaskNotResponding.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwTaskNotResponding.att.description = 'FSW Exc. Error Status Reg. 2(SwTaskNotResponding)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_SwTaskNotResponding.dim = {'hk8_packet'};

    % id 2834: TLM8_FswExErrStatReg2 (EEPROM general error)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_general_error.att.telemetry_point_id = '2834';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_general_error.att.mnemonic = 'TLM8_FswExErrStatReg2 (EEPROM general error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_general_error.att.start_bit = '149';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_general_error.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_general_error.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_general_error.att.description = 'FSW Exc. Error Status Reg. 2(EEPROM General Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_general_error.dim = {'hk8_packet'};

    % id 2835: TLM8_FswExErrStatReg2 (EEPROM write error)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_write_error.att.telemetry_point_id = '2835';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_write_error.att.mnemonic = 'TLM8_FswExErrStatReg2 (EEPROM write error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_write_error.att.start_bit = '150';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_write_error.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_write_error.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_write_error.att.description = 'FSW Exc. Error Status Reg. 2(EEPROM Write Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_write_error.dim = {'hk8_packet'};

    % id 2836: TLM8_FswExErrStatReg2 (Isr Missing 8 Sec int)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Missing_8_Sec_int.att.telemetry_point_id = '2836';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Missing_8_Sec_int.att.mnemonic = 'TLM8_FswExErrStatReg2 (Isr Missing 8 Sec int)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Missing_8_Sec_int.att.start_bit = '151';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Missing_8_Sec_int.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Missing_8_Sec_int.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Missing_8_Sec_int.att.description = 'FSW Exc. Error Status Reg. 2(ISR - Missing 8sec Int)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Missing_8_Sec_int.dim = {'hk8_packet'};

    % id 2837: TLM8_FswExErrStatReg2 (Isr Early 8 Sec int)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Early_8_Sec_int.att.telemetry_point_id = '2837';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Early_8_Sec_int.att.mnemonic = 'TLM8_FswExErrStatReg2 (Isr Early 8 Sec int)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Early_8_Sec_int.att.start_bit = '152';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Early_8_Sec_int.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Early_8_Sec_int.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Early_8_Sec_int.att.description = 'FSW Exc. Error Status Reg. 2(ISR - Early 8sec Int)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Early_8_Sec_int.dim = {'hk8_packet'};

    % id 2838: TLM8_FswExErrStatReg2 (Isr unexpected int)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_unexpected_int.att.telemetry_point_id = '2838';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_unexpected_int.att.mnemonic = 'TLM8_FswExErrStatReg2 (Isr unexpected int)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_unexpected_int.att.start_bit = '153';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_unexpected_int.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_unexpected_int.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_unexpected_int.att.description = 'FSW Exc. Error Status Reg. 2(ISR - Unexpected Int)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_unexpected_int.dim = {'hk8_packet'};

    % id 2839: TLM8_FswExErrStatReg2 (Isr Invld int)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Invld_int.att.telemetry_point_id = '2839';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Invld_int.att.mnemonic = 'TLM8_FswExErrStatReg2 (Isr Invld int)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Invld_int.att.start_bit = '154';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Invld_int.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Invld_int.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Invld_int.att.description = 'FSW Exc. Error Status Reg. 2(ISR - Invalid Int)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Invld_int.dim = {'hk8_packet'};

    % id 2840: TLM8_FswExErrStatReg2 (Isr Msg Queue Tx Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Msg_Queue_Tx_Err.att.telemetry_point_id = '2840';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Msg_Queue_Tx_Err.att.mnemonic = 'TLM8_FswExErrStatReg2 (Isr Msg Queue Tx Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Msg_Queue_Tx_Err.att.start_bit = '155';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Msg_Queue_Tx_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Msg_Queue_Tx_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Msg_Queue_Tx_Err.att.description = 'FSW Exc. Error Status Reg. 2(ISR - Message queue tx error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Isr_Msg_Queue_Tx_Err.dim = {'hk8_packet'};

    % id 2841: TLM8_FswExErrStatReg2 (Free Mem Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Free_Mem_Err.att.telemetry_point_id = '2841';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Free_Mem_Err.att.mnemonic = 'TLM8_FswExErrStatReg2 (Free Mem Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Free_Mem_Err.att.start_bit = '156';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Free_Mem_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Free_Mem_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Free_Mem_Err.att.description = 'FSW Exc. Error Status Reg. 2(Free Memory Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Free_Mem_Err.dim = {'hk8_packet'};

    % id 2842: TLM8_FswExErrStatReg2 (Alloc Mem Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Alloc_Mem_Err.att.telemetry_point_id = '2842';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Alloc_Mem_Err.att.mnemonic = 'TLM8_FswExErrStatReg2 (Alloc Mem Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Alloc_Mem_Err.att.start_bit = '157';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Alloc_Mem_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Alloc_Mem_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Alloc_Mem_Err.att.description = 'FSW Exc. Error Status Reg. 2(Allocate Memory Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Alloc_Mem_Err.dim = {'hk8_packet'};

    % id 2843: TLM8_FswExErrStatReg2 (Neon Lmp Calib)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Neon_Lmp_Calib.att.telemetry_point_id = '2843';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Neon_Lmp_Calib.att.mnemonic = 'TLM8_FswExErrStatReg2 (Neon Lmp Calib)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Neon_Lmp_Calib.att.start_bit = '158';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Neon_Lmp_Calib.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Neon_Lmp_Calib.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Neon_Lmp_Calib.att.description = 'FSW Exc. Error Status Reg. 2(Neon Lamp is Calibrated)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_Neon_Lmp_Calib.dim = {'hk8_packet'};

    % id 2844: TLM8_FswExErrStatReg2 (EEPROM being Accessed)
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_being_Accessed.att.telemetry_point_id = '2844';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_being_Accessed.att.mnemonic = 'TLM8_FswExErrStatReg2 (EEPROM being Accessed)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_being_Accessed.att.start_bit = '159';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_being_Accessed.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_being_Accessed.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_being_Accessed.att.description = 'FSW Exc. Error Status Reg. 2(EEPROM is being Accessed)';
    g_metadata.packets.instr_hk8.FswExErrStatReg2_EEPROM_being_Accessed.dim = {'hk8_packet'};

    % id 2845: TLM8_FswExErrStatReg 3 (Sig Proc 5V OverVoltage Thresh Stat)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sig_Proc_5V_OverVoltage_Thresh_Stat.att.telemetry_point_id = '2845';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sig_Proc_5V_OverVoltage_Thresh_Stat.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Sig Proc 5V OverVoltage Thresh Stat)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sig_Proc_5V_OverVoltage_Thresh_Stat.att.start_bit = '160';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sig_Proc_5V_OverVoltage_Thresh_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sig_Proc_5V_OverVoltage_Thresh_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sig_Proc_5V_OverVoltage_Thresh_Stat.att.description = 'FSW Exc. Error Status Reg. 3(Signal Processing +/- 5V OV Threshold Status)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sig_Proc_5V_OverVoltage_Thresh_Stat.dim = {'hk8_packet'};

    % id 2846: TLM8_FswExErrStatReg 3 (Diag Mode Setting)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Diag_Mode_Setting.att.telemetry_point_id = '2846';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Diag_Mode_Setting.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Diag Mode Setting)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Diag_Mode_Setting.att.start_bit = '161';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Diag_Mode_Setting.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Diag_Mode_Setting.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Diag_Mode_Setting.att.description = 'FSW Exc. Error Status Reg. 3(Diag Dwell Mode Setting)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Diag_Mode_Setting.dim = {'hk8_packet'};

    % id 2847: TLM8_FswExErrStatReg 3 (Sub Patch Temp Thresh Stat)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sub_Patch_Temp_Thresh_Stat.att.telemetry_point_id = '2847';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sub_Patch_Temp_Thresh_Stat.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Sub Patch Temp Thresh Stat)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sub_Patch_Temp_Thresh_Stat.att.start_bit = '162';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sub_Patch_Temp_Thresh_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sub_Patch_Temp_Thresh_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sub_Patch_Temp_Thresh_Stat.att.description = 'FSW Exc. Error Status Reg. 3(Sub Patch Temp Threshold Status)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Sub_Patch_Temp_Thresh_Stat.dim = {'hk8_packet'};

    % id 2848: TLM8_FswExErrStatReg 3 (Patch Temp Thresh Stat)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Patch_Temp_Thresh_Stat.att.telemetry_point_id = '2848';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Patch_Temp_Thresh_Stat.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Patch Temp Thresh Stat)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Patch_Temp_Thresh_Stat.att.start_bit = '163';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Patch_Temp_Thresh_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Patch_Temp_Thresh_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Patch_Temp_Thresh_Stat.att.description = 'FSW Exc. Error Status Reg. 3(Patch Temp Threshold Status)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Patch_Temp_Thresh_Stat.dim = {'hk8_packet'};

    % id 2849: TLM8_FswExErrStatReg 3 (PCE HK Tele Valid)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCE_HK_Tele_Valid.att.telemetry_point_id = '2849';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCE_HK_Tele_Valid.att.mnemonic = 'TLM8_FswExErrStatReg 3 (PCE HK Tele Valid)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCE_HK_Tele_Valid.att.start_bit = '164';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCE_HK_Tele_Valid.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCE_HK_Tele_Valid.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCE_HK_Tele_Valid.att.description = 'FSW Exc. Error Status Reg. 3(PCE HK Tlm Valid)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCE_HK_Tele_Valid.dim = {'hk8_packet'};

    % id 2850: TLM8_FswExErrStatReg 3 (Cmd Rejected)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Cmd_Rejected.att.telemetry_point_id = '2850';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Cmd_Rejected.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Cmd Rejected)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Cmd_Rejected.att.start_bit = '165';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Cmd_Rejected.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Cmd_Rejected.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Cmd_Rejected.att.description = 'FSW Exc. Error Status Reg. 3(Cmd Rejected)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Cmd_Rejected.dim = {'hk8_packet'};

    % id 2851: TLM8_FswExErrStatReg 3 (PCI Config Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCI_Config_Err.att.telemetry_point_id = '2851';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCI_Config_Err.att.mnemonic = 'TLM8_FswExErrStatReg 3 (PCI Config Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCI_Config_Err.att.start_bit = '166';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCI_Config_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCI_Config_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCI_Config_Err.att.description = 'FSW Exc. Error Status Reg. 3(PCI Configuration Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_PCI_Config_Err.dim = {'hk8_packet'};

    % id 2852: TLM8_FswExErrStatReg 3 (Init Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Init_Err.att.telemetry_point_id = '2852';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Init_Err.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Init Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Init_Err.att.start_bit = '167';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Init_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Init_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Init_Err.att.description = 'FSW Exc. Error Status Reg. 3(Initialization Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Init_Err.dim = {'hk8_packet'};

    % id 2853: TLM8_FswExErrStatReg 3 (Too Much Tele Sent)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Much_Tele_Sent.att.telemetry_point_id = '2853';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Much_Tele_Sent.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Too Much Tele Sent)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Much_Tele_Sent.att.start_bit = '168';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Much_Tele_Sent.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Much_Tele_Sent.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Much_Tele_Sent.att.description = 'FSW Exc. Error Status Reg. 3(Too Much Tlm Sent)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Much_Tele_Sent.dim = {'hk8_packet'};

    % id 2854: TLM8_FswExErrStatReg 3 (Too Few Tele Sent)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Few_Tele_Sent.att.telemetry_point_id = '2854';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Few_Tele_Sent.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Too Few Tele Sent)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Few_Tele_Sent.att.start_bit = '169';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Few_Tele_Sent.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Few_Tele_Sent.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Few_Tele_Sent.att.description = 'FSW Exc. Error Status Reg. 3(Too Few Tlm Sent)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Too_Few_Tele_Sent.dim = {'hk8_packet'};

    % id 2855: TLM8_FswExErrStatReg 3 (Invld Cmd Par)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Cmd_Par.att.telemetry_point_id = '2855';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Cmd_Par.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Invld Cmd Par)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Cmd_Par.att.start_bit = '170';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Cmd_Par.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Cmd_Par.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Cmd_Par.att.description = 'FSW Exc. Error Status Reg. 3(Invalid Cmd Parameters)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Cmd_Par.dim = {'hk8_packet'};

    % id 2856: TLM8_FswExErrStatReg 3 (Invld Mem Bank)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Mem_Bank.att.telemetry_point_id = '2856';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Mem_Bank.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Invld Mem Bank)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Mem_Bank.att.start_bit = '171';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Mem_Bank.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Mem_Bank.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Mem_Bank.att.description = 'FSW Exc. Error Status Reg. 3(Invalid Memory Bank)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Invld_Mem_Bank.dim = {'hk8_packet'};

    % id 2857: TLM8_FswExErrStatReg 3 (Default Case Reached)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Default_Case_Reached.att.telemetry_point_id = '2857';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Default_Case_Reached.att.mnemonic = 'TLM8_FswExErrStatReg 3 (Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Default_Case_Reached.att.start_bit = '172';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Default_Case_Reached.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Default_Case_Reached.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Default_Case_Reached.att.description = 'FSW Exc. Error Status Reg. 3(Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_Default_Case_Reached.dim = {'hk8_packet'};

    % id 2858: TLM8_FswExErrStatReg 3 (MQ Rcv Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Rcv_Err.att.telemetry_point_id = '2858';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Rcv_Err.att.mnemonic = 'TLM8_FswExErrStatReg 3 (MQ Rcv Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Rcv_Err.att.start_bit = '173';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Rcv_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Rcv_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Rcv_Err.att.description = 'FSW Exc. Error Status Reg. 3(Message Queue Receive Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Rcv_Err.dim = {'hk8_packet'};

    % id 2859: TLM8_FswExErrStatReg 3 (MQ Snd Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Snd_Err.att.telemetry_point_id = '2859';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Snd_Err.att.mnemonic = 'TLM8_FswExErrStatReg 3 (MQ Snd Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Snd_Err.att.start_bit = '174';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Snd_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Snd_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Snd_Err.att.description = 'FSW Exc. Error Status Reg. 3(Message Queue Send Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_MQ_Snd_Err.dim = {'hk8_packet'};

    % id 2860: TLM8_FswExErrStatReg 3 (OS Func Call Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_OS_Func_Call_Err.att.telemetry_point_id = '2860';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_OS_Func_Call_Err.att.mnemonic = 'TLM8_FswExErrStatReg 3 (OS Func Call Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_OS_Func_Call_Err.att.start_bit = '175';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_OS_Func_Call_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_OS_Func_Call_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_OS_Func_Call_Err.att.description = 'FSW Exc. Error Status Reg. 3(Operating System Function Call Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_3_OS_Func_Call_Err.dim = {'hk8_packet'};

    % id 2861: TLM8_FswExErrStatReg 4 (Spare)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Spare.att.telemetry_point_id = '2861';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Spare.att.mnemonic = 'TLM8_FswExErrStatReg 4 (Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Spare.att.start_bit = '176';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Spare.att.description = 'FSW Exc. Error Status Reg. 4(Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Spare.dim = {'hk8_packet'};

    % id 16176: TLM8_FswExErrStatReg 4 (Porchswing Current Monitoring Threshold Trip Status)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Threshold_Trip_.att.telemetry_point_id = '16176';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Threshold_Trip_.att.mnemonic = 'TLM8_FswExErrStatReg 4 (Porchswing Current Monitoring Threshold Trip Status)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Threshold_Trip_.att.start_bit = '178';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Threshold_Trip_.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Threshold_Trip_.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Threshold_Trip_.att.description = 'FSW Exc. Error Status Reg. 4(Porchswing Current Monitoring Threshold Trip Status';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Threshold_Trip_.dim = {'hk8_packet'};

    % id 16177: TLM8_FswExErrStatReg 4 (Porchswing MPD Monitoring Threshold Trip Status)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Threshold_Trip_Stat.att.telemetry_point_id = '16177';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Threshold_Trip_Stat.att.mnemonic = 'TLM8_FswExErrStatReg 4 (Porchswing MPD Monitoring Threshold Trip Status)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Threshold_Trip_Stat.att.start_bit = '179';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Threshold_Trip_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Threshold_Trip_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Threshold_Trip_Stat.att.description = 'FSW Exc. Error Status Reg. 4(Porchswing MPD Monitoring Threshold Trip Status)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Threshold_Trip_Stat.dim = {'hk8_packet'};

    % id 16178: TLM8_FswExErrStatReg 4 (Porchswing Current Monitoring Control)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Control.att.telemetry_point_id = '16178';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Control.att.mnemonic = 'TLM8_FswExErrStatReg 4 (Porchswing Current Monitoring Control)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Control.att.start_bit = '180';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Control.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Control.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Control.att.description = 'FSW Exc. Error Status Reg. 4(Porchswing Current Monitoring Control)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Control.dim = {'hk8_packet'};

    % id 16179: TLM8_FswExErrStatReg 4 (Porchswing MPD Monitoring Control)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Control.att.telemetry_point_id = '16179';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Control.att.mnemonic = 'TLM8_FswExErrStatReg 4 (Porchswing MPD Monitoring Control)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Control.att.start_bit = '181';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Control.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Control.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Control.att.description = 'FSW Exc. Error Status Reg. 4(Porchswing MPD Monitoring Control)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Control.dim = {'hk8_packet'};

    % id 2862: TLM8_FswExErrStatReg 4 (SCC write error)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SCC_write_error.att.telemetry_point_id = '2862';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SCC_write_error.att.mnemonic = 'TLM8_FswExErrStatReg 4 (SCC write error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SCC_write_error.att.start_bit = '182';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SCC_write_error.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SCC_write_error.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SCC_write_error.att.description = 'FSW Exc. Error Status Reg. 4(Serial Comm Controller Write Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SCC_write_error.dim = {'hk8_packet'};

    % id 2863: TLM8_FswExErrStatReg 4 (SW Upload Succ)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Succ.att.telemetry_point_id = '2863';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Succ.att.mnemonic = 'TLM8_FswExErrStatReg 4 (SW Upload Succ)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Succ.att.start_bit = '183';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Succ.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Succ.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Succ.att.description = 'FSW Exc. Error Status Reg. 4(Software Upload Successful)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Succ.dim = {'hk8_packet'};

    % id 2864: TLM8_FswExErrStatReg 4 (Msg Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Msg_Err.att.telemetry_point_id = '2864';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Msg_Err.att.mnemonic = 'TLM8_FswExErrStatReg 4 (Msg Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Msg_Err.att.start_bit = '184';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Msg_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Msg_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Msg_Err.att.description = 'FSW Exc. Error Status Reg. 4(Message Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Msg_Err.dim = {'hk8_packet'};

    % id 2865: TLM8_FswExErrStatReg 4 (Reserved)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Reserved.att.telemetry_point_id = '2865';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Reserved.att.mnemonic = 'TLM8_FswExErrStatReg 4 (Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Reserved.att.start_bit = '185';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Reserved.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Reserved.att.description = 'FSW Exc. Error Status Reg. 4(Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Reserved.dim = {'hk8_packet'};

    % id 2866: TLM8_FswExErrStatReg 4 (Wrong Sz Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Wrong_Sz_Err.att.telemetry_point_id = '2866';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Wrong_Sz_Err.att.mnemonic = 'TLM8_FswExErrStatReg 4 (Wrong Sz Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Wrong_Sz_Err.att.start_bit = '186';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Wrong_Sz_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Wrong_Sz_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Wrong_Sz_Err.att.description = 'FSW Exc. Error Status Reg. 4(Wrong Size Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Wrong_Sz_Err.dim = {'hk8_packet'};

    % id 2867: TLM8_FswExErrStatReg 4 (IM Cmd Queue OVR Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_IM_Cmd_Queue_OVR_Err.att.telemetry_point_id = '2867';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_IM_Cmd_Queue_OVR_Err.att.mnemonic = 'TLM8_FswExErrStatReg 4 (IM Cmd Queue OVR Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_IM_Cmd_Queue_OVR_Err.att.start_bit = '187';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_IM_Cmd_Queue_OVR_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_IM_Cmd_Queue_OVR_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_IM_Cmd_Queue_OVR_Err.att.description = 'FSW Exc. Error Status Reg. 4(IFM Cmd Queue Overrun Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_IM_Cmd_Queue_OVR_Err.dim = {'hk8_packet'};

    % id 2868: TLM8_FswExErrStatReg 4 (Default Case Reached)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Default_Case_Reached.att.telemetry_point_id = '2868';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Default_Case_Reached.att.mnemonic = 'TLM8_FswExErrStatReg 4 (Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Default_Case_Reached.att.start_bit = '188';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Default_Case_Reached.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Default_Case_Reached.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Default_Case_Reached.att.description = 'FSW Exc. Error Status Reg. 4(Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_Default_Case_Reached.dim = {'hk8_packet'};

    % id 2869: TLM8_FswExErrStatReg 4 (MQ Rcv Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_MQ_Rcv_Err.att.telemetry_point_id = '2869';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_MQ_Rcv_Err.att.mnemonic = 'TLM8_FswExErrStatReg 4 (MQ Rcv Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_MQ_Rcv_Err.att.start_bit = '189';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_MQ_Rcv_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_MQ_Rcv_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_MQ_Rcv_Err.att.description = 'FSW Exc. Error Status Reg. 4(Message Queue Receive Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_MQ_Rcv_Err.dim = {'hk8_packet'};

    % id 2870: TLM8_FswExErrStatReg 4 (OS Func Call Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_OS_Func_Call_Err.att.telemetry_point_id = '2870';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_OS_Func_Call_Err.att.mnemonic = 'TLM8_FswExErrStatReg 4 (OS Func Call Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_OS_Func_Call_Err.att.start_bit = '190';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_OS_Func_Call_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_OS_Func_Call_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_OS_Func_Call_Err.att.description = 'FSW Exc. Error Status Reg. 4(Operating System Function Call Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_OS_Func_Call_Err.dim = {'hk8_packet'};

    % id 2871: TLM8_FswExErrStatReg 4 (SW Upload Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Err.att.telemetry_point_id = '2871';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Err.att.mnemonic = 'TLM8_FswExErrStatReg 4 (SW Upload Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Err.att.start_bit = '191';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Err.att.description = 'FSW Exc. Error Status Reg. 4(Software Upload Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Err.dim = {'hk8_packet'};

    % id 2872: TLM8_FswExErrStatReg 5 (Spare)
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Spare.att.telemetry_point_id = '2872';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Spare.att.mnemonic = 'TLM8_FswExErrStatReg 5 (Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Spare.att.start_bit = '192';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Spare.att.num_bits = '6';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Spare.att.description = 'FSW Exc. Error Status Reg. 5(Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Spare.dim = {'hk8_packet'};

    % id 15904: TLM8_FswExErrStatReg 5 (TaskIdForWatchdogFailure)
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_TaskIdForWatchdogFailure.att.telemetry_point_id = '15904';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_TaskIdForWatchdogFailure.att.mnemonic = 'TLM8_FswExErrStatReg 5 (TaskIdForWatchdogFailure)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_TaskIdForWatchdogFailure.att.start_bit = '198';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_TaskIdForWatchdogFailure.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_TaskIdForWatchdogFailure.att.num_bits = '5';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_TaskIdForWatchdogFailure.att.description = 'FSW Exc. Error Status Reg. 5(TaskIdForWatchdogFailure)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_TaskIdForWatchdogFailure.dim = {'hk8_packet'};

    % id 2873: TLM8_FswExErrStatReg 5 (Free Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Free_Err.att.telemetry_point_id = '2873';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Free_Err.att.mnemonic = 'TLM8_FswExErrStatReg 5 (Free Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Free_Err.att.start_bit = '203';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Free_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Free_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Free_Err.att.description = 'FSW Exc. Error Status Reg. 5(Free Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Free_Err.dim = {'hk8_packet'};

    % id 2874: TLM8_FswExErrStatReg 5 (Malloc Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Malloc_Err.att.telemetry_point_id = '2874';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Malloc_Err.att.mnemonic = 'TLM8_FswExErrStatReg 5 (Malloc Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Malloc_Err.att.start_bit = '204';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Malloc_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Malloc_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Malloc_Err.att.description = 'FSW Exc. Error Status Reg. 5(Malloc Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Malloc_Err.dim = {'hk8_packet'};

    % id 2875: TLM8_FswExErrStatReg 5 (IM Cmd Par Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Cmd_Par_Err.att.telemetry_point_id = '2875';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Cmd_Par_Err.att.mnemonic = 'TLM8_FswExErrStatReg 5 (IM Cmd Par Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Cmd_Par_Err.att.start_bit = '205';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Cmd_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Cmd_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Cmd_Par_Err.att.description = 'FSW Exc. Error Status Reg. 5(IFM Cmd Parameters Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Cmd_Par_Err.dim = {'hk8_packet'};

    % id 2876: TLM8_FswExErrStatReg 5 (Cmd Reject Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Cmd_Reject_Err.att.telemetry_point_id = '2876';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Cmd_Reject_Err.att.mnemonic = 'TLM8_FswExErrStatReg 5 (Cmd Reject Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Cmd_Reject_Err.att.start_bit = '206';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Cmd_Reject_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Cmd_Reject_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Cmd_Reject_Err.att.description = 'FSW Exc. Error Status Reg. 5(Cmd Rejected Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_Cmd_Reject_Err.dim = {'hk8_packet'};

    % id 2877: TLM8_FswExErrStatReg 5 (IM Rpt Err in Tele)
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Rpt_Err_in_Tele.att.telemetry_point_id = '2877';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Rpt_Err_in_Tele.att.mnemonic = 'TLM8_FswExErrStatReg 5 (IM Rpt Err in Tele)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Rpt_Err_in_Tele.att.start_bit = '207';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Rpt_Err_in_Tele.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Rpt_Err_in_Tele.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Rpt_Err_in_Tele.att.description = 'FSW Exc. Error Status Reg. 5(IFM Reported Error in Tlm)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_5_IM_Rpt_Err_in_Tele.dim = {'hk8_packet'};

    % id 2878: TLM8_FswExErrStatReg 6 (Spare)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Spare.att.telemetry_point_id = '2878';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Spare.att.mnemonic = 'TLM8_FswExErrStatReg 6 (Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Spare.att.start_bit = '208';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Spare.att.num_bits = '3';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Spare.att.description = 'FSW Exc. Error Status Reg. 6(Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Spare.dim = {'hk8_packet'};

    % id 2879: TLM8_FswExErrStatReg 6 (Msg Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Msg_Err.att.telemetry_point_id = '2879';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Msg_Err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (Msg Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Msg_Err.att.start_bit = '211';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Msg_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Msg_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Msg_Err.att.description = 'FSW Exc. Error Status Reg. 6(Message Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Msg_Err.dim = {'hk8_packet'};

    % id 2880: TLM8_FswExErrStatReg 6 (OVR err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OVR_err.att.telemetry_point_id = '2880';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OVR_err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (OVR err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OVR_err.att.start_bit = '212';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OVR_err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OVR_err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OVR_err.att.description = 'FSW Exc. Error Status Reg. 6(Overrun Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OVR_err.dim = {'hk8_packet'};

    % id 2881: TLM8_FswExErrStatReg 6 (Parity Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Parity_Err.att.telemetry_point_id = '2881';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Parity_Err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (Parity Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Parity_Err.att.start_bit = '213';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Parity_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Parity_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Parity_Err.att.description = 'FSW Exc. Error Status Reg. 6(Parity Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Parity_Err.dim = {'hk8_packet'};

    % id 2882: TLM8_FswExErrStatReg 6 (Frame Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Frame_Err.att.telemetry_point_id = '2882';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Frame_Err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (Frame Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Frame_Err.att.start_bit = '214';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Frame_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Frame_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Frame_Err.att.description = 'FSW Exc. Error Status Reg. 6(Frame Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Frame_Err.dim = {'hk8_packet'};

    % id 2883: TLM8_FswExErrStatReg 6 (Wrong Sz Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Wrong_Sz_Err.att.telemetry_point_id = '2883';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Wrong_Sz_Err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (Wrong Sz Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Wrong_Sz_Err.att.start_bit = '215';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Wrong_Sz_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Wrong_Sz_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Wrong_Sz_Err.att.description = 'FSW Exc. Error Status Reg. 6(Wrong Size Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Wrong_Sz_Err.dim = {'hk8_packet'};

    % id 2884: TLM8_FswExErrStatReg 6 (EOF Not By Scc Reg Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_EOF_Not_By_Scc_Reg_Err.att.telemetry_point_id = '2884';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_EOF_Not_By_Scc_Reg_Err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (EOF Not By Scc Reg Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_EOF_Not_By_Scc_Reg_Err.att.start_bit = '216';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_EOF_Not_By_Scc_Reg_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_EOF_Not_By_Scc_Reg_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_EOF_Not_By_Scc_Reg_Err.att.description = 'FSW Exc. Error Status Reg. 6(EOF Not By Serial Comm Controller Reg. Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_EOF_Not_By_Scc_Reg_Err.dim = {'hk8_packet'};

    % id 2885: TLM8_FswExErrStatReg 6 (Queue OVR Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Queue_OVR_Err.att.telemetry_point_id = '2885';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Queue_OVR_Err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (Queue OVR Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Queue_OVR_Err.att.start_bit = '217';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Queue_OVR_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Queue_OVR_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Queue_OVR_Err.att.description = 'FSW Exc. Error Status Reg. 6(Queue Overrun Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Queue_OVR_Err.dim = {'hk8_packet'};

    % id 2886: TLM8_FswExErrStatReg 6 (SCC Write Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_SCC_Write_Err.att.telemetry_point_id = '2886';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_SCC_Write_Err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (SCC Write Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_SCC_Write_Err.att.start_bit = '218';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_SCC_Write_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_SCC_Write_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_SCC_Write_Err.att.description = 'FSW Exc. Error Status Reg. 6(Serial Comm Controller Write Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_SCC_Write_Err.dim = {'hk8_packet'};

    % id 2887: TLM8_FswExErrStatReg 6 (Trans to SSM Failed)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Trans_to_SSM_Failed.att.telemetry_point_id = '2887';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Trans_to_SSM_Failed.att.mnemonic = 'TLM8_FswExErrStatReg 6 (Trans to SSM Failed)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Trans_to_SSM_Failed.att.start_bit = '219';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Trans_to_SSM_Failed.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Trans_to_SSM_Failed.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Trans_to_SSM_Failed.att.description = 'FSW Exc. Error Status Reg. 6(Transmit to SSM Failed)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Trans_to_SSM_Failed.dim = {'hk8_packet'};

    % id 2888: TLM8_FswExErrStatReg 6 (Default Case Reached)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Default_Case_Reached.att.telemetry_point_id = '2888';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Default_Case_Reached.att.mnemonic = 'TLM8_FswExErrStatReg 6 (Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Default_Case_Reached.att.start_bit = '220';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Default_Case_Reached.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Default_Case_Reached.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Default_Case_Reached.att.description = 'FSW Exc. Error Status Reg. 6(Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_Default_Case_Reached.dim = {'hk8_packet'};

    % id 2889: TLM8_FswExErrStatReg 6 (MQ Rcv Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Rcv_Err.att.telemetry_point_id = '2889';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Rcv_Err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (MQ Rcv Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Rcv_Err.att.start_bit = '221';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Rcv_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Rcv_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Rcv_Err.att.description = 'FSW Exc. Error Status Reg. 6(Message Queue Receive Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Rcv_Err.dim = {'hk8_packet'};

    % id 2890: TLM8_FswExErrStatReg 6 (MQ Snd Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Snd_Err.att.telemetry_point_id = '2890';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Snd_Err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (MQ Snd Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Snd_Err.att.start_bit = '222';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Snd_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Snd_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Snd_Err.att.description = 'FSW Exc. Error Status Reg. 6(Message Queue Send Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_MQ_Snd_Err.dim = {'hk8_packet'};

    % id 2891: TLM8_FswExErrStatReg 6 (OS Func Call Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OS_Func_Call_Err.att.telemetry_point_id = '2891';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OS_Func_Call_Err.att.mnemonic = 'TLM8_FswExErrStatReg 6 (OS Func Call Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OS_Func_Call_Err.att.start_bit = '223';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OS_Func_Call_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OS_Func_Call_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OS_Func_Call_Err.att.description = 'FSW Exc. Error Status Reg. 6(Operating System Function Call Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg_6_OS_Func_Call_Err.dim = {'hk8_packet'};

    % id 2892: TLM8_FswExErrStatReg7 (SPare)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SPare.att.telemetry_point_id = '2892';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SPare.att.mnemonic = 'TLM8_FswExErrStatReg7 (SPare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SPare.att.start_bit = '224';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SPare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SPare.att.num_bits = '5';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SPare.att.description = 'FSW Exc. Error Status Reg. 7(Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SPare.dim = {'hk8_packet'};

    % id 2893: TLM8_FswExErrStatReg7 (SW Upload Success)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SW_Upload_Success.att.telemetry_point_id = '2893';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SW_Upload_Success.att.mnemonic = 'TLM8_FswExErrStatReg7 (SW Upload Success)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SW_Upload_Success.att.start_bit = '229';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SW_Upload_Success.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SW_Upload_Success.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SW_Upload_Success.att.description = 'FSW Exc. Error Status Reg. 7(Software Upload Successful)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SW_Upload_Success.dim = {'hk8_packet'};

    % id 2894: TLM8_FswExErrStatReg7 (Cmd Reject Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Cmd_Reject_Err.att.telemetry_point_id = '2894';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Cmd_Reject_Err.att.mnemonic = 'TLM8_FswExErrStatReg7 (Cmd Reject Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Cmd_Reject_Err.att.start_bit = '230';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Cmd_Reject_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Cmd_Reject_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Cmd_Reject_Err.att.description = 'FSW Exc. Error Status Reg. 7(Cmd Rejected Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Cmd_Reject_Err.dim = {'hk8_packet'};

    % id 2895: TLM8_FswExErrStatReg7 (SSM Malloc Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Malloc_Err.att.telemetry_point_id = '2895';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Malloc_Err.att.mnemonic = 'TLM8_FswExErrStatReg7 (SSM Malloc Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Malloc_Err.att.start_bit = '231';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Malloc_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Malloc_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Malloc_Err.att.description = 'FSW Exc. Error Status Reg. 7(SSM Malloc Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Malloc_Err.dim = {'hk8_packet'};

    % id 2896: TLM8_FswExErrStatReg7 (SSM UL Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_UL_Err.att.telemetry_point_id = '2896';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_UL_Err.att.mnemonic = 'TLM8_FswExErrStatReg7 (SSM UL Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_UL_Err.att.start_bit = '232';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_UL_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_UL_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_UL_Err.att.description = 'FSW Exc. Error Status Reg. 7(SSM Upload Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_UL_Err.dim = {'hk8_packet'};

    % id 2897: TLM8_FswExErrStatReg7 (SSM Cmd Par Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Cmd_Par_Err.att.telemetry_point_id = '2897';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Cmd_Par_Err.att.mnemonic = 'TLM8_FswExErrStatReg7 (SSM Cmd Par Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Cmd_Par_Err.att.start_bit = '233';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Cmd_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Cmd_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Cmd_Par_Err.att.description = 'FSW Exc. Error Status Reg. 7(SSM Cmd Parameter Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_SSM_Cmd_Par_Err.dim = {'hk8_packet'};

    % id 2898: TLM8_FswExErrStatReg7 (Written EEPROm CRC Badr)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Written_EEPROm_CRC_Badr.att.telemetry_point_id = '2898';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Written_EEPROm_CRC_Badr.att.mnemonic = 'TLM8_FswExErrStatReg7 (Written EEPROm CRC Badr)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Written_EEPROm_CRC_Badr.att.start_bit = '234';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Written_EEPROm_CRC_Badr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Written_EEPROm_CRC_Badr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Written_EEPROm_CRC_Badr.att.description = 'FSW Exc. Error Status Reg. 7(Written EEPROM CRC Bad)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Written_EEPROm_CRC_Badr.dim = {'hk8_packet'};

    % id 2899: TLM8_FswExErrStatReg7 (LVDS Missing Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_LVDS_Missing_Err.att.telemetry_point_id = '2899';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_LVDS_Missing_Err.att.mnemonic = 'TLM8_FswExErrStatReg7 (LVDS Missing Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_LVDS_Missing_Err.att.start_bit = '235';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_LVDS_Missing_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_LVDS_Missing_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_LVDS_Missing_Err.att.description = 'FSW Exc. Error Status Reg. 7(Low Voltage Differential Signal Header Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_LVDS_Missing_Err.dim = {'hk8_packet'};

    % id 2900: TLM8_FswExErrStatReg7 (STX Missing Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_STX_Missing_Err.att.telemetry_point_id = '2900';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_STX_Missing_Err.att.mnemonic = 'TLM8_FswExErrStatReg7 (STX Missing Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_STX_Missing_Err.att.start_bit = '236';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_STX_Missing_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_STX_Missing_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_STX_Missing_Err.att.description = 'FSW Exc. Error Status Reg. 7(Start Transmission Missing Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_STX_Missing_Err.dim = {'hk8_packet'};

    % id 2901: TLM8_FswExErrStatReg7 (ETX Missing Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_ETX_Missing_Err.att.telemetry_point_id = '2901';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_ETX_Missing_Err.att.mnemonic = 'TLM8_FswExErrStatReg7 (ETX Missing Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_ETX_Missing_Err.att.start_bit = '237';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_ETX_Missing_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_ETX_Missing_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_ETX_Missing_Err.att.description = 'FSW Exc. Error Status Reg. 7(End Transmission Missing Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_ETX_Missing_Err.dim = {'hk8_packet'};

    % id 2902: TLM8_FswExErrStatReg7 (Chksum Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Chksum_Err.att.telemetry_point_id = '2902';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Chksum_Err.att.mnemonic = 'TLM8_FswExErrStatReg7 (Chksum Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Chksum_Err.att.start_bit = '238';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Chksum_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Chksum_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Chksum_Err.att.description = 'FSW Exc. Error Status Reg. 7(Checksum Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Chksum_Err.dim = {'hk8_packet'};

    % id 2903: TLM8_FswExErrStatReg7 (Reported Err in Tele)
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Reported_Err_in_Tele.att.telemetry_point_id = '2903';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Reported_Err_in_Tele.att.mnemonic = 'TLM8_FswExErrStatReg7 (Reported Err in Tele)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Reported_Err_in_Tele.att.start_bit = '239';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Reported_Err_in_Tele.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Reported_Err_in_Tele.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Reported_Err_in_Tele.att.description = 'FSW Exc. Error Status Reg. 7(Reported Error in Tlm)';
    g_metadata.packets.instr_hk8.FswExErrStatReg7_Reported_Err_in_Tele.dim = {'hk8_packet'};

    % id 2904: TLM8_FswExErrStatReg8 (Spare)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Spare.att.telemetry_point_id = '2904';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Spare.att.mnemonic = 'TLM8_FswExErrStatReg8 (Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Spare.att.start_bit = '240';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Spare.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Spare.att.description = 'FSW Exc. Error Status Reg. 8(Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Spare.dim = {'hk8_packet'};

    % id 2905: TLM8_FswExErrStatReg8 (Pckt Dropped)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Pckt_Dropped.att.telemetry_point_id = '2905';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Pckt_Dropped.att.mnemonic = 'TLM8_FswExErrStatReg8 (Pckt Dropped)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Pckt_Dropped.att.start_bit = '241';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Pckt_Dropped.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Pckt_Dropped.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Pckt_Dropped.att.description = 'FSW Exc. Error Status Reg. 8(Packet Dropped)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Pckt_Dropped.dim = {'hk8_packet'};

    % id 2906: TLM8_FswExErrStatReg8 (Invld Par Len)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Par_Len.att.telemetry_point_id = '2906';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Par_Len.att.mnemonic = 'TLM8_FswExErrStatReg8 (Invld Par Len)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Par_Len.att.start_bit = '242';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Par_Len.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Par_Len.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Par_Len.att.description = 'FSW Exc. Error Status Reg. 8(Invalid Parameter Length)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Par_Len.dim = {'hk8_packet'};

    % id 2907: TLM8_FswExErrStatReg8 (Invld APID type)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID_type.att.telemetry_point_id = '2907';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID_type.att.mnemonic = 'TLM8_FswExErrStatReg8 (Invld APID type)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID_type.att.start_bit = '243';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID_type.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID_type.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID_type.att.description = 'FSW Exc. Error Status Reg. 8(Invalid APID type)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID_type.dim = {'hk8_packet'};

    % id 2908: TLM8_FswExErrStatReg8 (Invld Cmd Len)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_Len.att.telemetry_point_id = '2908';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_Len.att.mnemonic = 'TLM8_FswExErrStatReg8 (Invld Cmd Len)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_Len.att.start_bit = '244';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_Len.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_Len.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_Len.att.description = 'FSW Exc. Error Status Reg. 8(Invalid Cmd Length)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_Len.dim = {'hk8_packet'};

    % id 2909: TLM8_FswExErrStatReg8 (Invld CCSDS Len)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_CCSDS_Len.att.telemetry_point_id = '2909';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_CCSDS_Len.att.mnemonic = 'TLM8_FswExErrStatReg8 (Invld CCSDS Len)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_CCSDS_Len.att.start_bit = '245';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_CCSDS_Len.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_CCSDS_Len.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_CCSDS_Len.att.description = 'FSW Exc. Error Status Reg. 8(Invalid CCSDS Length)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_CCSDS_Len.dim = {'hk8_packet'};

    % id 2910: TLM8_FswExErrStatReg8 (Invld Seg Pckt Rcv)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Seg_Pckt_Rcv.att.telemetry_point_id = '2910';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Seg_Pckt_Rcv.att.mnemonic = 'TLM8_FswExErrStatReg8 (Invld Seg Pckt Rcv)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Seg_Pckt_Rcv.att.start_bit = '246';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Seg_Pckt_Rcv.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Seg_Pckt_Rcv.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Seg_Pckt_Rcv.att.description = 'FSW Exc. Error Status Reg. 8(Invalid Segmented Packet Received)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Seg_Pckt_Rcv.dim = {'hk8_packet'};

    % id 2911: TLM8_FswExErrStatReg8 (Invld APID)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID.att.telemetry_point_id = '2911';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID.att.mnemonic = 'TLM8_FswExErrStatReg8 (Invld APID)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID.att.start_bit = '247';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID.att.description = 'FSW Exc. Error Status Reg. 8(Invalid APID)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_APID.dim = {'hk8_packet'};

    % id 2912: TLM8_FswExErrStatReg8 (Invld Chksum)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Chksum.att.telemetry_point_id = '2912';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Chksum.att.mnemonic = 'TLM8_FswExErrStatReg8 (Invld Chksum)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Chksum.att.start_bit = '248';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Chksum.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Chksum.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Chksum.att.description = 'FSW Exc. Error Status Reg. 8(Invalid Checksum)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Chksum.dim = {'hk8_packet'};

    % id 2913: TLM8_FswExErrStatReg8 (Invld Cmd ID)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_ID.att.telemetry_point_id = '2913';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_ID.att.mnemonic = 'TLM8_FswExErrStatReg8 (Invld Cmd ID)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_ID.att.start_bit = '249';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_ID.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_ID.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_ID.att.description = 'FSW Exc. Error Status Reg. 8(Invalid Cmd ID)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_ID.dim = {'hk8_packet'};

    % id 2914: TLM8_FswExErrStatReg8 (Default Case Reached)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Default_Case_Reached.att.telemetry_point_id = '2914';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Default_Case_Reached.att.mnemonic = 'TLM8_FswExErrStatReg8 (Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Default_Case_Reached.att.start_bit = '250';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Default_Case_Reached.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Default_Case_Reached.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Default_Case_Reached.att.description = 'FSW Exc. Error Status Reg. 8(Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Default_Case_Reached.dim = {'hk8_packet'};

    % id 2915: TLM8_FswExErrStatReg8 (MQ Rcv Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Rcv_Err.att.telemetry_point_id = '2915';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Rcv_Err.att.mnemonic = 'TLM8_FswExErrStatReg8 (MQ Rcv Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Rcv_Err.att.start_bit = '251';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Rcv_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Rcv_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Rcv_Err.att.description = 'FSW Exc. Error Status Reg. 8(Message Queue Receive Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Rcv_Err.dim = {'hk8_packet'};

    % id 2916: TLM8_FswExErrStatReg8 (MQ Snd Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Snd_Err.att.telemetry_point_id = '2916';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Snd_Err.att.mnemonic = 'TLM8_FswExErrStatReg8 (MQ Snd Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Snd_Err.att.start_bit = '252';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Snd_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Snd_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Snd_Err.att.description = 'FSW Exc. Error Status Reg. 8(Message Queue Send Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MQ_Snd_Err.dim = {'hk8_packet'};

    % id 2917: TLM8_FswExErrStatReg8 (Reserved)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Reserved.att.telemetry_point_id = '2917';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Reserved.att.mnemonic = 'TLM8_FswExErrStatReg8 (Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Reserved.att.start_bit = '253';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Reserved.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Reserved.att.description = 'FSW Exc. Error Status Reg. 8(Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_Reserved.dim = {'hk8_packet'};

    % id 2918: TLM8_FswExErrStatReg8 (MM Alloc Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MM_Alloc_Err.att.telemetry_point_id = '2918';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MM_Alloc_Err.att.mnemonic = 'TLM8_FswExErrStatReg8 (MM Alloc Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MM_Alloc_Err.att.start_bit = '254';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MM_Alloc_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MM_Alloc_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MM_Alloc_Err.att.description = 'FSW Exc. Error Status Reg. 8(Memory Manager Allocation Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_MM_Alloc_Err.dim = {'hk8_packet'};

    % id 2919: TLM8_FswExErrStatReg8 (OS Func Call Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg8_OS_Func_Call_Err.att.telemetry_point_id = '2919';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_OS_Func_Call_Err.att.mnemonic = 'TLM8_FswExErrStatReg8 (OS Func Call Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_OS_Func_Call_Err.att.start_bit = '255';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_OS_Func_Call_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_OS_Func_Call_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_OS_Func_Call_Err.att.description = 'FSW Exc. Error Status Reg. 8(Operating System Function Call Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg8_OS_Func_Call_Err.dim = {'hk8_packet'};

    % id 2920: TLM8_FswExErrStatReg9 (PCI Init Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_PCI_Init_Err.att.telemetry_point_id = '2920';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_PCI_Init_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (PCI Init Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_PCI_Init_Err.att.start_bit = '256';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_PCI_Init_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_PCI_Init_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_PCI_Init_Err.att.description = 'FSW Exc. Error Status Reg. 9(PCI Init Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_PCI_Init_Err.dim = {'hk8_packet'};

    % id 2921: TLM8_FswExErrStatReg9 (UnSupp Config)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_UnSupp_Config.att.telemetry_point_id = '2921';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_UnSupp_Config.att.mnemonic = 'TLM8_FswExErrStatReg9 (UnSupp Config)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_UnSupp_Config.att.start_bit = '257';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_UnSupp_Config.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_UnSupp_Config.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_UnSupp_Config.att.description = 'FSW Exc. Error Status Reg. 9(Unsupported Configuration)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_UnSupp_Config.dim = {'hk8_packet'};

    % id 2922: TLM8_FswExErrStatReg9 (Invld Diag Chan Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Diag_Chan_Err.att.telemetry_point_id = '2922';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Diag_Chan_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (Invld Diag Chan Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Diag_Chan_Err.att.start_bit = '258';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Diag_Chan_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Diag_Chan_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Diag_Chan_Err.att.description = 'FSW Exc. Error Status Reg. 9(Invalid Diag Chan. Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Diag_Chan_Err.dim = {'hk8_packet'};

    % id 2923: TLM8_FswExErrStatReg9 (Unsupp Sci Data Len/Bit Trim Tbl/Dec Rate Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.telemetry_point_id = '2923';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (Unsupp Sci Data Len/Bit Trim Tbl/Dec Rate Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.start_bit = '259';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.description = 'FSW Exc. Error Status Reg. 9(Unsupported Sci Data Len/Bit Trim Tbl/Dec Rate Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.dim = {'hk8_packet'};

    % id 2924: TLM8_FswExErrStatReg9 (No Term on Tele Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_No_Term_on_Tele_Err.att.telemetry_point_id = '2924';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_No_Term_on_Tele_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (No Term on Tele Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_No_Term_on_Tele_Err.att.start_bit = '260';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_No_Term_on_Tele_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_No_Term_on_Tele_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_No_Term_on_Tele_Err.att.description = 'FSW Exc. Error Status Reg. 9(No Termination On Tlm Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_No_Term_on_Tele_Err.dim = {'hk8_packet'};

    % id 2925: TLM8_FswExErrStatReg9 (Invld Tele ID Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Tele_ID_Err.att.telemetry_point_id = '2925';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Tele_ID_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (Invld Tele ID Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Tele_ID_Err.att.start_bit = '261';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Tele_ID_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Tele_ID_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Tele_ID_Err.att.description = 'FSW Exc. Error Status Reg. 9(Invalid Tlm ID Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Tele_ID_Err.dim = {'hk8_packet'};

    % id 2926: TLM8_FswExErrStatReg9 (Invld Coef Tbl ID Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Coef_Tbl_ID_Err.att.telemetry_point_id = '2926';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Coef_Tbl_ID_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (Invld Coef Tbl ID Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Coef_Tbl_ID_Err.att.start_bit = '262';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Coef_Tbl_ID_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Coef_Tbl_ID_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Coef_Tbl_ID_Err.att.description = 'FSW Exc. Error Status Reg. 9(Invalid Coefficient Table ID Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Coef_Tbl_ID_Err.dim = {'hk8_packet'};

    % id 2927: TLM8_FswExErrStatReg9 (Bit Trim Tbl Indx Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Bit_Trim_Tbl_Indx_Err.att.telemetry_point_id = '2927';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Bit_Trim_Tbl_Indx_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (Bit Trim Tbl Indx Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Bit_Trim_Tbl_Indx_Err.att.start_bit = '263';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Bit_Trim_Tbl_Indx_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Bit_Trim_Tbl_Indx_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Bit_Trim_Tbl_Indx_Err.att.description = 'FSW Exc. Error Status Reg. 9(Bit Trim Table Index Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Bit_Trim_Tbl_Indx_Err.dim = {'hk8_packet'};

    % id 2928: TLM8_FswExErrStatReg9 (Impulse Tbl Indx Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Impulse_Tbl_Indx_Err.att.telemetry_point_id = '2928';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Impulse_Tbl_Indx_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (Impulse Tbl Indx Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Impulse_Tbl_Indx_Err.att.start_bit = '264';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Impulse_Tbl_Indx_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Impulse_Tbl_Indx_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Impulse_Tbl_Indx_Err.att.description = 'FSW Exc. Error Status Reg. 9(Impulse Table Index Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Impulse_Tbl_Indx_Err.dim = {'hk8_packet'};

    % id 2929: TLM8_FswExErrStatReg9 (Invld Module ID)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Module_ID.att.telemetry_point_id = '2929';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Module_ID.att.mnemonic = 'TLM8_FswExErrStatReg9 (Invld Module ID)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Module_ID.att.start_bit = '265';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Module_ID.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Module_ID.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Module_ID.att.description = 'FSW Exc. Error Status Reg. 9(Invalid Module ID)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Invld_Module_ID.dim = {'hk8_packet'};

    % id 2930: TLM8_FswExErrStatReg9 (Config Data Ptr Null Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Config_Data_Ptr_Null_Err.att.telemetry_point_id = '2930';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Config_Data_Ptr_Null_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (Config Data Ptr Null Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Config_Data_Ptr_Null_Err.att.start_bit = '266';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Config_Data_Ptr_Null_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Config_Data_Ptr_Null_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Config_Data_Ptr_Null_Err.att.description = 'FSW Exc. Error Status Reg. 9(Configuration Data Pointer Null Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Config_Data_Ptr_Null_Err.dim = {'hk8_packet'};

    % id 2931: TLM8_FswExErrStatReg9 (Rcv Unknown ID-Default Case)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Rcv_Unknown_ID_Default_Case.att.telemetry_point_id = '2931';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Rcv_Unknown_ID_Default_Case.att.mnemonic = 'TLM8_FswExErrStatReg9 (Rcv Unknown ID-Default Case)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Rcv_Unknown_ID_Default_Case.att.start_bit = '267';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Rcv_Unknown_ID_Default_Case.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Rcv_Unknown_ID_Default_Case.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Rcv_Unknown_ID_Default_Case.att.description = 'FSW Exc. Error Status Reg. 9(Receive Unknown ID - Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Rcv_Unknown_ID_Default_Case.dim = {'hk8_packet'};

    % id 2932: TLM8_FswExErrStatReg9 (Trans Unknown ID-Default Case)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Trans_Unknown_ID_Default_Case.att.telemetry_point_id = '2932';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Trans_Unknown_ID_Default_Case.att.mnemonic = 'TLM8_FswExErrStatReg9 (Trans Unknown ID-Default Case)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Trans_Unknown_ID_Default_Case.att.start_bit = '268';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Trans_Unknown_ID_Default_Case.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Trans_Unknown_ID_Default_Case.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Trans_Unknown_ID_Default_Case.att.description = 'FSW Exc. Error Status Reg. 9(Transmit Unknown ID - Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_Trans_Unknown_ID_Default_Case.dim = {'hk8_packet'};

    % id 2933: TLM8_FswExErrStatReg9 (MQ Rcv Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Rcv_Err.att.telemetry_point_id = '2933';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Rcv_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (MQ Rcv Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Rcv_Err.att.start_bit = '269';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Rcv_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Rcv_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Rcv_Err.att.description = 'FSW Exc. Error Status Reg. 9(Message Queue Receive Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Rcv_Err.dim = {'hk8_packet'};

    % id 2934: TLM8_FswExErrStatReg9 (MQ Snd Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Snd_Err.att.telemetry_point_id = '2934';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Snd_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (MQ Snd Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Snd_Err.att.start_bit = '270';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Snd_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Snd_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Snd_Err.att.description = 'FSW Exc. Error Status Reg. 9(Message Queue Send Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_MQ_Snd_Err.dim = {'hk8_packet'};

    % id 2935: TLM8_FswExErrStatReg9 (OS Func Call Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg9_OS_Func_Call_Err.att.telemetry_point_id = '2935';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_OS_Func_Call_Err.att.mnemonic = 'TLM8_FswExErrStatReg9 (OS Func Call Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_OS_Func_Call_Err.att.start_bit = '271';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_OS_Func_Call_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_OS_Func_Call_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_OS_Func_Call_Err.att.description = 'FSW Exc. Error Status Reg. 9(Operating System Function Call Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg9_OS_Func_Call_Err.dim = {'hk8_packet'};

    % id 2937: TLM8_FswExErrStatReg10 (Taps I Coef MisMatch)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_I_Coef_MisMatch.att.telemetry_point_id = '2937';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_I_Coef_MisMatch.att.mnemonic = 'TLM8_FswExErrStatReg10 (Taps I Coef MisMatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_I_Coef_MisMatch.att.start_bit = '272';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_I_Coef_MisMatch.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_I_Coef_MisMatch.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_I_Coef_MisMatch.att.description = 'FSW Exc. Error Status Reg. 10(Taps I Coefficient Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_I_Coef_MisMatch.dim = {'hk8_packet'};

    % id 2936: TLM8_FswExErrStatReg10 (Taps Q Coef MisMatch)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_Q_Coef_MisMatch.att.telemetry_point_id = '2936';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_Q_Coef_MisMatch.att.mnemonic = 'TLM8_FswExErrStatReg10 (Taps Q Coef MisMatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_Q_Coef_MisMatch.att.start_bit = '273';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_Q_Coef_MisMatch.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_Q_Coef_MisMatch.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_Q_Coef_MisMatch.att.description = 'FSW Exc. Error Status Reg. 10(Taps Q Coefficient Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Taps_Q_Coef_MisMatch.dim = {'hk8_packet'};

    % id 2938: TLM8_FswExErrStatReg10 (Coef Dat Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Dat_Err.att.telemetry_point_id = '2938';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Dat_Err.att.mnemonic = 'TLM8_FswExErrStatReg10 (Coef Dat Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Dat_Err.att.start_bit = '274';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Dat_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Dat_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Dat_Err.att.description = 'FSW Exc. Error Status Reg. 10(Coefficient Data Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Dat_Err.dim = {'hk8_packet'};

    % id 2939: TLM8_FswExErrStatReg10 (Config Dat Err - 4 min)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_4_min.att.telemetry_point_id = '2939';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_4_min.att.mnemonic = 'TLM8_FswExErrStatReg10 (Config Dat Err - 4 min)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_4_min.att.start_bit = '275';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_4_min.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_4_min.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_4_min.att.description = 'FSW Exc. Error Status Reg. 10(Configuration Data Error - 4 Minute)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_4_min.dim = {'hk8_packet'};

    % id 2940: TLM8_FswExErrStatReg10 (Config Dat Err - 8 sec)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_8_sec.att.telemetry_point_id = '2940';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_8_sec.att.mnemonic = 'TLM8_FswExErrStatReg10 (Config Dat Err - 8 sec)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_8_sec.att.start_bit = '276';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_8_sec.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_8_sec.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_8_sec.att.description = 'FSW Exc. Error Status Reg. 10(Configuration Data Error - 8 Second)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_8_sec.dim = {'hk8_packet'};

    % id 2941: TLM8_FswExErrStatReg10 (Persistant Tbl Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Persistant_Tbl_Err.att.telemetry_point_id = '2941';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Persistant_Tbl_Err.att.mnemonic = 'TLM8_FswExErrStatReg10 (Persistant Tbl Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Persistant_Tbl_Err.att.start_bit = '277';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Persistant_Tbl_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Persistant_Tbl_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Persistant_Tbl_Err.att.description = 'FSW Exc. Error Status Reg. 10(Persistent Table Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Persistant_Tbl_Err.dim = {'hk8_packet'};

    % id 2942: TLM8_FswExErrStatReg10 (Setup Data Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Setup_Data_Err.att.telemetry_point_id = '2942';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Setup_Data_Err.att.mnemonic = 'TLM8_FswExErrStatReg10 (Setup Data Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Setup_Data_Err.att.start_bit = '278';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Setup_Data_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Setup_Data_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Setup_Data_Err.att.description = 'FSW Exc. Error Status Reg. 10(Setup Data Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Setup_Data_Err.dim = {'hk8_packet'};

    % id 2943: TLM8_FswExErrStatReg10 (Invld Num Coef Entries)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Invld_Num_Coef_Entries.att.telemetry_point_id = '2943';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Invld_Num_Coef_Entries.att.mnemonic = 'TLM8_FswExErrStatReg10 (Invld Num Coef Entries)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Invld_Num_Coef_Entries.att.start_bit = '279';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Invld_Num_Coef_Entries.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Invld_Num_Coef_Entries.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Invld_Num_Coef_Entries.att.description = 'FSW Exc. Error Status Reg. 10(Invalid Number of Coefficient Entries)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Invld_Num_Coef_Entries.dim = {'hk8_packet'};

    % id 2944: TLM8_FswExErrStatReg10 (Filter Offset Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Filter_Offset_Err.att.telemetry_point_id = '2944';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Filter_Offset_Err.att.mnemonic = 'TLM8_FswExErrStatReg10 (Filter Offset Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Filter_Offset_Err.att.start_bit = '280';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Filter_Offset_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Filter_Offset_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Filter_Offset_Err.att.description = 'FSW Exc. Error Status Reg. 10(Filter Offset Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Filter_Offset_Err.dim = {'hk8_packet'};

    % id 2945: TLM8_FswExErrStatReg10 (Run Samples > Total Samples)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Run_Samples_Total_Samples.att.telemetry_point_id = '2945';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Run_Samples_Total_Samples.att.mnemonic = 'TLM8_FswExErrStatReg10 (Run Samples > Total Samples)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Run_Samples_Total_Samples.att.start_bit = '281';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Run_Samples_Total_Samples.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Run_Samples_Total_Samples.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Run_Samples_Total_Samples.att.description = 'FSW Exc. Error Status Reg. 10(Run Samples > Total Samples)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Run_Samples_Total_Samples.dim = {'hk8_packet'};

    % id 2946: TLM8_FswExErrStatReg10 (Bit Trim Tbl Start/Stop Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Bit_Trim_Tbl_Start_Stop_Err.att.telemetry_point_id = '2946';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Bit_Trim_Tbl_Start_Stop_Err.att.mnemonic = 'TLM8_FswExErrStatReg10 (Bit Trim Tbl Start/Stop Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Bit_Trim_Tbl_Start_Stop_Err.att.start_bit = '282';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Bit_Trim_Tbl_Start_Stop_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Bit_Trim_Tbl_Start_Stop_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Bit_Trim_Tbl_Start_Stop_Err.att.description = 'FSW Exc. Error Status Reg. 10(Bit Trim Table Start/Stop Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Bit_Trim_Tbl_Start_Stop_Err.dim = {'hk8_packet'};

    % id 2947: TLM8_FswExErrStatReg10 (Coef Mismatch)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Mismatch.att.telemetry_point_id = '2947';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Mismatch.att.mnemonic = 'TLM8_FswExErrStatReg10 (Coef Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Mismatch.att.start_bit = '283';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Mismatch.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Mismatch.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Mismatch.att.description = 'FSW Exc. Error Status Reg. 10(Coefficient Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Coef_Mismatch.dim = {'hk8_packet'};

    % id 2948: TLM8_FswExErrStatReg10 (Mem Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Mem_Err.att.telemetry_point_id = '2948';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Mem_Err.att.mnemonic = 'TLM8_FswExErrStatReg10 (Mem Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Mem_Err.att.start_bit = '284';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Mem_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Mem_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Mem_Err.att.description = 'FSW Exc. Error Status Reg. 10(Memory Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Mem_Err.dim = {'hk8_packet'};

    % id 2949: TLM8_FswExErrStatReg10 (PCI Retry Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_PCI_Retry_Err.att.telemetry_point_id = '2949';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_PCI_Retry_Err.att.mnemonic = 'TLM8_FswExErrStatReg10 (PCI Retry Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_PCI_Retry_Err.att.start_bit = '285';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_PCI_Retry_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_PCI_Retry_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_PCI_Retry_Err.att.description = 'FSW Exc. Error Status Reg. 10(PCI Retry Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_PCI_Retry_Err.dim = {'hk8_packet'};

    % id 2950: TLM8_FswExErrStatReg10 (Sig Proc in Rst)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Sig_Proc_in_Rst.att.telemetry_point_id = '2950';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Sig_Proc_in_Rst.att.mnemonic = 'TLM8_FswExErrStatReg10 (Sig Proc in Rst)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Sig_Proc_in_Rst.att.start_bit = '286';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Sig_Proc_in_Rst.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Sig_Proc_in_Rst.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Sig_Proc_in_Rst.att.description = 'FSW Exc. Error Status Reg. 10(Signal Processor Is In Reset)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_Sig_Proc_in_Rst.dim = {'hk8_packet'};

    % id 2951: TLM8_FswExErrStatReg10 (SSM Scn Pos Missing Err/Invld)
    g_metadata.packets.instr_hk8.FswExErrStatReg10_SSM_Scn_Pos_Missing_Err_Invld.att.telemetry_point_id = '2951';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_SSM_Scn_Pos_Missing_Err_Invld.att.mnemonic = 'TLM8_FswExErrStatReg10 (SSM Scn Pos Missing Err/Invld)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_SSM_Scn_Pos_Missing_Err_Invld.att.start_bit = '287';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_SSM_Scn_Pos_Missing_Err_Invld.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_SSM_Scn_Pos_Missing_Err_Invld.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_SSM_Scn_Pos_Missing_Err_Invld.att.description = 'FSW Exc. Error Status Reg. 10(SSM Scan Position Missing Error or Invalid)';
    g_metadata.packets.instr_hk8.FswExErrStatReg10_SSM_Scn_Pos_Missing_Err_Invld.dim = {'hk8_packet'};

    % id 2952: TLM8_FswExErrStatReg11 (Wake Up Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Wake_Up_Err.att.telemetry_point_id = '2952';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Wake_Up_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (Wake Up Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Wake_Up_Err.att.start_bit = '288';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Wake_Up_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Wake_Up_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Wake_Up_Err.att.description = 'FSW Exc. Error Status Reg. 11(Wake Up Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Wake_Up_Err.dim = {'hk8_packet'};

    % id 2953: TLM8_FswExErrStatReg11 (DMA Addr Write Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_DMA_Addr_Write_Err.att.telemetry_point_id = '2953';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_DMA_Addr_Write_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (DMA Addr Write Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_DMA_Addr_Write_Err.att.start_bit = '289';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_DMA_Addr_Write_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_DMA_Addr_Write_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_DMA_Addr_Write_Err.att.description = 'FSW Exc. Error Status Reg. 11(DMA Address Write Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_DMA_Addr_Write_Err.dim = {'hk8_packet'};

    % id 2954: TLM8_FswExErrStatReg11 (Mem dmp Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Mem_dmp_Err.att.telemetry_point_id = '2954';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Mem_dmp_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (Mem dmp Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Mem_dmp_Err.att.start_bit = '290';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Mem_dmp_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Mem_dmp_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Mem_dmp_Err.att.description = 'FSW Exc. Error Status Reg. 11(Memory Dump Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Mem_dmp_Err.dim = {'hk8_packet'};

    % id 2955: TLM8_FswExErrStatReg11 (LRD Num FOVs ERR)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Num_FOVs_ERR.att.telemetry_point_id = '2955';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Num_FOVs_ERR.att.mnemonic = 'TLM8_FswExErrStatReg11 (LRD Num FOVs ERR)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Num_FOVs_ERR.att.start_bit = '291';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Num_FOVs_ERR.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Num_FOVs_ERR.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Num_FOVs_ERR.att.description = 'FSW Exc. Error Status Reg. 11(Low Rate Data Number of FOVs Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Num_FOVs_ERR.dim = {'hk8_packet'};

    % id 2956: TLM8_FswExErrStatReg11 (LRD FOV Val Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Val_Err.att.telemetry_point_id = '2956';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Val_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (LRD FOV Val Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Val_Err.att.start_bit = '292';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Val_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Val_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Val_Err.att.description = 'FSW Exc. Error Status Reg. 11(Low Rate Data FOV Value Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Val_Err.dim = {'hk8_packet'};

    % id 2957: TLM8_FswExErrStatReg11 (LRD Mode Sel Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Mode_Sel_Err.att.telemetry_point_id = '2957';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Mode_Sel_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (LRD Mode Sel Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Mode_Sel_Err.att.start_bit = '293';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Mode_Sel_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Mode_Sel_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Mode_Sel_Err.att.description = 'FSW Exc. Error Status Reg. 11(Low Rate Data Mode Select Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_Mode_Sel_Err.dim = {'hk8_packet'};

    % id 2958: TLM8_FswExErrStatReg11 (LRD FOV Repeat Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Repeat_Err.att.telemetry_point_id = '2958';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Repeat_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (LRD FOV Repeat Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Repeat_Err.att.start_bit = '294';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Repeat_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Repeat_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Repeat_Err.att.description = 'FSW Exc. Error Status Reg. 11(Low Rate Data FOV Repeated Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Repeat_Err.dim = {'hk8_packet'};

    % id 2959: TLM8_FswExErrStatReg11 (Filt Dec Sample Cnt Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Filt_Dec_Sample_Cnt_Err.att.telemetry_point_id = '2959';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Filt_Dec_Sample_Cnt_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (Filt Dec Sample Cnt Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Filt_Dec_Sample_Cnt_Err.att.start_bit = '295';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Filt_Dec_Sample_Cnt_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Filt_Dec_Sample_Cnt_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Filt_Dec_Sample_Cnt_Err.att.description = 'FSW Exc. Error Status Reg. 11(Filtered Decimated Sample Count Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Filt_Dec_Sample_Cnt_Err.dim = {'hk8_packet'};

    % id 2960: TLM8_FswExErrStatReg11 (FOR Upset Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_FOR_Upset_Err.att.telemetry_point_id = '2960';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_FOR_Upset_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (FOR Upset Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_FOR_Upset_Err.att.start_bit = '296';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_FOR_Upset_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_FOR_Upset_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_FOR_Upset_Err.att.description = 'FSW Exc. Error Status Reg. 11(Field of Regard Upset Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_FOR_Upset_Err.dim = {'hk8_packet'};

    % id 2961: TLM8_FswExErrStatReg11 (SEFI Upset Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_SEFI_Upset_Err.att.telemetry_point_id = '2961';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_SEFI_Upset_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (SEFI Upset Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_SEFI_Upset_Err.att.start_bit = '297';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_SEFI_Upset_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_SEFI_Upset_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_SEFI_Upset_Err.att.description = 'FSW Exc. Error Status Reg. 11(Single Event Function Interrupt Upset Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_SEFI_Upset_Err.dim = {'hk8_packet'};

    % id 2962: TLM8_FswExErrStatReg11 (PCI Retry Count Too Big Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Retry_Count_Too_Big_Err.att.telemetry_point_id = '2962';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Retry_Count_Too_Big_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (PCI Retry Count Too Big Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Retry_Count_Too_Big_Err.att.start_bit = '298';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Retry_Count_Too_Big_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Retry_Count_Too_Big_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Retry_Count_Too_Big_Err.att.description = 'FSW Exc. Error Status Reg. 11(PCI Retry Count Too Big Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Retry_Count_Too_Big_Err.dim = {'hk8_packet'};

    % id 2963: TLM8_FswExErrStatReg11 (PCI Config Read Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Config_Read_Err.att.telemetry_point_id = '2963';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Config_Read_Err.att.mnemonic = 'TLM8_FswExErrStatReg11 (PCI Config Read Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Config_Read_Err.att.start_bit = '299';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Config_Read_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Config_Read_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Config_Read_Err.att.description = 'FSW Exc. Error Status Reg. 11(PCI Configuration Read Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_PCI_Config_Read_Err.dim = {'hk8_packet'};

    % id 2964: TLM8_FswExErrStatReg11 (Device Not Found)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Device_Not_Found.att.telemetry_point_id = '2964';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Device_Not_Found.att.mnemonic = 'TLM8_FswExErrStatReg11 (Device Not Found)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Device_Not_Found.att.start_bit = '300';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Device_Not_Found.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Device_Not_Found.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Device_Not_Found.att.description = 'FSW Exc. Error Status Reg. 11(Device Not Found)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Device_Not_Found.dim = {'hk8_packet'};

    % id 2965: TLM8_FswExErrStatReg11 (Invalid Param)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Invalid_Param.att.telemetry_point_id = '2965';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Invalid_Param.att.mnemonic = 'TLM8_FswExErrStatReg11 (Invalid Param)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Invalid_Param.att.start_bit = '301';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Invalid_Param.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Invalid_Param.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Invalid_Param.att.description = 'FSW Exc. Error Status Reg. 11(Invalid Param)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Invalid_Param.dim = {'hk8_packet'};

    % id 2966: TLM8_FswExErrStatReg11 (Reserved)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Reserved.att.telemetry_point_id = '2966';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Reserved.att.mnemonic = 'TLM8_FswExErrStatReg11 (Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Reserved.att.start_bit = '302';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Reserved.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Reserved.att.description = 'FSW Exc. Error Status Reg. 11(Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Reserved.dim = {'hk8_packet'};

    % id 2967: TLM8_FswExErrStatReg11 (Spare2)
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Spare2.att.telemetry_point_id = '2967';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Spare2.att.mnemonic = 'TLM8_FswExErrStatReg11 (Spare2)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Spare2.att.start_bit = '303';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Spare2.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Spare2.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Spare2.att.description = 'FSW Exc. Error Status Reg. 11(Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg11_Spare2.dim = {'hk8_packet'};

    % id 2968: TLM8_FswExErrStatReg12 (PCI Init Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_PCI_Init_Err.att.telemetry_point_id = '2968';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_PCI_Init_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (PCI Init Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_PCI_Init_Err.att.start_bit = '304';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_PCI_Init_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_PCI_Init_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_PCI_Init_Err.att.description = 'FSW Exc. Error Status Reg. 12(PCI Init Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_PCI_Init_Err.dim = {'hk8_packet'};

    % id 2969: TLM8_FswExErrStatReg12 (Unsupp Config)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Config.att.telemetry_point_id = '2969';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Config.att.mnemonic = 'TLM8_FswExErrStatReg12 (Unsupp Config)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Config.att.start_bit = '305';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Config.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Config.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Config.att.description = 'FSW Exc. Error Status Reg. 12(Unsupported Configuration)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Config.dim = {'hk8_packet'};

    % id 2970: TLM8_FswExErrStatReg12 (Invld Diag Chan Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Diag_Chan_Err.att.telemetry_point_id = '2970';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Diag_Chan_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (Invld Diag Chan Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Diag_Chan_Err.att.start_bit = '306';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Diag_Chan_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Diag_Chan_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Diag_Chan_Err.att.description = 'FSW Exc. Error Status Reg. 12(Invalid Diag Chan. Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Diag_Chan_Err.dim = {'hk8_packet'};

    % id 2971: TLM8_FswExErrStatReg12 (Unsupp Sci Data Len/Bit Trim Tbl/Dec Rate Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.telemetry_point_id = '2971';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (Unsupp Sci Data Len/Bit Trim Tbl/Dec Rate Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.start_bit = '307';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.description = 'FSW Exc. Error Status Reg. 12(Unsupported Sci Data Len/Bit Trim Tbl/Dec Rate Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.dim = {'hk8_packet'};

    % id 2972: TLM8_FswExErrStatReg12 (No Term on Tele Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_No_Term_on_Tele_Err.att.telemetry_point_id = '2972';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_No_Term_on_Tele_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (No Term on Tele Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_No_Term_on_Tele_Err.att.start_bit = '308';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_No_Term_on_Tele_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_No_Term_on_Tele_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_No_Term_on_Tele_Err.att.description = 'FSW Exc. Error Status Reg. 12(No Termination On Tlm Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_No_Term_on_Tele_Err.dim = {'hk8_packet'};

    % id 2973: TLM8_FswExErrStatReg12 (Invld Tele ID Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Tele_ID_Err.att.telemetry_point_id = '2973';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Tele_ID_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (Invld Tele ID Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Tele_ID_Err.att.start_bit = '309';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Tele_ID_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Tele_ID_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Tele_ID_Err.att.description = 'FSW Exc. Error Status Reg. 12(Invalid Tlm ID Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Tele_ID_Err.dim = {'hk8_packet'};

    % id 2974: TLM8_FswExErrStatReg12 (Invld Coef Tbl ID Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Coef_Tbl_ID_Err.att.telemetry_point_id = '2974';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Coef_Tbl_ID_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (Invld Coef Tbl ID Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Coef_Tbl_ID_Err.att.start_bit = '310';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Coef_Tbl_ID_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Coef_Tbl_ID_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Coef_Tbl_ID_Err.att.description = 'FSW Exc. Error Status Reg. 12(Invalid Coefficient Table ID Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Coef_Tbl_ID_Err.dim = {'hk8_packet'};

    % id 2975: TLM8_FswExErrStatReg12 (Bit Trim Indx Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Bit_Trim_Indx_Err.att.telemetry_point_id = '2975';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Bit_Trim_Indx_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (Bit Trim Indx Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Bit_Trim_Indx_Err.att.start_bit = '311';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Bit_Trim_Indx_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Bit_Trim_Indx_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Bit_Trim_Indx_Err.att.description = 'FSW Exc. Error Status Reg. 12(Bit Trim Table Index Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Bit_Trim_Indx_Err.dim = {'hk8_packet'};

    % id 2976: TLM8_FswExErrStatReg12 (Impulse Tbl Index Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Impulse_Tbl_Index_Err.att.telemetry_point_id = '2976';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Impulse_Tbl_Index_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (Impulse Tbl Index Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Impulse_Tbl_Index_Err.att.start_bit = '312';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Impulse_Tbl_Index_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Impulse_Tbl_Index_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Impulse_Tbl_Index_Err.att.description = 'FSW Exc. Error Status Reg. 12(Impulse Table Index Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Impulse_Tbl_Index_Err.dim = {'hk8_packet'};

    % id 2977: TLM8_FswExErrStatReg12 (Invld Module ID)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Module_ID.att.telemetry_point_id = '2977';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Module_ID.att.mnemonic = 'TLM8_FswExErrStatReg12 (Invld Module ID)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Module_ID.att.start_bit = '313';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Module_ID.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Module_ID.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Module_ID.att.description = 'FSW Exc. Error Status Reg. 12(Invalid Module ID)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Invld_Module_ID.dim = {'hk8_packet'};

    % id 2978: TLM8_FswExErrStatReg12 (Config Data Ptr Null Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Config_Data_Ptr_Null_Err.att.telemetry_point_id = '2978';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Config_Data_Ptr_Null_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (Config Data Ptr Null Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Config_Data_Ptr_Null_Err.att.start_bit = '314';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Config_Data_Ptr_Null_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Config_Data_Ptr_Null_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Config_Data_Ptr_Null_Err.att.description = 'FSW Exc. Error Status Reg. 12(Configuration Data Pointer Null Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Config_Data_Ptr_Null_Err.dim = {'hk8_packet'};

    % id 2979: TLM8_FswExErrStatReg12 (Rcv Unknown ID-Deflt Case)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Rcv_Unknown_ID_Deflt_Case.att.telemetry_point_id = '2979';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Rcv_Unknown_ID_Deflt_Case.att.mnemonic = 'TLM8_FswExErrStatReg12 (Rcv Unknown ID-Deflt Case)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Rcv_Unknown_ID_Deflt_Case.att.start_bit = '315';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Rcv_Unknown_ID_Deflt_Case.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Rcv_Unknown_ID_Deflt_Case.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Rcv_Unknown_ID_Deflt_Case.att.description = 'FSW Exc. Error Status Reg. 12(Receive Unknown ID - Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Rcv_Unknown_ID_Deflt_Case.dim = {'hk8_packet'};

    % id 2980: TLM8_FswExErrStatReg12 (Trans Unknown ID-Deflt Case)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Trans_Unknown_ID_Deflt_Case.att.telemetry_point_id = '2980';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Trans_Unknown_ID_Deflt_Case.att.mnemonic = 'TLM8_FswExErrStatReg12 (Trans Unknown ID-Deflt Case)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Trans_Unknown_ID_Deflt_Case.att.start_bit = '316';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Trans_Unknown_ID_Deflt_Case.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Trans_Unknown_ID_Deflt_Case.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Trans_Unknown_ID_Deflt_Case.att.description = 'FSW Exc. Error Status Reg. 12(Transmit Unknown ID - Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_Trans_Unknown_ID_Deflt_Case.dim = {'hk8_packet'};

    % id 2981: TLM8_FswExErrStatReg12 (MQ Rcv Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Rcv_Err.att.telemetry_point_id = '2981';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Rcv_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (MQ Rcv Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Rcv_Err.att.start_bit = '317';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Rcv_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Rcv_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Rcv_Err.att.description = 'FSW Exc. Error Status Reg. 12(Message Queue Receive Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Rcv_Err.dim = {'hk8_packet'};

    % id 2982: TLM8_FswExErrStatReg12 (MQ Snd Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Snd_Err.att.telemetry_point_id = '2982';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Snd_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (MQ Snd Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Snd_Err.att.start_bit = '318';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Snd_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Snd_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Snd_Err.att.description = 'FSW Exc. Error Status Reg. 12(Message Queue Send Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_MQ_Snd_Err.dim = {'hk8_packet'};

    % id 2983: TLM8_FswExErrStatReg12 (OS Func Call Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg12_OS_Func_Call_Err.att.telemetry_point_id = '2983';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_OS_Func_Call_Err.att.mnemonic = 'TLM8_FswExErrStatReg12 (OS Func Call Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_OS_Func_Call_Err.att.start_bit = '319';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_OS_Func_Call_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_OS_Func_Call_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_OS_Func_Call_Err.att.description = 'FSW Exc. Error Status Reg. 12(Operating System Function Call Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg12_OS_Func_Call_Err.dim = {'hk8_packet'};

    % id 2985: TLM8_FswExErrStatReg13 (Taps I Coef MisMatch)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_I_Coef_MisMatch.att.telemetry_point_id = '2985';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_I_Coef_MisMatch.att.mnemonic = 'TLM8_FswExErrStatReg13 (Taps I Coef MisMatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_I_Coef_MisMatch.att.start_bit = '320';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_I_Coef_MisMatch.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_I_Coef_MisMatch.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_I_Coef_MisMatch.att.description = 'FSW Exc. Error Status Reg. 13(Taps I Coefficient Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_I_Coef_MisMatch.dim = {'hk8_packet'};

    % id 2984: TLM8_FswExErrStatReg13 (Taps Q Coef MisMatch)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_Q_Coef_MisMatch.att.telemetry_point_id = '2984';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_Q_Coef_MisMatch.att.mnemonic = 'TLM8_FswExErrStatReg13 (Taps Q Coef MisMatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_Q_Coef_MisMatch.att.start_bit = '321';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_Q_Coef_MisMatch.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_Q_Coef_MisMatch.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_Q_Coef_MisMatch.att.description = 'FSW Exc. Error Status Reg. 13(Taps Q Coefficient Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Taps_Q_Coef_MisMatch.dim = {'hk8_packet'};

    % id 2986: TLM8_FswExErrStatReg13 (Coef Dat Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Dat_Err.att.telemetry_point_id = '2986';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Dat_Err.att.mnemonic = 'TLM8_FswExErrStatReg13 (Coef Dat Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Dat_Err.att.start_bit = '322';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Dat_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Dat_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Dat_Err.att.description = 'FSW Exc. Error Status Reg. 13(Coefficient Data Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Dat_Err.dim = {'hk8_packet'};

    % id 2987: TLM8_FswExErrStatReg13 (Config Dat Err - 4 min)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_4_min.att.telemetry_point_id = '2987';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_4_min.att.mnemonic = 'TLM8_FswExErrStatReg13 (Config Dat Err - 4 min)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_4_min.att.start_bit = '323';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_4_min.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_4_min.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_4_min.att.description = 'FSW Exc. Error Status Reg. 13(Configuration Data Error - 4 Minute)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_4_min.dim = {'hk8_packet'};

    % id 2988: TLM8_FswExErrStatReg13 (Config Dat Err - 8 sec)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_8_sec.att.telemetry_point_id = '2988';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_8_sec.att.mnemonic = 'TLM8_FswExErrStatReg13 (Config Dat Err - 8 sec)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_8_sec.att.start_bit = '324';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_8_sec.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_8_sec.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_8_sec.att.description = 'FSW Exc. Error Status Reg. 13(Configuration Data Error - 8 Second)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_8_sec.dim = {'hk8_packet'};

    % id 2989: TLM8_FswExErrStatReg13 (Persistant Tbl Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Persistant_Tbl_Err.att.telemetry_point_id = '2989';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Persistant_Tbl_Err.att.mnemonic = 'TLM8_FswExErrStatReg13 (Persistant Tbl Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Persistant_Tbl_Err.att.start_bit = '325';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Persistant_Tbl_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Persistant_Tbl_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Persistant_Tbl_Err.att.description = 'FSW Exc. Error Status Reg. 13(Persistent Table Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Persistant_Tbl_Err.dim = {'hk8_packet'};

    % id 2990: TLM8_FswExErrStatReg13 (Setup Data Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Setup_Data_Err.att.telemetry_point_id = '2990';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Setup_Data_Err.att.mnemonic = 'TLM8_FswExErrStatReg13 (Setup Data Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Setup_Data_Err.att.start_bit = '326';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Setup_Data_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Setup_Data_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Setup_Data_Err.att.description = 'FSW Exc. Error Status Reg. 13(Setup Data Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Setup_Data_Err.dim = {'hk8_packet'};

    % id 2991: TLM8_FswExErrStatReg13 (Invld Num Coef Entries)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Invld_Num_Coef_Entries.att.telemetry_point_id = '2991';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Invld_Num_Coef_Entries.att.mnemonic = 'TLM8_FswExErrStatReg13 (Invld Num Coef Entries)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Invld_Num_Coef_Entries.att.start_bit = '327';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Invld_Num_Coef_Entries.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Invld_Num_Coef_Entries.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Invld_Num_Coef_Entries.att.description = 'FSW Exc. Error Status Reg. 13(Invalid Number of Coefficient Entries)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Invld_Num_Coef_Entries.dim = {'hk8_packet'};

    % id 2992: TLM8_FswExErrStatReg13 (Filter Offset Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Filter_Offset_Err.att.telemetry_point_id = '2992';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Filter_Offset_Err.att.mnemonic = 'TLM8_FswExErrStatReg13 (Filter Offset Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Filter_Offset_Err.att.start_bit = '328';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Filter_Offset_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Filter_Offset_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Filter_Offset_Err.att.description = 'FSW Exc. Error Status Reg. 13(Filter Offset Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Filter_Offset_Err.dim = {'hk8_packet'};

    % id 2993: TLM8_FswExErrStatReg13 (Run Samples > Total Samples)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Run_Samples_Total_Samples.att.telemetry_point_id = '2993';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Run_Samples_Total_Samples.att.mnemonic = 'TLM8_FswExErrStatReg13 (Run Samples > Total Samples)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Run_Samples_Total_Samples.att.start_bit = '329';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Run_Samples_Total_Samples.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Run_Samples_Total_Samples.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Run_Samples_Total_Samples.att.description = 'FSW Exc. Error Status Reg. 13(Run Samples > Total Samples)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Run_Samples_Total_Samples.dim = {'hk8_packet'};

    % id 2994: TLM8_FswExErrStatReg13 (Bit Trim Tbl Start/Stop Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Bit_Trim_Tbl_Start_Stop_Err.att.telemetry_point_id = '2994';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Bit_Trim_Tbl_Start_Stop_Err.att.mnemonic = 'TLM8_FswExErrStatReg13 (Bit Trim Tbl Start/Stop Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Bit_Trim_Tbl_Start_Stop_Err.att.start_bit = '330';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Bit_Trim_Tbl_Start_Stop_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Bit_Trim_Tbl_Start_Stop_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Bit_Trim_Tbl_Start_Stop_Err.att.description = 'FSW Exc. Error Status Reg. 13(Bit Trim Table Start/Stop Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Bit_Trim_Tbl_Start_Stop_Err.dim = {'hk8_packet'};

    % id 2995: TLM8_FswExErrStatReg13 (Coef Mismatch)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Mismatch.att.telemetry_point_id = '2995';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Mismatch.att.mnemonic = 'TLM8_FswExErrStatReg13 (Coef Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Mismatch.att.start_bit = '331';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Mismatch.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Mismatch.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Mismatch.att.description = 'FSW Exc. Error Status Reg. 13(Coefficient Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Coef_Mismatch.dim = {'hk8_packet'};

    % id 2996: TLM8_FswExErrStatReg13 (Mem Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Mem_Err.att.telemetry_point_id = '2996';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Mem_Err.att.mnemonic = 'TLM8_FswExErrStatReg13 (Mem Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Mem_Err.att.start_bit = '332';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Mem_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Mem_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Mem_Err.att.description = 'FSW Exc. Error Status Reg. 13(Memory Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Mem_Err.dim = {'hk8_packet'};

    % id 2997: TLM8_FswExErrStatReg13 (PCI Retry Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_PCI_Retry_Err.att.telemetry_point_id = '2997';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_PCI_Retry_Err.att.mnemonic = 'TLM8_FswExErrStatReg13 (PCI Retry Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_PCI_Retry_Err.att.start_bit = '333';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_PCI_Retry_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_PCI_Retry_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_PCI_Retry_Err.att.description = 'FSW Exc. Error Status Reg. 13(PCI Retry Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_PCI_Retry_Err.dim = {'hk8_packet'};

    % id 2998: TLM8_FswExErrStatReg13 (Sig Proc in Rst)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Sig_Proc_in_Rst.att.telemetry_point_id = '2998';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Sig_Proc_in_Rst.att.mnemonic = 'TLM8_FswExErrStatReg13 (Sig Proc in Rst)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Sig_Proc_in_Rst.att.start_bit = '334';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Sig_Proc_in_Rst.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Sig_Proc_in_Rst.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Sig_Proc_in_Rst.att.description = 'FSW Exc. Error Status Reg. 13(Signal Processor Is In Reset)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_Sig_Proc_in_Rst.dim = {'hk8_packet'};

    % id 2999: TLM8_FswExErrStatReg13 (SSM Scn Pos Missing Err/Invld)
    g_metadata.packets.instr_hk8.FswExErrStatReg13_SSM_Scn_Pos_Missing_Err_Invld.att.telemetry_point_id = '2999';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_SSM_Scn_Pos_Missing_Err_Invld.att.mnemonic = 'TLM8_FswExErrStatReg13 (SSM Scn Pos Missing Err/Invld)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_SSM_Scn_Pos_Missing_Err_Invld.att.start_bit = '335';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_SSM_Scn_Pos_Missing_Err_Invld.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_SSM_Scn_Pos_Missing_Err_Invld.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_SSM_Scn_Pos_Missing_Err_Invld.att.description = 'FSW Exc. Error Status Reg. 13(SSM Scan Position Missing Error or Invalid)';
    g_metadata.packets.instr_hk8.FswExErrStatReg13_SSM_Scn_Pos_Missing_Err_Invld.dim = {'hk8_packet'};

    % id 3000: TLM8_FswExErrStatReg14 (Wake Up Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Wake_Up_Err.att.telemetry_point_id = '3000';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Wake_Up_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (Wake Up Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Wake_Up_Err.att.start_bit = '336';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Wake_Up_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Wake_Up_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Wake_Up_Err.att.description = 'FSW Exc. Error Status Reg. 14(Wake Up Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Wake_Up_Err.dim = {'hk8_packet'};

    % id 3001: TLM8_FswExErrStatReg14 (DMA Addr Write Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_DMA_Addr_Write_Err.att.telemetry_point_id = '3001';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_DMA_Addr_Write_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (DMA Addr Write Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_DMA_Addr_Write_Err.att.start_bit = '337';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_DMA_Addr_Write_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_DMA_Addr_Write_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_DMA_Addr_Write_Err.att.description = 'FSW Exc. Error Status Reg. 14(DMA Address Write Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_DMA_Addr_Write_Err.dim = {'hk8_packet'};

    % id 3002: TLM8_FswExErrStatReg14 (Mem dmp Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Mem_dmp_Err.att.telemetry_point_id = '3002';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Mem_dmp_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (Mem dmp Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Mem_dmp_Err.att.start_bit = '338';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Mem_dmp_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Mem_dmp_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Mem_dmp_Err.att.description = 'FSW Exc. Error Status Reg. 14(Memory Dump Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Mem_dmp_Err.dim = {'hk8_packet'};

    % id 3003: TLM8_FswExErrStatReg14 (LRD Num FOVs ERR)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Num_FOVs_ERR.att.telemetry_point_id = '3003';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Num_FOVs_ERR.att.mnemonic = 'TLM8_FswExErrStatReg14 (LRD Num FOVs ERR)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Num_FOVs_ERR.att.start_bit = '339';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Num_FOVs_ERR.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Num_FOVs_ERR.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Num_FOVs_ERR.att.description = 'FSW Exc. Error Status Reg. 14(Low Rate Data Number of FOVs Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Num_FOVs_ERR.dim = {'hk8_packet'};

    % id 3004: TLM8_FswExErrStatReg14 (LRD FOV Val Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Val_Err.att.telemetry_point_id = '3004';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Val_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (LRD FOV Val Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Val_Err.att.start_bit = '340';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Val_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Val_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Val_Err.att.description = 'FSW Exc. Error Status Reg. 14(Low Rate Data FOV Value Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Val_Err.dim = {'hk8_packet'};

    % id 3005: TLM8_FswExErrStatReg14 (LRD Mode Sel Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Mode_Sel_Err.att.telemetry_point_id = '3005';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Mode_Sel_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (LRD Mode Sel Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Mode_Sel_Err.att.start_bit = '341';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Mode_Sel_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Mode_Sel_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Mode_Sel_Err.att.description = 'FSW Exc. Error Status Reg. 14(Low Rate Data Mode Select Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_Mode_Sel_Err.dim = {'hk8_packet'};

    % id 3006: TLM8_FswExErrStatReg14 (LRD FOV Repeat Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Repeat_Err.att.telemetry_point_id = '3006';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Repeat_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (LRD FOV Repeat Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Repeat_Err.att.start_bit = '342';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Repeat_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Repeat_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Repeat_Err.att.description = 'FSW Exc. Error Status Reg. 14(Low Rate Data FOV Repeated Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Repeat_Err.dim = {'hk8_packet'};

    % id 3007: TLM8_FswExErrStatReg14 (Filtrd Dec Sample Cnt Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Filtrd_Dec_Sample_Cnt_Err.att.telemetry_point_id = '3007';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Filtrd_Dec_Sample_Cnt_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (Filtrd Dec Sample Cnt Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Filtrd_Dec_Sample_Cnt_Err.att.start_bit = '343';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Filtrd_Dec_Sample_Cnt_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Filtrd_Dec_Sample_Cnt_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Filtrd_Dec_Sample_Cnt_Err.att.description = 'FSW Exc. Error Status Reg. 14(Filtered Decimated Sample Count Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Filtrd_Dec_Sample_Cnt_Err.dim = {'hk8_packet'};

    % id 3008: TLM8_FswExErrStatReg14 (FOR Upset Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_FOR_Upset_Err.att.telemetry_point_id = '3008';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_FOR_Upset_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (FOR Upset Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_FOR_Upset_Err.att.start_bit = '344';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_FOR_Upset_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_FOR_Upset_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_FOR_Upset_Err.att.description = 'FSW Exc. Error Status Reg. 14(Field of Regard Upset Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_FOR_Upset_Err.dim = {'hk8_packet'};

    % id 3009: TLM8_FswExErrStatReg14 (SEFI Upset Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_SEFI_Upset_Err.att.telemetry_point_id = '3009';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_SEFI_Upset_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (SEFI Upset Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_SEFI_Upset_Err.att.start_bit = '345';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_SEFI_Upset_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_SEFI_Upset_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_SEFI_Upset_Err.att.description = 'FSW Exc. Error Status Reg. 14(Single Event Function Interrupt Upset Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_SEFI_Upset_Err.dim = {'hk8_packet'};

    % id 3010: TLM8_FswExErrStatReg14 (PCI Retry Count Too Big Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Retry_Count_Too_Big_Err.att.telemetry_point_id = '3010';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Retry_Count_Too_Big_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (PCI Retry Count Too Big Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Retry_Count_Too_Big_Err.att.start_bit = '346';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Retry_Count_Too_Big_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Retry_Count_Too_Big_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Retry_Count_Too_Big_Err.att.description = 'FSW Exc. Error Status Reg. 14(PCI Retry Count Too Big Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Retry_Count_Too_Big_Err.dim = {'hk8_packet'};

    % id 3011: TLM8_FswExErrStatReg14 (PCI Config Read Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Config_Read_Err.att.telemetry_point_id = '3011';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Config_Read_Err.att.mnemonic = 'TLM8_FswExErrStatReg14 (PCI Config Read Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Config_Read_Err.att.start_bit = '347';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Config_Read_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Config_Read_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Config_Read_Err.att.description = 'FSW Exc. Error Status Reg. 14(PCI Configuration Read Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_PCI_Config_Read_Err.dim = {'hk8_packet'};

    % id 3012: TLM8_FswExErrStatReg14 (Device Not Found)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Device_Not_Found.att.telemetry_point_id = '3012';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Device_Not_Found.att.mnemonic = 'TLM8_FswExErrStatReg14 (Device Not Found)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Device_Not_Found.att.start_bit = '348';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Device_Not_Found.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Device_Not_Found.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Device_Not_Found.att.description = 'FSW Exc. Error Status Reg. 14(Device Not Found)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Device_Not_Found.dim = {'hk8_packet'};

    % id 3013: TLM8_FswExErrStatReg14 (Invalid Param)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Invalid_Param.att.telemetry_point_id = '3013';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Invalid_Param.att.mnemonic = 'TLM8_FswExErrStatReg14 (Invalid Param)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Invalid_Param.att.start_bit = '349';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Invalid_Param.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Invalid_Param.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Invalid_Param.att.description = 'FSW Exc. Error Status Reg. 14(Invalid Param)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Invalid_Param.dim = {'hk8_packet'};

    % id 3014: TLM8_FswExErrStatReg14 (Reserved)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Reserved.att.telemetry_point_id = '3014';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Reserved.att.mnemonic = 'TLM8_FswExErrStatReg14 (Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Reserved.att.start_bit = '350';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Reserved.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Reserved.att.description = 'FSW Exc. Error Status Reg. 14(Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Reserved.dim = {'hk8_packet'};

    % id 3015: TLM8_FswExErrStatReg14 (Spare2)
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Spare2.att.telemetry_point_id = '3015';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Spare2.att.mnemonic = 'TLM8_FswExErrStatReg14 (Spare2)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Spare2.att.start_bit = '351';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Spare2.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Spare2.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Spare2.att.description = 'FSW Exc. Error Status Reg. 14(Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg14_Spare2.dim = {'hk8_packet'};

    % id 3016: TLM8_FswExErrStatReg15 (PCI Init Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_PCI_Init_Err.att.telemetry_point_id = '3016';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_PCI_Init_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (PCI Init Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_PCI_Init_Err.att.start_bit = '352';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_PCI_Init_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_PCI_Init_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_PCI_Init_Err.att.description = 'FSW Exc. Error Status Reg. 15(PCI Init Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_PCI_Init_Err.dim = {'hk8_packet'};

    % id 3017: TLM8_FswExErrStatReg15 (Unsupp Config)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Config.att.telemetry_point_id = '3017';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Config.att.mnemonic = 'TLM8_FswExErrStatReg15 (Unsupp Config)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Config.att.start_bit = '353';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Config.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Config.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Config.att.description = 'FSW Exc. Error Status Reg. 15(Unsupported Configuration)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Config.dim = {'hk8_packet'};

    % id 3018: TLM8_FswExErrStatReg15 (Invld Diag Chan Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Diag_Chan_Err.att.telemetry_point_id = '3018';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Diag_Chan_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (Invld Diag Chan Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Diag_Chan_Err.att.start_bit = '354';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Diag_Chan_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Diag_Chan_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Diag_Chan_Err.att.description = 'FSW Exc. Error Status Reg. 15(Invalid Diag Chan. Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Diag_Chan_Err.dim = {'hk8_packet'};

    % id 3019: TLM8_FswExErrStatReg15 (Unsupp Sci Data Len/Bit Trim Tbl/Dec Rate Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.telemetry_point_id = '3019';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (Unsupp Sci Data Len/Bit Trim Tbl/Dec Rate Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.start_bit = '355';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.att.description = 'FSW Exc. Error Status Reg. 15(Unsupported Sci Data Len/Bit Trim Tbl/Dec Rate Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err.dim = {'hk8_packet'};

    % id 3020: TLM8_FswExErrStatReg15 (No Term on Tele Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_No_Term_on_Tele_Err.att.telemetry_point_id = '3020';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_No_Term_on_Tele_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (No Term on Tele Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_No_Term_on_Tele_Err.att.start_bit = '356';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_No_Term_on_Tele_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_No_Term_on_Tele_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_No_Term_on_Tele_Err.att.description = 'FSW Exc. Error Status Reg. 15(No Termination On Tlm Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_No_Term_on_Tele_Err.dim = {'hk8_packet'};

    % id 3021: TLM8_FswExErrStatReg15 (Invld Tele ID Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Tele_ID_Err.att.telemetry_point_id = '3021';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Tele_ID_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (Invld Tele ID Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Tele_ID_Err.att.start_bit = '357';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Tele_ID_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Tele_ID_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Tele_ID_Err.att.description = 'FSW Exc. Error Status Reg. 15(Invalid Tlm ID Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Tele_ID_Err.dim = {'hk8_packet'};

    % id 3022: TLM8_FswExErrStatReg15 (Invld Coef Tbl ID Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Coef_Tbl_ID_Err.att.telemetry_point_id = '3022';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Coef_Tbl_ID_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (Invld Coef Tbl ID Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Coef_Tbl_ID_Err.att.start_bit = '358';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Coef_Tbl_ID_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Coef_Tbl_ID_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Coef_Tbl_ID_Err.att.description = 'FSW Exc. Error Status Reg. 15(Invalid Coefficient Table ID Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Coef_Tbl_ID_Err.dim = {'hk8_packet'};

    % id 3023: TLM8_FswExErrStatReg15 (Bit Trim Indx Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Bit_Trim_Indx_Err.att.telemetry_point_id = '3023';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Bit_Trim_Indx_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (Bit Trim Indx Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Bit_Trim_Indx_Err.att.start_bit = '359';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Bit_Trim_Indx_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Bit_Trim_Indx_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Bit_Trim_Indx_Err.att.description = 'FSW Exc. Error Status Reg. 15(Bit Trim Table Index Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Bit_Trim_Indx_Err.dim = {'hk8_packet'};

    % id 3024: TLM8_FswExErrStatReg15 (Impulse Tbl Index Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Impulse_Tbl_Index_Err.att.telemetry_point_id = '3024';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Impulse_Tbl_Index_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (Impulse Tbl Index Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Impulse_Tbl_Index_Err.att.start_bit = '360';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Impulse_Tbl_Index_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Impulse_Tbl_Index_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Impulse_Tbl_Index_Err.att.description = 'FSW Exc. Error Status Reg. 15(Impulse Table Index Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Impulse_Tbl_Index_Err.dim = {'hk8_packet'};

    % id 3025: TLM8_FswExErrStatReg15 (Invld Module ID)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Module_ID.att.telemetry_point_id = '3025';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Module_ID.att.mnemonic = 'TLM8_FswExErrStatReg15 (Invld Module ID)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Module_ID.att.start_bit = '361';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Module_ID.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Module_ID.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Module_ID.att.description = 'FSW Exc. Error Status Reg. 15(Invalid Module ID)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Invld_Module_ID.dim = {'hk8_packet'};

    % id 3026: TLM8_FswExErrStatReg15 (Config Data Ptr Null Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Config_Data_Ptr_Null_Err.att.telemetry_point_id = '3026';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Config_Data_Ptr_Null_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (Config Data Ptr Null Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Config_Data_Ptr_Null_Err.att.start_bit = '362';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Config_Data_Ptr_Null_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Config_Data_Ptr_Null_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Config_Data_Ptr_Null_Err.att.description = 'FSW Exc. Error Status Reg. 15(Configuration Data Pointer Null Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Config_Data_Ptr_Null_Err.dim = {'hk8_packet'};

    % id 3027: TLM8_FswExErrStatReg15 (Rcv Unknown ID-Deflt Case)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Rcv_Unknown_ID_Deflt_Case.att.telemetry_point_id = '3027';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Rcv_Unknown_ID_Deflt_Case.att.mnemonic = 'TLM8_FswExErrStatReg15 (Rcv Unknown ID-Deflt Case)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Rcv_Unknown_ID_Deflt_Case.att.start_bit = '363';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Rcv_Unknown_ID_Deflt_Case.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Rcv_Unknown_ID_Deflt_Case.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Rcv_Unknown_ID_Deflt_Case.att.description = 'FSW Exc. Error Status Reg. 15(Receive Unknown ID - Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Rcv_Unknown_ID_Deflt_Case.dim = {'hk8_packet'};

    % id 3028: TLM8_FswExErrStatReg15 (Trans Unknown ID-Deflt Case)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Trans_Unknown_ID_Deflt_Case.att.telemetry_point_id = '3028';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Trans_Unknown_ID_Deflt_Case.att.mnemonic = 'TLM8_FswExErrStatReg15 (Trans Unknown ID-Deflt Case)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Trans_Unknown_ID_Deflt_Case.att.start_bit = '364';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Trans_Unknown_ID_Deflt_Case.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Trans_Unknown_ID_Deflt_Case.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Trans_Unknown_ID_Deflt_Case.att.description = 'FSW Exc. Error Status Reg. 15(Transmit Unknown ID - Default Case Reached)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_Trans_Unknown_ID_Deflt_Case.dim = {'hk8_packet'};

    % id 3029: TLM8_FswExErrStatReg15 (MQ Rcv Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Rcv_Err.att.telemetry_point_id = '3029';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Rcv_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (MQ Rcv Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Rcv_Err.att.start_bit = '365';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Rcv_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Rcv_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Rcv_Err.att.description = 'FSW Exc. Error Status Reg. 15(Message Queue Receive Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Rcv_Err.dim = {'hk8_packet'};

    % id 3030: TLM8_FswExErrStatReg15 (MQ Snd Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Snd_Err.att.telemetry_point_id = '3030';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Snd_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (MQ Snd Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Snd_Err.att.start_bit = '366';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Snd_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Snd_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Snd_Err.att.description = 'FSW Exc. Error Status Reg. 15(Message Queue Send Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_MQ_Snd_Err.dim = {'hk8_packet'};

    % id 3031: TLM8_FswExErrStatReg15 (OS Func Call Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg15_OS_Func_Call_Err.att.telemetry_point_id = '3031';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_OS_Func_Call_Err.att.mnemonic = 'TLM8_FswExErrStatReg15 (OS Func Call Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_OS_Func_Call_Err.att.start_bit = '367';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_OS_Func_Call_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_OS_Func_Call_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_OS_Func_Call_Err.att.description = 'FSW Exc. Error Status Reg. 15(Operating System Function Call Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg15_OS_Func_Call_Err.dim = {'hk8_packet'};

    % id 3033: TLM8_FswExErrStatReg16 (Taps I Coef MisMatch)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_I_Coef_MisMatch.att.telemetry_point_id = '3033';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_I_Coef_MisMatch.att.mnemonic = 'TLM8_FswExErrStatReg16 (Taps I Coef MisMatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_I_Coef_MisMatch.att.start_bit = '368';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_I_Coef_MisMatch.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_I_Coef_MisMatch.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_I_Coef_MisMatch.att.description = 'FSW Exc. Error Status Reg. 16(Taps I Coefficient Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_I_Coef_MisMatch.dim = {'hk8_packet'};

    % id 3032: TLM8_FswExErrStatReg16 (Taps Q Coef MisMatch)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_Q_Coef_MisMatch.att.telemetry_point_id = '3032';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_Q_Coef_MisMatch.att.mnemonic = 'TLM8_FswExErrStatReg16 (Taps Q Coef MisMatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_Q_Coef_MisMatch.att.start_bit = '369';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_Q_Coef_MisMatch.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_Q_Coef_MisMatch.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_Q_Coef_MisMatch.att.description = 'FSW Exc. Error Status Reg. 16(Taps Q Coefficient Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Taps_Q_Coef_MisMatch.dim = {'hk8_packet'};

    % id 3034: TLM8_FswExErrStatReg16 (Coef Dat Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Dat_Err.att.telemetry_point_id = '3034';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Dat_Err.att.mnemonic = 'TLM8_FswExErrStatReg16 (Coef Dat Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Dat_Err.att.start_bit = '370';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Dat_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Dat_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Dat_Err.att.description = 'FSW Exc. Error Status Reg. 16(Coefficient Data Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Dat_Err.dim = {'hk8_packet'};

    % id 3035: TLM8_FswExErrStatReg16 (Config Dat Err - 4 min)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_4_min.att.telemetry_point_id = '3035';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_4_min.att.mnemonic = 'TLM8_FswExErrStatReg16 (Config Dat Err - 4 min)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_4_min.att.start_bit = '371';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_4_min.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_4_min.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_4_min.att.description = 'FSW Exc. Error Status Reg. 16(Configuration Data Error - 4 Minute)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_4_min.dim = {'hk8_packet'};

    % id 3036: TLM8_FswExErrStatReg16 (Config Dat Err - 8 sec)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_8_sec.att.telemetry_point_id = '3036';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_8_sec.att.mnemonic = 'TLM8_FswExErrStatReg16 (Config Dat Err - 8 sec)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_8_sec.att.start_bit = '372';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_8_sec.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_8_sec.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_8_sec.att.description = 'FSW Exc. Error Status Reg. 16(Configuration Data Error - 8 Second)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_8_sec.dim = {'hk8_packet'};

    % id 3037: TLM8_FswExErrStatReg16 (Persistant Tbl Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Persistant_Tbl_Err.att.telemetry_point_id = '3037';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Persistant_Tbl_Err.att.mnemonic = 'TLM8_FswExErrStatReg16 (Persistant Tbl Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Persistant_Tbl_Err.att.start_bit = '373';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Persistant_Tbl_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Persistant_Tbl_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Persistant_Tbl_Err.att.description = 'FSW Exc. Error Status Reg. 16(Persistent Table Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Persistant_Tbl_Err.dim = {'hk8_packet'};

    % id 3038: TLM8_FswExErrStatReg16 (Setup Data Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Setup_Data_Err.att.telemetry_point_id = '3038';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Setup_Data_Err.att.mnemonic = 'TLM8_FswExErrStatReg16 (Setup Data Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Setup_Data_Err.att.start_bit = '374';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Setup_Data_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Setup_Data_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Setup_Data_Err.att.description = 'FSW Exc. Error Status Reg. 16(Setup Data Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Setup_Data_Err.dim = {'hk8_packet'};

    % id 3039: TLM8_FswExErrStatReg16 (Invld Num Coef Entries)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Invld_Num_Coef_Entries.att.telemetry_point_id = '3039';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Invld_Num_Coef_Entries.att.mnemonic = 'TLM8_FswExErrStatReg16 (Invld Num Coef Entries)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Invld_Num_Coef_Entries.att.start_bit = '375';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Invld_Num_Coef_Entries.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Invld_Num_Coef_Entries.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Invld_Num_Coef_Entries.att.description = 'FSW Exc. Error Status Reg. 16(Invalid Number of Coefficient Entries)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Invld_Num_Coef_Entries.dim = {'hk8_packet'};

    % id 3040: TLM8_FswExErrStatReg16 (Filter Offset Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Filter_Offset_Err.att.telemetry_point_id = '3040';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Filter_Offset_Err.att.mnemonic = 'TLM8_FswExErrStatReg16 (Filter Offset Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Filter_Offset_Err.att.start_bit = '376';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Filter_Offset_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Filter_Offset_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Filter_Offset_Err.att.description = 'FSW Exc. Error Status Reg. 16(Filter Offset Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Filter_Offset_Err.dim = {'hk8_packet'};

    % id 3041: TLM8_FswExErrStatReg16 (Run Samples > Total Samples)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Run_Samples_Total_Samples.att.telemetry_point_id = '3041';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Run_Samples_Total_Samples.att.mnemonic = 'TLM8_FswExErrStatReg16 (Run Samples > Total Samples)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Run_Samples_Total_Samples.att.start_bit = '377';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Run_Samples_Total_Samples.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Run_Samples_Total_Samples.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Run_Samples_Total_Samples.att.description = 'FSW Exc. Error Status Reg. 16(Run Samples > Total Samples)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Run_Samples_Total_Samples.dim = {'hk8_packet'};

    % id 3042: TLM8_FswExErrStatReg16 (Bit Trim Tbl Start/Stop Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Bit_Trim_Tbl_Start_Stop_Err.att.telemetry_point_id = '3042';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Bit_Trim_Tbl_Start_Stop_Err.att.mnemonic = 'TLM8_FswExErrStatReg16 (Bit Trim Tbl Start/Stop Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Bit_Trim_Tbl_Start_Stop_Err.att.start_bit = '378';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Bit_Trim_Tbl_Start_Stop_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Bit_Trim_Tbl_Start_Stop_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Bit_Trim_Tbl_Start_Stop_Err.att.description = 'FSW Exc. Error Status Reg. 16(Bit Trim Table Start/Stop Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Bit_Trim_Tbl_Start_Stop_Err.dim = {'hk8_packet'};

    % id 3043: TLM8_FswExErrStatReg16 (Coef Mismatch)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Mismatch.att.telemetry_point_id = '3043';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Mismatch.att.mnemonic = 'TLM8_FswExErrStatReg16 (Coef Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Mismatch.att.start_bit = '379';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Mismatch.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Mismatch.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Mismatch.att.description = 'FSW Exc. Error Status Reg. 16(Coefficient Mismatch)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Coef_Mismatch.dim = {'hk8_packet'};

    % id 3044: TLM8_FswExErrStatReg16 (Mem Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Mem_Err.att.telemetry_point_id = '3044';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Mem_Err.att.mnemonic = 'TLM8_FswExErrStatReg16 (Mem Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Mem_Err.att.start_bit = '380';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Mem_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Mem_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Mem_Err.att.description = 'FSW Exc. Error Status Reg. 16(Memory Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Mem_Err.dim = {'hk8_packet'};

    % id 3045: TLM8_FswExErrStatReg16 (PCI Retry Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_PCI_Retry_Err.att.telemetry_point_id = '3045';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_PCI_Retry_Err.att.mnemonic = 'TLM8_FswExErrStatReg16 (PCI Retry Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_PCI_Retry_Err.att.start_bit = '381';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_PCI_Retry_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_PCI_Retry_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_PCI_Retry_Err.att.description = 'FSW Exc. Error Status Reg. 16(PCI Retry Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_PCI_Retry_Err.dim = {'hk8_packet'};

    % id 3046: TLM8_FswExErrStatReg16 (Sig Proc in Rst)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Sig_Proc_in_Rst.att.telemetry_point_id = '3046';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Sig_Proc_in_Rst.att.mnemonic = 'TLM8_FswExErrStatReg16 (Sig Proc in Rst)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Sig_Proc_in_Rst.att.start_bit = '382';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Sig_Proc_in_Rst.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Sig_Proc_in_Rst.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Sig_Proc_in_Rst.att.description = 'FSW Exc. Error Status Reg. 16(Signal Processor Is In Reset)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_Sig_Proc_in_Rst.dim = {'hk8_packet'};

    % id 3047: TLM8_FswExErrStatReg16 (SSM Scn Pos Missing Err/Invld)
    g_metadata.packets.instr_hk8.FswExErrStatReg16_SSM_Scn_Pos_Missing_Err_Invld.att.telemetry_point_id = '3047';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_SSM_Scn_Pos_Missing_Err_Invld.att.mnemonic = 'TLM8_FswExErrStatReg16 (SSM Scn Pos Missing Err/Invld)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_SSM_Scn_Pos_Missing_Err_Invld.att.start_bit = '383';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_SSM_Scn_Pos_Missing_Err_Invld.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_SSM_Scn_Pos_Missing_Err_Invld.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_SSM_Scn_Pos_Missing_Err_Invld.att.description = 'FSW Exc. Error Status Reg. 16(SSM Scan Position Missing Error or Invalid)';
    g_metadata.packets.instr_hk8.FswExErrStatReg16_SSM_Scn_Pos_Missing_Err_Invld.dim = {'hk8_packet'};

    % id 3048: TLM8_FswExErrStatReg17 (Wake Up Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Wake_Up_Err.att.telemetry_point_id = '3048';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Wake_Up_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (Wake Up Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Wake_Up_Err.att.start_bit = '384';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Wake_Up_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Wake_Up_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Wake_Up_Err.att.description = 'FSW Exc. Error Status Reg. 17(Wake Up Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Wake_Up_Err.dim = {'hk8_packet'};

    % id 3049: TLM8_FswExErrStatReg17 (DMA Addr Write Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_DMA_Addr_Write_Err.att.telemetry_point_id = '3049';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_DMA_Addr_Write_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (DMA Addr Write Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_DMA_Addr_Write_Err.att.start_bit = '385';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_DMA_Addr_Write_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_DMA_Addr_Write_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_DMA_Addr_Write_Err.att.description = 'FSW Exc. Error Status Reg. 17(DMA Address Write Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_DMA_Addr_Write_Err.dim = {'hk8_packet'};

    % id 3050: TLM8_FswExErrStatReg17 (Mem dmp Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Mem_dmp_Err.att.telemetry_point_id = '3050';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Mem_dmp_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (Mem dmp Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Mem_dmp_Err.att.start_bit = '386';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Mem_dmp_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Mem_dmp_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Mem_dmp_Err.att.description = 'FSW Exc. Error Status Reg. 17(Memory Dump Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Mem_dmp_Err.dim = {'hk8_packet'};

    % id 3051: TLM8_FswExErrStatReg17 (LRD Num FOVs ERR)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Num_FOVs_ERR.att.telemetry_point_id = '3051';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Num_FOVs_ERR.att.mnemonic = 'TLM8_FswExErrStatReg17 (LRD Num FOVs ERR)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Num_FOVs_ERR.att.start_bit = '387';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Num_FOVs_ERR.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Num_FOVs_ERR.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Num_FOVs_ERR.att.description = 'FSW Exc. Error Status Reg. 17(Low Rate Data Number of FOVs Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Num_FOVs_ERR.dim = {'hk8_packet'};

    % id 3052: TLM8_FswExErrStatReg17 (LRD FOV Val Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Val_Err.att.telemetry_point_id = '3052';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Val_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (LRD FOV Val Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Val_Err.att.start_bit = '388';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Val_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Val_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Val_Err.att.description = 'FSW Exc. Error Status Reg. 17(Low Rate Data FOV Value Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Val_Err.dim = {'hk8_packet'};

    % id 3053: TLM8_FswExErrStatReg17 (LRD Mode Sel Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Mode_Sel_Err.att.telemetry_point_id = '3053';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Mode_Sel_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (LRD Mode Sel Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Mode_Sel_Err.att.start_bit = '389';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Mode_Sel_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Mode_Sel_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Mode_Sel_Err.att.description = 'FSW Exc. Error Status Reg. 17(Low Rate Data Mode Select Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_Mode_Sel_Err.dim = {'hk8_packet'};

    % id 3054: TLM8_FswExErrStatReg17 (LRD FOV Repeat Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Repeat_Err.att.telemetry_point_id = '3054';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Repeat_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (LRD FOV Repeat Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Repeat_Err.att.start_bit = '390';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Repeat_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Repeat_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Repeat_Err.att.description = 'FSW Exc. Error Status Reg. 17(Low Rate Data FOV Repeated Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Repeat_Err.dim = {'hk8_packet'};

    % id 3055: TLM8_FswExErrStatReg17 (Fltrd Dec Sample Cnt Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Fltrd_Dec_Sample_Cnt_Err.att.telemetry_point_id = '3055';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Fltrd_Dec_Sample_Cnt_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (Fltrd Dec Sample Cnt Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Fltrd_Dec_Sample_Cnt_Err.att.start_bit = '391';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Fltrd_Dec_Sample_Cnt_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Fltrd_Dec_Sample_Cnt_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Fltrd_Dec_Sample_Cnt_Err.att.description = 'FSW Exc. Error Status Reg. 17(Filtered Decimated Sample Count Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Fltrd_Dec_Sample_Cnt_Err.dim = {'hk8_packet'};

    % id 3056: TLM8_FswExErrStatReg17 (FOR Upset Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_FOR_Upset_Err.att.telemetry_point_id = '3056';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_FOR_Upset_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (FOR Upset Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_FOR_Upset_Err.att.start_bit = '392';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_FOR_Upset_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_FOR_Upset_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_FOR_Upset_Err.att.description = 'FSW Exc. Error Status Reg. 17(Field of Regard Upset Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_FOR_Upset_Err.dim = {'hk8_packet'};

    % id 3057: TLM8_FswExErrStatReg17 (SEFI Upset Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_SEFI_Upset_Err.att.telemetry_point_id = '3057';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_SEFI_Upset_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (SEFI Upset Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_SEFI_Upset_Err.att.start_bit = '393';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_SEFI_Upset_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_SEFI_Upset_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_SEFI_Upset_Err.att.description = 'FSW Exc. Error Status Reg. 17(Single Event Function Interrupt Upset Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_SEFI_Upset_Err.dim = {'hk8_packet'};

    % id 3058: TLM8_FswExErrStatReg17 (PCI Retry Count Too Big Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Retry_Count_Too_Big_Err.att.telemetry_point_id = '3058';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Retry_Count_Too_Big_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (PCI Retry Count Too Big Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Retry_Count_Too_Big_Err.att.start_bit = '394';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Retry_Count_Too_Big_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Retry_Count_Too_Big_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Retry_Count_Too_Big_Err.att.description = 'FSW Exc. Error Status Reg. 17(PCI Retry Count Too Big Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Retry_Count_Too_Big_Err.dim = {'hk8_packet'};

    % id 3059: TLM8_FswExErrStatReg17 (PCI Config Read Err)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Config_Read_Err.att.telemetry_point_id = '3059';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Config_Read_Err.att.mnemonic = 'TLM8_FswExErrStatReg17 (PCI Config Read Err)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Config_Read_Err.att.start_bit = '395';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Config_Read_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Config_Read_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Config_Read_Err.att.description = 'FSW Exc. Error Status Reg. 17(PCI Configuration Read Error)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_PCI_Config_Read_Err.dim = {'hk8_packet'};

    % id 3060: TLM8_FswExErrStatReg17 (Dev Not Found)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Dev_Not_Found.att.telemetry_point_id = '3060';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Dev_Not_Found.att.mnemonic = 'TLM8_FswExErrStatReg17 (Dev Not Found)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Dev_Not_Found.att.start_bit = '396';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Dev_Not_Found.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Dev_Not_Found.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Dev_Not_Found.att.description = 'FSW Exc. Error Status Reg. 17(Device Not Found)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Dev_Not_Found.dim = {'hk8_packet'};

    % id 3061: TLM8_FswExErrStatReg17 (Invalid Param)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Invalid_Param.att.telemetry_point_id = '3061';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Invalid_Param.att.mnemonic = 'TLM8_FswExErrStatReg17 (Invalid Param)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Invalid_Param.att.start_bit = '397';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Invalid_Param.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Invalid_Param.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Invalid_Param.att.description = 'FSW Exc. Error Status Reg. 17(Invalid Param)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Invalid_Param.dim = {'hk8_packet'};

    % id 3062: TLM8_FswExErrStatReg17 (Reserved)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Reserved.att.telemetry_point_id = '3062';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Reserved.att.mnemonic = 'TLM8_FswExErrStatReg17 (Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Reserved.att.start_bit = '398';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Reserved.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Reserved.att.description = 'FSW Exc. Error Status Reg. 17(Reserved)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Reserved.dim = {'hk8_packet'};

    % id 3063: TLM8_FswExErrStatReg17 (Spare2)
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Spare2.att.telemetry_point_id = '3063';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Spare2.att.mnemonic = 'TLM8_FswExErrStatReg17 (Spare2)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Spare2.att.start_bit = '399';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Spare2.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Spare2.att.num_bits = '1';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Spare2.att.description = 'FSW Exc. Error Status Reg. 17(Spare)';
    g_metadata.packets.instr_hk8.FswExErrStatReg17_Spare2.dim = {'hk8_packet'};

    % id 3064: TLM8_SpWStatReg1 (Link Identifier)
    g_metadata.packets.instr_hk8.SpWStatReg1_Link_Identifier.att.telemetry_point_id = '3064';
    g_metadata.packets.instr_hk8.SpWStatReg1_Link_Identifier.att.mnemonic = 'TLM8_SpWStatReg1 (Link Identifier)';
    g_metadata.packets.instr_hk8.SpWStatReg1_Link_Identifier.att.start_bit = '400';
    g_metadata.packets.instr_hk8.SpWStatReg1_Link_Identifier.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg1_Link_Identifier.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SpWStatReg1_Link_Identifier.att.description = 'SpaceWire Status Reg. 1 (Link Identifier - Indicates which link is currently active)';
    g_metadata.packets.instr_hk8.SpWStatReg1_Link_Identifier.dim = {'hk8_packet'};

    % id 16335: TLM8_SpWStatReg1 (DisconnectErrCntrRolloverFlag)
    g_metadata.packets.instr_hk8.SpWStatReg1_DisconnectErrCntrRolloverFlag.att.telemetry_point_id = '16335';
    g_metadata.packets.instr_hk8.SpWStatReg1_DisconnectErrCntrRolloverFlag.att.mnemonic = 'TLM8_SpWStatReg1 (DisconnectErrCntrRolloverFlag)';
    g_metadata.packets.instr_hk8.SpWStatReg1_DisconnectErrCntrRolloverFlag.att.start_bit = '402';
    g_metadata.packets.instr_hk8.SpWStatReg1_DisconnectErrCntrRolloverFlag.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg1_DisconnectErrCntrRolloverFlag.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg1_DisconnectErrCntrRolloverFlag.att.description = 'SpaceWire Status Reg. 1 (Disconnect Error Counter roll-over flag)';
    g_metadata.packets.instr_hk8.SpWStatReg1_DisconnectErrCntrRolloverFlag.dim = {'hk8_packet'};

    % id 16336: TLM8_SpWStatReg1 (ParityErrCntrRolloverFlag)
    g_metadata.packets.instr_hk8.SpWStatReg1_ParityErrCntrRolloverFlag.att.telemetry_point_id = '16336';
    g_metadata.packets.instr_hk8.SpWStatReg1_ParityErrCntrRolloverFlag.att.mnemonic = 'TLM8_SpWStatReg1 (ParityErrCntrRolloverFlag)';
    g_metadata.packets.instr_hk8.SpWStatReg1_ParityErrCntrRolloverFlag.att.start_bit = '403';
    g_metadata.packets.instr_hk8.SpWStatReg1_ParityErrCntrRolloverFlag.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg1_ParityErrCntrRolloverFlag.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg1_ParityErrCntrRolloverFlag.att.description = 'SpaceWire Status Reg. 1 (Parity Error Counter roll-over flag)';
    g_metadata.packets.instr_hk8.SpWStatReg1_ParityErrCntrRolloverFlag.dim = {'hk8_packet'};

    % id 16337: TLM8_SpWStatReg1 (RecPktAboveMaxNumBytesCntrRolloverFlag)
    g_metadata.packets.instr_hk8.SpWStatReg1_RecPktAboveMaxNumBytesCntrRolloverFlag.att.telemetry_point_id = '16337';
    g_metadata.packets.instr_hk8.SpWStatReg1_RecPktAboveMaxNumBytesCntrRolloverFlag.att.mnemonic = 'TLM8_SpWStatReg1 (RecPktAboveMaxNumBytesCntrRolloverFlag)';
    g_metadata.packets.instr_hk8.SpWStatReg1_RecPktAboveMaxNumBytesCntrRolloverFlag.att.start_bit = '404';
    g_metadata.packets.instr_hk8.SpWStatReg1_RecPktAboveMaxNumBytesCntrRolloverFlag.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg1_RecPktAboveMaxNumBytesCntrRolloverFlag.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg1_RecPktAboveMaxNumBytesCntrRolloverFlag.att.description = 'SpaceWire Status Reg. 1 (Receive packets greater than Maximum Number of Bytes Counter roll-over flag)';
    g_metadata.packets.instr_hk8.SpWStatReg1_RecPktAboveMaxNumBytesCntrRolloverFlag.dim = {'hk8_packet'};

    % id 16338: TLM8_SpWStatReg1 (SpWTransmitErrCntrRolloverFlag)
    g_metadata.packets.instr_hk8.SpWStatReg1_SpWTransmitErrCntrRolloverFlag.att.telemetry_point_id = '16338';
    g_metadata.packets.instr_hk8.SpWStatReg1_SpWTransmitErrCntrRolloverFlag.att.mnemonic = 'TLM8_SpWStatReg1 (SpWTransmitErrCntrRolloverFlag)';
    g_metadata.packets.instr_hk8.SpWStatReg1_SpWTransmitErrCntrRolloverFlag.att.start_bit = '405';
    g_metadata.packets.instr_hk8.SpWStatReg1_SpWTransmitErrCntrRolloverFlag.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg1_SpWTransmitErrCntrRolloverFlag.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg1_SpWTransmitErrCntrRolloverFlag.att.description = 'SpaceWire Status Reg. 1 (Transmit Error Counter roll-over flag)';
    g_metadata.packets.instr_hk8.SpWStatReg1_SpWTransmitErrCntrRolloverFlag.dim = {'hk8_packet'};

    % id 16339: TLM8_SpWStatReg1 (Spare)
    g_metadata.packets.instr_hk8.SpWStatReg1_Spare.att.telemetry_point_id = '16339';
    g_metadata.packets.instr_hk8.SpWStatReg1_Spare.att.mnemonic = 'TLM8_SpWStatReg1 (Spare)';
    g_metadata.packets.instr_hk8.SpWStatReg1_Spare.att.start_bit = '406';
    g_metadata.packets.instr_hk8.SpWStatReg1_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg1_Spare.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg1_Spare.att.description = 'SpaceWire Status Reg. 1 (Spare)';
    g_metadata.packets.instr_hk8.SpWStatReg1_Spare.dim = {'hk8_packet'};

    % id 3065: TLM8_SpWStatReg1 (ActivePortChangeRolloverFlag)
    g_metadata.packets.instr_hk8.SpWStatReg1_ActivePortChangeRolloverFlag.att.telemetry_point_id = '3065';
    g_metadata.packets.instr_hk8.SpWStatReg1_ActivePortChangeRolloverFlag.att.mnemonic = 'TLM8_SpWStatReg1 (ActivePortChangeRolloverFlag)';
    g_metadata.packets.instr_hk8.SpWStatReg1_ActivePortChangeRolloverFlag.att.start_bit = '407';
    g_metadata.packets.instr_hk8.SpWStatReg1_ActivePortChangeRolloverFlag.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg1_ActivePortChangeRolloverFlag.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg1_ActivePortChangeRolloverFlag.att.description = 'SpaceWire Status Reg. 1 (Active port/link changes roll-over flag)';
    g_metadata.packets.instr_hk8.SpWStatReg1_ActivePortChangeRolloverFlag.dim = {'hk8_packet'};

    % id 3066: TLM8_SpWStatReg1 (NumActivePortChanges)
    g_metadata.packets.instr_hk8.SpWStatReg1_NumActivePortChanges.att.telemetry_point_id = '3066';
    g_metadata.packets.instr_hk8.SpWStatReg1_NumActivePortChanges.att.mnemonic = 'TLM8_SpWStatReg1 (NumActivePortChanges)';
    g_metadata.packets.instr_hk8.SpWStatReg1_NumActivePortChanges.att.start_bit = '408';
    g_metadata.packets.instr_hk8.SpWStatReg1_NumActivePortChanges.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg1_NumActivePortChanges.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg1_NumActivePortChanges.att.description = 'SpaceWire Status Reg. 1 (Number of active port/link changes caused by commands or fault corrections)';
    g_metadata.packets.instr_hk8.SpWStatReg1_NumActivePortChanges.dim = {'hk8_packet'};

    % id 3067: TLM8_SpWStatReg2 (DisconnectErrCntr)
    g_metadata.packets.instr_hk8.SpWStatReg2_DisconnectErrCntr.att.telemetry_point_id = '3067';
    g_metadata.packets.instr_hk8.SpWStatReg2_DisconnectErrCntr.att.mnemonic = 'TLM8_SpWStatReg2 (DisconnectErrCntr)';
    g_metadata.packets.instr_hk8.SpWStatReg2_DisconnectErrCntr.att.start_bit = '416';
    g_metadata.packets.instr_hk8.SpWStatReg2_DisconnectErrCntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg2_DisconnectErrCntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg2_DisconnectErrCntr.att.description = 'SpaceWire Status Reg. 2 (SpaceWire Disconnect Error Counter)';
    g_metadata.packets.instr_hk8.SpWStatReg2_DisconnectErrCntr.dim = {'hk8_packet'};

    % id 3068: TLM8_SpWStatReg2 (ParityErrCntr)
    g_metadata.packets.instr_hk8.SpWStatReg2_ParityErrCntr.att.telemetry_point_id = '3068';
    g_metadata.packets.instr_hk8.SpWStatReg2_ParityErrCntr.att.mnemonic = 'TLM8_SpWStatReg2 (ParityErrCntr)';
    g_metadata.packets.instr_hk8.SpWStatReg2_ParityErrCntr.att.start_bit = '424';
    g_metadata.packets.instr_hk8.SpWStatReg2_ParityErrCntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg2_ParityErrCntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg2_ParityErrCntr.att.description = 'SpaceWire Status Reg. 2 (SpaceWire Parity Error Counter)';
    g_metadata.packets.instr_hk8.SpWStatReg2_ParityErrCntr.dim = {'hk8_packet'};

    % id 3069: TLM8_SpWStatReg3 (RecPktsGreaterThanMaxBytesCntr)
    g_metadata.packets.instr_hk8.SpWStatReg3_RecPktsGreaterThanMaxBytesCntr.att.telemetry_point_id = '3069';
    g_metadata.packets.instr_hk8.SpWStatReg3_RecPktsGreaterThanMaxBytesCntr.att.mnemonic = 'TLM8_SpWStatReg3 (RecPktsGreaterThanMaxBytesCntr)';
    g_metadata.packets.instr_hk8.SpWStatReg3_RecPktsGreaterThanMaxBytesCntr.att.start_bit = '432';
    g_metadata.packets.instr_hk8.SpWStatReg3_RecPktsGreaterThanMaxBytesCntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg3_RecPktsGreaterThanMaxBytesCntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg3_RecPktsGreaterThanMaxBytesCntr.att.description = 'SpaceWire Status Reg. 3 (Receive packets greater than Maximum Number of Bytes Counter)';
    g_metadata.packets.instr_hk8.SpWStatReg3_RecPktsGreaterThanMaxBytesCntr.dim = {'hk8_packet'};

    % id 3070: TLM8_SpWStatReg3 (TransmitErrCntr)
    g_metadata.packets.instr_hk8.SpWStatReg3_TransmitErrCntr.att.telemetry_point_id = '3070';
    g_metadata.packets.instr_hk8.SpWStatReg3_TransmitErrCntr.att.mnemonic = 'TLM8_SpWStatReg3 (TransmitErrCntr)';
    g_metadata.packets.instr_hk8.SpWStatReg3_TransmitErrCntr.att.start_bit = '440';
    g_metadata.packets.instr_hk8.SpWStatReg3_TransmitErrCntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg3_TransmitErrCntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg3_TransmitErrCntr.att.description = 'SpaceWire Status Reg. 3 (SpaceWire Transmit Error Counter)';
    g_metadata.packets.instr_hk8.SpWStatReg3_TransmitErrCntr.dim = {'hk8_packet'};

    % id 3071: TLM8_SpWStatReg4 (SpWCreditErrCounter)
    g_metadata.packets.instr_hk8.SpWStatReg4_SpWCreditErrCounter.att.telemetry_point_id = '3071';
    g_metadata.packets.instr_hk8.SpWStatReg4_SpWCreditErrCounter.att.mnemonic = 'TLM8_SpWStatReg4 (SpWCreditErrCounter)';
    g_metadata.packets.instr_hk8.SpWStatReg4_SpWCreditErrCounter.att.start_bit = '448';
    g_metadata.packets.instr_hk8.SpWStatReg4_SpWCreditErrCounter.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg4_SpWCreditErrCounter.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg4_SpWCreditErrCounter.att.description = 'SpaceWire Status Reg. 4 (SpaceWire Credit Error Counter)';
    g_metadata.packets.instr_hk8.SpWStatReg4_SpWCreditErrCounter.dim = {'hk8_packet'};

    % id 3072: TLM8_SpWStatReg4 (EscapeErrorCounter)
    g_metadata.packets.instr_hk8.SpWStatReg4_EscapeErrorCounter.att.telemetry_point_id = '3072';
    g_metadata.packets.instr_hk8.SpWStatReg4_EscapeErrorCounter.att.mnemonic = 'TLM8_SpWStatReg4 (EscapeErrorCounter)';
    g_metadata.packets.instr_hk8.SpWStatReg4_EscapeErrorCounter.att.start_bit = '456';
    g_metadata.packets.instr_hk8.SpWStatReg4_EscapeErrorCounter.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg4_EscapeErrorCounter.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg4_EscapeErrorCounter.att.description = 'SpaceWire Status Reg. 4 (SpaceWire Escape Error Counter)';
    g_metadata.packets.instr_hk8.SpWStatReg4_EscapeErrorCounter.dim = {'hk8_packet'};

    % id 3073: TLM8_SpWStatReg5 (NumMissedTODs_ToInitSafeMode)
    g_metadata.packets.instr_hk8.SpWStatReg5_NumMissedTODs_ToInitSafeMode.att.telemetry_point_id = '3073';
    g_metadata.packets.instr_hk8.SpWStatReg5_NumMissedTODs_ToInitSafeMode.att.mnemonic = 'TLM8_SpWStatReg5 (NumMissedTODs_ToInitSafeMode)';
    g_metadata.packets.instr_hk8.SpWStatReg5_NumMissedTODs_ToInitSafeMode.att.start_bit = '464';
    g_metadata.packets.instr_hk8.SpWStatReg5_NumMissedTODs_ToInitSafeMode.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg5_NumMissedTODs_ToInitSafeMode.att.num_bits = '6';
    g_metadata.packets.instr_hk8.SpWStatReg5_NumMissedTODs_ToInitSafeMode.att.description = 'SpaceWire Status Reg. 5 (Current number of missed TODs to initiate going to Safe Mode)';
    g_metadata.packets.instr_hk8.SpWStatReg5_NumMissedTODs_ToInitSafeMode.dim = {'hk8_packet'};

    % id 16340: TLM8_SpWStatReg5 (RecEEPonRecSpWPkt)
    g_metadata.packets.instr_hk8.SpWStatReg5_RecEEPonRecSpWPkt.att.telemetry_point_id = '16340';
    g_metadata.packets.instr_hk8.SpWStatReg5_RecEEPonRecSpWPkt.att.mnemonic = 'TLM8_SpWStatReg5 (RecEEPonRecSpWPkt)';
    g_metadata.packets.instr_hk8.SpWStatReg5_RecEEPonRecSpWPkt.att.start_bit = '470';
    g_metadata.packets.instr_hk8.SpWStatReg5_RecEEPonRecSpWPkt.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg5_RecEEPonRecSpWPkt.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg5_RecEEPonRecSpWPkt.att.description = 'SpaceWire Status Reg. 5 (Receive EEP on a Received SpaceWire Packet)';
    g_metadata.packets.instr_hk8.SpWStatReg5_RecEEPonRecSpWPkt.dim = {'hk8_packet'};

    % id 16341: TLM8_SpWStatReg5 (UserPktErrCntrRolloverFlag)
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntrRolloverFlag.att.telemetry_point_id = '16341';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntrRolloverFlag.att.mnemonic = 'TLM8_SpWStatReg5 (UserPktErrCntrRolloverFlag)';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntrRolloverFlag.att.start_bit = '471';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntrRolloverFlag.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntrRolloverFlag.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntrRolloverFlag.att.description = 'SpaceWire Status Reg. 5 (Error in User Packet Detected roll-over flag)';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntrRolloverFlag.dim = {'hk8_packet'};

    % id 3074: TLM8_SpWStatReg5 (UserPktErrCntr)
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntr.att.telemetry_point_id = '3074';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntr.att.mnemonic = 'TLM8_SpWStatReg5 (UserPktErrCntr)';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntr.att.start_bit = '472';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntr.att.description = 'SpaceWire Status Reg. 5 (SpaceWire Error in User Packet Detected Counter)';
    g_metadata.packets.instr_hk8.SpWStatReg5_UserPktErrCntr.dim = {'hk8_packet'};

    % id 3075: TLM8_SpWStatReg6 (CCSDSInvalidCmdsRcvd)
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSInvalidCmdsRcvd.att.telemetry_point_id = '3075';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSInvalidCmdsRcvd.att.mnemonic = 'TLM8_SpWStatReg6 (CCSDSInvalidCmdsRcvd)';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSInvalidCmdsRcvd.att.start_bit = '480';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSInvalidCmdsRcvd.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSInvalidCmdsRcvd.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSInvalidCmdsRcvd.att.description = 'SpaceWire Status Reg. 6 (CCSDS Invalid Commands Rcvd)';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSInvalidCmdsRcvd.dim = {'hk8_packet'};

    % id 16342: TLM8_SpWStatReg6 (CCSDSCmdInvalidRolloverFlag)
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSCmdInvalidRolloverFlag.att.telemetry_point_id = '16342';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSCmdInvalidRolloverFlag.att.mnemonic = 'TLM8_SpWStatReg6 (CCSDSCmdInvalidRolloverFlag)';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSCmdInvalidRolloverFlag.att.start_bit = '488';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSCmdInvalidRolloverFlag.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSCmdInvalidRolloverFlag.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSCmdInvalidRolloverFlag.att.description = 'SpaceWire Status Reg. 6 (CCSDS Command Invalid roll-over flag)';
    g_metadata.packets.instr_hk8.SpWStatReg6_CCSDSCmdInvalidRolloverFlag.dim = {'hk8_packet'};

    % id 16343: TLM8_SpWStatReg6 (Spare)
    g_metadata.packets.instr_hk8.SpWStatReg6_Spare.att.telemetry_point_id = '16343';
    g_metadata.packets.instr_hk8.SpWStatReg6_Spare.att.mnemonic = 'TLM8_SpWStatReg6 (Spare)';
    g_metadata.packets.instr_hk8.SpWStatReg6_Spare.att.start_bit = '489';
    g_metadata.packets.instr_hk8.SpWStatReg6_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg6_Spare.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg6_Spare.att.description = 'SpaceWire Status Reg. 6 (Spare)';
    g_metadata.packets.instr_hk8.SpWStatReg6_Spare.dim = {'hk8_packet'};

    % id 16344: TLM8_SpWStatReg6 (AutonomousTransitiontoSafeModeIndctr)
    g_metadata.packets.instr_hk8.SpWStatReg6_AutonomousTransitiontoSafeModeIndctr.att.telemetry_point_id = '16344';
    g_metadata.packets.instr_hk8.SpWStatReg6_AutonomousTransitiontoSafeModeIndctr.att.mnemonic = 'TLM8_SpWStatReg6 (AutonomousTransitiontoSafeModeIndctr)';
    g_metadata.packets.instr_hk8.SpWStatReg6_AutonomousTransitiontoSafeModeIndctr.att.start_bit = '490';
    g_metadata.packets.instr_hk8.SpWStatReg6_AutonomousTransitiontoSafeModeIndctr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg6_AutonomousTransitiontoSafeModeIndctr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg6_AutonomousTransitiontoSafeModeIndctr.att.description = 'SpaceWire Status Reg. 6 (Autonomous Instrument transition to Safe Mode Indicator)';
    g_metadata.packets.instr_hk8.SpWStatReg6_AutonomousTransitiontoSafeModeIndctr.dim = {'hk8_packet'};

    % id 3076: TLM8_SpWStatReg6 (NumMissedTODs_ToInitLinkRecovery)
    g_metadata.packets.instr_hk8.SpWStatReg6_NumMissedTODs_ToInitLinkRecovery.att.telemetry_point_id = '3076';
    g_metadata.packets.instr_hk8.SpWStatReg6_NumMissedTODs_ToInitLinkRecovery.att.mnemonic = 'TLM8_SpWStatReg6 (NumMissedTODs_ToInitLinkRecovery)';
    g_metadata.packets.instr_hk8.SpWStatReg6_NumMissedTODs_ToInitLinkRecovery.att.start_bit = '491';
    g_metadata.packets.instr_hk8.SpWStatReg6_NumMissedTODs_ToInitLinkRecovery.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg6_NumMissedTODs_ToInitLinkRecovery.att.num_bits = '5';
    g_metadata.packets.instr_hk8.SpWStatReg6_NumMissedTODs_ToInitLinkRecovery.att.description = 'SpaceWire Status Reg. 6 (Current number of missed TOD messages for Instrument to initial Link Recovery Algorithm)';
    g_metadata.packets.instr_hk8.SpWStatReg6_NumMissedTODs_ToInitLinkRecovery.dim = {'hk8_packet'};

    % id 3077: TLM8_SpWStatReg7 (Reserved)
    g_metadata.packets.instr_hk8.SpWStatReg7_Reserved.att.telemetry_point_id = '3077';
    g_metadata.packets.instr_hk8.SpWStatReg7_Reserved.att.mnemonic = 'TLM8_SpWStatReg7 (Reserved)';
    g_metadata.packets.instr_hk8.SpWStatReg7_Reserved.att.start_bit = '496';
    g_metadata.packets.instr_hk8.SpWStatReg7_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_Reserved.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SpWStatReg7_Reserved.att.description = 'SpaceWire Status Reg. 7(Reserved)';
    g_metadata.packets.instr_hk8.SpWStatReg7_Reserved.dim = {'hk8_packet'};

    % id 16346: TLM8_SpWStatReg7 (JTAG_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_JTAG_CritErr.att.telemetry_point_id = '16346';
    g_metadata.packets.instr_hk8.SpWStatReg7_JTAG_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (JTAG_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_JTAG_CritErr.att.start_bit = '498';
    g_metadata.packets.instr_hk8.SpWStatReg7_JTAG_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_JTAG_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_JTAG_CritErr.att.description = 'SpaceWire Status Reg. 7(JTAG Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_JTAG_CritErr.dim = {'hk8_packet'};

    % id 16347: TLM8_SpWStatReg7 (Clock_and_Test_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_Clock_and_Test_CritErr.att.telemetry_point_id = '16347';
    g_metadata.packets.instr_hk8.SpWStatReg7_Clock_and_Test_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (Clock_and_Test_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_Clock_and_Test_CritErr.att.start_bit = '499';
    g_metadata.packets.instr_hk8.SpWStatReg7_Clock_and_Test_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_Clock_and_Test_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_Clock_and_Test_CritErr.att.description = 'SpaceWire Status Reg. 7(Clock and Test Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_Clock_and_Test_CritErr.dim = {'hk8_packet'};

    % id 16348: TLM8_SpWStatReg7 (RIF0_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF0_CritErr.att.telemetry_point_id = '16348';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF0_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (RIF0_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF0_CritErr.att.start_bit = '500';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF0_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF0_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF0_CritErr.att.description = 'SpaceWire Status Reg. 7(RIF (0) Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF0_CritErr.dim = {'hk8_packet'};

    % id 16349: TLM8_SpWStatReg7 (RIF1_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF1_CritErr.att.telemetry_point_id = '16349';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF1_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (RIF1_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF1_CritErr.att.start_bit = '501';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF1_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF1_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF1_CritErr.att.description = 'SpaceWire Status Reg. 7(RIF (1) Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_RIF1_CritErr.dim = {'hk8_packet'};

    % id 16350: TLM8_SpWStatReg7 (PCI0_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI0_CritErr.att.telemetry_point_id = '16350';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI0_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (PCI0_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI0_CritErr.att.start_bit = '502';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI0_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI0_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI0_CritErr.att.description = 'SpaceWire Status Reg. 7(PCI (0) Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI0_CritErr.dim = {'hk8_packet'};

    % id 16351: TLM8_SpWStatReg7 (PCI1_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI1_CritErr.att.telemetry_point_id = '16351';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI1_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (PCI1_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI1_CritErr.att.start_bit = '503';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI1_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI1_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI1_CritErr.att.description = 'SpaceWire Status Reg. 7(PCI (1) Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_PCI1_CritErr.dim = {'hk8_packet'};

    % id 16352: TLM8_SpWStatReg7 (Misc_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_Misc_CritErr.att.telemetry_point_id = '16352';
    g_metadata.packets.instr_hk8.SpWStatReg7_Misc_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (Misc_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_Misc_CritErr.att.start_bit = '504';
    g_metadata.packets.instr_hk8.SpWStatReg7_Misc_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_Misc_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_Misc_CritErr.att.description = 'SpaceWire Status Reg. 7(Miscellaneous Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_Misc_CritErr.dim = {'hk8_packet'};

    % id 16353: TLM8_SpWStatReg7 (UART_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_UART_CritErr.att.telemetry_point_id = '16353';
    g_metadata.packets.instr_hk8.SpWStatReg7_UART_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (UART_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_UART_CritErr.att.start_bit = '505';
    g_metadata.packets.instr_hk8.SpWStatReg7_UART_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_UART_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_UART_CritErr.att.description = 'SpaceWire Status Reg. 7(UART Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_UART_CritErr.dim = {'hk8_packet'};

    % id 16354: TLM8_SpWStatReg7 (DMA_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_DMA_CritErr.att.telemetry_point_id = '16354';
    g_metadata.packets.instr_hk8.SpWStatReg7_DMA_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (DMA_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_DMA_CritErr.att.start_bit = '506';
    g_metadata.packets.instr_hk8.SpWStatReg7_DMA_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_DMA_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_DMA_CritErr.att.description = 'SpaceWire Status Reg. 7(DMA Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_DMA_CritErr.dim = {'hk8_packet'};

    % id 16355: TLM8_SpWStatReg7 (SRAM0_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM0_CritErr.att.telemetry_point_id = '16355';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM0_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (SRAM0_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM0_CritErr.att.start_bit = '507';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM0_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM0_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM0_CritErr.att.description = 'SpaceWire Status Reg. 7(SRAM(0) Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM0_CritErr.dim = {'hk8_packet'};

    % id 16356: TLM8_SpWStatReg7 (SRAM1_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM1_CritErr.att.telemetry_point_id = '16356';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM1_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (SRAM1_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM1_CritErr.att.start_bit = '508';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM1_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM1_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM1_CritErr.att.description = 'SpaceWire Status Reg. 7(SRAM(1) Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_SRAM1_CritErr.dim = {'hk8_packet'};

    % id 16357: TLM8_SpWStatReg7 (OCB_CM_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_OCB_CM_CritErr.att.telemetry_point_id = '16357';
    g_metadata.packets.instr_hk8.SpWStatReg7_OCB_CM_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (OCB_CM_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_OCB_CM_CritErr.att.start_bit = '509';
    g_metadata.packets.instr_hk8.SpWStatReg7_OCB_CM_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_OCB_CM_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_OCB_CM_CritErr.att.description = 'SpaceWire Status Reg. 7(OCB CM Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_OCB_CM_CritErr.dim = {'hk8_packet'};

    % id 16358: TLM8_SpWStatReg7 (Mem_Controller_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_Mem_Controller_CritErr.att.telemetry_point_id = '16358';
    g_metadata.packets.instr_hk8.SpWStatReg7_Mem_Controller_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (Mem_Controller_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_Mem_Controller_CritErr.att.start_bit = '510';
    g_metadata.packets.instr_hk8.SpWStatReg7_Mem_Controller_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_Mem_Controller_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_Mem_Controller_CritErr.att.description = 'SpaceWire Status Reg. 7(Memory Controller Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_Mem_Controller_CritErr.dim = {'hk8_packet'};

    % id 3078: TLM8_SpWStatReg7 (EMC_CritErr)
    g_metadata.packets.instr_hk8.SpWStatReg7_EMC_CritErr.att.telemetry_point_id = '3078';
    g_metadata.packets.instr_hk8.SpWStatReg7_EMC_CritErr.att.mnemonic = 'TLM8_SpWStatReg7 (EMC_CritErr)';
    g_metadata.packets.instr_hk8.SpWStatReg7_EMC_CritErr.att.start_bit = '511';
    g_metadata.packets.instr_hk8.SpWStatReg7_EMC_CritErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg7_EMC_CritErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg7_EMC_CritErr.att.description = 'SpaceWire Status Reg. 7(EMC Critical Error)';
    g_metadata.packets.instr_hk8.SpWStatReg7_EMC_CritErr.dim = {'hk8_packet'};

    % id 3079: TLM8_SpWStatReg8 (ASICRtr_PortStat_NLL)
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_NLL.att.telemetry_point_id = '3079';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_NLL.att.mnemonic = 'TLM8_SpWStatReg8 (ASICRtr_PortStat_NLL)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_NLL.att.start_bit = '512';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_NLL.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_NLL.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_NLL.att.description = 'SpaceWire Status Reg. 8 (ASIC Router - Port Status - [NLL] NULL)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_NLL.dim = {'hk8_packet'};

    % id 15700: TLM8_SpWStatReg8 (ASICRtr_PortStat_FCR)
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCR.att.telemetry_point_id = '15700';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCR.att.mnemonic = 'TLM8_SpWStatReg8 (ASICRtr_PortStat_FCR)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCR.att.start_bit = '513';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCR.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCR.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCR.att.description = 'SpaceWire Status Reg. 8 (ASIC Router - Port Status - [FCR] Flow Control Received)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCR.dim = {'hk8_packet'};

    % id 15701: TLM8_SpWStatReg8 (ASICRtr_PortStat_DCR)
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DCR.att.telemetry_point_id = '15701';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DCR.att.mnemonic = 'TLM8_SpWStatReg8 (ASICRtr_PortStat_DCR)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DCR.att.start_bit = '514';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DCR.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DCR.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DCR.att.description = 'SpaceWire Status Reg. 8 (ASIC Router - Port Status - [DCR] Data Character)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DCR.dim = {'hk8_packet'};

    % id 15758: TLM8_SpWStatReg8 (ASICRtr_PortStat_LinkState)
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_LinkState.att.telemetry_point_id = '15758';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_LinkState.att.mnemonic = 'TLM8_SpWStatReg8 (ASICRtr_PortStat_LinkState)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_LinkState.att.start_bit = '515';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_LinkState.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_LinkState.att.num_bits = '3';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_LinkState.att.description = 'SpaceWire Status Reg. 8(ASIC Router - Port Status - Link State)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_LinkState.dim = {'hk8_packet'};

    % id 15759: TLM8_SpWStatReg8 (ASICRtr_PortStat_EE)
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_EE.att.telemetry_point_id = '15759';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_EE.att.mnemonic = 'TLM8_SpWStatReg8 (ASICRtr_PortStat_EE)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_EE.att.start_bit = '518';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_EE.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_EE.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_EE.att.description = 'SpaceWire Status Reg. 8 (ASIC Router - Port Status - [EE] Escape Error)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_EE.dim = {'hk8_packet'};

    % id 15760: TLM8_SpWStatReg8 (ASICRtr_PortStat_PEC)
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PEC.att.telemetry_point_id = '15760';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PEC.att.mnemonic = 'TLM8_SpWStatReg8 (ASICRtr_PortStat_PEC)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PEC.att.start_bit = '519';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PEC.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PEC.att.num_bits = '3';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PEC.att.description = 'SpaceWire Status Reg. 8 (ASIC Router - Port Status - [PEC] Parity Error Count)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PEC.dim = {'hk8_packet'};

    % id 15761: TLM8_SpWStatReg8 (ASICRtr_PortStat_DEC)
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DEC.att.telemetry_point_id = '15761';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DEC.att.mnemonic = 'TLM8_SpWStatReg8 (ASICRtr_PortStat_DEC)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DEC.att.start_bit = '522';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DEC.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DEC.att.num_bits = '3';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DEC.att.description = 'SpaceWire Status Reg. 8 (ASIC Router - Port Status - [DEC] Disconnect Error Count)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DEC.dim = {'hk8_packet'};

    % id 15762: TLM8_SpWStatReg8 (ASICRtr_PortStat_FCU)
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCU.att.telemetry_point_id = '15762';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCU.att.mnemonic = 'TLM8_SpWStatReg8 (ASICRtr_PortStat_FCU)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCU.att.start_bit = '525';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCU.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCU.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCU.att.description = 'SpaceWire Status Reg. 8 (ASIC Router - Port Status - [FCU] Flow Control Underflow Error)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCU.dim = {'hk8_packet'};

    % id 15763: TLM8_SpWStatReg8 (ASICRtr_PortStat_FCO)
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCO.att.telemetry_point_id = '15763';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCO.att.mnemonic = 'TLM8_SpWStatReg8 (ASICRtr_PortStat_FCO)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCO.att.start_bit = '526';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCO.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCO.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCO.att.description = 'SpaceWire Status Reg. 8 (ASIC Router - Port Status - [FCO] Flow Control Overflow Error)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCO.dim = {'hk8_packet'};

    % id 3080: TLM8_SpWStatReg8 (ASICRtr_PortStat_PTE)
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PTE.att.telemetry_point_id = '3080';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PTE.att.mnemonic = 'TLM8_SpWStatReg8 (ASICRtr_PortStat_PTE)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PTE.att.start_bit = '527';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PTE.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PTE.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PTE.att.description = 'SpaceWire Status Reg. 8 (ASIC Router - Port Status - [PTE] Output Port Timeout Error)';
    g_metadata.packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PTE.dim = {'hk8_packet'};

    % id 3081: TLM8_SpWStatReg9 (ASIC_RIFStat_Res3)
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res3.att.telemetry_point_id = '3081';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res3.att.mnemonic = 'TLM8_SpWStatReg9 (ASIC_RIFStat_Res3)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res3.att.start_bit = '528';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res3.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res3.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res3.att.description = 'SpaceWire Status Reg. 9 (SpaceWire ASIC - RIF Interrupt Status - Reserved)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res3.dim = {'hk8_packet'};

    % id 3082: TLM8_SpWStatReg9 (ASIC_RIFStat_TxOCB_ParityErr)
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ParityErr.att.telemetry_point_id = '3082';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ParityErr.att.mnemonic = 'TLM8_SpWStatReg9 (ASIC_RIFStat_TxOCB_ParityErr)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ParityErr.att.start_bit = '530';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ParityErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ParityErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ParityErr.att.description = 'SpaceWire Status Reg. 9 (SpaceWire ASIC - RIF Interrupt Status - Tx OCB Parity Error)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ParityErr.dim = {'hk8_packet'};

    % id 3083: TLM8_SpWStatReg9 (ASIC_RIFStat_TxOCB_ReDataErr)
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ReDataErr.att.telemetry_point_id = '3083';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ReDataErr.att.mnemonic = 'TLM8_SpWStatReg9 (ASIC_RIFStat_TxOCB_ReDataErr)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ReDataErr.att.start_bit = '531';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ReDataErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ReDataErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ReDataErr.att.description = 'SpaceWire Status Reg. 9 (SpaceWire ASIC - RIF Interrupt Status - Tx OCB Read Data Error)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ReDataErr.dim = {'hk8_packet'};

    % id 3084: TLM8_SpWStatReg9 (ASIC_RIFStat_Res2)
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res2.att.telemetry_point_id = '3084';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res2.att.mnemonic = 'TLM8_SpWStatReg9 (ASIC_RIFStat_Res2)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res2.att.start_bit = '532';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res2.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res2.att.num_bits = '3';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res2.att.description = 'SpaceWire Status Reg. 9 (SpaceWire ASIC - RIF Interrupt Status - Reserved)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res2.dim = {'hk8_packet'};

    % id 3085: TLM8_SpWStatReg9 (ASIC_RIFStat_RxOCB_ParityErr)
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ParityErr.att.telemetry_point_id = '3085';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ParityErr.att.mnemonic = 'TLM8_SpWStatReg9 (ASIC_RIFStat_RxOCB_ParityErr)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ParityErr.att.start_bit = '535';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ParityErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ParityErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ParityErr.att.description = 'SpaceWire Status Reg. 9 (SpaceWire ASIC - RIF Interrupt Status - Rx OCB Parity Error)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ParityErr.dim = {'hk8_packet'};

    % id 3086: TLM8_SpWStatReg9 (ASIC_RIFStat_RxOCB_ReDataErr)
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ReDataErr.att.telemetry_point_id = '3086';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ReDataErr.att.mnemonic = 'TLM8_SpWStatReg9 (ASIC_RIFStat_RxOCB_ReDataErr)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ReDataErr.att.start_bit = '536';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ReDataErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ReDataErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ReDataErr.att.description = 'SpaceWire Status Reg. 9 (SpaceWire ASIC - RIF Interrupt Status - Rx OCB Read Data Error)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ReDataErr.dim = {'hk8_packet'};

    % id 3087: TLM8_SpWStatReg9 (ASIC_RIFStat_AddressPhaseParityErr)
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AddressPhaseParityErr.att.telemetry_point_id = '3087';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AddressPhaseParityErr.att.mnemonic = 'TLM8_SpWStatReg9 (ASIC_RIFStat_AddressPhaseParityErr)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AddressPhaseParityErr.att.start_bit = '537';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AddressPhaseParityErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AddressPhaseParityErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AddressPhaseParityErr.att.description = 'SpaceWire Status Reg. 9 (SpaceWire ASIC - RIF Interrupt Status - Address Phase Parity Error)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AddressPhaseParityErr.dim = {'hk8_packet'};

    % id 3088: TLM8_SpWStatReg9 (ASIC_RIFStat_WrDataParityErr)
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_WrDataParityErr.att.telemetry_point_id = '3088';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_WrDataParityErr.att.mnemonic = 'TLM8_SpWStatReg9 (ASIC_RIFStat_WrDataParityErr)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_WrDataParityErr.att.start_bit = '538';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_WrDataParityErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_WrDataParityErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_WrDataParityErr.att.description = 'SpaceWire Status Reg. 9 (SpaceWire ASIC - RIF Interrupt Status - Write Data Parity Error )';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_WrDataParityErr.dim = {'hk8_packet'};

    % id 3089: TLM8_SpWStatReg9 (ASIC_RIFStat_AccessErr)
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AccessErr.att.telemetry_point_id = '3089';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AccessErr.att.mnemonic = 'TLM8_SpWStatReg9 (ASIC_RIFStat_AccessErr)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AccessErr.att.start_bit = '539';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AccessErr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AccessErr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AccessErr.att.description = 'Spacewire Status Reg. 9 (SpaceWire ASIC - RIF Interrupt Status - Access Error)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AccessErr.dim = {'hk8_packet'};

    % id 3090: TLM8_SpWStatReg9 (ASIC_RIFStat_Res)
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res.att.telemetry_point_id = '3090';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res.att.mnemonic = 'TLM8_SpWStatReg9 (ASIC_RIFStat_Res)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res.att.start_bit = '540';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res.att.num_bits = '4';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res.att.description = 'SpaceWire Status Reg. 9 (SpaceWire ASIC - RIF Interrupt Status - Reserved)';
    g_metadata.packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res.dim = {'hk8_packet'};

    % id 3091: TLM8_SpWStatReg10 (ASIC_PCIBusErrStatReg_Res)
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_Res.att.telemetry_point_id = '3091';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_Res.att.mnemonic = 'TLM8_SpWStatReg10 (ASIC_PCIBusErrStatReg_Res)';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_Res.att.start_bit = '544';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_Res.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_Res.att.num_bits = '4';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_Res.att.description = 'SpaceWire Status Reg. 10 (SpaceWire ASIC - PCI Bus Error Status Register  - Reserved)';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_Res.dim = {'hk8_packet'};

    % id 3092: TLM8_SpWStatReg10 (ASIC_PCIBusErrStatReg_PCIcmd)
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_PCIcmd.att.telemetry_point_id = '3092';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_PCIcmd.att.mnemonic = 'TLM8_SpWStatReg10 (ASIC_PCIBusErrStatReg_PCIcmd)';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_PCIcmd.att.start_bit = '548';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_PCIcmd.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_PCIcmd.att.num_bits = '4';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_PCIcmd.att.description = 'SpaceWire Status Reg. 10 (SpaceWire ASIC - PCI Bus Error Status Register - PCI Command)';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_PCIcmd.dim = {'hk8_packet'};

    % id 3093: TLM8_SpWStatReg10 (ASIC_PCIBusErrStatReg_CurrBusOwner)
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_CurrBusOwner.att.telemetry_point_id = '3093';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_CurrBusOwner.att.mnemonic = 'TLM8_SpWStatReg10 (ASIC_PCIBusErrStatReg_CurrBusOwner)';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_CurrBusOwner.att.start_bit = '552';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_CurrBusOwner.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_CurrBusOwner.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_CurrBusOwner.att.description = 'SpaceWire Status Reg. 10 (SpaceWire ASIC - PCI Bus Error Status Register - Current Bus Owner)';
    g_metadata.packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_CurrBusOwner.dim = {'hk8_packet'};

    % id 16405: TLM8_SpWStatReg11 (Missed_TOD_cntr)
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr.att.telemetry_point_id = '16405';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr.att.mnemonic = 'TLM8_SpWStatReg11 (Missed_TOD_cntr)';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr.att.start_bit = '560';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr.att.description = 'SpaceWire Status Reg. 11 (Missed TOD Counter)';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr.dim = {'hk8_packet'};

    % id 16406: TLM8_SpWStatReg11 (Missed_TOD_cntr_rollover_flag)
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr_rollover_flag.att.telemetry_point_id = '16406';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr_rollover_flag.att.mnemonic = 'TLM8_SpWStatReg11 (Missed_TOD_cntr_rollover_flag)';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr_rollover_flag.att.start_bit = '568';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr_rollover_flag.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr_rollover_flag.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr_rollover_flag.att.description = 'SpaceWire Status Reg. 11 (Missed TOD Counter rollover flag)';
    g_metadata.packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr_rollover_flag.dim = {'hk8_packet'};

    % id 3096: TLM8_SpWStatReg11 (Spare)
    g_metadata.packets.instr_hk8.SpWStatReg11_Spare.att.telemetry_point_id = '3096';
    g_metadata.packets.instr_hk8.SpWStatReg11_Spare.att.mnemonic = 'TLM8_SpWStatReg11 (Spare)';
    g_metadata.packets.instr_hk8.SpWStatReg11_Spare.att.start_bit = '569';
    g_metadata.packets.instr_hk8.SpWStatReg11_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg11_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SpWStatReg11_Spare.att.description = 'SpaceWire Status Reg. 11 (Spare)';
    g_metadata.packets.instr_hk8.SpWStatReg11_Spare.dim = {'hk8_packet'};

    % id 3097: TLM8_SpWStatReg11 (EnableDisable_TODSafeModeCntr)
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_TODSafeModeCntr.att.telemetry_point_id = '3097';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_TODSafeModeCntr.att.mnemonic = 'TLM8_SpWStatReg11 (EnableDisable_TODSafeModeCntr)';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_TODSafeModeCntr.att.start_bit = '571';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_TODSafeModeCntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_TODSafeModeCntr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_TODSafeModeCntr.att.description = 'SpaceWire Status Reg. 11 (Enable/Disable TOD Safe-Mode Counter)';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_TODSafeModeCntr.dim = {'hk8_packet'};

    % id 3098: TLM8_SpWStatReg11 (EnableDisable_LinkAB_TODCntr)
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_LinkAB_TODCntr.att.telemetry_point_id = '3098';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_LinkAB_TODCntr.att.mnemonic = 'TLM8_SpWStatReg11 (EnableDisable_LinkAB_TODCntr)';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_LinkAB_TODCntr.att.start_bit = '572';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_LinkAB_TODCntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_LinkAB_TODCntr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_LinkAB_TODCntr.att.description = 'SpaceWire Status Reg. 11 (Enable/Disable Link A/B TOD Counter)';
    g_metadata.packets.instr_hk8.SpWStatReg11_EnableDisable_LinkAB_TODCntr.dim = {'hk8_packet'};

    % id 3099: TLM8_SpWStatReg11 (TODmissed)
    g_metadata.packets.instr_hk8.SpWStatReg11_TODmissed.att.telemetry_point_id = '3099';
    g_metadata.packets.instr_hk8.SpWStatReg11_TODmissed.att.mnemonic = 'TLM8_SpWStatReg11 (TODmissed)';
    g_metadata.packets.instr_hk8.SpWStatReg11_TODmissed.att.start_bit = '573';
    g_metadata.packets.instr_hk8.SpWStatReg11_TODmissed.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg11_TODmissed.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg11_TODmissed.att.description = 'SpaceWire Status Reg. 11 (TOD missed)';
    g_metadata.packets.instr_hk8.SpWStatReg11_TODmissed.dim = {'hk8_packet'};

    % id 3100: TLM8_SpWStatReg11 (SpW_fault_log_full)
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_full.att.telemetry_point_id = '3100';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_full.att.mnemonic = 'TLM8_SpWStatReg11 (SpW_fault_log_full)';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_full.att.start_bit = '574';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_full.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_full.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_full.att.description = 'SpaceWire Status Reg. 11 (SpaceWire Fault Log Full)';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_full.dim = {'hk8_packet'};

    % id 3101: TLM8_SpWStatReg11 (SpW_fault_log_not_empty)
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_not_empty.att.telemetry_point_id = '3101';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_not_empty.att.mnemonic = 'TLM8_SpWStatReg11 (SpW_fault_log_not_empty)';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_not_empty.att.start_bit = '575';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_not_empty.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_not_empty.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_not_empty.att.description = 'SpaceWire Status Reg. 11 (SpaceWire Fault Log Not Empty)';
    g_metadata.packets.instr_hk8.SpWStatReg11_SpW_fault_log_not_empty.dim = {'hk8_packet'};

    % id 3102: TLM8_SpWStatReg12 (SpW_CCASftw_MinorVersion)
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MinorVersion.att.telemetry_point_id = '3102';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MinorVersion.att.mnemonic = 'TLM8_SpWStatReg12 (SpW_CCASftw_MinorVersion)';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MinorVersion.att.start_bit = '576';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MinorVersion.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MinorVersion.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MinorVersion.att.description = 'SpaceWire Status Reg. 12 (Spacewire CCA Software - Minor Version)';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MinorVersion.dim = {'hk8_packet'};

    % id 3103: TLM8_SpWStatReg12 (SpW_CCASftw_MajorVersion)
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MajorVersion.att.telemetry_point_id = '3103';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MajorVersion.att.mnemonic = 'TLM8_SpWStatReg12 (SpW_CCASftw_MajorVersion)';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MajorVersion.att.start_bit = '584';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MajorVersion.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MajorVersion.att.num_bits = '8';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MajorVersion.att.description = 'SpaceWire Status Reg. 12 (Spacewire CCA Software - Major Version)';
    g_metadata.packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MajorVersion.dim = {'hk8_packet'};

    % id 3104: TLM8_SpWModeStatReg (Test_Pkt)
    g_metadata.packets.instr_hk8.SpWModeStatReg_Test_Pkt.att.telemetry_point_id = '3104';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Test_Pkt.att.mnemonic = 'TLM8_SpWModeStatReg (Test_Pkt)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Test_Pkt.att.start_bit = '592';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Test_Pkt.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Test_Pkt.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Test_Pkt.att.description = 'SpaceWire Mode Status Register (Test Packet)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Test_Pkt.dim = {'hk8_packet'};

    % id 3105: TLM8_SpWModeStatReg (Online_BIT)
    g_metadata.packets.instr_hk8.SpWModeStatReg_Online_BIT.att.telemetry_point_id = '3105';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Online_BIT.att.mnemonic = 'TLM8_SpWModeStatReg (Online_BIT)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Online_BIT.att.start_bit = '593';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Online_BIT.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Online_BIT.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Online_BIT.att.description = 'SpaceWire Mode Status Register (Online BIT)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Online_BIT.dim = {'hk8_packet'};

    % id 3106: TLM8_SpWModeStatReg (LowRateDataAlg)
    g_metadata.packets.instr_hk8.SpWModeStatReg_LowRateDataAlg.att.telemetry_point_id = '3106';
    g_metadata.packets.instr_hk8.SpWModeStatReg_LowRateDataAlg.att.mnemonic = 'TLM8_SpWModeStatReg (LowRateDataAlg)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_LowRateDataAlg.att.start_bit = '594';
    g_metadata.packets.instr_hk8.SpWModeStatReg_LowRateDataAlg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_LowRateDataAlg.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SpWModeStatReg_LowRateDataAlg.att.description = 'SpaceWire Mode Status Register (Low Rate Data Algorithm)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_LowRateDataAlg.dim = {'hk8_packet'};

    % id 3107: TLM8_SpWModeStatReg (ZPD_alg)
    g_metadata.packets.instr_hk8.SpWModeStatReg_ZPD_alg.att.telemetry_point_id = '3107';
    g_metadata.packets.instr_hk8.SpWModeStatReg_ZPD_alg.att.mnemonic = 'TLM8_SpWModeStatReg (ZPD_alg)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_ZPD_alg.att.start_bit = '596';
    g_metadata.packets.instr_hk8.SpWModeStatReg_ZPD_alg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_ZPD_alg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_ZPD_alg.att.description = 'SpaceWire Mode Status Register (ZPD algorithm)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_ZPD_alg.dim = {'hk8_packet'};

    % id 3108: TLM8_SpWModeStatReg (AutoNeonCal)
    g_metadata.packets.instr_hk8.SpWModeStatReg_AutoNeonCal.att.telemetry_point_id = '3108';
    g_metadata.packets.instr_hk8.SpWModeStatReg_AutoNeonCal.att.mnemonic = 'TLM8_SpWModeStatReg (AutoNeonCal)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_AutoNeonCal.att.start_bit = '597';
    g_metadata.packets.instr_hk8.SpWModeStatReg_AutoNeonCal.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_AutoNeonCal.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_AutoNeonCal.att.description = 'SpaceWire Mode Status Register (Auto Neon Calibration)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_AutoNeonCal.dim = {'hk8_packet'};

    % id 3109: TLM8_SpWModeStatReg (Boot_EEPROM_Img_Executing)
    g_metadata.packets.instr_hk8.SpWModeStatReg_Boot_EEPROM_Img_Executing.att.telemetry_point_id = '3109';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Boot_EEPROM_Img_Executing.att.mnemonic = 'TLM8_SpWModeStatReg (Boot_EEPROM_Img_Executing)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Boot_EEPROM_Img_Executing.att.start_bit = '598';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Boot_EEPROM_Img_Executing.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Boot_EEPROM_Img_Executing.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Boot_EEPROM_Img_Executing.att.description = 'SpaceWire Mode Status Register (Boot EEPROM Image Executing)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Boot_EEPROM_Img_Executing.dim = {'hk8_packet'};

    % id 15764: TLM8_SpWModeStatReg (Thermal_Cntrl)
    g_metadata.packets.instr_hk8.SpWModeStatReg_Thermal_Cntrl.att.telemetry_point_id = '15764';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Thermal_Cntrl.att.mnemonic = 'TLM8_SpWModeStatReg (Thermal_Cntrl)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Thermal_Cntrl.att.start_bit = '599';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Thermal_Cntrl.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Thermal_Cntrl.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Thermal_Cntrl.att.description = 'SpaceWire Mode Status Register (Thermal Control Enabled)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Thermal_Cntrl.dim = {'hk8_packet'};

    % id 15765: TLM8_SpWModeStatReg (InstMode_Outgas)
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Outgas.att.telemetry_point_id = '15765';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Outgas.att.mnemonic = 'TLM8_SpWModeStatReg (InstMode_Outgas)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Outgas.att.start_bit = '600';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Outgas.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Outgas.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Outgas.att.description = 'SpaceWire Mode Status Register (Instrument Mode - Outgas)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Outgas.dim = {'hk8_packet'};

    % id 3110: TLM8_SpWModeStatReg (InstMode_Operational)
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Operational.att.telemetry_point_id = '3110';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Operational.att.mnemonic = 'TLM8_SpWModeStatReg (InstMode_Operational)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Operational.att.start_bit = '601';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Operational.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Operational.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Operational.att.description = 'SpaceWire Mode Status Register (Instrument Mode - Operational)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Operational.dim = {'hk8_packet'};

    % id 3111: TLM8_SpWModeStatReg (InstMode_Diagnostic)
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Diagnostic.att.telemetry_point_id = '3111';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Diagnostic.att.mnemonic = 'TLM8_SpWModeStatReg (InstMode_Diagnostic)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Diagnostic.att.start_bit = '602';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Diagnostic.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Diagnostic.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Diagnostic.att.description = 'SpaceWire Mode Status Register (Instrument Mode - Diagnostic)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Diagnostic.dim = {'hk8_packet'};

    % id 3112: TLM8_SpWModeStatReg (InstMode_Safe)
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Safe.att.telemetry_point_id = '3112';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Safe.att.mnemonic = 'TLM8_SpWModeStatReg (InstMode_Safe)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Safe.att.start_bit = '603';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Safe.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Safe.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Safe.att.description = 'SpaceWire Mode Status Register (Instrument Mode - Safe)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_InstMode_Safe.dim = {'hk8_packet'};

    % id 3113: TLM8_SpWModeStatReg (Spare2)
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare2.att.telemetry_point_id = '3113';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare2.att.mnemonic = 'TLM8_SpWModeStatReg (Spare2)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare2.att.start_bit = '604';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare2.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare2.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare2.att.description = 'SpaceWire Mode Status Register (Spare2)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare2.dim = {'hk8_packet'};

    % id 3114: TLM8_SpWModeStatReg (SpW_POST_Results)
    g_metadata.packets.instr_hk8.SpWModeStatReg_SpW_POST_Results.att.telemetry_point_id = '3114';
    g_metadata.packets.instr_hk8.SpWModeStatReg_SpW_POST_Results.att.mnemonic = 'TLM8_SpWModeStatReg (SpW_POST_Results)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_SpW_POST_Results.att.start_bit = '605';
    g_metadata.packets.instr_hk8.SpWModeStatReg_SpW_POST_Results.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_SpW_POST_Results.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_SpW_POST_Results.att.description = 'SpaceWire Mode Status Register (SpaceWire POST Results)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_SpW_POST_Results.dim = {'hk8_packet'};

    % id 3115: TLM8_SpWModeStatReg (PCE_POST_Results)
    g_metadata.packets.instr_hk8.SpWModeStatReg_PCE_POST_Results.att.telemetry_point_id = '3115';
    g_metadata.packets.instr_hk8.SpWModeStatReg_PCE_POST_Results.att.mnemonic = 'TLM8_SpWModeStatReg (PCE_POST_Results)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_PCE_POST_Results.att.start_bit = '606';
    g_metadata.packets.instr_hk8.SpWModeStatReg_PCE_POST_Results.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_PCE_POST_Results.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_PCE_POST_Results.att.description = 'SpaceWire Mode Status Register (PCE POST Results)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_PCE_POST_Results.dim = {'hk8_packet'};

    % id 3116: TLM8_SpWModeStatReg (Spare)
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare.att.telemetry_point_id = '3116';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare.att.mnemonic = 'TLM8_SpWModeStatReg (Spare)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare.att.start_bit = '607';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare.att.description = 'SpaceWire Mode Status Register (Spare)';
    g_metadata.packets.instr_hk8.SpWModeStatReg_Spare.dim = {'hk8_packet'};

    % id 3117: TLM8_Telem_command_success_count MSW
    g_metadata.packets.instr_hk8.Telem_command_success_count_MSW.att.telemetry_point_id = '3117';
    g_metadata.packets.instr_hk8.Telem_command_success_count_MSW.att.mnemonic = 'TLM8_Telem_command_success_count MSW';
    g_metadata.packets.instr_hk8.Telem_command_success_count_MSW.att.start_bit = '608';
    g_metadata.packets.instr_hk8.Telem_command_success_count_MSW.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Telem_command_success_count_MSW.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Telem_command_success_count_MSW.att.description = 'Tlm Cmd Success Count MSW';
    g_metadata.packets.instr_hk8.Telem_command_success_count_MSW.dim = {'hk8_packet'};

    % id 3118: TLM8_Telem_command_success_count LSW
    g_metadata.packets.instr_hk8.Telem_command_success_count_LSW.att.telemetry_point_id = '3118';
    g_metadata.packets.instr_hk8.Telem_command_success_count_LSW.att.mnemonic = 'TLM8_Telem_command_success_count LSW';
    g_metadata.packets.instr_hk8.Telem_command_success_count_LSW.att.start_bit = '624';
    g_metadata.packets.instr_hk8.Telem_command_success_count_LSW.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Telem_command_success_count_LSW.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Telem_command_success_count_LSW.att.description = 'Tlm Cmd Success Count LSW';
    g_metadata.packets.instr_hk8.Telem_command_success_count_LSW.dim = {'hk8_packet'};

    % id 3119: TLM8_IfmStatFlg (spare1)
    g_metadata.packets.instr_hk8.IfmStatFlg_spare1.att.telemetry_point_id = '3119';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare1.att.mnemonic = 'TLM8_IfmStatFlg (spare1)';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare1.att.start_bit = '640';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare1.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare1.att.num_bits = '5';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare1.att.description = 'IFM Status Flag(Spare)';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare1.dim = {'hk8_packet'};

    % id 3120: TLM8_IfmStatFlg (Infererom Mode Stat)
    g_metadata.packets.instr_hk8.IfmStatFlg_Infererom_Mode_Stat.att.telemetry_point_id = '3120';
    g_metadata.packets.instr_hk8.IfmStatFlg_Infererom_Mode_Stat.att.mnemonic = 'TLM8_IfmStatFlg (Infererom Mode Stat)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Infererom_Mode_Stat.att.start_bit = '645';
    g_metadata.packets.instr_hk8.IfmStatFlg_Infererom_Mode_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_Infererom_Mode_Stat.att.num_bits = '2';
    g_metadata.packets.instr_hk8.IfmStatFlg_Infererom_Mode_Stat.att.description = 'IFM Status Flag(Interferometer Mode Status)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Infererom_Mode_Stat.dim = {'hk8_packet'};

    % id 3121: TLM8_IfmStatFlg (spare2)
    g_metadata.packets.instr_hk8.IfmStatFlg_spare2.att.telemetry_point_id = '3121';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare2.att.mnemonic = 'TLM8_IfmStatFlg (spare2)';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare2.att.start_bit = '647';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare2.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare2.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare2.att.description = 'IFM Status Flag(Spare)';
    g_metadata.packets.instr_hk8.IfmStatFlg_spare2.dim = {'hk8_packet'};

    % id 3122: TLM8_IfmStatFlg (Porchswing Sweep Dir)
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Dir.att.telemetry_point_id = '3122';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Dir.att.mnemonic = 'TLM8_IfmStatFlg (Porchswing Sweep Dir)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Dir.att.start_bit = '648';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Dir.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Dir.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Dir.att.description = 'IFM Status Flag(Porchswing Sweep Direction)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Dir.dim = {'hk8_packet'};

    % id 3123: TLM8_IfmStatFlg (Porchswing Sweep Lck)
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Lck.att.telemetry_point_id = '3123';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Lck.att.mnemonic = 'TLM8_IfmStatFlg (Porchswing Sweep Lck)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Lck.att.start_bit = '649';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Lck.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Lck.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Lck.att.description = 'IFM Status Flag(Porchswing Sweep Locked)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Lck.dim = {'hk8_packet'};

    % id 3124: TLM8_IfmStatFlg (Loss PCE Frame Sync Pulse Stat)
    g_metadata.packets.instr_hk8.IfmStatFlg_Loss_PCE_Frame_Sync_Pulse_Stat.att.telemetry_point_id = '3124';
    g_metadata.packets.instr_hk8.IfmStatFlg_Loss_PCE_Frame_Sync_Pulse_Stat.att.mnemonic = 'TLM8_IfmStatFlg (Loss PCE Frame Sync Pulse Stat)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Loss_PCE_Frame_Sync_Pulse_Stat.att.start_bit = '650';
    g_metadata.packets.instr_hk8.IfmStatFlg_Loss_PCE_Frame_Sync_Pulse_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_Loss_PCE_Frame_Sync_Pulse_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmStatFlg_Loss_PCE_Frame_Sync_Pulse_Stat.att.description = 'IFM Status Flag(Loss of PCE Frame Sync Pulse Status)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Loss_PCE_Frame_Sync_Pulse_Stat.dim = {'hk8_packet'};

    % id 3125: TLM8_IfmStatFlg (Porchswing MPD+ Switch Stat)
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_MPD_Switch_Stat.att.telemetry_point_id = '3125';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_MPD_Switch_Stat.att.mnemonic = 'TLM8_IfmStatFlg (Porchswing MPD+ Switch Stat)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_MPD_Switch_Stat.att.start_bit = '651';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_MPD_Switch_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_MPD_Switch_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_MPD_Switch_Stat.att.description = 'IFM Status Flag(Porchswing Mean Path Differential Switch Status)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_MPD_Switch_Stat.dim = {'hk8_packet'};

    % id 3126: TLM8_IfmStatFlg (Porchswing ZPD Switch Stat)
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_ZPD_Switch_Stat.att.telemetry_point_id = '3126';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_ZPD_Switch_Stat.att.mnemonic = 'TLM8_IfmStatFlg (Porchswing ZPD Switch Stat)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_ZPD_Switch_Stat.att.start_bit = '652';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_ZPD_Switch_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_ZPD_Switch_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_ZPD_Switch_Stat.att.description = 'IFM Status Flag(Porchswing Zero Path Differential Switch Status)';
    g_metadata.packets.instr_hk8.IfmStatFlg_Porchswing_ZPD_Switch_Stat.dim = {'hk8_packet'};

    % id 3127: TLM8_IfmStatFlg (DA Servo Status)
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Servo_Status.att.telemetry_point_id = '3127';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Servo_Status.att.mnemonic = 'TLM8_IfmStatFlg (DA Servo Status)';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Servo_Status.att.start_bit = '653';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Servo_Status.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Servo_Status.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Servo_Status.att.description = 'IFM Status Flag(DA Servo Status)';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Servo_Status.dim = {'hk8_packet'};

    % id 3128: TLM8_IfmStatFlg (DA - Y servo locked)
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Y_servo_locked.att.telemetry_point_id = '3128';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Y_servo_locked.att.mnemonic = 'TLM8_IfmStatFlg (DA - Y servo locked)';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Y_servo_locked.att.start_bit = '654';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Y_servo_locked.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Y_servo_locked.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Y_servo_locked.att.description = 'IFM Status Flag(DA-Y servo locked)';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_Y_servo_locked.dim = {'hk8_packet'};

    % id 3129: TLM8_IfmStatFlg (DA - X servo locked)
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_X_servo_locked.att.telemetry_point_id = '3129';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_X_servo_locked.att.mnemonic = 'TLM8_IfmStatFlg (DA - X servo locked)';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_X_servo_locked.att.start_bit = '655';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_X_servo_locked.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_X_servo_locked.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_X_servo_locked.att.description = 'IFMStatus Flag(DA-X servo locked)';
    g_metadata.packets.instr_hk8.IfmStatFlg_DA_X_servo_locked.dim = {'hk8_packet'};

    % id 3130: TLM8_SSMStatWrd (CT Over-Speed Trip)
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Over_Speed_Trip.att.telemetry_point_id = '3130';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Over_Speed_Trip.att.mnemonic = 'TLM8_SSMStatWrd (CT Over-Speed Trip)';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Over_Speed_Trip.att.start_bit = '656';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Over_Speed_Trip.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Over_Speed_Trip.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Over_Speed_Trip.att.description = 'SSM Status Word(X-Track Over-speed Trip)';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Over_Speed_Trip.dim = {'hk8_packet'};

    % id 3131: TLM8_SSMStatWrd (Spare)
    g_metadata.packets.instr_hk8.SSMStatWrd_Spare.att.telemetry_point_id = '3131';
    g_metadata.packets.instr_hk8.SSMStatWrd_Spare.att.mnemonic = 'TLM8_SSMStatWrd (Spare)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Spare.att.start_bit = '657';
    g_metadata.packets.instr_hk8.SSMStatWrd_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_Spare.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_Spare.att.description = 'SSM Status Word(Spare)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Spare.dim = {'hk8_packet'};

    % id 3132: TLM8_SSMStatWrd (Redundant Drv Relay Fault)
    g_metadata.packets.instr_hk8.SSMStatWrd_Redundant_Drv_Relay_Fault.att.telemetry_point_id = '3132';
    g_metadata.packets.instr_hk8.SSMStatWrd_Redundant_Drv_Relay_Fault.att.mnemonic = 'TLM8_SSMStatWrd (Redundant Drv Relay Fault)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Redundant_Drv_Relay_Fault.att.start_bit = '658';
    g_metadata.packets.instr_hk8.SSMStatWrd_Redundant_Drv_Relay_Fault.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_Redundant_Drv_Relay_Fault.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_Redundant_Drv_Relay_Fault.att.description = 'SSM Status Word(Redundant Drive Relay Fault)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Redundant_Drv_Relay_Fault.dim = {'hk8_packet'};

    % id 3133: TLM8_SSMStatWrd (Loss 8 Sec Sync Stat)
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_8_Sec_Sync_Stat.att.telemetry_point_id = '3133';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_8_Sec_Sync_Stat.att.mnemonic = 'TLM8_SSMStatWrd (Loss 8 Sec Sync Stat)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_8_Sec_Sync_Stat.att.start_bit = '659';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_8_Sec_Sync_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_8_Sec_Sync_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_8_Sec_Sync_Stat.att.description = 'SSM Status Word(Loss of 8 Sec Sync Status)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_8_Sec_Sync_Stat.dim = {'hk8_packet'};

    % id 3134: TLM8_SSMStatWrd (IT Vel Compen Act/Idle)
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Vel_Compen_Act_Idle.att.telemetry_point_id = '3134';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Vel_Compen_Act_Idle.att.mnemonic = 'TLM8_SSMStatWrd (IT Vel Compen Act/Idle)';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Vel_Compen_Act_Idle.att.start_bit = '660';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Vel_Compen_Act_Idle.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Vel_Compen_Act_Idle.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Vel_Compen_Act_Idle.att.description = 'SSM Status Word(In-Track Velocity Compensation Active/Idle)';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Vel_Compen_Act_Idle.dim = {'hk8_packet'};

    % id 3135: TLM8_SSMStatWrd (CT Axis Motor Winding Temp Go/NoGo)
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Axis_Motor_Winding_Temp_Go_NoGo.att.telemetry_point_id = '3135';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Axis_Motor_Winding_Temp_Go_NoGo.att.mnemonic = 'TLM8_SSMStatWrd (CT Axis Motor Winding Temp Go/NoGo)';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Axis_Motor_Winding_Temp_Go_NoGo.att.start_bit = '661';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Axis_Motor_Winding_Temp_Go_NoGo.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Axis_Motor_Winding_Temp_Go_NoGo.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Axis_Motor_Winding_Temp_Go_NoGo.att.description = 'SSM Status Word(X-Track Axis Motor Winding Temp Go/No Go)';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Axis_Motor_Winding_Temp_Go_NoGo.dim = {'hk8_packet'};

    % id 3136: TLM8_SSMStatWrd (IT Axis Motor Winding Temp Go/NoGo)
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Axis_Motor_Winding_Temp_Go_NoGo.att.telemetry_point_id = '3136';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Axis_Motor_Winding_Temp_Go_NoGo.att.mnemonic = 'TLM8_SSMStatWrd (IT Axis Motor Winding Temp Go/NoGo)';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Axis_Motor_Winding_Temp_Go_NoGo.att.start_bit = '662';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Axis_Motor_Winding_Temp_Go_NoGo.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Axis_Motor_Winding_Temp_Go_NoGo.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Axis_Motor_Winding_Temp_Go_NoGo.att.description = 'SSM Status Word(In-Track Axis Motor Winding Temp Go/No Go)';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Axis_Motor_Winding_Temp_Go_NoGo.dim = {'hk8_packet'};

    % id 3137: TLM8_SSMStatWrd (Primary PW Current Monitor Go/NoGo)
    g_metadata.packets.instr_hk8.SSMStatWrd_Primary_PW_Current_Monitor_Go_NoGo.att.telemetry_point_id = '3137';
    g_metadata.packets.instr_hk8.SSMStatWrd_Primary_PW_Current_Monitor_Go_NoGo.att.mnemonic = 'TLM8_SSMStatWrd (Primary PW Current Monitor Go/NoGo)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Primary_PW_Current_Monitor_Go_NoGo.att.start_bit = '663';
    g_metadata.packets.instr_hk8.SSMStatWrd_Primary_PW_Current_Monitor_Go_NoGo.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_Primary_PW_Current_Monitor_Go_NoGo.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_Primary_PW_Current_Monitor_Go_NoGo.att.description = 'SSM Status Word(Primary Power Current Monitor Go/No Go Bit)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Primary_PW_Current_Monitor_Go_NoGo.dim = {'hk8_packet'};

    % id 3138: TLM8_SSMStatWrd (SSm Mode Stat)
    g_metadata.packets.instr_hk8.SSMStatWrd_SSm_Mode_Stat.att.telemetry_point_id = '3138';
    g_metadata.packets.instr_hk8.SSMStatWrd_SSm_Mode_Stat.att.mnemonic = 'TLM8_SSMStatWrd (SSm Mode Stat)';
    g_metadata.packets.instr_hk8.SSMStatWrd_SSm_Mode_Stat.att.start_bit = '664';
    g_metadata.packets.instr_hk8.SSMStatWrd_SSm_Mode_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_SSm_Mode_Stat.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SSMStatWrd_SSm_Mode_Stat.att.description = 'SSM Status Word(SSM Mode Status)';
    g_metadata.packets.instr_hk8.SSMStatWrd_SSm_Mode_Stat.dim = {'hk8_packet'};

    % id 3139: TLM8_SSMStatWrd (Motion Compen Active/Idle)
    g_metadata.packets.instr_hk8.SSMStatWrd_Motion_Compen_Active_Idle.att.telemetry_point_id = '3139';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motion_Compen_Active_Idle.att.mnemonic = 'TLM8_SSMStatWrd (Motion Compen Active/Idle)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motion_Compen_Active_Idle.att.start_bit = '666';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motion_Compen_Active_Idle.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motion_Compen_Active_Idle.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motion_Compen_Active_Idle.att.description = 'SSM Status Word(Motion Compensation Active/Idle)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motion_Compen_Active_Idle.dim = {'hk8_packet'};

    % id 3140: TLM8_SSMStatWrd (CT Motor Drv OvLoad Trip)
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Motor_Drv_OvLoad_Trip.att.telemetry_point_id = '3140';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Motor_Drv_OvLoad_Trip.att.mnemonic = 'TLM8_SSMStatWrd (CT Motor Drv OvLoad Trip)';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Motor_Drv_OvLoad_Trip.att.start_bit = '667';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Motor_Drv_OvLoad_Trip.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Motor_Drv_OvLoad_Trip.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Motor_Drv_OvLoad_Trip.att.description = 'SSM Status Word(X-Track Motor Drive Overload Trip)';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Motor_Drv_OvLoad_Trip.dim = {'hk8_packet'};

    % id 3141: TLM8_SSMStatWrd (IT Motor Drv OvLoad Trip)
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Motor_Drv_OvLoad_Trip.att.telemetry_point_id = '3141';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Motor_Drv_OvLoad_Trip.att.mnemonic = 'TLM8_SSMStatWrd (IT Motor Drv OvLoad Trip)';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Motor_Drv_OvLoad_Trip.att.start_bit = '668';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Motor_Drv_OvLoad_Trip.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Motor_Drv_OvLoad_Trip.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Motor_Drv_OvLoad_Trip.att.description = 'SSM Status Word(In-Track Motor Drive Overload Trip)';
    g_metadata.packets.instr_hk8.SSMStatWrd_IT_Motor_Drv_OvLoad_Trip.dim = {'hk8_packet'};

    % id 3142: TLM8_SSMStatWrd (Loss 200ms Sync Stat)
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_200ms_Sync_Stat.att.telemetry_point_id = '3142';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_200ms_Sync_Stat.att.mnemonic = 'TLM8_SSMStatWrd (Loss 200ms Sync Stat)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_200ms_Sync_Stat.att.start_bit = '669';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_200ms_Sync_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_200ms_Sync_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_200ms_Sync_Stat.att.description = 'SSM Status Word(Loss of 200 mSec Sync Status)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Loss_200ms_Sync_Stat.dim = {'hk8_packet'};

    % id 3143: TLM8_SSMStatWrd (Motor Drives on/off)
    g_metadata.packets.instr_hk8.SSMStatWrd_Motor_Drives_on_off.att.telemetry_point_id = '3143';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motor_Drives_on_off.att.mnemonic = 'TLM8_SSMStatWrd (Motor Drives on/off)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motor_Drives_on_off.att.start_bit = '670';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motor_Drives_on_off.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motor_Drives_on_off.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motor_Drives_on_off.att.description = 'SSM Status Word(Motor Drives On/Off)';
    g_metadata.packets.instr_hk8.SSMStatWrd_Motor_Drives_on_off.dim = {'hk8_packet'};

    % id 3144: TLM8_SSMStatWrd (CT Encoder Stat)
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Encoder_Stat.att.telemetry_point_id = '3144';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Encoder_Stat.att.mnemonic = 'TLM8_SSMStatWrd (CT Encoder Stat)';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Encoder_Stat.att.start_bit = '671';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Encoder_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Encoder_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Encoder_Stat.att.description = 'SSM Status Word(X-Track Encoder Status)';
    g_metadata.packets.instr_hk8.SSMStatWrd_CT_Encoder_Stat.dim = {'hk8_packet'};

    % id 3145: TLM8_IFC Interrupt Reg 1 (PCI Internal Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Internal_Err.att.telemetry_point_id = '3145';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Internal_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Internal Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Internal_Err.att.start_bit = '672';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Internal_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Internal_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Internal_Err.att.description = 'IFC Interrupt Reg. 1(PCI Internal Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Internal_Err.dim = {'hk8_packet'};

    % id 3146: TLM8_IFC Interrupt Reg 1 (PCI Rst Detected)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Rst_Detected.att.telemetry_point_id = '3146';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Rst_Detected.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Rst Detected)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Rst_Detected.att.start_bit = '673';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Rst_Detected.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Rst_Detected.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Rst_Detected.att.description = 'IFC Interrupt Reg. 1(PCI Reset Detected)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Rst_Detected.dim = {'hk8_packet'};

    % id 3147: TLM8_IFC Interrupt Reg 1 (PCI Protocol Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Protocol_Err.att.telemetry_point_id = '3147';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Protocol_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Protocol Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Protocol_Err.att.start_bit = '674';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Protocol_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Protocol_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Protocol_Err.att.description = 'IFC Interrupt Reg. 1(PCI Protocol Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Protocol_Err.dim = {'hk8_packet'};

    % id 3148: TLM8_IFC Interrupt Reg 1 (PCI SERR Detected)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_SERR_Detected.att.telemetry_point_id = '3148';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_SERR_Detected.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI SERR Detected)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_SERR_Detected.att.start_bit = '675';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_SERR_Detected.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_SERR_Detected.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_SERR_Detected.att.description = 'IFC Interrupt Reg. 1(PCI System Error Detected)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_SERR_Detected.dim = {'hk8_packet'};

    % id 3149: TLM8_IFC Interrupt Reg 1 (PCI Bus Addr Par Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Bus_Addr_Par_Err.att.telemetry_point_id = '3149';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Bus_Addr_Par_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Bus Addr Par Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Bus_Addr_Par_Err.att.start_bit = '676';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Bus_Addr_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Bus_Addr_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Bus_Addr_Par_Err.att.description = 'IFC Interrupt Reg. 1(PCI Bus Address Parity Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Bus_Addr_Par_Err.dim = {'hk8_packet'};

    % id 3150: TLM8_IFC Interrupt Reg 1 (PCI Arbiter TO)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbiter_TO.att.telemetry_point_id = '3150';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbiter_TO.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Arbiter TO)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbiter_TO.att.start_bit = '677';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbiter_TO.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbiter_TO.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbiter_TO.att.description = 'IFC Interrupt Reg. 1(PCI Arbiter Timeout)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbiter_TO.dim = {'hk8_packet'};

    % id 3151: TLM8_IFC Interrupt Reg 1 (PCI Dat Phase TO)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Dat_Phase_TO.att.telemetry_point_id = '3151';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Dat_Phase_TO.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Dat Phase TO)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Dat_Phase_TO.att.start_bit = '678';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Dat_Phase_TO.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Dat_Phase_TO.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Dat_Phase_TO.att.description = 'IFC Interrupt Reg. 1(PCI Dat Phase Timeout)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Dat_Phase_TO.dim = {'hk8_packet'};

    % id 3152: TLM8_IFC Interrupt Reg 1 (PCI Arbitration Laten TO)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbitration_Laten_TO.att.telemetry_point_id = '3152';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbitration_Laten_TO.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Arbitration Laten TO)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbitration_Laten_TO.att.start_bit = '679';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbitration_Laten_TO.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbitration_Laten_TO.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbitration_Laten_TO.att.description = 'IFC Interrupt Reg. 1(PCI Arbitration Laten Timeout)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbitration_Laten_TO.dim = {'hk8_packet'};

    % id 3153: TLM8_IFC Interrupt Reg 1 (Reserved)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Reserved.att.telemetry_point_id = '3153';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Reserved.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (Reserved)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Reserved.att.start_bit = '680';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Reserved.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Reserved.att.description = 'IFC Interrupt Reg. 1(Reserved)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Reserved.dim = {'hk8_packet'};

    % id 3154: TLM8_IFC Interrupt Reg 1 (PCI Initiator PERR Rcv)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_PERR_Rcv.att.telemetry_point_id = '3154';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_PERR_Rcv.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Initiator PERR Rcv)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_PERR_Rcv.att.start_bit = '681';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_PERR_Rcv.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_PERR_Rcv.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_PERR_Rcv.att.description = 'IFC Interrupt Reg. 1(PCI Initiator Parity Error Receive)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_PERR_Rcv.dim = {'hk8_packet'};

    % id 3155: TLM8_IFC Interrupt Reg 1 (PCI Initiator Dat Par Err Detected)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Dat_Par_Err_Detected.att.telemetry_point_id = '3155';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Dat_Par_Err_Detected.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Initiator Dat Par Err Detected)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Dat_Par_Err_Detected.att.start_bit = '682';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Dat_Par_Err_Detected.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Dat_Par_Err_Detected.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Dat_Par_Err_Detected.att.description = 'IFC Interrupt Reg. 1(PCI Initiator Dat Parity Error Detected)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Dat_Par_Err_Detected.dim = {'hk8_packet'};

    % id 3156: TLM8_IFC Interrupt Reg 1 (PCI Initiator Rdy Par Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Rdy_Par_Err.att.telemetry_point_id = '3156';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Rdy_Par_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Initiator Rdy Par Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Rdy_Par_Err.att.start_bit = '683';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Rdy_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Rdy_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Rdy_Par_Err.att.description = 'IFC Interrupt Reg. 1(PCI Initiator Ready Parity Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Rdy_Par_Err.dim = {'hk8_packet'};

    % id 3157: TLM8_IFC Interrupt Reg 1 (Mem Spc Overlap Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Mem_Spc_Overlap_Err.att.telemetry_point_id = '3157';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Mem_Spc_Overlap_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (Mem Spc Overlap Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Mem_Spc_Overlap_Err.att.start_bit = '684';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Mem_Spc_Overlap_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Mem_Spc_Overlap_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Mem_Spc_Overlap_Err.att.description = 'IFC Interrupt Reg. 1(Memory Space Overlap Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_Mem_Spc_Overlap_Err.dim = {'hk8_packet'};

    % id 3158: TLM8_IFC Interrupt Reg 1 (PCI Target PERR Rcv)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_PERR_Rcv.att.telemetry_point_id = '3158';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_PERR_Rcv.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Target PERR Rcv)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_PERR_Rcv.att.start_bit = '685';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_PERR_Rcv.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_PERR_Rcv.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_PERR_Rcv.att.description = 'IFC Interrupt Reg. 1(PCI Target PERR Receive)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_PERR_Rcv.dim = {'hk8_packet'};

    % id 3159: TLM8_IFC Interrupt Reg 1 (PCI Target Dat Par Err Detected)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Dat_Par_Err_Detected.att.telemetry_point_id = '3159';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Dat_Par_Err_Detected.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Target Dat Par Err Detected)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Dat_Par_Err_Detected.att.start_bit = '686';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Dat_Par_Err_Detected.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Dat_Par_Err_Detected.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Dat_Par_Err_Detected.att.description = 'IFC Interrupt Reg. 1(PCI Target Data Parity Error Detected)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Dat_Par_Err_Detected.dim = {'hk8_packet'};

    % id 3160: TLM8_IFC Interrupt Reg 1 (PCI Target Rdy Par Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Rdy_Par_Err.att.telemetry_point_id = '3160';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Rdy_Par_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 1 (PCI Target Rdy Par Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Rdy_Par_Err.att.start_bit = '687';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Rdy_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Rdy_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Rdy_Par_Err.att.description = 'IFC Interrupt Reg. 1(PCI Target Ready Parity Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Rdy_Par_Err.dim = {'hk8_packet'};

    % id 3161: TLM8_IFC Interrupt Reg 2 (PCI Detected Par Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Detected_Par_Err.att.telemetry_point_id = '3161';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Detected_Par_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI Detected Par Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Detected_Par_Err.att.start_bit = '688';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Detected_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Detected_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Detected_Par_Err.att.description = 'IFC Interrupt Reg. 2(PCI Detected Parity Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Detected_Par_Err.dim = {'hk8_packet'};

    % id 3162: TLM8_IFC Interrupt Reg 2 (PCI Signalled Sys Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Signalled_Sys_Err.att.telemetry_point_id = '3162';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Signalled_Sys_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI Signalled Sys Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Signalled_Sys_Err.att.start_bit = '689';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Signalled_Sys_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Signalled_Sys_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Signalled_Sys_Err.att.description = 'IFC Interrupt Reg. 2(PCI Signaled System Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Signalled_Sys_Err.dim = {'hk8_packet'};

    % id 3163: TLM8_IFC Interrupt Reg 2 (PCI Rcv Master Abort)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Master_Abort.att.telemetry_point_id = '3163';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Master_Abort.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI Rcv Master Abort)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Master_Abort.att.start_bit = '690';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Master_Abort.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Master_Abort.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Master_Abort.att.description = 'IFC Interrupt Reg. 2(PCI Receive Master Abort)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Master_Abort.dim = {'hk8_packet'};

    % id 3164: TLM8_IFC Interrupt Reg 2 (PCI Rcv Target Abort)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Target_Abort.att.telemetry_point_id = '3164';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Target_Abort.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI Rcv Target Abort)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Target_Abort.att.start_bit = '691';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Target_Abort.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Target_Abort.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Target_Abort.att.description = 'IFC Interrupt Reg. 2(PCI Receive Target Abort)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Target_Abort.dim = {'hk8_packet'};

    % id 3165: TLM8_IFC Interrupt Reg 2 (PCI Sig Target Abort)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Sig_Target_Abort.att.telemetry_point_id = '3165';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Sig_Target_Abort.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI Sig Target Abort)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Sig_Target_Abort.att.start_bit = '692';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Sig_Target_Abort.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Sig_Target_Abort.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Sig_Target_Abort.att.description = 'IFC Interrupt Reg. 2(PCI Signal Target Abort)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Sig_Target_Abort.dim = {'hk8_packet'};

    % id 3166: TLM8_IFC Interrupt Reg 2 (Res)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_Res.att.telemetry_point_id = '3166';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_Res.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (Res)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_Res.att.start_bit = '693';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_Res.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_Res.att.num_bits = '2';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_Res.att.description = 'IFC Interrupt Reg. 2(Reserved)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_Res.dim = {'hk8_packet'};

    % id 3167: TLM8_IFC Interrupt Reg 2 (PCI Master Dat Par Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Master_Dat_Par_Err.att.telemetry_point_id = '3167';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Master_Dat_Par_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI Master Dat Par Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Master_Dat_Par_Err.att.start_bit = '695';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Master_Dat_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Master_Dat_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Master_Dat_Par_Err.att.description = 'IFC Interrupt Reg. 2(PCI Master Dat Parity Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Master_Dat_Par_Err.dim = {'hk8_packet'};

    % id 3168: TLM8_IFC Interrupt Reg 2 (PCI OCB Master Dat Read Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Read_Err.att.telemetry_point_id = '3168';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Read_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI OCB Master Dat Read Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Read_Err.att.start_bit = '696';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Read_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Read_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Read_Err.att.description = 'IFC Interrupt Reg. 2(PCI On Chip Bus Master Data Read Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Read_Err.dim = {'hk8_packet'};

    % id 3169: TLM8_IFC Interrupt Reg 2 (PCI OCB Master Dat Par Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Par_Err.att.telemetry_point_id = '3169';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Par_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI OCB Master Dat Par Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Par_Err.att.start_bit = '697';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Par_Err.att.description = 'IFC Interrupt Reg. 2(PCI On Chip Bus Master Data Parity Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Par_Err.dim = {'hk8_packet'};

    % id 3170: TLM8_IFC Interrupt Reg 2 (PCI OCB Write Buff Par Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Write_Buff_Par_Err.att.telemetry_point_id = '3170';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Write_Buff_Par_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI OCB Write Buff Par Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Write_Buff_Par_Err.att.start_bit = '698';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Write_Buff_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Write_Buff_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Write_Buff_Par_Err.att.description = 'IFC Interrupt Reg. 2(PCI On Chip Bus Write Buffer Parity Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Write_Buff_Par_Err.dim = {'hk8_packet'};

    % id 3171: TLM8_IFC Interrupt Reg 2 (PCI OCB Slv BE Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_BE_Err.att.telemetry_point_id = '3171';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_BE_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI OCB Slv BE Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_BE_Err.att.start_bit = '699';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_BE_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_BE_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_BE_Err.att.description = 'IFC Interrupt Reg. 2(PCI On Chip Bus Slave Byte Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_BE_Err.dim = {'hk8_packet'};

    % id 3172: TLM8_IFC Interrupt Reg 2 (PCI OCB Slv Dat Par Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_Dat_Par_Err.att.telemetry_point_id = '3172';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_Dat_Par_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI OCB Slv Dat Par Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_Dat_Par_Err.att.start_bit = '700';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_Dat_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_Dat_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_Dat_Par_Err.att.description = 'IFC Interrupt Reg. 2(PCI On Chip Bus Slave Data Parity Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_Dat_Par_Err.dim = {'hk8_packet'};

    % id 3173: TLM8_IFC Interrupt Reg 2 (PCI Invld OCB Access)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Access.att.telemetry_point_id = '3173';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Access.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI Invld OCB Access)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Access.att.start_bit = '701';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Access.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Access.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Access.att.description = 'IFC Interrupt Reg. 2(PCI Invalid On Chip Bus Access)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Access.dim = {'hk8_packet'};

    % id 3174: TLM8_IFC Interrupt Reg 2 (PCI Invld OCB Addr)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Addr.att.telemetry_point_id = '3174';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Addr.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI Invld OCB Addr)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Addr.att.start_bit = '702';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Addr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Addr.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Addr.att.description = 'IFC Interrupt Reg. 2(PCI Invalid On Chip Bus Address)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Addr.dim = {'hk8_packet'};

    % id 3175: TLM8_IFC Interrupt Reg 2 (PCI OCB Addr Par Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Addr_Par_Err.att.telemetry_point_id = '3175';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Addr_Par_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 2 (PCI OCB Addr Par Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Addr_Par_Err.att.start_bit = '703';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Addr_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Addr_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Addr_Par_Err.att.description = 'IFC Interrupt Reg. 2(PCI On Chip Bus Address Parity Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Addr_Par_Err.dim = {'hk8_packet'};

    % id 3176: TLM8_IFC Interrupt Reg 3 (Spare)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Spare.att.telemetry_point_id = '3176';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Spare.att.mnemonic = 'TLM8_IFC Interrupt Reg 3 (Spare)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Spare.att.start_bit = '704';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Spare.att.num_bits = '11';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Spare.att.description = 'IFC Interrupt Reg. 3(Spare)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Spare.dim = {'hk8_packet'};

    % id 16386: TLM8_IFC Interrupt Reg 3 (OCB MCP Error)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_OCB_MCP_Error.att.telemetry_point_id = '16386';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_OCB_MCP_Error.att.mnemonic = 'TLM8_IFC Interrupt Reg 3 (OCB MCP Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_OCB_MCP_Error.att.start_bit = '715';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_OCB_MCP_Error.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_OCB_MCP_Error.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_OCB_MCP_Error.att.description = 'IFC Interrupt Reg. 3(OCB MCP Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_OCB_MCP_Error.dim = {'hk8_packet'};

    % id 16387: TLM8_IFC Interrupt Reg 3 (60x MCP Error)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_60x_MCP_Error.att.telemetry_point_id = '16387';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_60x_MCP_Error.att.mnemonic = 'TLM8_IFC Interrupt Reg 3 (60x MCP Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_60x_MCP_Error.att.start_bit = '716';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_60x_MCP_Error.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_60x_MCP_Error.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_60x_MCP_Error.att.description = 'IFC Interrupt Reg. 3(60x MCP Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_60x_MCP_Error.dim = {'hk8_packet'};

    % id 16388: TLM8_IFC Interrupt Reg 3 (Power PCI Internal Bus Error)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Power_PCI_Internal_Bus_Error.att.telemetry_point_id = '16388';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Power_PCI_Internal_Bus_Error.att.mnemonic = 'TLM8_IFC Interrupt Reg 3 (Power PCI Internal Bus Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Power_PCI_Internal_Bus_Error.att.start_bit = '717';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Power_PCI_Internal_Bus_Error.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Power_PCI_Internal_Bus_Error.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Power_PCI_Internal_Bus_Error.att.description = 'IFC Interrupt Reg. 3(Power PCI Internal Bus Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Power_PCI_Internal_Bus_Error.dim = {'hk8_packet'};

    % id 3178: TLM8_IFC Interrupt Reg 3 (Address out of range)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Address_out_of_range.att.telemetry_point_id = '3178';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Address_out_of_range.att.mnemonic = 'TLM8_IFC Interrupt Reg 3 (Address out of range)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Address_out_of_range.att.start_bit = '718';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Address_out_of_range.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Address_out_of_range.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Address_out_of_range.att.description = 'IFC Interrupt Reg. 3(Address out of range)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Address_out_of_range.dim = {'hk8_packet'};

    % id 3179: TLM8_IFC Interrupt Reg 3 (Memory control interface error)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Memory_control_interface_error.att.telemetry_point_id = '3179';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Memory_control_interface_error.att.mnemonic = 'TLM8_IFC Interrupt Reg 3 (Memory control interface error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Memory_control_interface_error.att.start_bit = '719';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Memory_control_interface_error.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Memory_control_interface_error.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Memory_control_interface_error.att.description = 'IFC Interrupt Reg. 3(Memory Ctrl I/F error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_3_Memory_control_interface_error.dim = {'hk8_packet'};

    % id 3180: TLM8_IFC Interrupt Reg 4 (Invld Request on Mem Req I/F Write)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Request_on_Mem_Req_I_F_Write.att.telemetry_point_id = '3180';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Request_on_Mem_Req_I_F_Write.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Invld Request on Mem Req I/F Write)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Request_on_Mem_Req_I_F_Write.att.start_bit = '720';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Request_on_Mem_Req_I_F_Write.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Request_on_Mem_Req_I_F_Write.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Request_on_Mem_Req_I_F_Write.att.description = 'IFC Interrupt Reg. 4(Invalid Request on Memory Required I/F Write)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Request_on_Mem_Req_I_F_Write.dim = {'hk8_packet'};

    % id 3181: TLM8_IFC Interrupt Reg 4 (Addr Par Err on Mem Config Interface)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Par_Err_on_Mem_Config_Interface.att.telemetry_point_id = '3181';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Par_Err_on_Mem_Config_Interface.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Addr Par Err on Mem Config Interface)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Par_Err_on_Mem_Config_Interface.att.start_bit = '721';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Par_Err_on_Mem_Config_Interface.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Par_Err_on_Mem_Config_Interface.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Par_Err_on_Mem_Config_Interface.att.description = 'IFC Interrupt Reg. 4(Address Parity Error on Memory Config I/F)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Par_Err_on_Mem_Config_Interface.dim = {'hk8_packet'};

    % id 3182: TLM8_IFC Interrupt Reg 4 (Dat Par Err on Mem Config Interface Write)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Dat_Par_Err_on_Mem_Config_Interface_Write.att.telemetry_point_id = '3182';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Dat_Par_Err_on_Mem_Config_Interface_Write.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Dat Par Err on Mem Config Interface Write)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Dat_Par_Err_on_Mem_Config_Interface_Write.att.start_bit = '722';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Dat_Par_Err_on_Mem_Config_Interface_Write.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Dat_Par_Err_on_Mem_Config_Interface_Write.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Dat_Par_Err_on_Mem_Config_Interface_Write.att.description = 'IFC Interrupt Reg. 4(Data Parity Error on Memory Config I/F Write)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Dat_Par_Err_on_Mem_Config_Interface_Write.dim = {'hk8_packet'};

    % id 3183: TLM8_IFC Interrupt Reg 4 (Byte En Par Err on Mem Config I/F Write)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Byte_En_Par_Err_on_Mem_Config_I_F_Write.att.telemetry_point_id = '3183';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Byte_En_Par_Err_on_Mem_Config_I_F_Write.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Byte En Par Err on Mem Config I/F Write)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Byte_En_Par_Err_on_Mem_Config_I_F_Write.att.start_bit = '723';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Byte_En_Par_Err_on_Mem_Config_I_F_Write.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Byte_En_Par_Err_on_Mem_Config_I_F_Write.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Byte_En_Par_Err_on_Mem_Config_I_F_Write.att.description = 'IFC Interrupt Reg. 4(Byte Enable Parity Error on Memory Config I/F Write)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Byte_En_Par_Err_on_Mem_Config_I_F_Write.dim = {'hk8_packet'};

    % id 3184: TLM8_IFC Interrupt Reg 4 (Invalid Addr on Mem Config Interface)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invalid_Addr_on_Mem_Config_Interface.att.telemetry_point_id = '3184';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invalid_Addr_on_Mem_Config_Interface.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Invalid Addr on Mem Config Interface)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invalid_Addr_on_Mem_Config_Interface.att.start_bit = '724';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invalid_Addr_on_Mem_Config_Interface.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invalid_Addr_on_Mem_Config_Interface.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invalid_Addr_on_Mem_Config_Interface.att.description = 'IFC Interrupt Reg. 4(Invalid Address on Memory Config I/F)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invalid_Addr_on_Mem_Config_Interface.dim = {'hk8_packet'};

    % id 3185: TLM8_IFC Interrupt Reg 4 (Invld Cmd on Mem Config Interface)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Cmd_on_Mem_Config_Interface.att.telemetry_point_id = '3185';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Cmd_on_Mem_Config_Interface.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Invld Cmd on Mem Config Interface)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Cmd_on_Mem_Config_Interface.att.start_bit = '725';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Cmd_on_Mem_Config_Interface.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Cmd_on_Mem_Config_Interface.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Cmd_on_Mem_Config_Interface.att.description = 'IFC Interrupt Reg. 4(Invalid Cmd on Memory Config I/F)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Cmd_on_Mem_Config_Interface.dim = {'hk8_packet'};

    % id 3186: TLM8_IFC Interrupt Reg 4 (Mem Refresh OVF)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Refresh_OVF.att.telemetry_point_id = '3186';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Refresh_OVF.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Mem Refresh OVF)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Refresh_OVF.att.start_bit = '726';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Refresh_OVF.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Refresh_OVF.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Refresh_OVF.att.description = 'IFC Interrupt Reg. 4(Memory Refresh OverFlow)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Refresh_OVF.dim = {'hk8_packet'};

    % id 3187: TLM8_IFC Interrupt Reg 4 (ROM Write Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_ROM_Write_Err.att.telemetry_point_id = '3187';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_ROM_Write_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (ROM Write Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_ROM_Write_Err.att.start_bit = '727';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_ROM_Write_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_ROM_Write_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_ROM_Write_Err.att.description = 'IFC Interrupt Reg. 4(ROM Write Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_ROM_Write_Err.dim = {'hk8_packet'};

    % id 3188: TLM8_IFC Interrupt Reg 4 (Addr Out of Bounds)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Out_of_Bounds.att.telemetry_point_id = '3188';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Out_of_Bounds.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Addr Out of Bounds)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Out_of_Bounds.att.start_bit = '728';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Out_of_Bounds.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Out_of_Bounds.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Out_of_Bounds.att.description = 'IFC Interrupt Reg. 4(Address Out of Bounds)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Out_of_Bounds.dim = {'hk8_packet'};

    % id 3189: TLM8_IFC Interrupt Reg 4 (Uncorrectable Addr Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Uncorrectable_Addr_Err.att.telemetry_point_id = '3189';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Uncorrectable_Addr_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Uncorrectable Addr Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Uncorrectable_Addr_Err.att.start_bit = '729';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Uncorrectable_Addr_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Uncorrectable_Addr_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Uncorrectable_Addr_Err.att.description = 'IFC Interrupt Reg. 4(Uncorrectable Address Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Uncorrectable_Addr_Err.dim = {'hk8_packet'};

    % id 3190: TLM8_IFC Interrupt Reg 4 (Reserved)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Reserved.att.telemetry_point_id = '3190';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Reserved.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Reserved)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Reserved.att.start_bit = '730';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Reserved.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Reserved.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Reserved.att.description = 'IFC Interrupt Reg. 4(Reserved)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Reserved.dim = {'hk8_packet'};

    % id 3191: TLM8_IFC Interrupt Reg 4 (* Nibble Correctable ECC Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Nibble_Correctable_ECC_Err.att.telemetry_point_id = '3191';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Nibble_Correctable_ECC_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (* Nibble Correctable ECC Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Nibble_Correctable_ECC_Err.att.start_bit = '731';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Nibble_Correctable_ECC_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Nibble_Correctable_ECC_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Nibble_Correctable_ECC_Err.att.description = 'IFC Interrupt Reg. 4(Nibble Correctable Error Correction Ctrl Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Nibble_Correctable_ECC_Err.dim = {'hk8_packet'};

    % id 3192: TLM8_IFC Interrupt Reg 4 (* Single Bit Correctable ECC Err)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Single_Bit_Correctable_ECC_Err.att.telemetry_point_id = '3192';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Single_Bit_Correctable_ECC_Err.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (* Single Bit Correctable ECC Err)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Single_Bit_Correctable_ECC_Err.att.start_bit = '732';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Single_Bit_Correctable_ECC_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Single_Bit_Correctable_ECC_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Single_Bit_Correctable_ECC_Err.att.description = 'IFC Interrupt Reg. 4(Single Bit Correctable Error Correction Ctrl Error)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Single_Bit_Correctable_ECC_Err.dim = {'hk8_packet'};

    % id 3193: TLM8_IFC Interrupt Reg 4 (* Mem Init Complete)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Init_Complete.att.telemetry_point_id = '3193';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Init_Complete.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (* Mem Init Complete)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Init_Complete.att.start_bit = '733';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Init_Complete.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Init_Complete.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Init_Complete.att.description = 'IFC Interrupt Reg. 4(Memory Initilization Complete)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Init_Complete.dim = {'hk8_packet'};

    % id 3194: TLM8_IFC Interrupt Reg 4 (Scrub Loop Complete)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Scrub_Loop_Complete.att.telemetry_point_id = '3194';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Scrub_Loop_Complete.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (Scrub Loop Complete)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Scrub_Loop_Complete.att.start_bit = '734';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Scrub_Loop_Complete.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Scrub_Loop_Complete.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Scrub_Loop_Complete.att.description = 'IFC Interrupt Reg. 4(Scrub Loop Complete)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_Scrub_Loop_Complete.dim = {'hk8_packet'};

    % id 3195: TLM8_IFC Interrupt Reg 4 (SDRAM Self-Refresh Cmd Complete)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_SDRAM_Self_Refresh_Cmd_Complete.att.telemetry_point_id = '3195';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_SDRAM_Self_Refresh_Cmd_Complete.att.mnemonic = 'TLM8_IFC Interrupt Reg 4 (SDRAM Self-Refresh Cmd Complete)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_SDRAM_Self_Refresh_Cmd_Complete.att.start_bit = '735';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_SDRAM_Self_Refresh_Cmd_Complete.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_SDRAM_Self_Refresh_Cmd_Complete.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_SDRAM_Self_Refresh_Cmd_Complete.att.description = 'IFC Interrupt Reg. 4(SDRAM Self-Refresh Cmd Complete)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_4_SDRAM_Self_Refresh_Cmd_Complete.dim = {'hk8_packet'};

    % id 3196: TLM8_IFC Interrupt Reg 5 (Spare)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Spare.att.telemetry_point_id = '3196';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Spare.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Spare)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Spare.att.start_bit = '736';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Spare.att.num_bits = '3';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Spare.att.description = 'IFC Interrupt Reg. 5(Spare)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Spare.dim = {'hk8_packet'};

    % id 16389: TLM8_IFC Interrupt Reg 5 (ECC Error Log Not Empty)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Not_Empty.att.telemetry_point_id = '16389';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Not_Empty.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (ECC Error Log Not Empty)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Not_Empty.att.start_bit = '739';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Not_Empty.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Not_Empty.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Not_Empty.att.description = 'IFC Interrupt Reg. 5(ECC Error Log Not Empty)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Not_Empty.dim = {'hk8_packet'};

    % id 16390: TLM8_IFC Interrupt Reg 5 (ECC Error Log Full)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Full.att.telemetry_point_id = '16390';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Full.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (ECC Error Log Full)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Full.att.start_bit = '740';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Full.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Full.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Full.att.description = 'IFC Interrupt Reg. 5(ECC Error Log Full)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Full.dim = {'hk8_packet'};

    % id 3197: TLM8_IFC Interrupt Reg 5 (Addr Out-of-Range - CATErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_CATErrInterStatReg.att.telemetry_point_id = '3197';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_CATErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Addr Out-of-Range - CATErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_CATErrInterStatReg.att.start_bit = '741';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_CATErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_CATErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_CATErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Address Out-of-Range - Clock and Test Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_CATErrInterStatReg.dim = {'hk8_packet'};

    % id 3198: TLM8_IFC Interrupt Reg 5 (Write Data Parity Error - CATErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_CATErrInterStatReg.att.telemetry_point_id = '3198';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_CATErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Write Data Parity Error - CATErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_CATErrInterStatReg.att.start_bit = '742';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_CATErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_CATErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_CATErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Write Data Parity Error - Clock and Test Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_CATErrInterStatReg.dim = {'hk8_packet'};

    % id 3199: TLM8_IFC Interrupt Reg 5 (Addr Phase Parity Error - CATErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_CATErrInterStatReg.att.telemetry_point_id = '3199';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_CATErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Addr Phase Parity Error - CATErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_CATErrInterStatReg.att.start_bit = '743';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_CATErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_CATErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_CATErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Address Phase Parity Error - Clock and Test Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_CATErrInterStatReg.dim = {'hk8_packet'};

    % id 3200: TLM8_IFC Interrupt Reg 5 (Write Access Error - CATErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_CATErrInterStatReg.att.telemetry_point_id = '3200';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_CATErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Write Access Error - CATErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_CATErrInterStatReg.att.start_bit = '744';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_CATErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_CATErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_CATErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Write Access Error - Clock and Test Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_CATErrInterStatReg.dim = {'hk8_packet'};

    % id 3201: TLM8_IFC Interrupt Reg 5 (Addr Phase Parity Error - MiscErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_MiscErrInterStatReg.att.telemetry_point_id = '3201';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_MiscErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Addr Phase Parity Error - MiscErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_MiscErrInterStatReg.att.start_bit = '745';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_MiscErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_MiscErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_MiscErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Address Phase Parity Error - Miscellaneous Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_MiscErrInterStatReg.dim = {'hk8_packet'};

    % id 3202: TLM8_IFC Interrupt Reg 5 (Write Data Parity Error - MiscErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_MiscErrInterStatReg.att.telemetry_point_id = '3202';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_MiscErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Write Data Parity Error - MiscErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_MiscErrInterStatReg.att.start_bit = '746';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_MiscErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_MiscErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_MiscErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Write Data Parity Error - Miscellaneous Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_MiscErrInterStatReg.dim = {'hk8_packet'};

    % id 3203: TLM8_IFC Interrupt Reg 5 (Write Access Error - MiscErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_MiscErrInterStatReg.att.telemetry_point_id = '3203';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_MiscErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Write Access Error - MiscErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_MiscErrInterStatReg.att.start_bit = '747';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_MiscErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_MiscErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_MiscErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Write Access Error - Miscellaneous Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_MiscErrInterStatReg.dim = {'hk8_packet'};

    % id 3204: TLM8_IFC Interrupt Reg 5 (Addr Out-of-Range - EMCErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_EMCErrInterStatReg.att.telemetry_point_id = '3204';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_EMCErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Addr Out-of-Range - EMCErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_EMCErrInterStatReg.att.start_bit = '748';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_EMCErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_EMCErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_EMCErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Address Out-of-Range - Embedded Microcontroller Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_EMCErrInterStatReg.dim = {'hk8_packet'};

    % id 3205: TLM8_IFC Interrupt Reg 5 (Write Data Parity Error - EMCErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_EMCErrInterStatReg.att.telemetry_point_id = '3205';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_EMCErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Write Data Parity Error - EMCErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_EMCErrInterStatReg.att.start_bit = '749';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_EMCErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_EMCErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_EMCErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Write Data Parity Error - Embedded Microcontroller Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_EMCErrInterStatReg.dim = {'hk8_packet'};

    % id 3206: TLM8_IFC Interrupt Reg 5 (Addr Phase Parity Error - EMCErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_EMCErrInterStatReg.att.telemetry_point_id = '3206';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_EMCErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Addr Phase Parity Error - EMCErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_EMCErrInterStatReg.att.start_bit = '750';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_EMCErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_EMCErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_EMCErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Address Phase Parity Error - Embedded Microcontroller Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_EMCErrInterStatReg.dim = {'hk8_packet'};

    % id 3207: TLM8_IFC Interrupt Reg 5 (Write Access Error - EMCErrInterStatReg)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_EMCErrInterStatReg.att.telemetry_point_id = '3207';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_EMCErrInterStatReg.att.mnemonic = 'TLM8_IFC Interrupt Reg 5 (Write Access Error - EMCErrInterStatReg)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_EMCErrInterStatReg.att.start_bit = '751';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_EMCErrInterStatReg.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_EMCErrInterStatReg.att.num_bits = '1';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_EMCErrInterStatReg.att.description = 'IFC Interrupt Reg. 5(Write Access Error - Embedded Microcontroller Error )';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_EMCErrInterStatReg.dim = {'hk8_packet'};

    % id 3208: TLM8_IFC Interrupt Reg 6 (Spare)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Spare.att.telemetry_point_id = '3208';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Spare.att.mnemonic = 'TLM8_IFC Interrupt Reg 6 (Spare)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Spare.att.start_bit = '752';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Spare.att.num_bits = '8';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Spare.att.description = 'IFC Interrupt Reg. 6(Spare)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Spare.dim = {'hk8_packet'};

    % id 3209: TLM8_IFC Interrupt Reg 6 (Num IFC Err Det During PwrUp BIT)
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Num_IFC_Err_Det_During_PwrUp_BIT.att.telemetry_point_id = '3209';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Num_IFC_Err_Det_During_PwrUp_BIT.att.mnemonic = 'TLM8_IFC Interrupt Reg 6 (Num IFC Err Det During PwrUp BIT)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Num_IFC_Err_Det_During_PwrUp_BIT.att.start_bit = '760';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Num_IFC_Err_Det_During_PwrUp_BIT.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Num_IFC_Err_Det_During_PwrUp_BIT.att.num_bits = '8';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Num_IFC_Err_Det_During_PwrUp_BIT.att.description = 'IFC Interrupt Reg. 6(Number IFC Error Detected During PowerUp BIT)';
    g_metadata.packets.instr_hk8.IFC_Interrupt_Reg_6_Num_IFC_Err_Det_During_PwrUp_BIT.dim = {'hk8_packet'};

    % id 3211: TLM8_LWSigProcFIRFilterUpperCtrlReg1(Diag Tst Sig Sel)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.telemetry_point_id{1} = '3211';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg1(Diag Tst Sig Sel)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.start_bit{1} = '768';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Diag Test Signal Select)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.dim = {'band', 'hk8_packet'};

    % id 3212: TLM8_LWSigProcFIRFilterUpperCtrlReg1(Reserved)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.telemetry_point_id{1} = '3212';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.start_bit{1} = '770';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.num_bits{1} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.dim = {'band', 'hk8_packet'};

    % id 3213: TLM8_LWSigProcFIRFilterUpperCtrlReg1(Diag Mode Chan Sel Default 1)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.telemetry_point_id{1} = '3213';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg1(Diag Mode Chan Sel Default 1)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.start_bit{1} = '771';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.num_bits{1} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Diag Mode Chan. Select)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.dim = {'band', 'hk8_packet'};

    % id 3214: TLM8_LWSigProcFIRFilterUpperCtrlReg1(Diag Mode)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.telemetry_point_id{1} = '3214';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg1(Diag Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.start_bit{1} = '776';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.num_bits{1} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Diag Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.dim = {'band', 'hk8_packet'};

    % id 3215: TLM8_LWSigProcFIRFilterUpperCtrlReg1(Not Used2)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.telemetry_point_id{1} = '3215';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg1(Not Used2)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.start_bit{1} = '777';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.num_bits{1} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Not Used2)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.dim = {'band', 'hk8_packet'};

    % id 3216: TLM8_LWSigProcFIRFilterUpperCtrlReg1(Byte Swap Mode)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.telemetry_point_id{1} = '3216';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg1(Byte Swap Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.start_bit{1} = '778';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.num_bits{1} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Byte Swap Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.dim = {'band', 'hk8_packet'};

    % id 3217: TLM8_LWSigProcFIRFilterUpperCtrlReg1(Decimation Rate Default 1)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.telemetry_point_id{1} = '3217';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg1(Decimation Rate Default 1)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.start_bit{1} = '779';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.num_bits{1} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Decimation Rate)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.dim = {'band', 'hk8_packet'};

    % id 3218: TLM8_LWSigProcFIRFilterLowerCtrlReg1(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.telemetry_point_id{1} = '3218';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterLowerCtrlReg1(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.start_bit{1} = '784';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.num_bits{1} = '3';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.description{1} = 'LW Signal Processor FIR Filter, Lower Ctrl Reg. 1(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3219: TLM8_LWSigProcFIRFilterLowerCtrlReg1(Reserved)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.telemetry_point_id{1} = '3219';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterLowerCtrlReg1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.start_bit{1} = '787';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.num_bits{1} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.description{1} = 'LW Signal Processor FIR Filter, Lower Ctrl Reg. 1(Reservedl)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.dim = {'band', 'hk8_packet'};

    % id 3220: TLM8_LWSigProcFIRFilterLowerCtrlReg1(Num of Taps)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.telemetry_point_id{1} = '3220';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterLowerCtrlReg1(Num of Taps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.start_bit{1} = '792';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.num_bits{1} = '8';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.description{1} = 'LW Signal Processor FIR Filter, Lower Ctrl Reg. 1(Number of Taps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.dim = {'band', 'hk8_packet'};

    % id 3221: TLM8_LWSigProcFIRFilterUpperCtrlReg2(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.telemetry_point_id{1} = '3221';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg2(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.start_bit{1} = '800';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.num_bits{1} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 2(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3222: TLM8_LWSigProcFIRFilterUpperCtrlReg2(Offset Samples to Strt of Filter)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.telemetry_point_id{1} = '3222';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg2(Offset Samples to Strt of Filter)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.start_bit{1} = '801';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.num_bits{1} = '15';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 2(Offset Samples to Start of Filter )';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.dim = {'band', 'hk8_packet'};

    % id 3223: TLM8_LWSigProcFIRFilterLowerCtrlReg2(Total Num of Samples)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.telemetry_point_id{1} = '3223';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterLowerCtrlReg2(Total Num of Samples)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.start_bit{1} = '816';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.description{1} = 'LW Signal Processor FIR Filter, Lower Ctrl Reg. 2(Total Number of Samples)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.dim = {'band', 'hk8_packet'};

    % id 3224: TLM8_LWSigProcFIRFilterUpperCtrlReg4(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.telemetry_point_id{1} = '3224';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg4(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.start_bit{1} = '832';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 4(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3225: TLM8_LWSigProcFIRFilterLowerCtrlReg4(Num of Raw A/D Samples to Acq)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.telemetry_point_id{1} = '3225';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterLowerCtrlReg4(Num of Raw A/D Samples to Acq)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.start_bit{1} = '848';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.description{1} = 'LW Signal Processor FIR Filter, Lower Ctrl Reg. 4(Number of Raw A/D Samples to Acquire)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.dim = {'band', 'hk8_packet'};

    % id 3226: TLM8_LWSigProcFIRFilterUpperCtrlReg5(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.telemetry_point_id{1} = '3226';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg5(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.start_bit{1} = '864';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 5(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3227: TLM8_LWSigProcFIRFilterLowerCtrlReg5(Num of Decimated Samples to Acq/Chan)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.telemetry_point_id{1} = '3227';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterLowerCtrlReg5(Num of Decimated Samples to Acq/Chan)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.start_bit{1} = '880';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.description{1} = 'LW Signal Processor FIR Filter, Lower Ctrl Reg. 5(Number of Decimated Samples to Acquire/Chan.)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.dim = {'band', 'hk8_packet'};

    % id 3228: TLM8_LWSigProcFIRFilterUpperCtrlReg6(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.telemetry_point_id{1} = '3228';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterUpperCtrlReg6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.start_bit{1} = '896';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.description{1} = 'LW Signal Processor FIR Filter, Upper Ctrl Reg. 6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3229: TLM8_LWSigProcFIRFilterLowerCtrlReg6(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.telemetry_point_id{1} = '3229';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterLowerCtrlReg6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.start_bit{1} = '912';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.num_bits{1} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.description{1} = 'LW Signal Processor FIR Filter, Lower Ctrl Reg. 6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3230: TLM8_LWSigProcFIRFilterLowerCtrlReg6(Phase Delay Adjust Phase Delay 30.3ns steps)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.telemetry_point_id{1} = '3230';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.mnemonic{1} = 'TLM8_LWSigProcFIRFilterLowerCtrlReg6(Phase Delay Adjust Phase Delay 30.3ns steps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.start_bit{1} = '917';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.num_bits{1} = '11';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.description{1} = 'LW Signal Processor FIR Filter, Lower Ctrl Reg. 6(Phase Delay Adjust Phase Delay 30.3ns steps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.dim = {'band', 'hk8_packet'};

    % id 3231: TLM8_LWcPCIRetryReg
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.telemetry_point_id{1} = '3231';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.mnemonic{1} = 'TLM8_LWcPCIRetryReg';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.start_bit{1} = '928';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.description{1} = 'LW cPCI Retry Reg. ';
    g_metadata.packets.instr_hk8.cPCIRetryReg.dim = {'band', 'hk8_packet'};

    % id 3232: TLM8_LWChan2PGASetting
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.telemetry_point_id{1} = '3232';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.mnemonic{1} = 'TLM8_LWChan2PGASetting';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.start_bit{1} = '944';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.num_bits{1} = '8';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.description{1} = 'LW Chan. 2 PGA Setting';
    g_metadata.packets.instr_hk8.Chan2PGASetting.dim = {'band', 'hk8_packet'};

    % id 3233: TLM8_LWChan1PGASetting
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.telemetry_point_id{1} = '3233';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.mnemonic{1} = 'TLM8_LWChan1PGASetting';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.start_bit{1} = '952';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.num_bits{1} = '8';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.description{1} = 'LW Chan. 1 PGA Setting';
    g_metadata.packets.instr_hk8.Chan1PGASetting.dim = {'band', 'hk8_packet'};

    % id 3234: TLM8_LWChan4PGASetting
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.telemetry_point_id{1} = '3234';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.mnemonic{1} = 'TLM8_LWChan4PGASetting';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.start_bit{1} = '960';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.num_bits{1} = '8';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.description{1} = 'LW Chan. 4 PGA Setting';
    g_metadata.packets.instr_hk8.Chan4PGASetting.dim = {'band', 'hk8_packet'};

    % id 3235: TLM8_LWChan3PGASetting
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.telemetry_point_id{1} = '3235';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.mnemonic{1} = 'TLM8_LWChan3PGASetting';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.start_bit{1} = '968';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.num_bits{1} = '8';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.description{1} = 'LW Chan. 3 PGA Setting';
    g_metadata.packets.instr_hk8.Chan3PGASetting.dim = {'band', 'hk8_packet'};

    % id 3236: TLM8_LWChan6PGASetting
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.telemetry_point_id{1} = '3236';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.mnemonic{1} = 'TLM8_LWChan6PGASetting';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.start_bit{1} = '976';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.num_bits{1} = '8';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.description{1} = 'LW Chan. 6 PGA Setting';
    g_metadata.packets.instr_hk8.Chan6PGASetting.dim = {'band', 'hk8_packet'};

    % id 3237: TLM8_LWChan5PGASetting
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.telemetry_point_id{1} = '3237';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.mnemonic{1} = 'TLM8_LWChan5PGASetting';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.start_bit{1} = '984';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.num_bits{1} = '8';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.description{1} = 'LW Chan. 5 PGA Setting';
    g_metadata.packets.instr_hk8.Chan5PGASetting.dim = {'band', 'hk8_packet'};

    % id 3238: TLM8_LWChan8PGASetting
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.telemetry_point_id{1} = '3238';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.mnemonic{1} = 'TLM8_LWChan8PGASetting';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.start_bit{1} = '992';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.num_bits{1} = '8';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.description{1} = 'LW Chan. 8 PGA Setting';
    g_metadata.packets.instr_hk8.Chan8PGASetting.dim = {'band', 'hk8_packet'};

    % id 3239: TLM8_LWChan7PGASetting
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.telemetry_point_id{1} = '3239';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.mnemonic{1} = 'TLM8_LWChan7PGASetting';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.start_bit{1} = '1000';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.num_bits{1} = '8';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.description{1} = 'LW Chan. 7 PGA Setting';
    g_metadata.packets.instr_hk8.Chan7PGASetting.dim = {'band', 'hk8_packet'};

    % id 3240: TLM8_LW DspHwCtrlSettingBits(Not Used)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.telemetry_point_id{1} = '3240';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.mnemonic{1} = 'TLM8_LW DspHwCtrlSettingBits(Not Used)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.start_bit{1} = '1008';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.num_bits{1} = '5';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.description{1} = 'LW DSP Hardware Ctrl Setting Bits(Not Used)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3241: TLM8_LW DspHwCtrlSettingBits(Reserved)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.telemetry_point_id{1} = '3241';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.mnemonic{1} = 'TLM8_LW DspHwCtrlSettingBits(Reserved)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.start_bit{1} = '1013';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.num_bits{1} = '1';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.description{1} = 'LW DSP Hardware Ctrl Setting Bits(Reserved)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.dim = {'band', 'hk8_packet'};

    % id 3242: TLM8_LW DspHwCtrlSettingBits(Scene Select Mode)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.telemetry_point_id{1} = '3242';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.mnemonic{1} = 'TLM8_LW DspHwCtrlSettingBits(Scene Select Mode)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.start_bit{1} = '1014';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.num_bits{1} = '1';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.description{1} = 'LW DSP Hardware Ctrl Setting Bits(Scene Select Mode)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.dim = {'band', 'hk8_packet'};

    % id 3243: TLM8_LW DspHwCtrlSettingBits(FilterEnable)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.telemetry_point_id{1} = '3243';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.mnemonic{1} = 'TLM8_LW DspHwCtrlSettingBits(FilterEnable)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.start_bit{1} = '1015';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.num_bits{1} = '1';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.description{1} = 'LW DSP Hardware Ctrl Setting Bits(Filter Enable)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.dim = {'band', 'hk8_packet'};

    % id 3244: TLM8_LWChan9PGASetting
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.telemetry_point_id{1} = '3244';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.mnemonic{1} = 'TLM8_LWChan9PGASetting';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.start_bit{1} = '1016';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.num_bits{1} = '8';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.description{1} = 'LW Chan. 9 PGA Setting';
    g_metadata.packets.instr_hk8.Chan9PGASetting.dim = {'band', 'hk8_packet'};

    % id 3245: TLM8_LWCoefTblIUpperChkSum
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.telemetry_point_id{1} = '3245';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.mnemonic{1} = 'TLM8_LWCoefTblIUpperChkSum';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.start_bit{1} = '1024';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.description{1} = 'LW Coefficient Table I, Upper Checksum';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.dim = {'band', 'hk8_packet'};

    % id 3246: TLM8_LWCoefTblILowerChkSum
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.telemetry_point_id{1} = '3246';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.mnemonic{1} = 'TLM8_LWCoefTblILowerChkSum';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.start_bit{1} = '1040';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.description{1} = 'LW Coefficient Table I, Lower Checksum';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.dim = {'band', 'hk8_packet'};

    % id 3247: TLM8_LWCoefTblQUpperChkSum
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.telemetry_point_id{1} = '3247';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.mnemonic{1} = 'TLM8_LWCoefTblQUpperChkSum';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.start_bit{1} = '1056';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.description{1} = 'LW Coefficient Table Q, Upper Checksum';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.dim = {'band', 'hk8_packet'};

    % id 3248: TLM8_LWCoefTblQLowerChkSum
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.telemetry_point_id{1} = '3248';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.mnemonic{1} = 'TLM8_LWCoefTblQLowerChkSum';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.start_bit{1} = '1072';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.description{1} = 'LW Coefficient Table Q, Lower Checksum';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.dim = {'band', 'hk8_packet'};

    % id 3250: TLM8_MWSigProcFIRFilterUpperCtrlReg1(Diag Tst Sig Sel)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.telemetry_point_id{2} = '3250';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg1(Diag Tst Sig Sel)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.start_bit{2} = '1088';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Diag Test Signal Select)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.dim = {'band', 'hk8_packet'};

    % id 3251: TLM8_MWSigProcFIRFilterUpperCtrlReg1(Reserved)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.telemetry_point_id{2} = '3251';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.start_bit{2} = '1090';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.num_bits{2} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.dim = {'band', 'hk8_packet'};

    % id 3252: TLM8_MWSigProcFIRFilterUpperCtrlReg1(Diag Mode Chan Sel Default 1)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.telemetry_point_id{2} = '3252';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg1(Diag Mode Chan Sel Default 1)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.start_bit{2} = '1091';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.num_bits{2} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Diag Mode Chan. Select)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.dim = {'band', 'hk8_packet'};

    % id 3253: TLM8_MWSigProcFIRFilterUpperCtrlReg1(Diag Mode)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.telemetry_point_id{2} = '3253';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg1(Diag Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.start_bit{2} = '1096';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.num_bits{2} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Diag Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.dim = {'band', 'hk8_packet'};

    % id 3254: TLM8_MWSigProcFIRFilterUpperCtrlReg1(Not Used2)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.telemetry_point_id{2} = '3254';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg1(Not Used2)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.start_bit{2} = '1097';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.num_bits{2} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Not Used2)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.dim = {'band', 'hk8_packet'};

    % id 3255: TLM8_MWSigProcFIRFilterUpperCtrlReg1(Byte Swap Mode)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.telemetry_point_id{2} = '3255';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg1(Byte Swap Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.start_bit{2} = '1098';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.num_bits{2} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Byte Swap Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.dim = {'band', 'hk8_packet'};

    % id 3256: TLM8_MWSigProcFIRFilterUpperCtrlReg1(Decimation Rate Default 1)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.telemetry_point_id{2} = '3256';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg1(Decimation Rate Default 1)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.start_bit{2} = '1099';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.num_bits{2} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Decimation Rate)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.dim = {'band', 'hk8_packet'};

    % id 3257: TLM8_MWSigProcFIRFilterLowerCtrlReg1(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.telemetry_point_id{2} = '3257';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterLowerCtrlReg1(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.start_bit{2} = '1104';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.num_bits{2} = '3';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.description{2} = 'MW Signal Processor FIR Filter, Lower Ctrl Reg. 1(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3258: TLM8_MWSigProcFIRFilterLowerCtrlReg1(Reserved)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.telemetry_point_id{2} = '3258';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterLowerCtrlReg1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.start_bit{2} = '1107';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.num_bits{2} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.description{2} = 'MW Signal Processor FIR Filter, Lower Ctrl Reg. 1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.dim = {'band', 'hk8_packet'};

    % id 3259: TLM8_MWSigProcFIRFilterLowerCtrlReg1(Num of Taps)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.telemetry_point_id{2} = '3259';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterLowerCtrlReg1(Num of Taps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.start_bit{2} = '1112';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.num_bits{2} = '8';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.description{2} = 'MW Signal Processor FIR Filter, Lower Ctrl Reg. 1(Number of Taps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.dim = {'band', 'hk8_packet'};

    % id 3260: TLM8_MWSigProcFIRFilterUpperCtrlReg2(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.telemetry_point_id{2} = '3260';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg2(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.start_bit{2} = '1120';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.num_bits{2} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 2(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3261: TLM8_MWSigProcFIRFilterUpperCtrlReg2(Offset Samples to Strt of Filter)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.telemetry_point_id{2} = '3261';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg2(Offset Samples to Strt of Filter)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.start_bit{2} = '1121';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.num_bits{2} = '15';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 2(Offset Samples to Start of Filter )';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.dim = {'band', 'hk8_packet'};

    % id 3262: TLM8_MWSigProcFIRFilterLowerCtrlReg2(Total Num of Samples)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.telemetry_point_id{2} = '3262';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterLowerCtrlReg2(Total Num of Samples)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.start_bit{2} = '1136';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.description{2} = 'MW Signal Processor FIR Filter, Lower Ctrl Reg. 2(Total Number of Samples)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.dim = {'band', 'hk8_packet'};

    % id 3263: TLM8_MWSigProcFIRFilterUpperCtrlReg4(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.telemetry_point_id{2} = '3263';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg4(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.start_bit{2} = '1152';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 4(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3264: TLM8_MWSigProcFIRFilterLowerCtrlReg4(Num of Raw A/D Samples to Acq)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.telemetry_point_id{2} = '3264';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterLowerCtrlReg4(Num of Raw A/D Samples to Acq)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.start_bit{2} = '1168';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.description{2} = 'MW Signal Processor FIR Filter, Lower Ctrl Reg. 4(Number of Raw A/D Samples to Acquire)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.dim = {'band', 'hk8_packet'};

    % id 3265: TLM8_MWSigProcFIRFilterUpperCtrlReg5(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.telemetry_point_id{2} = '3265';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg5(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.start_bit{2} = '1184';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 5(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3266: TLM8_MWSigProcFIRFilterLowerCtrlReg5(Num of Decimated Samples to Acq/Chan)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.telemetry_point_id{2} = '3266';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterLowerCtrlReg5(Num of Decimated Samples to Acq/Chan)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.start_bit{2} = '1200';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.description{2} = 'MW Signal Processor FIR Filter, Lower Ctrl Reg. 5(Number of Decimated Samples to Acquire/Chan. )';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.dim = {'band', 'hk8_packet'};

    % id 3267: TLM8_MWSigProcFIRFilterUpperCtrlReg6(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.telemetry_point_id{2} = '3267';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterUpperCtrlReg6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.start_bit{2} = '1216';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.description{2} = 'MW Signal Processor FIR Filter, Upper Ctrl Reg. 6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3268: TLM8_MWSigProcFIRFilterLowerCtrlReg6(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.telemetry_point_id{2} = '3268';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterLowerCtrlReg6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.start_bit{2} = '1232';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.num_bits{2} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.description{2} = 'MW Signal Processor FIR Filter, Lower Ctrl Reg. 6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3269: TLM8_MWSigProcFIRFilterLowerCtrlReg6(Phase Delay Adjust Phase Delay 30.3ns steps)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.telemetry_point_id{2} = '3269';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.mnemonic{2} = 'TLM8_MWSigProcFIRFilterLowerCtrlReg6(Phase Delay Adjust Phase Delay 30.3ns steps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.start_bit{2} = '1237';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.num_bits{2} = '11';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.description{2} = 'MW Signal Processor FIR Filter, Lower Ctrl Reg. 6(Phase Delay Adjust Phase Delay 30.3ns steps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.dim = {'band', 'hk8_packet'};

    % id 3270: TLM8_MWcPCIRetryReg
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.telemetry_point_id{2} = '3270';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.mnemonic{2} = 'TLM8_MWcPCIRetryReg';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.start_bit{2} = '1248';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.description{2} = 'MW cPCI Retry Reg. ';
    g_metadata.packets.instr_hk8.cPCIRetryReg.dim = {'band', 'hk8_packet'};

    % id 3271: TLM8_MWChan2PGASetting
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.telemetry_point_id{2} = '3271';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.mnemonic{2} = 'TLM8_MWChan2PGASetting';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.start_bit{2} = '1264';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.num_bits{2} = '8';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.description{2} = 'MW Chan. 2 PGA Setting';
    g_metadata.packets.instr_hk8.Chan2PGASetting.dim = {'band', 'hk8_packet'};

    % id 3272: TLM8_MWChan1PGASetting
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.telemetry_point_id{2} = '3272';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.mnemonic{2} = 'TLM8_MWChan1PGASetting';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.start_bit{2} = '1272';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.num_bits{2} = '8';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.description{2} = 'MW Chan. 1 PGA Setting';
    g_metadata.packets.instr_hk8.Chan1PGASetting.dim = {'band', 'hk8_packet'};

    % id 3273: TLM8_MWChan4PGASetting
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.telemetry_point_id{2} = '3273';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.mnemonic{2} = 'TLM8_MWChan4PGASetting';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.start_bit{2} = '1280';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.num_bits{2} = '8';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.description{2} = 'MW Chan. 4 PGA Setting';
    g_metadata.packets.instr_hk8.Chan4PGASetting.dim = {'band', 'hk8_packet'};

    % id 3274: TLM8_MWChan3PGASetting
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.telemetry_point_id{2} = '3274';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.mnemonic{2} = 'TLM8_MWChan3PGASetting';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.start_bit{2} = '1288';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.num_bits{2} = '8';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.description{2} = 'MW Chan. 3 PGA Setting';
    g_metadata.packets.instr_hk8.Chan3PGASetting.dim = {'band', 'hk8_packet'};

    % id 3275: TLM8_MWChan6PGASetting
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.telemetry_point_id{2} = '3275';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.mnemonic{2} = 'TLM8_MWChan6PGASetting';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.start_bit{2} = '1296';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.num_bits{2} = '8';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.description{2} = 'MW Chan. 6 PGA Setting';
    g_metadata.packets.instr_hk8.Chan6PGASetting.dim = {'band', 'hk8_packet'};

    % id 3276: TLM8_MWChan5PGASetting
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.telemetry_point_id{2} = '3276';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.mnemonic{2} = 'TLM8_MWChan5PGASetting';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.start_bit{2} = '1304';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.num_bits{2} = '8';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.description{2} = 'MW Chan. 5 PGA Setting';
    g_metadata.packets.instr_hk8.Chan5PGASetting.dim = {'band', 'hk8_packet'};

    % id 3277: TLM8_MWChan8PGASetting
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.telemetry_point_id{2} = '3277';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.mnemonic{2} = 'TLM8_MWChan8PGASetting';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.start_bit{2} = '1312';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.num_bits{2} = '8';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.description{2} = 'MW Chan. 8 PGA Setting';
    g_metadata.packets.instr_hk8.Chan8PGASetting.dim = {'band', 'hk8_packet'};

    % id 3278: TLM8_MWChan7PGASetting
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.telemetry_point_id{2} = '3278';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.mnemonic{2} = 'TLM8_MWChan7PGASetting';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.start_bit{2} = '1320';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.num_bits{2} = '8';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.description{2} = 'MW Chan. 7 PGA Setting';
    g_metadata.packets.instr_hk8.Chan7PGASetting.dim = {'band', 'hk8_packet'};

    % id 3279: TLM8_MW DspHwCtrlSettingBits(Not Used)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.telemetry_point_id{2} = '3279';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.mnemonic{2} = 'TLM8_MW DspHwCtrlSettingBits(Not Used)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.start_bit{2} = '1328';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.num_bits{2} = '5';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.description{2} = 'MW DSP Hardware Ctrl Setting Bits(Not Used)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3280: TLM8_MW DspHwCtrlSettingBits(Reserved)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.telemetry_point_id{2} = '3280';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.mnemonic{2} = 'TLM8_MW DspHwCtrlSettingBits(Reserved)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.start_bit{2} = '1333';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.num_bits{2} = '1';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.description{2} = 'MW DSP Hardware Ctrl Setting Bits(Reserved)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.dim = {'band', 'hk8_packet'};

    % id 3281: TLM8_MW DspHwCtrlSettingBits(Scene Select Mode)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.telemetry_point_id{2} = '3281';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.mnemonic{2} = 'TLM8_MW DspHwCtrlSettingBits(Scene Select Mode)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.start_bit{2} = '1334';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.num_bits{2} = '1';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.description{2} = 'MW DSP Hardware Ctrl Setting Bits(Scene Select Mode)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.dim = {'band', 'hk8_packet'};

    % id 3282: TLM8_MW DspHwCtrlSettingBits(FilterEnable)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.telemetry_point_id{2} = '3282';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.mnemonic{2} = 'TLM8_MW DspHwCtrlSettingBits(FilterEnable)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.start_bit{2} = '1335';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.num_bits{2} = '1';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.description{2} = 'MW DSP Hardware Ctrl Setting Bits(Filter Enable)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.dim = {'band', 'hk8_packet'};

    % id 3283: TLM8_MWChan9PGASetting
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.telemetry_point_id{2} = '3283';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.mnemonic{2} = 'TLM8_MWChan9PGASetting';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.start_bit{2} = '1336';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.num_bits{2} = '8';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.description{2} = 'MW Chan. 9 PGA Setting';
    g_metadata.packets.instr_hk8.Chan9PGASetting.dim = {'band', 'hk8_packet'};

    % id 3284: TLM8_MWCoefTblIUpperChkSum
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.telemetry_point_id{2} = '3284';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.mnemonic{2} = 'TLM8_MWCoefTblIUpperChkSum';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.start_bit{2} = '1344';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.description{2} = 'MW Coefficient Table I, Upper Checksum';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.dim = {'band', 'hk8_packet'};

    % id 3285: TLM8_MWCoefTblILowerChkSum
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.telemetry_point_id{2} = '3285';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.mnemonic{2} = 'TLM8_MWCoefTblILowerChkSum';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.start_bit{2} = '1360';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.description{2} = 'MW Coefficient Table I, Lower Checksum';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.dim = {'band', 'hk8_packet'};

    % id 3286: TLM8_MWCoefTblQUpperChkSum
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.telemetry_point_id{2} = '3286';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.mnemonic{2} = 'TLM8_MWCoefTblQUpperChkSum';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.start_bit{2} = '1376';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.description{2} = 'MW Coefficient Table Q, Upper Checksum';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.dim = {'band', 'hk8_packet'};

    % id 3287: TLM8_MWCoefTblQLowerChkSum
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.telemetry_point_id{2} = '3287';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.mnemonic{2} = 'TLM8_MWCoefTblQLowerChkSum';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.start_bit{2} = '1392';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.description{2} = 'MW Coefficient Table Q, Lower Checksum';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.dim = {'band', 'hk8_packet'};

    % id 3289: TLM8_SWSigProcFIRFilterUpperCtrlReg1(Diag Tst Sig Sel)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.telemetry_point_id{3} = '3289';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg1(Diag Tst Sig Sel)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.start_bit{3} = '1408';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Diag Test Signal Select)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel.dim = {'band', 'hk8_packet'};

    % id 3290: TLM8_SWSigProcFIRFilterUpperCtrlReg1(Reserved)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.telemetry_point_id{3} = '3290';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.start_bit{3} = '1410';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.num_bits{3} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved.dim = {'band', 'hk8_packet'};

    % id 3291: TLM8_SWSigProcFIRFilterUpperCtrlReg1(Diag Mode Chan Sel Default 1)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.telemetry_point_id{3} = '3291';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg1(Diag Mode Chan Sel Default 1)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.start_bit{3} = '1411';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.num_bits{3} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Diag Mode Chan. Select)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1.dim = {'band', 'hk8_packet'};

    % id 3292: TLM8_SWSigProcFIRFilterUpperCtrlReg1(Diag Mode)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.telemetry_point_id{3} = '3292';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg1(Diag Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.start_bit{3} = '1416';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.num_bits{3} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Diag Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode.dim = {'band', 'hk8_packet'};

    % id 3293: TLM8_SWSigProcFIRFilterUpperCtrlReg1(Not Used2)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.telemetry_point_id{3} = '3293';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg1(Not Used2)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.start_bit{3} = '1417';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.num_bits{3} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Not Used2)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2.dim = {'band', 'hk8_packet'};

    % id 3294: TLM8_SWSigProcFIRFilterUpperCtrlReg1(Byte Swap Mode)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.telemetry_point_id{3} = '3294';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg1(Byte Swap Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.start_bit{3} = '1418';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.num_bits{3} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Byte Swap Mode)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode.dim = {'band', 'hk8_packet'};

    % id 3295: TLM8_SWSigProcFIRFilterUpperCtrlReg1(Decimation Rate Default 1)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.telemetry_point_id{3} = '3295';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg1(Decimation Rate Default 1)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.start_bit{3} = '1419';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.num_bits{3} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 1(Decimation Rate)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1.dim = {'band', 'hk8_packet'};

    % id 3296: TLM8_SWSigProcFIRFilterLowerCtrlReg1(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.telemetry_point_id{3} = '3296';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterLowerCtrlReg1(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.start_bit{3} = '1424';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.num_bits{3} = '3';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.att.description{3} = 'SW Signal Processor FIR Filter, Lower Ctrl Reg. 1(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3297: TLM8_SWSigProcFIRFilterLowerCtrlReg1(Reserved)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.telemetry_point_id{3} = '3297';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterLowerCtrlReg1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.start_bit{3} = '1427';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.num_bits{3} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.att.description{3} = 'SW Signal Processor FIR Filter, Lower Ctrl Reg. 1(Reserved)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved.dim = {'band', 'hk8_packet'};

    % id 3298: TLM8_SWSigProcFIRFilterLowerCtrlReg1(Num of Taps)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.telemetry_point_id{3} = '3298';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterLowerCtrlReg1(Num of Taps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.start_bit{3} = '1432';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.num_bits{3} = '8';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.att.description{3} = 'SW Signal Processor FIR Filter, Lower Ctrl Reg. 1(Number of Taps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps.dim = {'band', 'hk8_packet'};

    % id 3299: TLM8_SWSigProcFIRFilterUpperCtrlReg2(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.telemetry_point_id{3} = '3299';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg2(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.start_bit{3} = '1440';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.num_bits{3} = '1';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 2(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3300: TLM8_SWSigProcFIRFilterUpperCtrlReg2(Offset Samples to Strt of Filter)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.telemetry_point_id{3} = '3300';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg2(Offset Samples to Strt of Filter)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.start_bit{3} = '1441';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.num_bits{3} = '15';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 2(Offset Samples to Start of Filter )';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte.dim = {'band', 'hk8_packet'};

    % id 3301: TLM8_SWSigProcFIRFilterLowerCtrlReg2(Total Num of Samples)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.telemetry_point_id{3} = '3301';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterLowerCtrlReg2(Total Num of Samples)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.start_bit{3} = '1456';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.att.description{3} = 'SW Signal Processor FIR Filter, Lower Ctrl Reg. 2(Total Number of Samples)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples.dim = {'band', 'hk8_packet'};

    % id 3302: TLM8_SWSigProcFIRFilterUpperCtrlReg4(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.telemetry_point_id{3} = '3302';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg4(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.start_bit{3} = '1472';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 4(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3303: TLM8_SWSigProcFIRFilterLowerCtrlReg4(Num of Raw A/D Samples to Acq)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.telemetry_point_id{3} = '3303';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterLowerCtrlReg4(Num of Raw A/D Samples to Acq)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.start_bit{3} = '1488';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.att.description{3} = 'SW Signal Processor FIR Filter, Lower Ctrl Reg. 4(Number of Raw A/D Samples to Acquire)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq.dim = {'band', 'hk8_packet'};

    % id 3304: TLM8_SWSigProcFIRFilterUpperCtrlReg5(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.telemetry_point_id{3} = '3304';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg5(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.start_bit{3} = '1504';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 5(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3305: TLM8_SWSigProcFIRFilterLowerCtrlReg5(Num of Decimated Samples to Acq/Chan)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.telemetry_point_id{3} = '3305';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterLowerCtrlReg5(Num of Decimated Samples to Acq/Chan)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.start_bit{3} = '1520';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.att.description{3} = 'SW Signal Processor FIR Filter, Lower Ctrl Reg. 5(Number of Decimated Samples to Acquire/ Chan. )';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq.dim = {'band', 'hk8_packet'};

    % id 3306: TLM8_SWSigProcFIRFilterUpperCtrlReg6(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.telemetry_point_id{3} = '3306';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterUpperCtrlReg6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.start_bit{3} = '1536';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.att.description{3} = 'SW Signal Processor FIR Filter, Upper Ctrl Reg. 6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3307: TLM8_SWSigProcFIRFilterLowerCtrlReg6(Not Used)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.telemetry_point_id{3} = '3307';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterLowerCtrlReg6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.start_bit{3} = '1552';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.num_bits{3} = '5';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.att.description{3} = 'SW Signal Processor FIR Filter, Lower Ctrl Reg. 6(Not Used)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3308: TLM8_SWSigProcFIRFilterLowerCtrlReg6(Phase Delay Adjust Phase Delay 30.3ns steps)
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.telemetry_point_id{3} = '3308';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.mnemonic{3} = 'TLM8_SWSigProcFIRFilterLowerCtrlReg6(Phase Delay Adjust Phase Delay 30.3ns steps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.start_bit{3} = '1557';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.num_bits{3} = '11';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.att.description{3} = 'SW Signal Processor FIR Filter, Lower Ctrl Reg. 6(Phase Delay Adjust Phase Delay 30.3ns steps)';
    g_metadata.packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay.dim = {'band', 'hk8_packet'};

    % id 3309: TLM8_SWcPCIRetryReg
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.telemetry_point_id{3} = '3309';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.mnemonic{3} = 'TLM8_SWcPCIRetryReg';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.start_bit{3} = '1568';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.cPCIRetryReg.att.description{3} = 'SW cPCI Retry Reg. ';
    g_metadata.packets.instr_hk8.cPCIRetryReg.dim = {'band', 'hk8_packet'};

    % id 3310: TLM8_SWChan2PGASetting
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.telemetry_point_id{3} = '3310';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.mnemonic{3} = 'TLM8_SWChan2PGASetting';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.start_bit{3} = '1584';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.num_bits{3} = '8';
    g_metadata.packets.instr_hk8.Chan2PGASetting.att.description{3} = 'SW Chan. 2 PGA Setting';
    g_metadata.packets.instr_hk8.Chan2PGASetting.dim = {'band', 'hk8_packet'};

    % id 3311: TLM8_SWChan1PGASetting
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.telemetry_point_id{3} = '3311';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.mnemonic{3} = 'TLM8_SWChan1PGASetting';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.start_bit{3} = '1592';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.num_bits{3} = '8';
    g_metadata.packets.instr_hk8.Chan1PGASetting.att.description{3} = 'SW Chan. 1 PGA Setting';
    g_metadata.packets.instr_hk8.Chan1PGASetting.dim = {'band', 'hk8_packet'};

    % id 3312: TLM8_SWChan4PGASetting
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.telemetry_point_id{3} = '3312';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.mnemonic{3} = 'TLM8_SWChan4PGASetting';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.start_bit{3} = '1600';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.num_bits{3} = '8';
    g_metadata.packets.instr_hk8.Chan4PGASetting.att.description{3} = 'SW Chan. 4 PGA Setting';
    g_metadata.packets.instr_hk8.Chan4PGASetting.dim = {'band', 'hk8_packet'};

    % id 3313: TLM8_SWChan3PGASetting
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.telemetry_point_id{3} = '3313';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.mnemonic{3} = 'TLM8_SWChan3PGASetting';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.start_bit{3} = '1608';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.num_bits{3} = '8';
    g_metadata.packets.instr_hk8.Chan3PGASetting.att.description{3} = 'SW Chan. 3 PGA Setting';
    g_metadata.packets.instr_hk8.Chan3PGASetting.dim = {'band', 'hk8_packet'};

    % id 3314: TLM8_SWChan6PGASetting
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.telemetry_point_id{3} = '3314';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.mnemonic{3} = 'TLM8_SWChan6PGASetting';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.start_bit{3} = '1616';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.num_bits{3} = '8';
    g_metadata.packets.instr_hk8.Chan6PGASetting.att.description{3} = 'SW Chan. 6 PGA Setting';
    g_metadata.packets.instr_hk8.Chan6PGASetting.dim = {'band', 'hk8_packet'};

    % id 3315: TLM8_SWChan5PGASetting
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.telemetry_point_id{3} = '3315';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.mnemonic{3} = 'TLM8_SWChan5PGASetting';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.start_bit{3} = '1624';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.num_bits{3} = '8';
    g_metadata.packets.instr_hk8.Chan5PGASetting.att.description{3} = 'SW Chan. 5 PGA Setting';
    g_metadata.packets.instr_hk8.Chan5PGASetting.dim = {'band', 'hk8_packet'};

    % id 3316: TLM8_SWChan8PGASetting
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.telemetry_point_id{3} = '3316';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.mnemonic{3} = 'TLM8_SWChan8PGASetting';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.start_bit{3} = '1632';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.num_bits{3} = '8';
    g_metadata.packets.instr_hk8.Chan8PGASetting.att.description{3} = 'SW Chan. 8 PGA Setting';
    g_metadata.packets.instr_hk8.Chan8PGASetting.dim = {'band', 'hk8_packet'};

    % id 3317: TLM8_SWChan7PGASetting
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.telemetry_point_id{3} = '3317';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.mnemonic{3} = 'TLM8_SWChan7PGASetting';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.start_bit{3} = '1640';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.num_bits{3} = '8';
    g_metadata.packets.instr_hk8.Chan7PGASetting.att.description{3} = 'SW Chan. 7 PGA Setting';
    g_metadata.packets.instr_hk8.Chan7PGASetting.dim = {'band', 'hk8_packet'};

    % id 3318: TLM8_SW DspHwCtrlSettingBits(Not Used)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.telemetry_point_id{3} = '3318';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.mnemonic{3} = 'TLM8_SW DspHwCtrlSettingBits(Not Used)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.start_bit{3} = '1648';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.num_bits{3} = '5';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.att.description{3} = 'SW DSP Hardware Ctrl Setting Bits(Not Used)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Not_Used.dim = {'band', 'hk8_packet'};

    % id 3319: TLM8_SW DspHwCtrlSettingBits(Reserved)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.telemetry_point_id{3} = '3319';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.mnemonic{3} = 'TLM8_SW DspHwCtrlSettingBits(Reserved)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.start_bit{3} = '1653';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.num_bits{3} = '1';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.att.description{3} = 'SW DSP Hardware Ctrl Setting Bits(Reserved)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Reserved.dim = {'band', 'hk8_packet'};

    % id 3320: TLM8_SW DspHwCtrlSettingBits(Scene Select Mode)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.telemetry_point_id{3} = '3320';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.mnemonic{3} = 'TLM8_SW DspHwCtrlSettingBits(Scene Select Mode)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.start_bit{3} = '1654';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.num_bits{3} = '1';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.att.description{3} = 'SW DSP Hardware Ctrl Setting Bits(Scene Select Mode)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode.dim = {'band', 'hk8_packet'};

    % id 3321: TLM8_SW DspHwCtrlSettingBits(FilterEnable)
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.telemetry_point_id{3} = '3321';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.mnemonic{3} = 'TLM8_SW DspHwCtrlSettingBits(FilterEnable)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.start_bit{3} = '1655';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.num_bits{3} = '1';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.att.description{3} = 'SW DSP Hardware Ctrl Setting Bits(Filter Enable)';
    g_metadata.packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable.dim = {'band', 'hk8_packet'};

    % id 3322: TLM8_SWChan9PGASetting
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.telemetry_point_id{3} = '3322';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.mnemonic{3} = 'TLM8_SWChan9PGASetting';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.start_bit{3} = '1656';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.num_bits{3} = '8';
    g_metadata.packets.instr_hk8.Chan9PGASetting.att.description{3} = 'SW Chan. 9 PGA Setting';
    g_metadata.packets.instr_hk8.Chan9PGASetting.dim = {'band', 'hk8_packet'};

    % id 3323: TLM8_SWCoefTblIUpperChkSum
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.telemetry_point_id{3} = '3323';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.mnemonic{3} = 'TLM8_SWCoefTblIUpperChkSum';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.start_bit{3} = '1664';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.att.description{3} = 'SW Coefficient Table I, Upper Checksum';
    g_metadata.packets.instr_hk8.CoefTblIUpperChkSum.dim = {'band', 'hk8_packet'};

    % id 3324: TLM8_SWCoefTblILowerChkSum
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.telemetry_point_id{3} = '3324';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.mnemonic{3} = 'TLM8_SWCoefTblILowerChkSum';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.start_bit{3} = '1680';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.att.description{3} = 'SW Coefficient Table I, Lower Checksum';
    g_metadata.packets.instr_hk8.CoefTblILowerChkSum.dim = {'band', 'hk8_packet'};

    % id 3325: TLM8_SWCoefTblQUpperChkSum
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.telemetry_point_id{3} = '3325';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.mnemonic{3} = 'TLM8_SWCoefTblQUpperChkSum';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.start_bit{3} = '1696';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.att.description{3} = 'SW Coefficient Table Q, Upper Checksum';
    g_metadata.packets.instr_hk8.CoefTblQUpperChkSum.dim = {'band', 'hk8_packet'};

    % id 3326: TLM8_SWCoefTblQLowerChkSum
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.telemetry_point_id{3} = '3326';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.mnemonic{3} = 'TLM8_SWCoefTblQLowerChkSum';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.start_bit{3} = '1712';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.att.description{3} = 'SW Coefficient Table Q, Lower Checksum';
    g_metadata.packets.instr_hk8.CoefTblQLowerChkSum.dim = {'band', 'hk8_packet'};

    % id 3327: TLM8_EpochNumReg(Not Used)
    g_metadata.packets.instr_hk8.EpochNumReg_Not_Used.att.telemetry_point_id = '3327';
    g_metadata.packets.instr_hk8.EpochNumReg_Not_Used.att.mnemonic = 'TLM8_EpochNumReg(Not Used)';
    g_metadata.packets.instr_hk8.EpochNumReg_Not_Used.att.start_bit = '1728';
    g_metadata.packets.instr_hk8.EpochNumReg_Not_Used.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.EpochNumReg_Not_Used.att.num_bits = '8';
    g_metadata.packets.instr_hk8.EpochNumReg_Not_Used.att.description = 'Not Used(Epoch Number Reg. )';
    g_metadata.packets.instr_hk8.EpochNumReg_Not_Used.dim = {'hk8_packet'};

    % id 3328: TLM8_EpochNumReg(epoch x)
    g_metadata.packets.instr_hk8.EpochNumReg_epoch_x.att.telemetry_point_id = '3328';
    g_metadata.packets.instr_hk8.EpochNumReg_epoch_x.att.mnemonic = 'TLM8_EpochNumReg(epoch x)';
    g_metadata.packets.instr_hk8.EpochNumReg_epoch_x.att.start_bit = '1736';
    g_metadata.packets.instr_hk8.EpochNumReg_epoch_x.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.EpochNumReg_epoch_x.att.num_bits = '8';
    g_metadata.packets.instr_hk8.EpochNumReg_epoch_x.att.description = 'Epoch Number Reg., Epoch x';
    g_metadata.packets.instr_hk8.EpochNumReg_epoch_x.dim = {'hk8_packet'};

    % id 3329: TLM8_+28VSSMBusCurrent(sample 1 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{1} = '3329';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{1} = 'TLM8_+28VSSMBusCurrent(sample 1 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{1} = '1744';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{1} = '+28Volt SSM Bus Current, Sample 1 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3330: TLM8_+28VSSMBusCurrent(sample 1 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{1} = '3330';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{1} = 'TLM8_+28VSSMBusCurrent(sample 1 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{1} = '1746';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{1} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{1} = '+28Volt SSM Bus Current, Sample 1 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3331: TLM8_+28VSSMBusCurrent(sample 2 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{2} = '3331';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{2} = 'TLM8_+28VSSMBusCurrent(sample 2 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{2} = '1760';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{2} = '+28Volt SSM Bus Current, Sample 2 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3332: TLM8_+28VSSMBusCurrent(sample 2 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{2} = '3332';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{2} = 'TLM8_+28VSSMBusCurrent(sample 2 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{2} = '1762';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{2} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{2} = '+28Volt SSM Bus Current, Sample 2 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3333: TLM8_+28VSSMBusCurrent(sample 3 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{3} = '3333';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{3} = 'TLM8_+28VSSMBusCurrent(sample 3 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{3} = '1776';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{3} = '+28Volt SSM Bus Current, Sample 3 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3334: TLM8_+28VSSMBusCurrent(sample 3 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{3} = '3334';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{3} = 'TLM8_+28VSSMBusCurrent(sample 3 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{3} = '1778';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{3} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{3} = '+28Volt SSM Bus Current, Sample 3 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3335: TLM8_+28VSSMBusCurrent(sample 4 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{4} = '3335';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{4} = 'TLM8_+28VSSMBusCurrent(sample 4 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{4} = '1792';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{4} = '+28Volt SSM Bus Current, Sample 4 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3336: TLM8_+28VSSMBusCurrent(sample 4 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{4} = '3336';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{4} = 'TLM8_+28VSSMBusCurrent(sample 4 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{4} = '1794';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{4} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{4} = '+28Volt SSM Bus Current, Sample 4 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3337: TLM8_+28VSSMBusCurrent(sample 5 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{5} = '3337';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{5} = 'TLM8_+28VSSMBusCurrent(sample 5 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{5} = '1808';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{5} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{5} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{5} = '+28Volt SSM Bus Current, Sample 5 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3338: TLM8_+28VSSMBusCurrent(sample 5 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{5} = '3338';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{5} = 'TLM8_+28VSSMBusCurrent(sample 5 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{5} = '1810';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{5} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{5} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{5} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{5} = '+28Volt SSM Bus Current, Sample 5 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3339: TLM8_+28VSSMBusCurrent(sample 6 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{6} = '3339';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{6} = 'TLM8_+28VSSMBusCurrent(sample 6 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{6} = '1824';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{6} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{6} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{6} = '+28Volt SSM Bus Current, Sample 6 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3340: TLM8_+28VSSMBusCurrent(sample 6 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{6} = '3340';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{6} = 'TLM8_+28VSSMBusCurrent(sample 6 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{6} = '1826';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{6} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{6} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{6} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{6} = '+28Volt SSM Bus Current, Sample 6 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3341: TLM8_+28VSSMBusCurrent(sample 7 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{7} = '3341';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{7} = 'TLM8_+28VSSMBusCurrent(sample 7 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{7} = '1840';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{7} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{7} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{7} = '+28Volt SSM Bus Current, Sample 7 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3342: TLM8_+28VSSMBusCurrent(sample 7 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{7} = '3342';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{7} = 'TLM8_+28VSSMBusCurrent(sample 7 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{7} = '1842';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{7} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{7} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{7} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{7} = '+28Volt SSM Bus Current, Sample 7 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3343: TLM8_+28VSSMBusCurrent(sample 8 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{8} = '3343';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{8} = 'TLM8_+28VSSMBusCurrent(sample 8 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{8} = '1856';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{8} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{8} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{8} = '+28Volt SSM Bus Current, Sample 8 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3344: TLM8_+28VSSMBusCurrent(sample 8 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{8} = '3344';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{8} = 'TLM8_+28VSSMBusCurrent(sample 8 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{8} = '1858';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{8} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{8} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{8} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{8} = '+28Volt SSM Bus Current, Sample 8 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3345: TLM8_+28VSSMBusCurrent(sample 9 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{9} = '3345';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{9} = 'TLM8_+28VSSMBusCurrent(sample 9 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{9} = '1872';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{9} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{9} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{9} = '+28Volt SSM Bus Current, Sample 9 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3346: TLM8_+28VSSMBusCurrent(sample 9 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{9} = '3346';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{9} = 'TLM8_+28VSSMBusCurrent(sample 9 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{9} = '1874';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{9} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{9} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{9} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{9} = '+28Volt SSM Bus Current, Sample 9 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3347: TLM8_+28VSSMBusCurrent(sample 10 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{10} = '3347';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{10} = 'TLM8_+28VSSMBusCurrent(sample 10 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{10} = '1888';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{10} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{10} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{10} = '+28Volt SSM Bus Current, Sample 10 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3348: TLM8_+28VSSMBusCurrent(sample 10 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{10} = '3348';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{10} = 'TLM8_+28VSSMBusCurrent(sample 10 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{10} = '1890';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{10} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{10} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{10} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{10} = '+28Volt SSM Bus Current, Sample 10 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3349: TLM8_+28VSSMBusCurrent(sample 11 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{11} = '3349';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{11} = 'TLM8_+28VSSMBusCurrent(sample 11 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{11} = '1904';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{11} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{11} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{11} = '+28Volt SSM Bus Current, Sample 11 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3350: TLM8_+28VSSMBusCurrent(sample 11 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{11} = '3350';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{11} = 'TLM8_+28VSSMBusCurrent(sample 11 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{11} = '1906';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{11} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{11} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{11} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{11} = '+28Volt SSM Bus Current, Sample 11 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3351: TLM8_+28VSSMBusCurrent(sample 12 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{12} = '3351';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{12} = 'TLM8_+28VSSMBusCurrent(sample 12 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{12} = '1920';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{12} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{12} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{12} = '+28Volt SSM Bus Current, Sample 12 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3352: TLM8_+28VSSMBusCurrent(sample 12 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{12} = '3352';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{12} = 'TLM8_+28VSSMBusCurrent(sample 12 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{12} = '1922';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{12} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{12} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{12} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{12} = '+28Volt SSM Bus Current, Sample 12 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3354: TLM8_Cross-TrackServoErr(sample 1 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{1} = '3354';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{1} = 'TLM8_Cross-TrackServoErr(sample 1 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{1} = '1936';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{1} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{1} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{1} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{1} = 'X-Track Servo Error, Sample 1 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3356: TLM8_In-TrackServoErr(sample 1 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{1} = '3356';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{1} = 'TLM8_In-TrackServoErr(sample 1 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{1} = '1952';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{1} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{1} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{1} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{1} = 'In-Track Servo Error, Sample 1 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3358: TLM8_Cross-TrackServoErr(sample 2 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{2} = '3358';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{2} = 'TLM8_Cross-TrackServoErr(sample 2 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{2} = '1968';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{2} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{2} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{2} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{2} = 'X-Track Servo Error, Sample 2 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3360: TLM8_In-TrackServoErr(sample 2 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{2} = '3360';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{2} = 'TLM8_In-TrackServoErr(sample 2 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{2} = '1984';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{2} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{2} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{2} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{2} = 'In-Track Servo Error, Sample 2 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3361: TLM8_CrossTrackAxisMotorCurrent(sample 1 epoch x - Spare)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.telemetry_point_id{1} = '3361';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.mnemonic{1} = 'TLM8_CrossTrackAxisMotorCurrent(sample 1 epoch x - Spare)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.start_bit{1} = '2000';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.description{1} = 'X-Track Axis Motor Current, Sample 1 Epoch x - Spare';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3362: TLM8_CrossTrackAxisMotorCurrent(sample 1 epoch x)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.telemetry_point_id{1} = '3362';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.mnemonic{1} = 'TLM8_CrossTrackAxisMotorCurrent(sample 1 epoch x)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.start_bit{1} = '2002';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.coeffs{1} = '3.2213 -0.00043573';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.description{1} = 'X-Track Axis Motor Current, Sample 1 Epoch x';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3364: TLM8_Cross-TrackServoErr(sample 3 (epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{3} = '3364';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{3} = 'TLM8_Cross-TrackServoErr(sample 3 (epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{3} = '2016';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{3} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{3} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{3} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{3} = 'X-Track Servo Error, Sample 3, Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3365: TLM8_In-TrackAxisMotorCurrent(sample 1 epoch x - Spare)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.telemetry_point_id{1} = '3365';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.mnemonic{1} = 'TLM8_In-TrackAxisMotorCurrent(sample 1 epoch x - Spare)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.start_bit{1} = '2032';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.description{1} = 'In-Track Axis Motor Current, Sample 1 Epoch x - Spare';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3366: TLM8_In-TrackAxisMotorCurrent(sample 1 epoch x)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.telemetry_point_id{1} = '3366';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.mnemonic{1} = 'TLM8_In-TrackAxisMotorCurrent(sample 1 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.start_bit{1} = '2034';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.coeffs{1} = '0.9757 -0.00013306';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.description{1} = 'In-Track Axis Motor Current, Sample 1 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3368: TLM8_In-TrackServoErr(sample 3 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{3} = '3368';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{3} = 'TLM8_In-TrackServoErr(sample 3 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{3} = '2048';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{3} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{3} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{3} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{3} = 'In-Track Servo Error, Sample 3 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3370: TLM8_Cross-TrackServoErr(sample 4 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{4} = '3370';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{4} = 'TLM8_Cross-TrackServoErr(sample 4 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{4} = '2064';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{4} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{4} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{4} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{4} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{4} = 'X-Track Servo Error, Sample 4 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3372: TLM8_In-TrackServoErr(sample 4 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{4} = '3372';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{4} = 'TLM8_In-TrackServoErr(sample 4 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{4} = '2080';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{4} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{4} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{4} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{4} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{4} = 'In-Track Servo Error, Sample 4 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3374: TLM8_Cross-TrackServoErr(sample 5 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{5} = '3374';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{5} = 'TLM8_Cross-TrackServoErr(sample 5 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{5} = '2096';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{5} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{5} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{5} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{5} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{5} = 'X-Track Servo Error, Sample 5 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3376: TLM8_In-TrackServoErr(sample 5 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{5} = '3376';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{5} = 'TLM8_In-TrackServoErr(sample 5 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{5} = '2112';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{5} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{5} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{5} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{5} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{5} = 'In-Track Servo Error, Sample 5 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3378: TLM8_Cross-TrackServoErr(sample 6 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{6} = '3378';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{6} = 'TLM8_Cross-TrackServoErr(sample 6 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{6} = '2128';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{6} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{6} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{6} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{6} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{6} = 'X-Track Servo Error, Sample 6 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3380: TLM8_In-TrackServoErr(sample 6 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{6} = '3380';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{6} = 'TLM8_In-TrackServoErr(sample 6 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{6} = '2144';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{6} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{6} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{6} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{6} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{6} = 'In-Track Servo Error, Sample 6 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3382: TLM8_Cross-TrackServoErr(sample 7 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{7} = '3382';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{7} = 'TLM8_Cross-TrackServoErr(sample 7 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{7} = '2160';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{7} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{7} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{7} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{7} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{7} = 'X-Track Servo Error, Sample 7 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3384: TLM8_In-TrackServoErr(sample 7 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{7} = '3384';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{7} = 'TLM8_In-TrackServoErr(sample 7 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{7} = '2176';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{7} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{7} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{7} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{7} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{7} = 'In-Track Servo Error, Sample 7 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3386: TLM8_Cross-TrackServoErr(sample 8 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{8} = '3386';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{8} = 'TLM8_Cross-TrackServoErr(sample 8 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{8} = '2192';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{8} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{8} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{8} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{8} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{8} = 'X-Track Servo Error, Sample 8 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3388: TLM8_In-TrackServoErr(sample 8 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{8} = '3388';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{8} = 'TLM8_In-TrackServoErr(sample 8 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{8} = '2208';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{8} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{8} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{8} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{8} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{8} = 'In-Track Servo Error, Sample 8 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3390: TLM8_Cross-TrackServoErr(sample 9 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{9} = '3390';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{9} = 'TLM8_Cross-TrackServoErr(sample 9 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{9} = '2224';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{9} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{9} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{9} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{9} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{9} = 'X-Track Servo Error, Sample 9 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3392: TLM8_In-TrackServoErr(sample 9 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{9} = '3392';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{9} = 'TLM8_In-TrackServoErr(sample 9 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{9} = '2240';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{9} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{9} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{9} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{9} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{9} = 'In-Track Servo Error, Sample 9 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3394: TLM8_Cross-TrackServoErr(sample 10 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{10} = '3394';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{10} = 'TLM8_Cross-TrackServoErr(sample 10 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{10} = '2256';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{10} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{10} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{10} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{10} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{10} = 'X-Track Servo Error, Sample 10 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3396: TLM8_In-TrackServoErr(sample 10 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{10} = '3396';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{10} = 'TLM8_In-TrackServoErr(sample 10 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{10} = '2272';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{10} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{10} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{10} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{10} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{10} = 'In-Track Servo Error, Sample 10 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3398: TLM8_Cross-TrackServoErr(sample 11 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{11} = '3398';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{11} = 'TLM8_Cross-TrackServoErr(sample 11 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{11} = '2288';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{11} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{11} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{11} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{11} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{11} = 'X-Track Servo Error, Sample 11 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3400: TLM8_In-TrackServoErr(sample 11 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{11} = '3400';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{11} = 'TLM8_In-TrackServoErr(sample 11 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{11} = '2304';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{11} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{11} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{11} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{11} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{11} = 'In-Track Servo Error, Sample 11 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3402: TLM8_Cross-TrackServoErr(sample 12 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{12} = '3402';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{12} = 'TLM8_Cross-TrackServoErr(sample 12 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{12} = '2320';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{12} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{12} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{12} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{12} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{12} = 'X-Track Servo Error, Sample 12 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3404: TLM8_In-TrackServoErr(sample 12 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{12} = '3404';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{12} = 'TLM8_In-TrackServoErr(sample 12 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{12} = '2336';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{12} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{12} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{12} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{12} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{12} = 'In-Track Servo Error, Sample 12 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3405: TLM8_Commandedcross-Trackposition(Lower epoch x)
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x.att.telemetry_point_id = '3405';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x.att.mnemonic = 'TLM8_Commandedcross-Trackposition(Lower epoch x)';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x.att.start_bit = '2352';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x.att.coeffs = '0 2.996';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x.att.description = 'Cmded X-Track Servo Position, Lower Epoch x';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x.dim = {'hk8_packet'};

    % id 3406: TLM8_Commandedcross-Trackposition(Upper epoch x)
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x.att.telemetry_point_id = '3406';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x.att.mnemonic = 'TLM8_Commandedcross-Trackposition(Upper epoch x)';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x.att.start_bit = '2368';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x.att.coeffs = '0 2.996';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x.att.description = 'Cmded X-Track Servo Position, Upper Epoch x';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x.dim = {'hk8_packet'};

    % id 3407: TLM8_Cross-Trackposition(Lower epoch x)
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x.att.telemetry_point_id = '3407';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x.att.mnemonic = 'TLM8_Cross-Trackposition(Lower epoch x)';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x.att.start_bit = '2384';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x.att.coeffs = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x.att.description = 'X-Track Servo Position, Lower Epoch x';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x.dim = {'hk8_packet'};

    % id 3408: TLM8_Cross-Trackposition(Upper epoch x)
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x.att.telemetry_point_id = '3408';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x.att.mnemonic = 'TLM8_Cross-Trackposition(Upper epoch x)';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x.att.start_bit = '2400';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x.att.coeffs = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x.att.description = 'X-Track Servo Position, Upper Epoch x';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x.dim = {'hk8_packet'};

    % id 3410: TLM8_Cross-TrackServoErr(sample 13 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{13} = '3410';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{13} = 'TLM8_Cross-TrackServoErr(sample 13 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{13} = '2416';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{13} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{13} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{13} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{13} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{13} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{13} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{13} = 'X-Track Servo Error, Sample 13 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3411: TLM8_CrossTrackAxisMotorCurrent(sample 2 epoch x - Spare)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.telemetry_point_id{2} = '3411';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.mnemonic{2} = 'TLM8_CrossTrackAxisMotorCurrent(sample 2 epoch x - Spare)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.start_bit{2} = '2432';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.description{2} = 'X-Track Axis Motor Current, Sample 2 Epoch x - Spare';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3412: TLM8_CrossTrackAxisMotorCurrent(sample 2 epoch x)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.telemetry_point_id{2} = '3412';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.mnemonic{2} = 'TLM8_CrossTrackAxisMotorCurrent(sample 2 epoch x)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.start_bit{2} = '2434';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.coeffs{2} = '3.2213 -0.00043573';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.description{2} = 'X-Track Axis Motor Current, Sample 2 Epoch x';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3414: TLM8_In-TrackServoErr(sample 13 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{13} = '3414';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{13} = 'TLM8_In-TrackServoErr(sample 13 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{13} = '2448';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{13} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{13} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{13} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{13} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{13} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{13} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{13} = 'In-Track Servo Error, Sample 13 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3415: TLM8_In-TrackAxisMotorCurrent(sample 2 epoch x - Spare)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.telemetry_point_id{2} = '3415';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.mnemonic{2} = 'TLM8_In-TrackAxisMotorCurrent(sample 2 epoch x - Spare)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.start_bit{2} = '2464';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.description{2} = 'In-Track Axis Motor Current, Sample 2 Epoch x - Spare';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3416: TLM8_In-TrackAxisMotorCurrent(sample 2 epoch x)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.telemetry_point_id{2} = '3416';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.mnemonic{2} = 'TLM8_In-TrackAxisMotorCurrent(sample 2 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.start_bit{2} = '2466';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.coeffs{2} = '0.9757 -0.00013306';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.description{2} = 'In-Track Axis Motor Current, Sample 2 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3418: TLM8_Cross-TrackServoErr(sample 14 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{14} = '3418';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{14} = 'TLM8_Cross-TrackServoErr(sample 14 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{14} = '2480';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{14} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{14} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{14} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{14} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{14} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{14} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{14} = 'X-Track Servo Error, Sample 14 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3420: TLM8_In-TrackServoErr(sample 14 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{14} = '3420';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{14} = 'TLM8_In-TrackServoErr(sample 14 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{14} = '2496';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{14} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{14} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{14} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{14} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{14} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{14} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{14} = 'In-Track Servo Error, Sample 14 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3422: TLM8_Cross-TrackServoErr(sample 15 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{15} = '3422';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{15} = 'TLM8_Cross-TrackServoErr(sample 15 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{15} = '2512';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{15} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{15} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{15} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{15} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{15} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{15} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{15} = 'X-Track Servo Error, Sample 15 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3424: TLM8_In-TrackServoErr(sample 15 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{15} = '3424';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{15} = 'TLM8_In-TrackServoErr(sample 15 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{15} = '2528';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{15} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{15} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{15} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{15} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{15} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{15} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{15} = 'In-Track Servo Error, Sample 15 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3426: TLM8_Cross-TrackServoErr(sample 16 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{16} = '3426';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{16} = 'TLM8_Cross-TrackServoErr(sample 16 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{16} = '2544';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{16} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{16} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{16} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{16} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{16} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{16} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{16} = 'X-Track Servo Error, Sample 16 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3428: TLM8_In-TrackServoErr(sample 16 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{16} = '3428';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{16} = 'TLM8_In-TrackServoErr(sample 16 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{16} = '2560';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{16} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{16} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{16} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{16} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{16} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{16} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{16} = 'In-Track Servo Error, Sample 16 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3430: TLM8_Cross-TrackServoErr(sample 17 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{17} = '3430';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{17} = 'TLM8_Cross-TrackServoErr(sample 17 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{17} = '2576';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{17} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{17} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{17} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{17} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{17} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{17} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{17} = 'X-Track Servo Error, Sample 17 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3432: TLM8_In-TrackServoErr(sample 17 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{17} = '3432';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{17} = 'TLM8_In-TrackServoErr(sample 17 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{17} = '2592';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{17} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{17} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{17} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{17} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{17} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{17} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{17} = 'In-Track Servo Error, Sample 17 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3433: TLM8_SSMScanmirrorbaffleTemp1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39_Spare.att.telemetry_point_id = '3433';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39_Spare.att.mnemonic = 'TLM8_SSMScanmirrorbaffleTemp1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39_Spare.att.start_bit = '2608';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39_Spare.att.description = 'SSM Scan Mirror Baffle Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3434: TLM8_SSMScanmirrorbaffleTemp1(epoch 39)
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39.att.telemetry_point_id = '3434';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39.att.mnemonic = 'TLM8_SSMScanmirrorbaffleTemp1(epoch 39)';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39.att.start_bit = '2610';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39.att.coeffs = '29.356386 0.006363';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39.att.description = 'SSM Scan Mirror Baffle Temp, Epoch 39';
    g_metadata.packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39.dim = {'hk8_packet'};

    % id 3435: TLM8_ICTPRT3(Spare)
    g_metadata.packets.instr_hk8.ICTPRT3_Spare.att.telemetry_point_id = '3435';
    g_metadata.packets.instr_hk8.ICTPRT3_Spare.att.mnemonic = 'TLM8_ICTPRT3(Spare)';
    g_metadata.packets.instr_hk8.ICTPRT3_Spare.att.start_bit = '2624';
    g_metadata.packets.instr_hk8.ICTPRT3_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.ICTPRT3_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.ICTPRT3_Spare.att.description = 'ICTPRT3 (Spare)';
    g_metadata.packets.instr_hk8.ICTPRT3_Spare.dim = {'hk8_packet'};

    % id 3436: TLM8_ICTPRT3(epoch 39)
    g_metadata.packets.instr_hk8.ICTPRT3_epoch_39.att.telemetry_point_id = '3436';
    g_metadata.packets.instr_hk8.ICTPRT3_epoch_39.att.mnemonic = 'TLM8_ICTPRT3(epoch 39)';
    g_metadata.packets.instr_hk8.ICTPRT3_epoch_39.att.start_bit = '2626';
    g_metadata.packets.instr_hk8.ICTPRT3_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.ICTPRT3_epoch_39.att.coeffs = '19.196 0.006272868';
    g_metadata.packets.instr_hk8.ICTPRT3_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.ICTPRT3_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.ICTPRT3_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.ICTPRT3_epoch_39.att.description = 'ICTPRT3 - Epoch 39';
    g_metadata.packets.instr_hk8.ICTPRT3_epoch_39.dim = {'hk8_packet'};

    % id 3437: TLM8_SSMstructureTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39_Spare.att.telemetry_point_id = '3437';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39_Spare.att.mnemonic = 'TLM8_SSMstructureTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39_Spare.att.start_bit = '2640';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39_Spare.att.description = 'SSM Structure Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3438: TLM8_SSMstructureTemp(epoch 39)
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39.att.telemetry_point_id = '3438';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39.att.mnemonic = 'TLM8_SSMstructureTemp(epoch 39)';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39.att.start_bit = '2642';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39.att.coeffs = '23.47 4.9024E-03 3.3086E-08 3.6732E-11 3.9652E-16';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39.att.description = 'SSM Structure Temp, Epoch 39';
    g_metadata.packets.instr_hk8.SSMstructureTemp_epoch_39.dim = {'hk8_packet'};

    % id 3439: TLM8_SSMelectronicsboardTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39_Spare.att.telemetry_point_id = '3439';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39_Spare.att.mnemonic = 'TLM8_SSMelectronicsboardTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39_Spare.att.start_bit = '2656';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39_Spare.att.description = 'SSM Electronics Board Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3440: TLM8_SSMelectronicsboardTemp(epoch 39)
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39.att.telemetry_point_id = '3440';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39.att.mnemonic = 'TLM8_SSMelectronicsboardTemp(epoch 39)';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39.att.start_bit = '2658';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39.att.coeffs = '23.47 4.9024E-03 3.3086E-08 3.6732E-11 3.9652E-16';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39.att.description = 'SSM Electronics Board Temp, Epoch 39';
    g_metadata.packets.instr_hk8.SSMelectronicsboardTemp_epoch_39.dim = {'hk8_packet'};

    % id 3441: TLM8_Cross-TrackMotorwindingTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39_Spare.att.telemetry_point_id = '3441';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39_Spare.att.mnemonic = 'TLM8_Cross-TrackMotorwindingTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39_Spare.att.start_bit = '2672';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39_Spare.att.description = 'X-Track Motor Winding Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3442: TLM8_Cross-TrackMotorwindingTemp(epoch 39)
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39.att.telemetry_point_id = '3442';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39.att.mnemonic = 'TLM8_Cross-TrackMotorwindingTemp(epoch 39)';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39.att.start_bit = '2674';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39.att.coeffs = '23.47 4.9024E-03 3.3086E-08 3.6732E-11 3.9652E-16';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39.att.description = 'X-Track Motor Winding Temp, Epoch 39';
    g_metadata.packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39.dim = {'hk8_packet'};

    % id 3443: TLM8_](epoch 39 - Spare)
    g_metadata.packets.instr_hk8.epoch_39_Spare.att.telemetry_point_id = '3443';
    g_metadata.packets.instr_hk8.epoch_39_Spare.att.mnemonic = 'TLM8_](epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.epoch_39_Spare.att.start_bit = '2688';
    g_metadata.packets.instr_hk8.epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.epoch_39_Spare.att.description = 'In-Track Motor Winding Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.epoch_39_Spare.dim = {'hk8_packet'};

    % id 3444: TLM8_InTrackMotorwindingTemp(epoch 39)
    g_metadata.packets.instr_hk8.InTrackMotorwindingTemp_epoch_39.att.telemetry_point_id = '3444';
    g_metadata.packets.instr_hk8.InTrackMotorwindingTemp_epoch_39.att.mnemonic = 'TLM8_InTrackMotorwindingTemp(epoch 39)';
    g_metadata.packets.instr_hk8.InTrackMotorwindingTemp_epoch_39.att.start_bit = '2690';
    g_metadata.packets.instr_hk8.InTrackMotorwindingTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.InTrackMotorwindingTemp_epoch_39.att.coeffs = '23.47 4.9024E-03 3.3086E-08 3.6732E-11 3.9652E-16';
    g_metadata.packets.instr_hk8.InTrackMotorwindingTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.InTrackMotorwindingTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.InTrackMotorwindingTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.InTrackMotorwindingTemp_epoch_39.att.description = 'In-Track Motor Winding Temp, Epoch 39';
    g_metadata.packets.instr_hk8.InTrackMotorwindingTemp_epoch_39.dim = {'hk8_packet'};

    % id 3445: TLM8_+2.5VDCASICcorevoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39_Spare.att.telemetry_point_id = '3445';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+2.5VDCASICcorevoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39_Spare.att.start_bit = '2704';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39_Spare.att.description = '+2.5VDC ASIC Core Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3446: TLM8_+2.5VDCASICcorevoltage(epoch 39)
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39.att.telemetry_point_id = '3446';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39.att.mnemonic = 'TLM8_+2.5VDCASICcorevoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39.att.start_bit = '2706';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39.att.coeffs = '0 3.6853E-04';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39.att.description = '+2.5VDC ASIC Core Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39.dim = {'hk8_packet'};

    % id 3447: TLM8_+3.3VDCsecondaryvoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39_Spare.att.telemetry_point_id = '3447';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+3.3VDCsecondaryvoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39_Spare.att.start_bit = '2720';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39_Spare.att.description = '+3.3VDC Secondary Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3448: TLM8_+3.3VDCsecondaryvoltage(epoch 39)
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39.att.telemetry_point_id = '3448';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39.att.mnemonic = 'TLM8_+3.3VDCsecondaryvoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39.att.start_bit = '2722';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39.att.coeffs = '0 5.083E-04';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39.att.description = '+3.3VDC secondary Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39.dim = {'hk8_packet'};

    % id 3449: TLM8_+5.0VDCsecondaryvoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39_Spare.att.telemetry_point_id = '3449';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+5.0VDCsecondaryvoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39_Spare.att.start_bit = '2736';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39_Spare.att.description = '+5.0VDC Secondary Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3450: TLM8_+5.0VDCsecondaryvoltage(epoch 39)
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39.att.telemetry_point_id = '3450';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39.att.mnemonic = 'TLM8_+5.0VDCsecondaryvoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39.att.start_bit = '2738';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39.att.coeffs = '0 7.639E-04';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39.att.description = '+5.0VDC Secondary Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39.dim = {'hk8_packet'};

    % id 3451: TLM8_+12VDCsecondaryvoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39_Spare.att.telemetry_point_id = '3451';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+12VDCsecondaryvoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39_Spare.att.start_bit = '2752';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39_Spare.att.description = '+12VDC Secondary Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3452: TLM8_+12VDCsecondaryvoltage(epoch 39)
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39.att.telemetry_point_id = '3452';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39.att.mnemonic = 'TLM8_+12VDCsecondaryvoltage(epoch 39)';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39.att.start_bit = '2754';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39.att.coeffs = '0 1.776E-03';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39.att.description = '+12VDC Secondary Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39.dim = {'hk8_packet'};

    % id 3453: TLM8_-12VDCsecondaryvoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39_Spare.att.telemetry_point_id = '3453';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39_Spare.att.mnemonic = 'TLM8_-12VDCsecondaryvoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39_Spare.att.start_bit = '2768';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39_Spare.att.description = '-12VDC Secondary Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3454: TLM8_-12VDCsecondaryvoltage(epoch 39)
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39.att.telemetry_point_id = '3454';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39.att.mnemonic = 'TLM8_-12VDCsecondaryvoltage(epoch 39)';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39.att.start_bit = '2770';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39.att.coeffs = '0 1.776E-03';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39.att.description = '-12VDC Secondary Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39.dim = {'hk8_packet'};

    % id 3456: TLM8_Cross-TrackServoErr(sample 18 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{18} = '3456';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{18} = 'TLM8_Cross-TrackServoErr(sample 18 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{18} = '2784';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{18} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{18} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{18} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{18} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{18} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{18} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{18} = 'X-Track Servo Error, Sample 18 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3458: TLM8_In-TrackServoErr(sample 18 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{18} = '3458';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{18} = 'TLM8_In-TrackServoErr(sample 18 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{18} = '2800';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{18} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{18} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{18} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{18} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{18} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{18} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{18} = 'In-Track Servo Error, Sample 18 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3460: TLM8_Cross-TrackServoErr(sample 19 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{19} = '3460';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{19} = 'TLM8_Cross-TrackServoErr(sample 19 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{19} = '2816';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{19} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{19} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{19} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{19} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{19} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{19} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{19} = 'X-Track Servo Error, Sample 19 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3462: TLM8_In-TrackServoErr(sample 19 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{19} = '3462';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{19} = 'TLM8_In-TrackServoErr(sample 19 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{19} = '2832';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{19} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{19} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{19} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{19} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{19} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{19} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{19} = 'In-Track Servo Error, Sample 19 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3463: TLM8_ScanIntrptlocation(epoch x)
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x.att.telemetry_point_id = '3463';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x.att.mnemonic = 'TLM8_ScanIntrptlocation(epoch x)';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x.att.start_bit = '2848';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x.att.coeffs = '0 9.58700E+01';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x.att.num_bits = '16';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x.att.description = 'Scan Interrupt Location, Epoch x';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x.dim = {'hk8_packet'};

    % id 3465: TLM8_Cross-TrackServoErr(sample 20 epoch x)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.telemetry_point_id{20} = '3465';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.mnemonic{20} = 'TLM8_Cross-TrackServoErr(sample 20 epoch x)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.start_bit{20} = '2864';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.data_type{20} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.signbit_loc{20} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.coeffs{20} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.num_bits{20} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.units{20} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.eu_type{20} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.att.description{20} = 'X-Track Servo Error, Sample 20 Epoch x';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3467: TLM8_In-TrackServoErr(sample 20 epoch x)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.telemetry_point_id{20} = '3467';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.mnemonic{20} = 'TLM8_In-TrackServoErr(sample 20 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.start_bit{20} = '2880';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.data_type{20} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.signbit_loc{20} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.coeffs{20} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.num_bits{20} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.units{20} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.eu_type{20} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.att.description{20} = 'In-Track Servo Error, Sample 20 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3469: TLM8_Cross-TrackServoErr(sample 21 Only if x = epoch 4 - 33 else Zero fill)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.att.telemetry_point_id = '3469';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.att.mnemonic = 'TLM8_Cross-TrackServoErr(sample 21 Only if x = epoch 4 - 33 else Zero fill)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.att.start_bit = '2896';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.att.signbit_loc = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.att.coeffs = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.att.description = 'X-Track Servo Error, Sample 21(Only if x = Epoch 4 - 33 else Zero fill)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi.dim = {'hk8_packet'};

    % id 3471: TLM8_In-TrackServoErr(sample 21 Only if x = epoch 4 - 33 else Zero fill)
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.att.telemetry_point_id = '3471';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.att.mnemonic = 'TLM8_In-TrackServoErr(sample 21 Only if x = epoch 4 - 33 else Zero fill)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.att.start_bit = '2912';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.att.signbit_loc = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.att.coeffs = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.att.num_bits = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.att.description = 'In-Track Servo Error, Sample 21(Only if x = Epoch 4 - 33 else Zero fill)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill.dim = {'hk8_packet'};

    % id 3472: TLM8_CommandedinTrackAxisposition(epoch x)
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x.att.telemetry_point_id = '3472';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x.att.mnemonic = 'TLM8_CommandedinTrackAxisposition(epoch x)';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x.att.start_bit = '2928';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x.att.coeffs = '0 0.564';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x.att.num_bits = '16';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x.att.description = 'Cmded In-Track Axis Position, Epoch x';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x.dim = {'hk8_packet'};

    % id 3473: TLM8_In-Trackposition(epoch x)
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x.att.telemetry_point_id = '3473';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x.att.mnemonic = 'TLM8_In-Trackposition(epoch x)';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x.att.start_bit = '2944';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x.att.coeffs = '0 0.564';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x.att.num_bits = '16';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x.att.description = 'In-Track Position, Epoch x';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x.dim = {'hk8_packet'};

    % id 3474: TLM8_CrossTrackAxisMotorCurrent(sample 3 epoch x - Spare)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.telemetry_point_id{3} = '3474';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.mnemonic{3} = 'TLM8_CrossTrackAxisMotorCurrent(sample 3 epoch x - Spare)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.start_bit{3} = '2960';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.att.description{3} = 'X-Track Axis Motor Current, Sample 3 Epoch x - Spare';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3475: TLM8_CrossTrackAxisMotorCurrent(sample 3 epoch x)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.telemetry_point_id{3} = '3475';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.mnemonic{3} = 'TLM8_CrossTrackAxisMotorCurrent(sample 3 epoch x)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.start_bit{3} = '2962';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.coeffs{3} = '3.2213 -0.00043573';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.att.description{3} = 'X-Track Axis Motor Current, Sample 3 Epoch x';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3476: TLM8_In-TrackAxisMotorCurrent(sample 3 epoch x - Spare)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.telemetry_point_id{3} = '3476';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.mnemonic{3} = 'TLM8_In-TrackAxisMotorCurrent(sample 3 epoch x - Spare)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.start_bit{3} = '2976';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.att.description{3} = 'In-Track Axis Motor Current, Sample 3 Epoch x - Spare';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3477: TLM8_In-TrackAxisMotorCurrent(sample 3 epoch x)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.telemetry_point_id{3} = '3477';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.mnemonic{3} = 'TLM8_In-TrackAxisMotorCurrent(sample 3 epoch x)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.start_bit{3} = '2978';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.coeffs{3} = '0.9757 -0.00013306';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.att.description{3} = 'In-Track Axis Motor Current, Sample 3 Epoch x';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3478: TLM8_+28VSSMBusCurrent(sample 13 epoch x - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.telemetry_point_id{13} = '3478';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.mnemonic{13} = 'TLM8_+28VSSMBusCurrent(sample 13 epoch x - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.start_bit{13} = '2992';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.data_type{13} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.num_bits{13} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.att.description{13} = '+28V SSM Bus Current, Sample 13 Epoch x - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3479: TLM8_+28VSSMBusCurrent(sample 13 epoch x)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.telemetry_point_id{13} = '3479';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.mnemonic{13} = 'TLM8_+28VSSMBusCurrent(sample 13 epoch x)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.start_bit{13} = '2994';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.data_type{13} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.coeffs{13} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.num_bits{13} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.units{13} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.eu_type{13} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.att.description{13} = '+28V SSM Bus Current, Sample 13 Epoch x';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3480: TLM8_+28VSSMBusCurrent(sample 1 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{1} = '3480';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{1} = 'TLM8_+28VSSMBusCurrent(sample 1 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{1} = '3008';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{1} = '+28V SSM Bus Current, Sample 1 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3481: TLM8_+28VSSMBusCurrent(sample 1 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{1} = '3481';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{1} = 'TLM8_+28VSSMBusCurrent(sample 1 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{1} = '3010';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{1} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description = cell(13, 1);
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{1} = '+28V SSM Bus Current, Sample 1 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3482: TLM8_+28VSSMBusCurrent(sample 2 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{2} = '3482';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{2} = 'TLM8_+28VSSMBusCurrent(sample 2 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{2} = '3024';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{2} = '+28V SSM Bus Current, Sample 2 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3483: TLM8_+28VSSMBusCurrent(sample 2 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{2} = '3483';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{2} = 'TLM8_+28VSSMBusCurrent(sample 2 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{2} = '3026';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{2} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{2} = '+28V SSM Bus Current, Sample 2 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3484: TLM8_+28VSSMBusCurrent(sample 3 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{3} = '3484';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{3} = 'TLM8_+28VSSMBusCurrent(sample 3 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{3} = '3040';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{3} = '+28V SSM Bus Current, Sample 3 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3485: TLM8_+28VSSMBusCurrent(sample 3 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{3} = '3485';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{3} = 'TLM8_+28VSSMBusCurrent(sample 3 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{3} = '3042';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{3} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{3} = '+28V SSM Bus Current, Sample 3 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3486: TLM8_+28VSSMBusCurrent(sample 4 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{4} = '3486';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{4} = 'TLM8_+28VSSMBusCurrent(sample 4 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{4} = '3056';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{4} = '+28V SSM Bus Current, Sample 4 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3487: TLM8_+28VSSMBusCurrent(sample 4 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{4} = '3487';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{4} = 'TLM8_+28VSSMBusCurrent(sample 4 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{4} = '3058';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{4} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{4} = '+28V SSM Bus Current, Sample 4 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3488: TLM8_+28VSSMBusCurrent(sample 5 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{5} = '3488';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{5} = 'TLM8_+28VSSMBusCurrent(sample 5 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{5} = '3072';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{5} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{5} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{5} = '+28V SSM Bus Current, Sample 5 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3489: TLM8_+28VSSMBusCurrent(sample 5 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{5} = '3489';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{5} = 'TLM8_+28VSSMBusCurrent(sample 5 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{5} = '3074';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{5} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{5} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{5} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{5} = '+28V SSM Bus Current, Sample 5 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3490: TLM8_+28VSSMBusCurrent(sample 6 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{6} = '3490';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{6} = 'TLM8_+28VSSMBusCurrent(sample 6 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{6} = '3088';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{6} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{6} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{6} = '+28V SSM Bus Current, Sample 6 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3491: TLM8_+28VSSMBusCurrent(sample 6 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{6} = '3491';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{6} = 'TLM8_+28VSSMBusCurrent(sample 6 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{6} = '3090';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{6} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{6} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{6} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{6} = '+28V SSM Bus Current, Sample 6 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3492: TLM8_+28VSSMBusCurrent(sample 7 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{7} = '3492';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{7} = 'TLM8_+28VSSMBusCurrent(sample 7 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{7} = '3104';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{7} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{7} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{7} = '+28V SSM Bus Current, Sample 7 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3493: TLM8_+28VSSMBusCurrent(sample 7 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{7} = '3493';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{7} = 'TLM8_+28VSSMBusCurrent(sample 7 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{7} = '3106';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{7} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{7} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{7} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{7} = '+28V SSM Bus Current, Sample 7 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3494: TLM8_+28VSSMBusCurrent(sample 8 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{8} = '3494';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{8} = 'TLM8_+28VSSMBusCurrent(sample 8 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{8} = '3120';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{8} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{8} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{8} = '+28V SSM Bus Current, Sample 8 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3495: TLM8_+28VSSMBusCurrent(sample 8 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{8} = '3495';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{8} = 'TLM8_+28VSSMBusCurrent(sample 8 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{8} = '3122';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{8} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{8} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{8} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{8} = '+28V SSM Bus Current, Sample 8 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3496: TLM8_+28VSSMBusCurrent(sample 9 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{9} = '3496';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{9} = 'TLM8_+28VSSMBusCurrent(sample 9 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{9} = '3136';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{9} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{9} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{9} = '+28V SSM Bus Current, Sample 9 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3497: TLM8_+28VSSMBusCurrent(sample 9 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{9} = '3497';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{9} = 'TLM8_+28VSSMBusCurrent(sample 9 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{9} = '3138';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{9} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{9} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{9} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{9} = '+28V SSM Bus Current, Sample 9 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3498: TLM8_+28VSSMBusCurrent(sample 10 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{10} = '3498';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{10} = 'TLM8_+28VSSMBusCurrent(sample 10 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{10} = '3152';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{10} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{10} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{10} = '+28V SSM Bus Current, Sample 10 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3499: TLM8_+28VSSMBusCurrent(sample 10 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{10} = '3499';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{10} = 'TLM8_+28VSSMBusCurrent(sample 10 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{10} = '3154';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{10} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{10} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{10} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{10} = '+28V SSM Bus Current, Sample 10 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3500: TLM8_+28VSSMBusCurrent(sample 11 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{11} = '3500';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{11} = 'TLM8_+28VSSMBusCurrent(sample 11 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{11} = '3168';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{11} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{11} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{11} = '+28V SSM Bus Current, Sample 11 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3501: TLM8_+28VSSMBusCurrent(sample 11 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{11} = '3501';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{11} = 'TLM8_+28VSSMBusCurrent(sample 11 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{11} = '3170';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{11} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{11} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{11} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{11} = '+28V SSM Bus Current, Sample 11 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3502: TLM8_+28VSSMBusCurrent(sample 12 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{12} = '3502';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{12} = 'TLM8_+28VSSMBusCurrent(sample 12 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{12} = '3184';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{12} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{12} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{12} = '+28V SSM Bus Current, Sample 12 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3503: TLM8_+28VSSMBusCurrent(sample 12 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{12} = '3503';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{12} = 'TLM8_+28VSSMBusCurrent(sample 12 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{12} = '3186';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{12} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{12} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{12} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{12} = '+28V SSM Bus Current, Sample 12 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3505: TLM8_Cross-TrackServoErr(sample 1 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{1} = '3505';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{1} = 'TLM8_Cross-TrackServoErr(sample 1 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{1} = '3200';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{1} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{1} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{1} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description = cell(20, 1);
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{1} = 'X-Track Servo Error, Sample 1 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3507: TLM8_In-TrackServoErr(sample 1 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{1} = '3507';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{1} = 'TLM8_In-TrackServoErr(sample 1 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{1} = '3216';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{1} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{1} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{1} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description = cell(20, 1);
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{1} = 'In-Track Servo Error, Sample 1 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3509: TLM8_Cross-TrackServoErr(sample 2 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{2} = '3509';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{2} = 'TLM8_Cross-TrackServoErr(sample 2 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{2} = '3232';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{2} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{2} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{2} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{2} = 'X-Track Servo Error, Sample 2 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3511: TLM8_In-TrackServoErr(sample 2 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{2} = '3511';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{2} = 'TLM8_In-TrackServoErr(sample 2 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{2} = '3248';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{2} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{2} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{2} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{2} = 'In-Track Servo Error, Sample 2 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3512: TLM8_CrossTrackAxisMotorCurrent(sample 1 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.telemetry_point_id{1} = '3512';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.mnemonic{1} = 'TLM8_CrossTrackAxisMotorCurrent(sample 1 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.start_bit{1} = '3264';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.description{1} = 'X-Track Axis Motor Current, Sample 1 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3513: TLM8_CrossTrackAxisMotorCurrent(sample 1 epoch x+1)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.telemetry_point_id{1} = '3513';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.mnemonic{1} = 'TLM8_CrossTrackAxisMotorCurrent(sample 1 epoch x+1)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.start_bit{1} = '3266';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.coeffs{1} = '3.2213 -0.00043573';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.description{1} = 'X-Track Axis Motor Current, Sample 1 Epoch x+1';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3515: TLM8_Cross-TrackServoErr(sample 3 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{3} = '3515';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{3} = 'TLM8_Cross-TrackServoErr(sample 3 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{3} = '3280';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{3} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{3} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{3} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{3} = 'X-Track Servo Error, Sample 3 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3516: TLM8_In-TrackAxisMotorCurrent(sample 1 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.telemetry_point_id{1} = '3516';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.mnemonic{1} = 'TLM8_In-TrackAxisMotorCurrent(sample 1 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.start_bit{1} = '3296';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.description{1} = 'In-Track Axis Motor Current, Sample 1 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3517: TLM8_In-TrackAxisMotorCurrent(sample 1 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.telemetry_point_id{1} = '3517';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.mnemonic{1} = 'TLM8_In-TrackAxisMotorCurrent(sample 1 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.start_bit{1} = '3298';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.coeffs{1} = '0.9757 -0.00013306';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.description{1} = 'In-Track Axis Motor Current, Sample 1 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3519: TLM8_In-TrackServoErr(sample 3 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{3} = '3519';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{3} = 'TLM8_In-TrackServoErr(sample 3 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{3} = '3312';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{3} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{3} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{3} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{3} = 'In-Track Servo Error, Sample 3 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3521: TLM8_Cross-TrackServoErr(sample 4 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{4} = '3521';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{4} = 'TLM8_Cross-TrackServoErr(sample 4 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{4} = '3328';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{4} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{4} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{4} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{4} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{4} = 'X-Track Servo Error, Sample 4 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3523: TLM8_In-TrackServoErr(sample 4 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{4} = '3523';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{4} = 'TLM8_In-TrackServoErr(sample 4 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{4} = '3344';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{4} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{4} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{4} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{4} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{4} = 'In-Track Servo Error, Sample 4 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3525: TLM8_Cross-TrackServoErr(sample 5 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{5} = '3525';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{5} = 'TLM8_Cross-TrackServoErr(sample 5 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{5} = '3360';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{5} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{5} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{5} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{5} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{5} = 'X-Track Servo Error, Sample 5 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3527: TLM8_In-TrackServoErr(sample 5 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{5} = '3527';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{5} = 'TLM8_In-TrackServoErr(sample 5 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{5} = '3376';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{5} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{5} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{5} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{5} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{5} = 'In-Track Servo Error, Sample 5 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3529: TLM8_Cross-TrackServoErr(sample 6 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{6} = '3529';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{6} = 'TLM8_Cross-TrackServoErr(sample 6 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{6} = '3392';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{6} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{6} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{6} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{6} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{6} = 'X-Track Servo Error, Sample 6 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3531: TLM8_In-TrackServoErr(sample 6 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{6} = '3531';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{6} = 'TLM8_In-TrackServoErr(sample 6 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{6} = '3408';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{6} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{6} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{6} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{6} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{6} = 'In-Track Servo Error, Sample 6 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3533: TLM8_Cross-TrackServoErr(sample 7 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{7} = '3533';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{7} = 'TLM8_Cross-TrackServoErr(sample 7 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{7} = '3424';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{7} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{7} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{7} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{7} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{7} = 'X-Track Servo Error, Sample 7 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3535: TLM8_In-TrackServoErr(sample 7 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{7} = '3535';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{7} = 'TLM8_In-TrackServoErr(sample 7 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{7} = '3440';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{7} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{7} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{7} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{7} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{7} = 'In-Track Servo Error, Sample 7 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3537: TLM8_Cross-TrackServoErr(sample 8 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{8} = '3537';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{8} = 'TLM8_Cross-TrackServoErr(sample 8 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{8} = '3456';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{8} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{8} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{8} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{8} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{8} = 'X-Track Servo Error, Sample 8 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3539: TLM8_In-TrackServoErr(sample 8 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{8} = '3539';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{8} = 'TLM8_In-TrackServoErr(sample 8 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{8} = '3472';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{8} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{8} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{8} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{8} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{8} = 'In-Track Servo Error, Sample 8 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3541: TLM8_Cross-TrackServoErr(sample 9 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{9} = '3541';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{9} = 'TLM8_Cross-TrackServoErr(sample 9 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{9} = '3488';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{9} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{9} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{9} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{9} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{9} = 'X-Track Servo Error, Sample 9 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3543: TLM8_In-TrackServoErr(sample 9 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{9} = '3543';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{9} = 'TLM8_In-TrackServoErr(sample 9 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{9} = '3504';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{9} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{9} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{9} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{9} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{9} = 'In-Track Servo Error, Sample 9 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3545: TLM8_Cross-TrackServoErr(sample 10 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{10} = '3545';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{10} = 'TLM8_Cross-TrackServoErr(sample 10 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{10} = '3520';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{10} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{10} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{10} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{10} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{10} = 'X-Track Servo Error, Sample 10 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3547: TLM8_In-TrackServoErr(sample 10 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{10} = '3547';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{10} = 'TLM8_In-TrackServoErr(sample 10 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{10} = '3536';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{10} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{10} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{10} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{10} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{10} = 'In-Track Servo Error, Sample 10 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3549: TLM8_Cross-TrackServoErr(sample 11 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{11} = '3549';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{11} = 'TLM8_Cross-TrackServoErr(sample 11 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{11} = '3552';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{11} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{11} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{11} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{11} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{11} = 'X-Track Servo Error, Sample 11 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3551: TLM8_In-TrackServoErr(sample 11 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{11} = '3551';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{11} = 'TLM8_In-TrackServoErr(sample 11 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{11} = '3568';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{11} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{11} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{11} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{11} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{11} = 'In-Track Servo Error, Sample 11 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3553: TLM8_Cross-TrackServoErr(sample 12 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{12} = '3553';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{12} = 'TLM8_Cross-TrackServoErr(sample 12 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{12} = '3584';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{12} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{12} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{12} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{12} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{12} = 'X-Track Servo Error, Sample 12 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3555: TLM8_In-TrackServoErr(sample 12 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{12} = '3555';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{12} = 'TLM8_In-TrackServoErr(sample 12 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{12} = '3600';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{12} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{12} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{12} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{12} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{12} = 'In-Track Servo Error, Sample 12 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3556: TLM8_Commandedcross-Trackposition(Lower epoch x+1)
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1.att.telemetry_point_id = '3556';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1.att.mnemonic = 'TLM8_Commandedcross-Trackposition(Lower epoch x+1)';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1.att.start_bit = '3616';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1.att.coeffs = '0 2.996';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1.att.description = 'Cmded X-Track Servo Position, Lower Epoch x+1';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1.dim = {'hk8_packet'};

    % id 3557: TLM8_Commandedcross-Trackposition(Upper epoch x+1)
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1.att.telemetry_point_id = '3557';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1.att.mnemonic = 'TLM8_Commandedcross-Trackposition(Upper epoch x+1)';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1.att.start_bit = '3632';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1.att.coeffs = '0 2.996';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1.att.description = 'Cmded X-Track Axis Servo Position, Upper Epoch x+1';
    g_metadata.packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1.dim = {'hk8_packet'};

    % id 3559: TLM8_Cross-Trackposition(Lower epoch x+1)
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1.att.telemetry_point_id = '3559';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1.att.mnemonic = 'TLM8_Cross-Trackposition(Lower epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1.att.start_bit = '3648';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1.att.coeffs = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1.att.description = 'X-Track Servo Position, Lower Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1.dim = {'hk8_packet'};

    % id 3561: TLM8_Cross-Trackposition(Upper epoch x+1)
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1.att.telemetry_point_id = '3561';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1.att.mnemonic = 'TLM8_Cross-Trackposition(Upper epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1.att.start_bit = '3664';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1.att.coeffs = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1.att.description = 'X-Track Servo Position, Upper Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1.dim = {'hk8_packet'};

    % id 3563: TLM8_Cross-TrackServoErr(sample 13 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{13} = '3563';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{13} = 'TLM8_Cross-TrackServoErr(sample 13 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{13} = '3680';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{13} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{13} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{13} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{13} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{13} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{13} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{13} = 'X-Track Servo Error, Sample 13 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3564: TLM8_CrossTrackAxisMotorCurrent(sample 2 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.telemetry_point_id{2} = '3564';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.mnemonic{2} = 'TLM8_CrossTrackAxisMotorCurrent(sample 2 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.start_bit{2} = '3696';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.description{2} = 'X-Track Axis Motor Current, Sample 2 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3565: TLM8_CrossTrackAxisMotorCurrent(sample 2 epoch x+1)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.telemetry_point_id{2} = '3565';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.mnemonic{2} = 'TLM8_CrossTrackAxisMotorCurrent(sample 2 epoch x+1)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.start_bit{2} = '3698';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.coeffs{2} = '3.2213 -0.00043573';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.description{2} = 'X-Track Axis Motor Current, Sample 2 Epoch x+1';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3567: TLM8_In-TrackServoErr(sample 13 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{13} = '3567';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{13} = 'TLM8_In-TrackServoErr(sample 13 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{13} = '3712';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{13} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{13} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{13} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{13} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{13} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{13} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{13} = 'In-Track Servo Error, Sample 13 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3568: TLM8_In-TrackAxisMotorCurrent(sample 2 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.telemetry_point_id{2} = '3568';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.mnemonic{2} = 'TLM8_In-TrackAxisMotorCurrent(sample 2 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.start_bit{2} = '3728';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.description{2} = 'In-Track Axis Motor Current, Sample 2 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3569: TLM8_In-TrackAxisMotorCurrent(sample 2 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.telemetry_point_id{2} = '3569';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.mnemonic{2} = 'TLM8_In-TrackAxisMotorCurrent(sample 2 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.start_bit{2} = '3730';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.coeffs{2} = '0.9757 -0.00013306';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.description{2} = 'In-Track Axis Motor Current, Sample 2 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3571: TLM8_Cross-TrackServoErr(sample 14 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{14} = '3571';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{14} = 'TLM8_Cross-TrackServoErr(sample 14 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{14} = '3744';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{14} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{14} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{14} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{14} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{14} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{14} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{14} = 'X-Track Servo Error, Sample 14 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3573: TLM8_In-TrackServoErr(sample 14 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{14} = '3573';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{14} = 'TLM8_In-TrackServoErr(sample 14 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{14} = '3760';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{14} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{14} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{14} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{14} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{14} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{14} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{14} = 'In-Track Servo Error, Sample 14 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3575: TLM8_Cross-TrackServoErr(sample 15 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{15} = '3575';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{15} = 'TLM8_Cross-TrackServoErr(sample 15 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{15} = '3776';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{15} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{15} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{15} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{15} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{15} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{15} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{15} = 'X-Track Servo Error, Sample 15 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3577: TLM8_In-TrackServoErr(sample 15 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{15} = '3577';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{15} = 'TLM8_In-TrackServoErr(sample 15 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{15} = '3792';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{15} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{15} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{15} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{15} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{15} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{15} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{15} = 'In-Track Servo Error, Sample 15 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3579: TLM8_Cross-TrackServoErr(sample 16 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{16} = '3579';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{16} = 'TLM8_Cross-TrackServoErr(sample 16 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{16} = '3808';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{16} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{16} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{16} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{16} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{16} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{16} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{16} = 'X-Track Servo Error, Sample 16 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3581: TLM8_In-TrackServoErr(sample 16 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{16} = '3581';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{16} = 'TLM8_In-TrackServoErr(sample 16 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{16} = '3824';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{16} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{16} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{16} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{16} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{16} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{16} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{16} = 'In-Track Servo Error, Sample 16 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3583: TLM8_Cross-TrackServoErr(sample 17 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{17} = '3583';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{17} = 'TLM8_Cross-TrackServoErr(sample 17 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{17} = '3840';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{17} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{17} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{17} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{17} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{17} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{17} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{17} = 'X-Track Servo Error, Sample 17 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3585: TLM8_In-TrackServoErr(sample 17 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{17} = '3585';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{17} = 'TLM8_In-TrackServoErr(sample 17 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{17} = '3856';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{17} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{17} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{17} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{17} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{17} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{17} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{17} = 'In-Track Servo Error, Sample 17 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3587: TLM8_Cross-TrackServoErr(sample 18 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{18} = '3587';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{18} = 'TLM8_Cross-TrackServoErr(sample 18 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{18} = '3872';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{18} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{18} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{18} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{18} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{18} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{18} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{18} = 'X-Track Servo Error, Sample 18 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3589: TLM8_In-TrackServoErr(sample 18 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{18} = '3589';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{18} = 'TLM8_In-TrackServoErr(sample 18 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{18} = '3888';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{18} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{18} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{18} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{18} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{18} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{18} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{18} = 'In-Track Servo Error, Sample 18 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3591: TLM8_Cross-TrackServoErr(sample 19 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{19} = '3591';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{19} = 'TLM8_Cross-TrackServoErr(sample 19 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{19} = '3904';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{19} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{19} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{19} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{19} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{19} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{19} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{19} = 'X-Track Servo Error, Sample 19 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3593: TLM8_In-TrackServoErr(sample 19 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{19} = '3593';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{19} = 'TLM8_In-TrackServoErr(sample 19 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{19} = '3920';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{19} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{19} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{19} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{19} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{19} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{19} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{19} = 'In-Track Servo Error, Sample 19 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3594: TLM8_ScanIntrptlocation(epoch x+1) 
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x_1.att.telemetry_point_id = '3594';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x_1.att.mnemonic = 'TLM8_ScanIntrptlocation(epoch x+1) ';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x_1.att.start_bit = '3936';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x_1.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x_1.att.coeffs = '0 9.58700E+01';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x_1.att.num_bits = '16';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x_1.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x_1.att.description = 'Scan Interrupt Location, Epoch x+1 ';
    g_metadata.packets.instr_hk8.ScanIntrptlocation_epoch_x_1.dim = {'hk8_packet'};

    % id 3596: TLM8_Cross-TrackServoErr(sample 20 epoch x+1)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.telemetry_point_id{20} = '3596';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.mnemonic{20} = 'TLM8_Cross-TrackServoErr(sample 20 epoch x+1)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.start_bit{20} = '3952';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.data_type{20} = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.signbit_loc{20} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.coeffs{20} = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.num_bits{20} = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.units{20} = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.eu_type{20} = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.att.description{20} = 'X-Track Servo Error, Sample 20 Epoch x+1';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3598: TLM8_In-TrackServoErr(sample 20 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.telemetry_point_id{20} = '3598';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.mnemonic{20} = 'TLM8_In-TrackServoErr(sample 20 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.start_bit{20} = '3968';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.data_type{20} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.signbit_loc{20} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.coeffs{20} = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.num_bits{20} = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.units{20} = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.eu_type{20} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.att.description{20} = 'In-Track Servo Error, Sample 20 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackServoErr_epoch_x_1.dim = {'servo_err_sample', 'hk8_packet'};

    % id 3600: TLM8_Cross-TrackServoErr(sample 21 Only if x+1 = epoch 4 - 33 else Zero fill)
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.att.telemetry_point_id = '3600';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.att.mnemonic = 'TLM8_Cross-TrackServoErr(sample 21 Only if x+1 = epoch 4 - 33 else Zero fill)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.att.start_bit = '3984';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.att.signbit_loc = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.att.coeffs = '0 2.996';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.att.description = 'X-Track Servo Error, Sample 21(Only if x+1 = Epoch 4 - 33 else Zero fill)';
    g_metadata.packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_.dim = {'hk8_packet'};

    % id 3602: TLM8_In-TrackServoErr(sample 21 Only if x+1 = epoch 4 - 33 else Zero fill)
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.att.telemetry_point_id = '3602';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.att.mnemonic = 'TLM8_In-TrackServoErr(sample 21 Only if x+1 = epoch 4 - 33 else Zero fill)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.att.start_bit = '4000';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.att.signbit_loc = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.att.coeffs = '0 0.564';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.att.num_bits = '16';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.att.units = 'uRadians';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.att.description = 'In-Track Servo Error, Sample 21(Only if x+1 = Epoch 4 - 33 else Zero fill)';
    g_metadata.packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil.dim = {'hk8_packet'};

    % id 3603: TLM8_CommandedinTrackAxisposition(epoch x+1)
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x_1.att.telemetry_point_id = '3603';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x_1.att.mnemonic = 'TLM8_CommandedinTrackAxisposition(epoch x+1)';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x_1.att.start_bit = '4016';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x_1.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x_1.att.coeffs = '0 0.564';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x_1.att.num_bits = '16';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x_1.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x_1.att.description = 'Cmded In-Track Axis Position, Epoch x+1';
    g_metadata.packets.instr_hk8.CommandedinTrackAxisposition_epoch_x_1.dim = {'hk8_packet'};

    % id 3604: TLM8_In-Trackposition(epoch x+1)
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x_1.att.telemetry_point_id = '3604';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x_1.att.mnemonic = 'TLM8_In-Trackposition(epoch x+1)';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x_1.att.start_bit = '4032';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x_1.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x_1.att.coeffs = '0 0.564';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x_1.att.num_bits = '16';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x_1.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x_1.att.description = 'In-Track Position, Epoch x+1';
    g_metadata.packets.instr_hk8.In_Trackposition_epoch_x_1.dim = {'hk8_packet'};

    % id 3605: TLM8_CrossTrackAxisMotorCurrent(sample 3 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.telemetry_point_id{3} = '3605';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.mnemonic{3} = 'TLM8_CrossTrackAxisMotorCurrent(sample 3 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.start_bit{3} = '4048';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.att.description{3} = 'X-Track Axis Motor Current, Sample 3 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3606: TLM8_CrossTrackAxisMotorCurrent(sample 3 epoch x+1)
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.telemetry_point_id{3} = '3606';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.mnemonic{3} = 'TLM8_CrossTrackAxisMotorCurrent(sample 3 epoch x+1)';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.start_bit{3} = '4050';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.coeffs{3} = '3.2213 -0.00043573';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.att.description{3} = 'X-Track Axis Motor Current, Sample 3 Epoch x+1';
    g_metadata.packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3607: TLM8_In-TrackAxisMotorCurrent(sample 3 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.telemetry_point_id{3} = '3607';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.mnemonic{3} = 'TLM8_In-TrackAxisMotorCurrent(sample 3 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.start_bit{3} = '4064';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.att.description{3} = 'In-Track Axis Motor Current, Sample 3 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3608: TLM8_In-TrackAxisMotorCurrent(sample 3 epoch x+1)
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.telemetry_point_id{3} = '3608';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.mnemonic{3} = 'TLM8_In-TrackAxisMotorCurrent(sample 3 epoch x+1)';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.start_bit{3} = '4066';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.coeffs{3} = '0.9757 -0.00013306';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.att.description{3} = 'In-Track Axis Motor Current, Sample 3 Epoch x+1';
    g_metadata.packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1.dim = {'axis_motor_current_sample', 'hk8_packet'};

    % id 3609: TLM8_+28VSSMBusCurrent(sample 13 epoch x+1 - Spare)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.telemetry_point_id{13} = '3609';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.mnemonic{13} = 'TLM8_+28VSSMBusCurrent(sample 13 epoch x+1 - Spare)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.start_bit{13} = '4080';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.data_type{13} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.num_bits{13} = '2';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.att.description{13} = '+28V SSM Bus Current, Sample 13 Epoch x+1 - Spare';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3610: TLM8_+28VSSMBusCurrent(sample 13 epoch x+1)
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.telemetry_point_id{13} = '3610';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.mnemonic{13} = 'TLM8_+28VSSMBusCurrent(sample 13 epoch x+1)';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.start_bit{13} = '4082';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.data_type{13} = 'signed';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.coeffs{13} = '-3.0662 0.0007673';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.num_bits{13} = '14';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.units{13} = 'Amps';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.eu_type{13} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.att.description{13} = '+28V SSM Bus Current, Sample 13 Epoch x+1';
    g_metadata.packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1.dim = {'ssm_bus_current_sample', 'hk8_packet'};

    % id 3611: TLM8_Zerofill1
    g_metadata.packets.instr_hk8.Zerofill1.att.telemetry_point_id = '3611';
    g_metadata.packets.instr_hk8.Zerofill1.att.mnemonic = 'TLM8_Zerofill1';
    g_metadata.packets.instr_hk8.Zerofill1.att.start_bit = '4096';
    g_metadata.packets.instr_hk8.Zerofill1.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Zerofill1.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Zerofill1.att.description = 'Zerofill1';
    g_metadata.packets.instr_hk8.Zerofill1.dim = {'hk8_packet'};

    % id 3612: TLM8_HKIOReg0(Bi-Level Par Bit)
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Par_Bit.att.telemetry_point_id = '3612';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Par_Bit.att.mnemonic = 'TLM8_HKIOReg0(Bi-Level Par Bit)';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Par_Bit.att.start_bit = '4112';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Par_Bit.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Par_Bit.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Par_Bit.att.description = 'HK I/O Reg. 0(Bi-Level Parity Bit)';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Par_Bit.dim = {'hk8_packet'};

    % id 3613: TLM8_HKIOReg0(Bi-Level Tele Input Signal)
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal.att.telemetry_point_id = '3613';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal.att.mnemonic = 'TLM8_HKIOReg0(Bi-Level Tele Input Signal)';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal.att.start_bit = '4113';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal.att.num_bits = '14';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal.att.description = 'HK I/O Reg. 0(Bi-Level Tlm Input Signal)';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal.dim = {'hk8_packet'};

    % id 3614: TLM8_HKIOReg0(Bi-Level Tele Input Signal - Cooler Door Status)
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal_Cooler_Door_Status.att.telemetry_point_id = '3614';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal_Cooler_Door_Status.att.mnemonic = 'TLM8_HKIOReg0(Bi-Level Tele Input Signal - Cooler Door Status)';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal_Cooler_Door_Status.att.start_bit = '4127';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal_Cooler_Door_Status.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal_Cooler_Door_Status.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal_Cooler_Door_Status.att.description = 'HK I/O Reg. 0(Bi-Level Tlm Input Signal - Cooler Door Status)';
    g_metadata.packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal_Cooler_Door_Status.dim = {'hk8_packet'};

    % id 3615: TLM8_HKIOReg1(Spare)
    g_metadata.packets.instr_hk8.HKIOReg1_Spare.att.telemetry_point_id = '3615';
    g_metadata.packets.instr_hk8.HKIOReg1_Spare.att.mnemonic = 'TLM8_HKIOReg1(Spare)';
    g_metadata.packets.instr_hk8.HKIOReg1_Spare.att.start_bit = '4128';
    g_metadata.packets.instr_hk8.HKIOReg1_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg1_Spare.att.num_bits = '4';
    g_metadata.packets.instr_hk8.HKIOReg1_Spare.att.description = 'HK I/O Reg. 0(Bi-Level Tlm Input Signal - Cooler Door Status - Spare)';
    g_metadata.packets.instr_hk8.HKIOReg1_Spare.dim = {'hk8_packet'};

    % id 3616: TLM8_HKIOReg1(TLM Dat 1)
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_1.att.telemetry_point_id = '3616';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_1.att.mnemonic = 'TLM8_HKIOReg1(TLM Dat 1)';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_1.att.start_bit = '4132';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_1.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_1.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_1.att.description = 'HK I/O Reg. 1(Tlm Data 1)';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_1.dim = {'hk8_packet'};

    % id 3617: TLM8_HKIOReg1(TLM Dat 0)
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_0.att.telemetry_point_id = '3617';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_0.att.mnemonic = 'TLM8_HKIOReg1(TLM Dat 0)';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_0.att.start_bit = '4133';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_0.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_0.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_0.att.description = 'HK I/O Reg. 1(Tlm Data 0)';
    g_metadata.packets.instr_hk8.HKIOReg1_TLM_Dat_0.dim = {'hk8_packet'};

    % id 3618: TLM8_HKIOReg1(Loaded Tele Addr Par Err)
    g_metadata.packets.instr_hk8.HKIOReg1_Loaded_Tele_Addr_Par_Err.att.telemetry_point_id = '3618';
    g_metadata.packets.instr_hk8.HKIOReg1_Loaded_Tele_Addr_Par_Err.att.mnemonic = 'TLM8_HKIOReg1(Loaded Tele Addr Par Err)';
    g_metadata.packets.instr_hk8.HKIOReg1_Loaded_Tele_Addr_Par_Err.att.start_bit = '4134';
    g_metadata.packets.instr_hk8.HKIOReg1_Loaded_Tele_Addr_Par_Err.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg1_Loaded_Tele_Addr_Par_Err.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg1_Loaded_Tele_Addr_Par_Err.att.description = 'HK I/O Reg. 1(Loaded Tlm Address Parity Error)';
    g_metadata.packets.instr_hk8.HKIOReg1_Loaded_Tele_Addr_Par_Err.dim = {'hk8_packet'};

    % id 3619: TLM8_HKIOReg1(HK Sampling Mode)
    g_metadata.packets.instr_hk8.HKIOReg1_HK_Sampling_Mode.att.telemetry_point_id = '3619';
    g_metadata.packets.instr_hk8.HKIOReg1_HK_Sampling_Mode.att.mnemonic = 'TLM8_HKIOReg1(HK Sampling Mode)';
    g_metadata.packets.instr_hk8.HKIOReg1_HK_Sampling_Mode.att.start_bit = '4135';
    g_metadata.packets.instr_hk8.HKIOReg1_HK_Sampling_Mode.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg1_HK_Sampling_Mode.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg1_HK_Sampling_Mode.att.description = 'HK I/O Reg. 1(HK Sampling Mode)';
    g_metadata.packets.instr_hk8.HKIOReg1_HK_Sampling_Mode.dim = {'hk8_packet'};

    % id 3620: TLM8_HKIOReg1(DAC Update Rate - Sample_strt_cnt)
    g_metadata.packets.instr_hk8.HKIOReg1_DAC_Update_Rate_Sample_strt_cnt.att.telemetry_point_id = '3620';
    g_metadata.packets.instr_hk8.HKIOReg1_DAC_Update_Rate_Sample_strt_cnt.att.mnemonic = 'TLM8_HKIOReg1(DAC Update Rate - Sample_strt_cnt)';
    g_metadata.packets.instr_hk8.HKIOReg1_DAC_Update_Rate_Sample_strt_cnt.att.start_bit = '4136';
    g_metadata.packets.instr_hk8.HKIOReg1_DAC_Update_Rate_Sample_strt_cnt.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg1_DAC_Update_Rate_Sample_strt_cnt.att.num_bits = '7';
    g_metadata.packets.instr_hk8.HKIOReg1_DAC_Update_Rate_Sample_strt_cnt.att.description = 'HK I/O Reg. 1(DAC Update Rate - Sample Start Count)';
    g_metadata.packets.instr_hk8.HKIOReg1_DAC_Update_Rate_Sample_strt_cnt.dim = {'hk8_packet'};

    % id 3621: TLM8_HKIOReg1(Automatic DAC Update)
    g_metadata.packets.instr_hk8.HKIOReg1_Automatic_DAC_Update.att.telemetry_point_id = '3621';
    g_metadata.packets.instr_hk8.HKIOReg1_Automatic_DAC_Update.att.mnemonic = 'TLM8_HKIOReg1(Automatic DAC Update)';
    g_metadata.packets.instr_hk8.HKIOReg1_Automatic_DAC_Update.att.start_bit = '4143';
    g_metadata.packets.instr_hk8.HKIOReg1_Automatic_DAC_Update.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg1_Automatic_DAC_Update.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg1_Automatic_DAC_Update.att.description = 'HK I/O Reg. 1(Automatic DAC Update)';
    g_metadata.packets.instr_hk8.HKIOReg1_Automatic_DAC_Update.dim = {'hk8_packet'};

    % id 3622: TLM8_HKIOReg2(DAC Chan B - PCE Struct Heater Therm Ctrl)
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_B_PCE_Struct_Heater_Therm_Ctrl.att.telemetry_point_id = '3622';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_B_PCE_Struct_Heater_Therm_Ctrl.att.mnemonic = 'TLM8_HKIOReg2(DAC Chan B - PCE Struct Heater Therm Ctrl)';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_B_PCE_Struct_Heater_Therm_Ctrl.att.start_bit = '4144';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_B_PCE_Struct_Heater_Therm_Ctrl.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_B_PCE_Struct_Heater_Therm_Ctrl.att.num_bits = '8';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_B_PCE_Struct_Heater_Therm_Ctrl.att.description = 'HK I/O Reg. 2(DAC Chan. B - PCE Struct Heater Thermal Ctrl)';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_B_PCE_Struct_Heater_Therm_Ctrl.dim = {'hk8_packet'};

    % id 3623: TLM8_HKIOReg2(DAC Chan A - Cooler Stage 1 Therm Ctrl)
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_A_Cooler_Stage_1_Therm_Ctrl.att.telemetry_point_id = '3623';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_A_Cooler_Stage_1_Therm_Ctrl.att.mnemonic = 'TLM8_HKIOReg2(DAC Chan A - Cooler Stage 1 Therm Ctrl)';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_A_Cooler_Stage_1_Therm_Ctrl.att.start_bit = '4152';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_A_Cooler_Stage_1_Therm_Ctrl.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_A_Cooler_Stage_1_Therm_Ctrl.att.num_bits = '8';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_A_Cooler_Stage_1_Therm_Ctrl.att.description = 'HK I/O Reg. 2(DAC Chan. A - Cooler Stage 1 Thermal Ctrl)';
    g_metadata.packets.instr_hk8.HKIOReg2_DAC_Chan_A_Cooler_Stage_1_Therm_Ctrl.dim = {'hk8_packet'};

    % id 3624: TLM8_HKIOReg3(Dac Chan D - Cooler Stage 4 Therm Ctrl)
    g_metadata.packets.instr_hk8.HKIOReg3_Dac_Chan_D_Cooler_Stage_4_Therm_Ctrl.att.telemetry_point_id = '3624';
    g_metadata.packets.instr_hk8.HKIOReg3_Dac_Chan_D_Cooler_Stage_4_Therm_Ctrl.att.mnemonic = 'TLM8_HKIOReg3(Dac Chan D - Cooler Stage 4 Therm Ctrl)';
    g_metadata.packets.instr_hk8.HKIOReg3_Dac_Chan_D_Cooler_Stage_4_Therm_Ctrl.att.start_bit = '4160';
    g_metadata.packets.instr_hk8.HKIOReg3_Dac_Chan_D_Cooler_Stage_4_Therm_Ctrl.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg3_Dac_Chan_D_Cooler_Stage_4_Therm_Ctrl.att.num_bits = '8';
    g_metadata.packets.instr_hk8.HKIOReg3_Dac_Chan_D_Cooler_Stage_4_Therm_Ctrl.att.description = 'HK I/O Reg. 3(DAC Chan. D - Cooler Stage 4 Thermal Ctrl)';
    g_metadata.packets.instr_hk8.HKIOReg3_Dac_Chan_D_Cooler_Stage_4_Therm_Ctrl.dim = {'hk8_packet'};

    % id 3625: TLM8_HKIOReg3(DAC Chan C - Cooler Stage 3 Therm Ctrl)
    g_metadata.packets.instr_hk8.HKIOReg3_DAC_Chan_C_Cooler_Stage_3_Therm_Ctrl.att.telemetry_point_id = '3625';
    g_metadata.packets.instr_hk8.HKIOReg3_DAC_Chan_C_Cooler_Stage_3_Therm_Ctrl.att.mnemonic = 'TLM8_HKIOReg3(DAC Chan C - Cooler Stage 3 Therm Ctrl)';
    g_metadata.packets.instr_hk8.HKIOReg3_DAC_Chan_C_Cooler_Stage_3_Therm_Ctrl.att.start_bit = '4168';
    g_metadata.packets.instr_hk8.HKIOReg3_DAC_Chan_C_Cooler_Stage_3_Therm_Ctrl.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg3_DAC_Chan_C_Cooler_Stage_3_Therm_Ctrl.att.num_bits = '8';
    g_metadata.packets.instr_hk8.HKIOReg3_DAC_Chan_C_Cooler_Stage_3_Therm_Ctrl.att.description = 'HK I/O Reg. 3(DAC Chan. C - Cooler Stage 3 Thermal Ctrl)';
    g_metadata.packets.instr_hk8.HKIOReg3_DAC_Chan_C_Cooler_Stage_3_Therm_Ctrl.dim = {'hk8_packet'};

    % id 3626: TLM8_HKIOReg4(Spare)
    g_metadata.packets.instr_hk8.HKIOReg4_Spare.att.telemetry_point_id = '3626';
    g_metadata.packets.instr_hk8.HKIOReg4_Spare.att.mnemonic = 'TLM8_HKIOReg4(Spare)';
    g_metadata.packets.instr_hk8.HKIOReg4_Spare.att.start_bit = '4176';
    g_metadata.packets.instr_hk8.HKIOReg4_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg4_Spare.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg4_Spare.att.description = 'HK I/O Reg. 3(DAC Chan. C - Cooler Stage 3 Thermal Ctrl - Spare)';
    g_metadata.packets.instr_hk8.HKIOReg4_Spare.dim = {'hk8_packet'};

    % id 3627: TLM8_HKIOReg4(SRAM Tele Addr Cnt)
    g_metadata.packets.instr_hk8.HKIOReg4_SRAM_Tele_Addr_Cnt.att.telemetry_point_id = '3627';
    g_metadata.packets.instr_hk8.HKIOReg4_SRAM_Tele_Addr_Cnt.att.mnemonic = 'TLM8_HKIOReg4(SRAM Tele Addr Cnt)';
    g_metadata.packets.instr_hk8.HKIOReg4_SRAM_Tele_Addr_Cnt.att.start_bit = '4177';
    g_metadata.packets.instr_hk8.HKIOReg4_SRAM_Tele_Addr_Cnt.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg4_SRAM_Tele_Addr_Cnt.att.num_bits = '15';
    g_metadata.packets.instr_hk8.HKIOReg4_SRAM_Tele_Addr_Cnt.att.description = 'HK I/O Reg. 4(SRAM Tlm Address Count)';
    g_metadata.packets.instr_hk8.HKIOReg4_SRAM_Tele_Addr_Cnt.dim = {'hk8_packet'};

    % id 3628: TLM8_HKIOReg5(Spare)
    g_metadata.packets.instr_hk8.HKIOReg5_Spare.att.telemetry_point_id = '3628';
    g_metadata.packets.instr_hk8.HKIOReg5_Spare.att.mnemonic = 'TLM8_HKIOReg5(Spare)';
    g_metadata.packets.instr_hk8.HKIOReg5_Spare.att.start_bit = '4192';
    g_metadata.packets.instr_hk8.HKIOReg5_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg5_Spare.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg5_Spare.att.description = 'HK I/O Reg. 4(SRAM Tlm Address Count - Spare)';
    g_metadata.packets.instr_hk8.HKIOReg5_Spare.dim = {'hk8_packet'};

    % id 3629: TLM8_HKIOReg5(HK SRAM Tele Mux Setting Start Addr)
    g_metadata.packets.instr_hk8.HKIOReg5_HK_SRAM_Tele_Mux_Setting_Start_Addr.att.telemetry_point_id = '3629';
    g_metadata.packets.instr_hk8.HKIOReg5_HK_SRAM_Tele_Mux_Setting_Start_Addr.att.mnemonic = 'TLM8_HKIOReg5(HK SRAM Tele Mux Setting Start Addr)';
    g_metadata.packets.instr_hk8.HKIOReg5_HK_SRAM_Tele_Mux_Setting_Start_Addr.att.start_bit = '4193';
    g_metadata.packets.instr_hk8.HKIOReg5_HK_SRAM_Tele_Mux_Setting_Start_Addr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg5_HK_SRAM_Tele_Mux_Setting_Start_Addr.att.num_bits = '15';
    g_metadata.packets.instr_hk8.HKIOReg5_HK_SRAM_Tele_Mux_Setting_Start_Addr.att.description = 'HK I/O Reg. 5(HK SRAM Tlm Mux Setting Start Address)';
    g_metadata.packets.instr_hk8.HKIOReg5_HK_SRAM_Tele_Mux_Setting_Start_Addr.dim = {'hk8_packet'};

    % id 3630: TLM8_HKIOReg6(Spare)
    g_metadata.packets.instr_hk8.HKIOReg6_Spare.att.telemetry_point_id = '3630';
    g_metadata.packets.instr_hk8.HKIOReg6_Spare.att.mnemonic = 'TLM8_HKIOReg6(Spare)';
    g_metadata.packets.instr_hk8.HKIOReg6_Spare.att.start_bit = '4208';
    g_metadata.packets.instr_hk8.HKIOReg6_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg6_Spare.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg6_Spare.att.description = 'HK I/O Reg. 5(HK SRAM Tlm Mux Setting Start Address - Spare)';
    g_metadata.packets.instr_hk8.HKIOReg6_Spare.dim = {'hk8_packet'};

    % id 3631: TLM8_HKIOReg6(Tele Dat1 Start Addr)
    g_metadata.packets.instr_hk8.HKIOReg6_Tele_Dat1_Start_Addr.att.telemetry_point_id = '3631';
    g_metadata.packets.instr_hk8.HKIOReg6_Tele_Dat1_Start_Addr.att.mnemonic = 'TLM8_HKIOReg6(Tele Dat1 Start Addr)';
    g_metadata.packets.instr_hk8.HKIOReg6_Tele_Dat1_Start_Addr.att.start_bit = '4209';
    g_metadata.packets.instr_hk8.HKIOReg6_Tele_Dat1_Start_Addr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg6_Tele_Dat1_Start_Addr.att.num_bits = '15';
    g_metadata.packets.instr_hk8.HKIOReg6_Tele_Dat1_Start_Addr.att.description = 'HK I/O Reg. 6(Tlm Data 1 Start Address)';
    g_metadata.packets.instr_hk8.HKIOReg6_Tele_Dat1_Start_Addr.dim = {'hk8_packet'};

    % id 3632: TLM8_HKIOReg7(Spare)
    g_metadata.packets.instr_hk8.HKIOReg7_Spare.att.telemetry_point_id = '3632';
    g_metadata.packets.instr_hk8.HKIOReg7_Spare.att.mnemonic = 'TLM8_HKIOReg7(Spare)';
    g_metadata.packets.instr_hk8.HKIOReg7_Spare.att.start_bit = '4224';
    g_metadata.packets.instr_hk8.HKIOReg7_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg7_Spare.att.num_bits = '1';
    g_metadata.packets.instr_hk8.HKIOReg7_Spare.att.description = 'HK I/O Reg. 6(Tlm Data 1 Start Address - Spare)';
    g_metadata.packets.instr_hk8.HKIOReg7_Spare.dim = {'hk8_packet'};

    % id 3633: TLM8_HKIOReg7(Tele Dat0 Start Addr)
    g_metadata.packets.instr_hk8.HKIOReg7_Tele_Dat0_Start_Addr.att.telemetry_point_id = '3633';
    g_metadata.packets.instr_hk8.HKIOReg7_Tele_Dat0_Start_Addr.att.mnemonic = 'TLM8_HKIOReg7(Tele Dat0 Start Addr)';
    g_metadata.packets.instr_hk8.HKIOReg7_Tele_Dat0_Start_Addr.att.start_bit = '4225';
    g_metadata.packets.instr_hk8.HKIOReg7_Tele_Dat0_Start_Addr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg7_Tele_Dat0_Start_Addr.att.num_bits = '15';
    g_metadata.packets.instr_hk8.HKIOReg7_Tele_Dat0_Start_Addr.att.description = 'HK I/O Reg. 7(Tlm Data 0 Start Address)';
    g_metadata.packets.instr_hk8.HKIOReg7_Tele_Dat0_Start_Addr.dim = {'hk8_packet'};

    % id 3634: TLM8_HKIOReg8(Spare)
    g_metadata.packets.instr_hk8.HKIOReg8_Spare.att.telemetry_point_id = '3634';
    g_metadata.packets.instr_hk8.HKIOReg8_Spare.att.mnemonic = 'TLM8_HKIOReg8(Spare)';
    g_metadata.packets.instr_hk8.HKIOReg8_Spare.att.start_bit = '4240';
    g_metadata.packets.instr_hk8.HKIOReg8_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg8_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.HKIOReg8_Spare.att.description = 'HK I/O Reg. 7(Tlm Data 0 Start Address - Spare)';
    g_metadata.packets.instr_hk8.HKIOReg8_Spare.dim = {'hk8_packet'};

    % id 3635: TLM8_HKIOReg8(Number Tele Values Collected)
    g_metadata.packets.instr_hk8.HKIOReg8_Number_Tele_Values_Collected.att.telemetry_point_id = '3635';
    g_metadata.packets.instr_hk8.HKIOReg8_Number_Tele_Values_Collected.att.mnemonic = 'TLM8_HKIOReg8(Number Tele Values Collected)';
    g_metadata.packets.instr_hk8.HKIOReg8_Number_Tele_Values_Collected.att.start_bit = '4242';
    g_metadata.packets.instr_hk8.HKIOReg8_Number_Tele_Values_Collected.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg8_Number_Tele_Values_Collected.att.num_bits = '14';
    g_metadata.packets.instr_hk8.HKIOReg8_Number_Tele_Values_Collected.att.description = 'HK I/O Reg. 8(Number Tlm Values Collected)';
    g_metadata.packets.instr_hk8.HKIOReg8_Number_Tele_Values_Collected.dim = {'hk8_packet'};

    % id 3636: TLM8_HKIOReg9(Spare)
    g_metadata.packets.instr_hk8.HKIOReg9_Spare.att.telemetry_point_id = '3636';
    g_metadata.packets.instr_hk8.HKIOReg9_Spare.att.mnemonic = 'TLM8_HKIOReg9(Spare)';
    g_metadata.packets.instr_hk8.HKIOReg9_Spare.att.start_bit = '4256';
    g_metadata.packets.instr_hk8.HKIOReg9_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg9_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.HKIOReg9_Spare.att.description = 'HK I/O Reg. 8(Number Tlm Values Collected - Spare)';
    g_metadata.packets.instr_hk8.HKIOReg9_Spare.dim = {'hk8_packet'};

    % id 3637: TLM8_HKIOReg9(Number Tele Addr Processed)
    g_metadata.packets.instr_hk8.HKIOReg9_Number_Tele_Addr_Processed.att.telemetry_point_id = '3637';
    g_metadata.packets.instr_hk8.HKIOReg9_Number_Tele_Addr_Processed.att.mnemonic = 'TLM8_HKIOReg9(Number Tele Addr Processed)';
    g_metadata.packets.instr_hk8.HKIOReg9_Number_Tele_Addr_Processed.att.start_bit = '4258';
    g_metadata.packets.instr_hk8.HKIOReg9_Number_Tele_Addr_Processed.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HKIOReg9_Number_Tele_Addr_Processed.att.num_bits = '14';
    g_metadata.packets.instr_hk8.HKIOReg9_Number_Tele_Addr_Processed.att.description = 'HK I/O Reg. 9(Number Tlm Address Processed)';
    g_metadata.packets.instr_hk8.HKIOReg9_Number_Tele_Addr_Processed.dim = {'hk8_packet'};

    % id 3638: TLM8_PorchswingMotorTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39_Spare.att.telemetry_point_id = '3638';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39_Spare.att.mnemonic = 'TLM8_PorchswingMotorTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39_Spare.att.start_bit = '4272';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39_Spare.att.description = 'Porchswing Motor Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3639: TLM8_PorchswingMotorTemp(epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39.att.telemetry_point_id = '3639';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39.att.mnemonic = 'TLM8_PorchswingMotorTemp(epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39.att.start_bit = '4274';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39.att.coeffs = '20.009 0.006297897';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39.att.description = 'Porchswing Motor Temp, Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorTemp_epoch_39.dim = {'hk8_packet'};

    % id 3640: TLM8_DAMotorTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39_Spare.att.telemetry_point_id = '3640';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39_Spare.att.mnemonic = 'TLM8_DAMotorTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39_Spare.att.start_bit = '4288';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39_Spare.att.description = 'DA Motor Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3641: TLM8_DAMotorTemp(epoch 39)
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39.att.telemetry_point_id = '3641';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39.att.mnemonic = 'TLM8_DAMotorTemp(epoch 39)';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39.att.start_bit = '4290';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39.att.coeffs = '19.279 0.006282453';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39.att.description = 'DA Motor Temp, Epoch 39';
    g_metadata.packets.instr_hk8.DAMotorTemp_epoch_39.dim = {'hk8_packet'};

    % id 3642: TLM8_PorchswingMotorCurrent(sample 1 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id{1} = '3642';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic{1} = 'TLM8_PorchswingMotorCurrent(sample 1 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit{1} = '4304';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description{1} = 'Porchswing Motor Current, Sample 1 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3643: TLM8_PorchswingMotorCurrent(sample 1 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id{1} = '3643';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic{1} = 'TLM8_PorchswingMotorCurrent(sample 1 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit{1} = '4306';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs{1} = '0 0.000152587890625';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description{1} = 'Porchswing Motor Current, Sample 1 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3644: TLM8_PorchswingMotorCurrent(sample 2 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id{2} = '3644';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic{2} = 'TLM8_PorchswingMotorCurrent(sample 2 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit{2} = '4320';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description{2} = 'Porchswing Motor Current, Sample 2 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3645: TLM8_PorchswingMotorCurrent(sample 2 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id{2} = '3645';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic{2} = 'TLM8_PorchswingMotorCurrent(sample 2 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit{2} = '4322';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs{2} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description{2} = 'Porchswing Motor Current, Sample 2 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3646: TLM8_PorchswingMotorCurrent(sample 3 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id{3} = '3646';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic{3} = 'TLM8_PorchswingMotorCurrent(sample 3 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit{3} = '4336';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description{3} = 'Porchswing Motor Current, Sample 3 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3647: TLM8_PorchswingMotorCurrent(sample 3 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id{3} = '3647';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic{3} = 'TLM8_PorchswingMotorCurrent(sample 3 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit{3} = '4338';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs{3} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description{3} = 'Porchswing Motor Current, Sample 3 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3648: TLM8_PorchswingMotorCurrent(sample 4 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id{4} = '3648';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic{4} = 'TLM8_PorchswingMotorCurrent(sample 4 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit{4} = '4352';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description{4} = 'Porchswing Motor Current, Sample 4 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3649: TLM8_PorchswingMotorCurrent(sample 4 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id{4} = '3649';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic{4} = 'TLM8_PorchswingMotorCurrent(sample 4 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit{4} = '4354';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs{4} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description{4} = 'Porchswing Motor Current, Sample 4 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3650: TLM8_PorchswingMotorCurrent(sample 5 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id{5} = '3650';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic{5} = 'TLM8_PorchswingMotorCurrent(sample 5 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit{5} = '4368';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type{5} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits{5} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description{5} = 'Porchswing Motor Current, Sample 5 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3651: TLM8_PorchswingMotorCurrent(sample 5 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id{5} = '3651';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic{5} = 'TLM8_PorchswingMotorCurrent(sample 5 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit{5} = '4370';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs{5} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits{5} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units{5} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description{5} = 'Porchswing Motor Current, Sample 5 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3652: TLM8_PorchswingMotorCurrent(sample 6 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id{6} = '3652';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic{6} = 'TLM8_PorchswingMotorCurrent(sample 6 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit{6} = '4384';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type{6} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits{6} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description{6} = 'Porchswing Motor Current, Sample 6 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3653: TLM8_PorchswingMotorCurrent(sample 6 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id{6} = '3653';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic{6} = 'TLM8_PorchswingMotorCurrent(sample 6 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit{6} = '4386';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs{6} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits{6} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units{6} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description{6} = 'Porchswing Motor Current, Sample 6 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3654: TLM8_PorchswingMotorCurrent(sample 7 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id{7} = '3654';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic{7} = 'TLM8_PorchswingMotorCurrent(sample 7 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit{7} = '4400';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type{7} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits{7} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description{7} = 'Porchswing Motor Current, Sample 7 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3655: TLM8_PorchswingMotorCurrent(sample 7 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id{7} = '3655';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic{7} = 'TLM8_PorchswingMotorCurrent(sample 7 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit{7} = '4402';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs{7} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits{7} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units{7} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description{7} = 'Porchswing Motor Current, Sample 7 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3656: TLM8_PorchswingMotorCurrent(sample 8 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id{8} = '3656';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic{8} = 'TLM8_PorchswingMotorCurrent(sample 8 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit{8} = '4416';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type{8} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits{8} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description{8} = 'Porchswing Motor Current, Sample 8 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3657: TLM8_PorchswingMotorCurrent(sample 8 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id{8} = '3657';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic{8} = 'TLM8_PorchswingMotorCurrent(sample 8 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit{8} = '4418';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs{8} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits{8} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units{8} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description{8} = 'Porchswing Motor Current, Sample 8 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3658: TLM8_DA-XMotorCurrent(sample 1 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.telemetry_point_id = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.telemetry_point_id{1} = '3658';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.mnemonic = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.mnemonic{1} = 'TLM8_DA-XMotorCurrent(sample 1 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.start_bit = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.start_bit{1} = '4432';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.data_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.num_bits = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.description = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.description{1} = 'DA-X Motor Current, Sample 1 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3659: TLM8_DA-XMotorCurrent(sample 1 epoch 39)
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.telemetry_point_id = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.telemetry_point_id{1} = '3659';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.mnemonic = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.mnemonic{1} = 'TLM8_DA-XMotorCurrent(sample 1 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.start_bit = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.start_bit{1} = '4434';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.data_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.coeffs = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.coeffs{1} = '0 0.0000152587890625';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.num_bits = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.units = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.eu_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.description = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.description{1} = 'DA-X Motor Current, Sample 1 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3660: TLM8_DA-YMotorCurrent(sample 1 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.telemetry_point_id = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.telemetry_point_id{1} = '3660';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.mnemonic = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.mnemonic{1} = 'TLM8_DA-YMotorCurrent(sample 1 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.start_bit = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.start_bit{1} = '4448';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.data_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.num_bits = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.description = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.description{1} = 'DA-Y Motor Current, Sample 1 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3661: TLM8_DA-YMotorCurrent(sample 1 epoch 39)
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.telemetry_point_id = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.telemetry_point_id{1} = '3661';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.mnemonic = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.mnemonic{1} = 'TLM8_DA-YMotorCurrent(sample 1 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.start_bit = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.start_bit{1} = '4450';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.data_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.coeffs = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.coeffs{1} = '0 0.0000152587890625';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.num_bits = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.units = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.eu_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.description = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.description{1} = 'DA-Y Motor Current, Sample 1 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3663: TLM8_PorchswingVelocity(sample 1 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{1} = '3663';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{1} = 'TLM8_PorchswingVelocity(sample 1 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{1} = '4464';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{1} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{1} = '0 0.0000489074084942387';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{1} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{1} = 'Porchswing Velocity, Sample 1 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3665: TLM8_DA-XTiltErr(sample 1 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{1} = '3665';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{1} = 'TLM8_DA-XTiltErr(sample 1 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{1} = '4480';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{1} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{1} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{1} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{1} = 'DA-X Tilt Error, Sample 1 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3667: TLM8_DA-YTiltErr(sample 1 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{1} = '3667';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{1} = 'TLM8_DA-YTiltErr(sample 1 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{1} = '4496';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{1} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{1} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{1} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{1} = 'DA-Y Tilt Error, Sample 1 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3668: TLM8_PorchswingMotorCurrent(sample 9 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id{9} = '3668';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic{9} = 'TLM8_PorchswingMotorCurrent(sample 9 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit{9} = '4512';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type{9} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits{9} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description{9} = 'Porchswing Motor Current, Sample 9 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3669: TLM8_PorchswingMotorCurrent(sample 9 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id{9} = '3669';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic{9} = 'TLM8_PorchswingMotorCurrent(sample 9 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit{9} = '4514';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs{9} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits{9} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units{9} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description{9} = 'Porchswing Motor Current, Sample 9 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3671: TLM8_PorchswingVelocity(sample 2 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{2} = '3671';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{2} = 'TLM8_PorchswingVelocity(sample 2 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{2} = '4528';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{2} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{2} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{2} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{2} = 'Porchswing Velocity, Sample 2 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3673: TLM8_DA-XTiltErr(sample 2 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{2} = '3673';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{2} = 'TLM8_DA-XTiltErr(sample 2 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{2} = '4544';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{2} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{2} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{2} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{2} = 'DA-X Tilt Error, Sample 2 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3675: TLM8_DA-YTiltErr(sample 2 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{2} = '3675';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{2} = 'TLM8_DA-YTiltErr(sample 2 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{2} = '4560';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{2} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{2} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{2} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{2} = 'DA-Y Tilt Error, Sample 2 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3677: TLM8_PorchswingVelocity(sample 3 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{3} = '3677';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{3} = 'TLM8_PorchswingVelocity(sample 3 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{3} = '4576';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{3} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{3} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{3} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{3} = 'Porchswing Velocity, Sample 3 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3679: TLM8_DA-XTiltErr(sample 3 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{3} = '3679';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{3} = 'TLM8_DA-XTiltErr(sample 3 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{3} = '4592';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{3} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{3} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{3} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{3} = 'DA-X Tilt Error, Sample 3 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3681: TLM8_DA-YTiltErr(sample 3 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{3} = '3681';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{3} = 'TLM8_DA-YTiltErr(sample 3 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{3} = '4608';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{3} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{3} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{3} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{3} = 'DA-Y Tilt Error, Sample 3 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3683: TLM8_PorchswingVelocity(sample 4 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{4} = '3683';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{4} = 'TLM8_PorchswingVelocity(sample 4 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{4} = '4624';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{4} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{4} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{4} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{4} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{4} = 'Porchswing Velocity, Sample 4 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3685: TLM8_DA-XTiltErr(sample 4 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{4} = '3685';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{4} = 'TLM8_DA-XTiltErr(sample 4 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{4} = '4640';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{4} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{4} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{4} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{4} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{4} = 'DA-X Tilt Error, Sample 4 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3687: TLM8_DA-YTiltErr(sample 4 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{4} = '3687';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{4} = 'TLM8_DA-YTiltErr(sample 4 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{4} = '4656';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{4} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{4} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{4} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{4} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{4} = 'DA-Y Tilt Error, Sample 4 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3689: TLM8_PorchswingVelocity(sample 5 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{5} = '3689';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{5} = 'TLM8_PorchswingVelocity(sample 5 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{5} = '4672';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{5} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{5} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{5} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{5} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{5} = 'Porchswing Velocity, Sample 5 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3691: TLM8_DA-XTiltErr(sample 5 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{5} = '3691';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{5} = 'TLM8_DA-XTiltErr(sample 5 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{5} = '4688';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{5} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{5} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{5} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{5} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{5} = 'DA-X Tilt Error, Sample 5 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3693: TLM8_DA-YTiltErr(sample 5 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{5} = '3693';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{5} = 'TLM8_DA-YTiltErr(sample 5 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{5} = '4704';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{5} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{5} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{5} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{5} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{5} = 'DA-Y Tilt Error, Sample 5 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3695: TLM8_PorchswingVelocity(sample 6 epoch 39) 
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{6} = '3695';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{6} = 'TLM8_PorchswingVelocity(sample 6 epoch 39) ';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{6} = '4720';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{6} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{6} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{6} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{6} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{6} = 'Porchswing Velocity, Sample 6 Epoch 39 ';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3697: TLM8_DA-XTiltErr(sample 6 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{6} = '3697';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{6} = 'TLM8_DA-XTiltErr(sample 6 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{6} = '4736';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{6} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{6} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{6} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{6} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{6} = 'DA-X Tilt Error, Sample 6 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3699: TLM8_DA-YTiltErr(sample 6 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{6} = '3699';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{6} = 'TLM8_DA-YTiltErr(sample 6 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{6} = '4752';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{6} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{6} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{6} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{6} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{6} = 'DA-Y Tilt Error, Sample 6 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3701: TLM8_PorchswingVelocity(sample 7 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{7} = '3701';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{7} = 'TLM8_PorchswingVelocity(sample 7 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{7} = '4768';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{7} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{7} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{7} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{7} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{7} = 'Porchswing Velocity, Sample 7 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3703: TLM8_DA-XTiltErr(sample 7 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{7} = '3703';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{7} = 'TLM8_DA-XTiltErr(sample 7 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{7} = '4784';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{7} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{7} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{7} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{7} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{7} = 'DA-X Tilt Error, Sample 7 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3705: TLM8_DA-YTiltErr(sample 7 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{7} = '3705';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{7} = 'TLM8_DA-YTiltErr(sample 7 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{7} = '4800';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{7} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{7} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{7} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{7} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{7} = 'DA-Y Tilt Error, Sample 7 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3707: TLM8_PorchswingVelocity(sample 8 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{8} = '3707';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{8} = 'TLM8_PorchswingVelocity(sample 8 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{8} = '4816';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{8} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{8} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{8} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{8} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{8} = 'Porchswing Velocity, Sample 8 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3709: TLM8_DA-XTiltErr(sample 8 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{8} = '3709';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{8} = 'TLM8_DA-XTiltErr(sample 8 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{8} = '4832';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{8} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{8} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{8} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{8} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{8} = 'DA-X Tilt Error, Sample 8 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3711: TLM8_DA-YTiltErr(sample 8 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{8} = '3711';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{8} = 'TLM8_DA-YTiltErr(sample 8 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{8} = '4848';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{8} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{8} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{8} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{8} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{8} = 'DA-Y Tilt Error, Sample 8 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3712: TLM8_LaserdetectionpeakTychannel(epoch 39)
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39.att.telemetry_point_id = '3712';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39.att.mnemonic = 'TLM8_LaserdetectionpeakTychannel(epoch 39)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39.att.start_bit = '4864';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39.att.coeffs = '0 6.072707E-04';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39.att.description = 'Laser Detection Peak Ty Chan., Epoch 39';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39.dim = {'hk8_packet'};

    % id 3713: TLM8_LaserdetectionpeakTxchannel(epoch 39)
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39.att.telemetry_point_id = '3713';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39.att.mnemonic = 'TLM8_LaserdetectionpeakTxchannel(epoch 39)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39.att.start_bit = '4880';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39.att.coeffs = '0 6.074279E-04';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39.att.description = 'Laser Detection Peak Tx Chan., Epoch 39';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39.dim = {'hk8_packet'};

    % id 3715: TLM8_PorchswingVelocity(sample 9 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{9} = '3715';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{9} = 'TLM8_PorchswingVelocity(sample 9 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{9} = '4896';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{9} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{9} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{9} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{9} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{9} = 'Porchswing Velocity, Sample 9 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3717: TLM8_DA-XTiltErr(sample 9 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{9} = '3717';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{9} = 'TLM8_DA-XTiltErr(sample 9 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{9} = '4912';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{9} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{9} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{9} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{9} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{9} = 'DA-X Tilt Error, Sample 9 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3719: TLM8_DA-YTiltErr(sample 9 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{9} = '3719';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{9} = 'TLM8_DA-YTiltErr(sample 9 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{9} = '4928';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{9} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{9} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{9} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{9} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{9} = 'DA-Y Tilt Error, Sample 9 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3720: TLM8_LaserDiodeCurrent(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39_Spare.att.telemetry_point_id = '3720';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39_Spare.att.mnemonic = 'TLM8_LaserDiodeCurrent(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39_Spare.att.start_bit = '4944';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39_Spare.att.description = 'Laser Diode Current, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3721: TLM8_LaserDiodeCurrent(epoch 39)
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39.att.telemetry_point_id = '3721';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39.att.mnemonic = 'TLM8_LaserDiodeCurrent(epoch 39)';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39.att.start_bit = '4946';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39.att.coeffs = '0.035 0.0000030517578125';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39.att.units = 'Amps';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39.att.description = 'Laser Diode Current, Epoch 39';
    g_metadata.packets.instr_hk8.LaserDiodeCurrent_epoch_39.dim = {'hk8_packet'};

    % id 3722: TLM8_ThermoelectriccoolerCurrent(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39_Spare.att.telemetry_point_id = '3722';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39_Spare.att.mnemonic = 'TLM8_ThermoelectriccoolerCurrent(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39_Spare.att.start_bit = '4960';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39_Spare.att.description = 'Thermoelectric Cooler Current, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3723: TLM8_ThermoelectriccoolerCurrent(epoch 39)
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39.att.telemetry_point_id = '3723';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39.att.mnemonic = 'TLM8_ThermoelectriccoolerCurrent(epoch 39)';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39.att.start_bit = '4962';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39.att.coeffs = '1.558271740E-02 3.124595960E-04 5.176685570E-09';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39.att.units = 'Amps';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39.att.description = 'Thermoelectric Cooler Current, Epoch 39';
    g_metadata.packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39.dim = {'hk8_packet'};

    % id 3725: TLM8_Porchswingposition(epoch 39)
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_39.att.telemetry_point_id = '3725';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_39.att.mnemonic = 'TLM8_Porchswingposition(epoch 39)';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_39.att.start_bit = '4976';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_39.att.signbit_loc = '0';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_39.att.coeffs = '-1.26894080E-02 3.87250E-07';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_39.att.description = 'Porchswing Position, Epoch 39 ';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_39.dim = {'hk8_packet'};

    % id 3727: TLM8_PorchswingpositionErr(epoch 39)
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_39.att.telemetry_point_id = '3727';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_39.att.mnemonic = 'TLM8_PorchswingpositionErr(epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_39.att.start_bit = '4992';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_39.att.signbit_loc = '16';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_39.att.coeffs = '0 0.00000038725';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_39.att.description = 'Porchswing Position Error, Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_39.dim = {'hk8_packet'};

    % id 3729: TLM8_OpticalZPDoffset(epoch 39)
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.att.telemetry_point_id = '3729';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.att.mnemonic = 'TLM8_OpticalZPDoffset(epoch 39)';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.att.start_bit = '5008';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.att.signbit_loc = '16';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.att.coeffs = '0 0.00000038725';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.att.units = 'Meters';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.att.description = 'Optical Zero Path Differential Offset, Epoch 39';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_39.dim = {'hk8_packet'};

    % id 3731: TLM8_PorchswingVelocity(sample 10 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{10} = '3731';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{10} = 'TLM8_PorchswingVelocity(sample 10 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{10} = '5024';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{10} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{10} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{10} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{10} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{10} = 'Porchswing Velocity, Sample 10 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3733: TLM8_DA-XTiltErr(sample 10 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{10} = '3733';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{10} = 'TLM8_DA-XTiltErr(sample 10 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{10} = '5040';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{10} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{10} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{10} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{10} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{10} = 'DA-X Tilt Error, Sample 10 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3735: TLM8_DA-YTiltErr(sample 10 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{10} = '3735';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{10} = 'TLM8_DA-YTiltErr(sample 10 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{10} = '5056';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{10} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{10} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{10} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{10} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{10} = 'DA-Y Tilt Error, Sample 10 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3736: TLM8_IECCAcalibrationresistorTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39_Spare.att.telemetry_point_id = '3736';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39_Spare.att.mnemonic = 'TLM8_IECCAcalibrationresistorTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39_Spare.att.start_bit = '5072';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39_Spare.att.description = 'IE CCA Cal. Resistor Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3737: TLM8_IECCAcalibrationresistorTemp(epoch 39)
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39.att.telemetry_point_id = '3737';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39.att.mnemonic = 'TLM8_IECCAcalibrationresistorTemp(epoch 39)';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39.att.start_bit = '5074';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39.att.coeffs = '19.453 0.006341245';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39.att.description = 'IE CCA Cal. Resistor Temp, Epoch 39';
    g_metadata.packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39.dim = {'hk8_packet'};

    % id 3738: TLM8_EquivalentTemperaturelowrangecalibrationresistor(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39_Spare.att.telemetry_point_id = '3738';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39_Spare.att.mnemonic = 'TLM8_EquivalentTemperaturelowrangecalibrationresistor(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39_Spare.att.start_bit = '5088';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39_Spare.att.description = 'Equiv. Temp. Low Range Cal. Resistor, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3739: TLM8_EquivalentTemperaturelowrangecalibrationresistor(epoch 39)
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39.att.telemetry_point_id = '3739';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39.att.mnemonic = 'TLM8_EquivalentTemperaturelowrangecalibrationresistor(epoch 39)';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39.att.start_bit = '5090';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39.att.coeffs = '19.778 0.006296006';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39.att.description = 'Equiv. Temp. Low Range Cal. Resistor, Epoch 39';
    g_metadata.packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39.dim = {'hk8_packet'};

    % id 3740: TLM8_EquivalentTemperaturehighrangecalibrationresistor(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39_Spare.att.telemetry_point_id = '3740';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39_Spare.att.mnemonic = 'TLM8_EquivalentTemperaturehighrangecalibrationresistor(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39_Spare.att.start_bit = '5104';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39_Spare.att.description = 'Equiv. Temp. High Range Cal. Resistor, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3741: TLM8_EquivalentTemperaturehighrangecalibrationresistor(epoch 39)
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39.att.telemetry_point_id = '3741';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39.att.mnemonic = 'TLM8_EquivalentTemperaturehighrangecalibrationresistor(epoch 39)';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39.att.start_bit = '5106';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39.att.coeffs = '19.778 0.006296006';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39.att.description = 'Equiv. Temp. High Range Cal. Resistor, Epoch 39';
    g_metadata.packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39.dim = {'hk8_packet'};

    % id 3742: TLM8_ApproximateICTTemp#1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39_Spare.att.telemetry_point_id = '3742';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39_Spare.att.mnemonic = 'TLM8_ApproximateICTTemp#1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39_Spare.att.start_bit = '5120';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39_Spare.att.description = 'Approx. Internal Cal. Target Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3743: TLM8_ApproximateICTTemp#1(epoch 39)
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39.att.telemetry_point_id = '3743';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39.att.mnemonic = 'TLM8_ApproximateICTTemp#1(epoch 39)';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39.att.start_bit = '5122';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39.att.coeffs = '21.047 0.006318255';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39.att.description = 'Approx. Internal Cal. Target Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_1_epoch_39.dim = {'hk8_packet'};

    % id 3744: TLM8_ApproximateICTTemp#2(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39_Spare.att.telemetry_point_id = '3744';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39_Spare.att.mnemonic = 'TLM8_ApproximateICTTemp#2(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39_Spare.att.start_bit = '5136';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39_Spare.att.description = 'Approx. Internal Cal. Target Temp 2, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3745: TLM8_ApproximateICTTemp#2(epoch 39)
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39.att.telemetry_point_id = '3745';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39.att.mnemonic = 'TLM8_ApproximateICTTemp#2(epoch 39)';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39.att.start_bit = '5138';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39.att.coeffs = '20.4908 0.00630489';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39.att.description = 'Approx. Internal Cal. Target Temp 2, Epoch 39';
    g_metadata.packets.instr_hk8.ApproximateICTTemp_2_epoch_39.dim = {'hk8_packet'};

    % id 3747: TLM8_PorchswingVelocity(sample 11 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{11} = '3747';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{11} = 'TLM8_PorchswingVelocity(sample 11 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{11} = '5152';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{11} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{11} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{11} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{11} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{11} = 'Porchswing Velocity, Sample 11 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3749: TLM8_DA-XTiltErr(sample 11 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{11} = '3749';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{11} = 'TLM8_DA-XTiltErr(sample 11 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{11} = '5168';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{11} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{11} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{11} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{11} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{11} = 'DA-X Tilt Error, Sample 11 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3751: TLM8_DA-YTiltErr(sample 11 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{11} = '3751';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{11} = 'TLM8_DA-YTiltErr(sample 11 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{11} = '5184';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{11} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{11} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{11} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{11} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{11} = 'DA-Y Tilt Error, Sample 11 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3752: TLM8_LaserDiodeTempAve(Spare)
    g_metadata.packets.instr_hk8.LaserDiodeTempAve_Spare.att.telemetry_point_id = '3752';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve_Spare.att.mnemonic = 'TLM8_LaserDiodeTempAve(Spare)';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve_Spare.att.start_bit = '5200';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve_Spare.att.description = 'Laser Diode Temp (average), Spare';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve_Spare.dim = {'hk8_packet'};

    % id 3753: TLM8_LaserDiodeTempAve
    g_metadata.packets.instr_hk8.LaserDiodeTempAve.att.telemetry_point_id = '3753';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve.att.mnemonic = 'TLM8_LaserDiodeTempAve';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve.att.start_bit = '5202';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve.att.coeffs = '19.630 0.006293041';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve.att.num_bits = '14';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve.att.units = '°C';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve.att.description = 'Laser Diode Temp (average)';
    g_metadata.packets.instr_hk8.LaserDiodeTempAve.dim = {'hk8_packet'};

    % id 3754: TLM8_BeamsplitterTemp#1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39_Spare.att.telemetry_point_id = '3754';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39_Spare.att.mnemonic = 'TLM8_BeamsplitterTemp#1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39_Spare.att.start_bit = '5216';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39_Spare.att.description = 'Beam Splitter Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3755: TLM8_BeamsplitterTemp#1(epoch 39)
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39.att.telemetry_point_id = '3755';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39.att.mnemonic = 'TLM8_BeamsplitterTemp#1(epoch 39)';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39.att.start_bit = '5218';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39.att.coeffs = '19.168 0.00627938';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39.att.description = 'Beam Splitter Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.BeamsplitterTemp_1_epoch_39.dim = {'hk8_packet'};

    % id 3756: TLM8_OMAstructureinputTemp#1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39_Spare.att.telemetry_point_id = '3756';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39_Spare.att.mnemonic = 'TLM8_OMAstructureinputTemp#1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39_Spare.att.start_bit = '5232';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39_Spare.att.description = 'OMA Structure Input Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3757: TLM8_OMAstructureinputTemp#1(epoch 39)
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39.att.telemetry_point_id = '3757';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39.att.mnemonic = 'TLM8_OMAstructureinputTemp#1(epoch 39)';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39.att.start_bit = '5234';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39.att.coeffs = '19.826 0.006294378';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39.att.description = 'OMA Structure Input Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_1_epoch_39.dim = {'hk8_packet'};

    % id 3758: TLM8_OMAstructureinputTemp_duplicate(Spare)
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate_Spare.att.telemetry_point_id = '3758';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate_Spare.att.mnemonic = 'TLM8_OMAstructureinputTemp_duplicate(Spare)';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate_Spare.att.start_bit = '5248';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate_Spare.att.description = 'OMA Structure Input Temp (duplicate) - Spare';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate_Spare.dim = {'hk8_packet'};

    % id 3759: TLM8_OMAstructureinputTemp_duplicate
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate.att.telemetry_point_id = '3759';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate.att.mnemonic = 'TLM8_OMAstructureinputTemp_duplicate';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate.att.start_bit = '5250';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate.att.coeffs = '19.826 0.006294378';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate.att.num_bits = '14';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate.att.units = '°C';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate.att.description = 'OMA Structure Input Temp (duplicate)';
    g_metadata.packets.instr_hk8.OMAstructureinputTemp_duplicate.dim = {'hk8_packet'};

    % id 3760: TLM8_LaserdetectionpeakRchannel(epoch 39)
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39.att.telemetry_point_id = '3760';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39.att.mnemonic = 'TLM8_LaserdetectionpeakRchannel(epoch 39)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39.att.start_bit = '5264';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39.att.coeffs = '0 5.755372E-04';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39.att.description = 'Laser Detection Peak R Chan., Epoch 39';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39.dim = {'hk8_packet'};

    % id 3761: TLM8_LaserdetectionpeakXchannel(epoch 39)
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39.att.telemetry_point_id = '3761';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39.att.mnemonic = 'TLM8_LaserdetectionpeakXchannel(epoch 39)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39.att.start_bit = '5280';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39.att.coeffs = '0 5.753506E-04';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39.att.description = 'Laser Detection Peak X Chan., Epoch 39';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39.dim = {'hk8_packet'};

    % id 3762: TLM8_LaserdetectionpeakYchannel(epoch 39)
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39.att.telemetry_point_id = '3762';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39.att.mnemonic = 'TLM8_LaserdetectionpeakYchannel(epoch 39)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39.att.start_bit = '5296';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39.att.coeffs = '0 5.752540E-04';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39.att.description = 'Laser Detection Peak Y Chan., Epoch 39';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39.dim = {'hk8_packet'};

    % id 3763: TLM8_LaserdetectionpeakFchannel(epoch 39)
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39.att.telemetry_point_id = '3763';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39.att.mnemonic = 'TLM8_LaserdetectionpeakFchannel(epoch 39)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39.att.start_bit = '5312';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39.att.coeffs = '0 5.436496E-04';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39.att.description = 'Laser Detection Peak F Chan., Epoch 39';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39.dim = {'hk8_packet'};

    % id 3764: TLM8_LaserdetectionpeakDchannel(epoch 39)
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39.att.telemetry_point_id = '3764';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39.att.mnemonic = 'TLM8_LaserdetectionpeakDchannel(epoch 39)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39.att.start_bit = '5328';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39.att.coeffs = '0 5.445093E-04';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39.att.description = 'Laser Detection Peak D Chan., Epoch 39';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39.dim = {'hk8_packet'};

    % id 3766: TLM8_PorchswingVelocity(sample 12 epoch 39) 
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.telemetry_point_id{12} = '3766';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.mnemonic{12} = 'TLM8_PorchswingVelocity(sample 12 epoch 39) ';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.start_bit{12} = '5344';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.signbit_loc{12} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.coeffs{12} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.num_bits{12} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.units{12} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.att.description{12} = 'Porchswing Velocity, Sample 12 Epoch 39 ';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_39.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3768: TLM8_DA-XTiltErr(sample 12 epoch 39)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.telemetry_point_id{12} = '3768';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.mnemonic{12} = 'TLM8_DA-XTiltErr(sample 12 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.start_bit{12} = '5360';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.signbit_loc{12} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.coeffs{12} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.num_bits{12} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.units{12} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.att.description{12} = 'DA-X Tilt Error, Sample 12 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3770: TLM8_DA-YTiltErr(sample 12 epoch 39)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.telemetry_point_id{12} = '3770';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.mnemonic{12} = 'TLM8_DA-YTiltErr(sample 12 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.start_bit{12} = '5376';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.signbit_loc{12} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.coeffs{12} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.num_bits{12} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.units{12} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.att.description{12} = 'DA-Y Tilt Error, Sample 12 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_39.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3771: TLM8_Neondetectionpeak(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39_Spare.att.telemetry_point_id = '3771';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39_Spare.att.mnemonic = 'TLM8_Neondetectionpeak(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39_Spare.att.start_bit = '5392';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39_Spare.att.description = 'Neon Detection Peak, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3772: TLM8_Neondetectionpeak(epoch 39)
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39.att.telemetry_point_id = '3772';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39.att.mnemonic = 'TLM8_Neondetectionpeak(epoch 39)';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39.att.start_bit = '5394';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39.att.coeffs = '0 1.007112E-03';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39.att.description = 'Neon Detection Peak, Epoch 39';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_39.dim = {'hk8_packet'};

    % id 3773: TLM8_DA-XMotorCurrent(sample 2 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.telemetry_point_id{2} = '3773';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.mnemonic{2} = 'TLM8_DA-XMotorCurrent(sample 2 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.start_bit{2} = '5408';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.att.description{2} = 'DA-X Motor Current, Sample 2 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3774: TLM8_DA-XMotorCurrent(sample 2 epoch 39)
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.telemetry_point_id{2} = '3774';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.mnemonic{2} = 'TLM8_DA-XMotorCurrent(sample 2 epoch 39)';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.start_bit{2} = '5410';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.coeffs{2} = '0 1.52587890625E-05';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.att.description{2} = 'DA-X Motor Current, Sample 2 Epoch 39';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_39.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3775: TLM8_DA-YMotorCurrent(sample 2 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.telemetry_point_id{2} = '3775';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.mnemonic{2} = 'TLM8_DA-YMotorCurrent(sample 2 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.start_bit{2} = '5424';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.att.description{2} = 'DA-Y Motor Current, Sample 2 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3776: TLM8_DA-YMotorCurrent(sample 2 epoch 39)
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.telemetry_point_id{2} = '3776';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.mnemonic{2} = 'TLM8_DA-YMotorCurrent(sample 2 epoch 39)';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.start_bit{2} = '5426';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.coeffs{2} = '0 1.52587890625E-05';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.att.description{2} = 'DA-Y Motor Current, Sample 2 Epoch 39';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_39.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3777: TLM8_PorchswingMotorCurrent(sample 10 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.telemetry_point_id{10} = '3777';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.mnemonic{10} = 'TLM8_PorchswingMotorCurrent(sample 10 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.start_bit{10} = '5440';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.data_type{10} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.num_bits{10} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.att.description{10} = 'Porchswing Motor Current, Sample 10 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3778: TLM8_PorchswingMotorCurrent(sample 10 epoch 39)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.telemetry_point_id{10} = '3778';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.mnemonic{10} = 'TLM8_PorchswingMotorCurrent(sample 10 epoch 39)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.start_bit{10} = '5442';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.coeffs{10} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.num_bits{10} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.units{10} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.att.description{10} = 'Porchswing Motor Current, Sample 10 Epoch 39';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_39.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3779: TLM8_LaserOpticalPower(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39_Spare.att.telemetry_point_id = '3779';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39_Spare.att.mnemonic = 'TLM8_LaserOpticalPower(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39_Spare.att.start_bit = '5456';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39_Spare.att.description = 'Laser Optical Power, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39_Spare.dim = {'hk8_packet'};

    % id 3780: TLM8_LaserOpticalPower(epoch 39)
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39.att.telemetry_point_id = '3780';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39.att.mnemonic = 'TLM8_LaserOpticalPower(epoch 39)';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39.att.start_bit = '5458';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39.att.coeffs = '0 1.95409047702289E-06';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39.att.units = 'Watts';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39.att.description = 'Laser Optical Power, Epoch 39';
    g_metadata.packets.instr_hk8.LaserOpticalPower_epoch_39.dim = {'hk8_packet'};

    % id 3781: TLM8_PorchswingMotorCurrent(sample 1 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id{1} = '3781';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic{1} = 'TLM8_PorchswingMotorCurrent(sample 1 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit{1} = '5472';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description{1} = 'Porchswing Motor Current, Sample 1 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3782: TLM8_PorchswingMotorCurrent(sample 1 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id{1} = '3782';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic{1} = 'TLM8_PorchswingMotorCurrent(sample 1 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit{1} = '5474';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs{1} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description = cell(10, 1);
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description{1} = 'Porchswing Motor Current, Sample 1 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3783: TLM8_PorchswingMotorCurrent(sample 2 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id{2} = '3783';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic{2} = 'TLM8_PorchswingMotorCurrent(sample 2 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit{2} = '5488';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description{2} = 'Porchswing Motor Current, Sample 2 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3784: TLM8_PorchswingMotorCurrent(sample 2 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id{2} = '3784';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic{2} = 'TLM8_PorchswingMotorCurrent(sample 2 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit{2} = '5490';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs{2} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description{2} = 'Porchswing Motor Current, Sample 2 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3785: TLM8_PorchswingMotorCurrent(sample 3 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id{3} = '3785';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic{3} = 'TLM8_PorchswingMotorCurrent(sample 3 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit{3} = '5504';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description{3} = 'Porchswing Motor Current, Sample 3 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3786: TLM8_PorchswingMotorCurrent(sample 3 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id{3} = '3786';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic{3} = 'TLM8_PorchswingMotorCurrent(sample 3 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit{3} = '5506';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs{3} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description{3} = 'Porchswing Motor Current, Sample 3 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3787: TLM8_PorchswingMotorCurrent(sample 4 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id{4} = '3787';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic{4} = 'TLM8_PorchswingMotorCurrent(sample 4 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit{4} = '5520';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description{4} = 'Porchswing Motor Current, Sample 4 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3788: TLM8_PorchswingMotorCurrent(sample 4 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id{4} = '3788';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic{4} = 'TLM8_PorchswingMotorCurrent(sample 4 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit{4} = '5522';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs{4} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description{4} = 'Porchswing Motor Current, Sample 4 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3789: TLM8_PorchswingMotorCurrent(sample 5 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id{5} = '3789';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic{5} = 'TLM8_PorchswingMotorCurrent(sample 5 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit{5} = '5536';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type{5} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits{5} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description{5} = 'Porchswing Motor Current, Sample 5 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3790: TLM8_PorchswingMotorCurrent(sample 5 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id{5} = '3790';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic{5} = 'TLM8_PorchswingMotorCurrent(sample 5 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit{5} = '5538';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs{5} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits{5} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units{5} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description{5} = 'Porchswing Motor Current, Sample 5 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3791: TLM8_PorchswingMotorCurrent(sample 6 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id{6} = '3791';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic{6} = 'TLM8_PorchswingMotorCurrent(sample 6 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit{6} = '5552';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type{6} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits{6} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description{6} = 'Porchswing Motor Current, Sample 6 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3792: TLM8_PorchswingMotorCurrent(sample 6 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id{6} = '3792';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic{6} = 'TLM8_PorchswingMotorCurrent(sample 6 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit{6} = '5554';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs{6} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits{6} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units{6} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description{6} = 'Porchswing Motor Current, Sample 6 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3793: TLM8_PorchswingMotorCurrent(sample 7 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id{7} = '3793';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic{7} = 'TLM8_PorchswingMotorCurrent(sample 7 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit{7} = '5568';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type{7} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits{7} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description{7} = 'Porchswing Motor Current, Sample 7 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3794: TLM8_PorchswingMotorCurrent(sample 7 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id{7} = '3794';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic{7} = 'TLM8_PorchswingMotorCurrent(sample 7 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit{7} = '5570';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs{7} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits{7} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units{7} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description{7} = 'Porchswing Motor Current, Sample 7 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3795: TLM8_PorchswingMotorCurrent(sample 8 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id{8} = '3795';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic{8} = 'TLM8_PorchswingMotorCurrent(sample 8 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit{8} = '5584';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type{8} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits{8} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description{8} = 'Porchswing Motor Current, Sample 8 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3796: TLM8_PorchswingMotorCurrent(sample 8 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id{8} = '3796';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic{8} = 'TLM8_PorchswingMotorCurrent(sample 8 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit{8} = '5586';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs{8} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits{8} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units{8} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description{8} = 'Porchswing Motor Current, Sample 8 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3797: TLM8_DA-XMotorCurrent(sample 1 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.telemetry_point_id = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.telemetry_point_id{1} = '3797';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.mnemonic = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.mnemonic{1} = 'TLM8_DA-XMotorCurrent(sample 1 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.start_bit = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.start_bit{1} = '5600';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.data_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.num_bits = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.description = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.description{1} = 'DA-X Motor Current, Sample 1 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3798: TLM8_DA-XMotorCurrent(sample 1 epoch 40)
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.telemetry_point_id = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.telemetry_point_id{1} = '3798';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.mnemonic = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.mnemonic{1} = 'TLM8_DA-XMotorCurrent(sample 1 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.start_bit = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.start_bit{1} = '5602';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.data_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.coeffs = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.coeffs{1} = '0 1.52587890625E-05';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.num_bits = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.units = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.eu_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.description = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.description{1} = 'DA-X Motor Current, Sample 1 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3799: TLM8_DA-YMotorCurrent(sample 1 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.telemetry_point_id = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.telemetry_point_id{1} = '3799';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.mnemonic = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.mnemonic{1} = 'TLM8_DA-YMotorCurrent(sample 1 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.start_bit = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.start_bit{1} = '5616';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.data_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.num_bits = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.description = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.description{1} = 'DA-Y Motor Current, Sample 1 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3800: TLM8_DA-YMotorCurrent(sample 1 epoch 40)
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.telemetry_point_id = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.telemetry_point_id{1} = '3800';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.mnemonic = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.mnemonic{1} = 'TLM8_DA-YMotorCurrent(sample 1 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.start_bit = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.start_bit{1} = '5618';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.data_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.coeffs = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.coeffs{1} = '0 1.52587890625E-05';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.num_bits = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.units = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.eu_type = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.description = cell(2, 1);
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.description{1} = 'DA-Y Motor Current, Sample 1 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3802: TLM8_PorchswingVelocity(sample 1 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{1} = '3802';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{1} = 'TLM8_PorchswingVelocity(sample 1 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{1} = '5632';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{1} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{1} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{1} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description = cell(12, 1);
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{1} = 'Porchswing Velocity, Sample 1 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3804: TLM8_DA-XTiltErr(sample 1 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{1} = '3804';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{1} = 'TLM8_DA-XTiltErr(sample 1 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{1} = '5648';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{1} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{1} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{1} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{1} = 'DA-X Tilt Error, Sample 1 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3806: TLM8_DA-YTiltErr(sample 1 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{1} = '3806';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{1} = 'TLM8_DA-YTiltErr(sample 1 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{1} = '5664';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{1} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{1} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{1} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{1} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description = cell(12, 1);
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{1} = 'DA-Y Tilt Error, Sample 1 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3807: TLM8_PorchswingMotorCurrent(sample 9 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id{9} = '3807';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic{9} = 'TLM8_PorchswingMotorCurrent(sample 9 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit{9} = '5680';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type{9} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits{9} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description{9} = 'Porchswing Motor Current, Sample 9 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3808: TLM8_PorchswingMotorCurrent(sample 9 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id{9} = '3808';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic{9} = 'TLM8_PorchswingMotorCurrent(sample 9 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit{9} = '5682';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs{9} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits{9} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units{9} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description{9} = 'Porchswing Motor Current, Sample 9 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3810: TLM8_PorchswingVelocity(sample 2 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{2} = '3810';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{2} = 'TLM8_PorchswingVelocity(sample 2 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{2} = '5696';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{2} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{2} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{2} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{2} = 'Porchswing Velocity, Sample 2 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3812: TLM8_DA-XTiltErr(sample 2 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{2} = '3812';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{2} = 'TLM8_DA-XTiltErr(sample 2 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{2} = '5712';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{2} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{2} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{2} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{2} = 'DA-X Tilt Error, Sample 2 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3814: TLM8_DA-YTiltErr(sample 2 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{2} = '3814';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{2} = 'TLM8_DA-YTiltErr(sample 2 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{2} = '5728';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{2} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{2} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{2} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{2} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{2} = 'DA-Y Tilt Error, Sample 2 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3816: TLM8_PorchswingVelocity(sample 3 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{3} = '3816';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{3} = 'TLM8_PorchswingVelocity(sample 3 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{3} = '5744';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{3} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{3} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{3} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{3} = 'Porchswing Velocity, Sample 3 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3818: TLM8_DA-XTiltErr(sample 3 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{3} = '3818';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{3} = 'TLM8_DA-XTiltErr(sample 3 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{3} = '5760';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{3} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{3} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{3} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{3} = 'DA-X Tilt Error, Sample 3 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3820: TLM8_DA-YTiltErr(sample 3 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{3} = '3820';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{3} = 'TLM8_DA-YTiltErr(sample 3 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{3} = '5776';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{3} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{3} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{3} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{3} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{3} = 'DA-Y Tilt Error, Sample 3 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3822: TLM8_PorchswingVelocity(sample 4 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{4} = '3822';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{4} = 'TLM8_PorchswingVelocity(sample 4 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{4} = '5792';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{4} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{4} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{4} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{4} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{4} = 'Porchswing Velocity, Sample 4 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3824: TLM8_DA-XTiltErr(sample 4 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{4} = '3824';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{4} = 'TLM8_DA-XTiltErr(sample 4 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{4} = '5808';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{4} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{4} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{4} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{4} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{4} = 'DA-X Tilt Error, Sample 4 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3826: TLM8_DA-YTiltErr(sample 4 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{4} = '3826';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{4} = 'TLM8_DA-YTiltErr(sample 4 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{4} = '5824';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{4} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{4} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{4} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{4} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{4} = 'DA-Y Tilt Error, Sample 4 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3828: TLM8_PorchswingVelocity(sample 5 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{5} = '3828';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{5} = 'TLM8_PorchswingVelocity(sample 5 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{5} = '5840';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{5} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{5} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{5} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{5} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{5} = 'Porchswing Velocity, Sample 5 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3830: TLM8_DA-XTiltErr(sample 5 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{5} = '3830';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{5} = 'TLM8_DA-XTiltErr(sample 5 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{5} = '5856';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{5} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{5} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{5} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{5} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{5} = 'DA-X Tilt Error, Sample 5 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3832: TLM8_DA-YTiltErr(sample 5 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{5} = '3832';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{5} = 'TLM8_DA-YTiltErr(sample 5 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{5} = '5872';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{5} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{5} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{5} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{5} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{5} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{5} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{5} = 'DA-Y Tilt Error, Sample 5 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3834: TLM8_PorchswingVelocity(sample 6 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{6} = '3834';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{6} = 'TLM8_PorchswingVelocity(sample 6 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{6} = '5888';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{6} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{6} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{6} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{6} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{6} = 'Porchswing Velocity, Sample 6 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3836: TLM8_DA-XTiltErr(sample 6 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{6} = '3836';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{6} = 'TLM8_DA-XTiltErr(sample 6 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{6} = '5904';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{6} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{6} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{6} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{6} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{6} = 'DA-X Tilt Error, Sample 6 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3838: TLM8_DA-YTiltErr(sample 6 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{6} = '3838';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{6} = 'TLM8_DA-YTiltErr(sample 6 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{6} = '5920';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{6} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{6} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{6} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{6} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{6} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{6} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{6} = 'DA-Y Tilt Error, Sample 6 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3840: TLM8_PorchswingVelocity(sample 7 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{7} = '3840';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{7} = 'TLM8_PorchswingVelocity(sample 7 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{7} = '5936';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{7} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{7} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{7} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{7} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{7} = 'Porchswing Velocity, Sample 7 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3842: TLM8_DA-XTiltErr(sample 7 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{7} = '3842';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{7} = 'TLM8_DA-XTiltErr(sample 7 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{7} = '5952';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{7} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{7} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{7} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{7} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{7} = 'DA-X Tilt Error, Sample 7 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3844: TLM8_DA-YTiltErr(sample 7 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{7} = '3844';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{7} = 'TLM8_DA-YTiltErr(sample 7 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{7} = '5968';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{7} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{7} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{7} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{7} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{7} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{7} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{7} = 'DA-Y Tilt Error, Sample 7 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3846: TLM8_PorchswingVelocity(sample 8 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{8} = '3846';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{8} = 'TLM8_PorchswingVelocity(sample 8 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{8} = '5984';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{8} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{8} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{8} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{8} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{8} = 'Porchswing Velocity, Sample 8 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3848: TLM8_DA-XTiltErr(sample 8 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{8} = '3848';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{8} = 'TLM8_DA-XTiltErr(sample 8 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{8} = '6000';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{8} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{8} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{8} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{8} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{8} = 'DA-X Tilt Error, Sample 8 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3850: TLM8_DA-YTiltErr(sample 8 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{8} = '3850';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{8} = 'TLM8_DA-YTiltErr(sample 8 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{8} = '6016';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{8} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{8} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{8} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{8} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{8} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{8} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{8} = 'DA-Y Tilt Error, Sample 8 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3851: TLM8_LaserdetectionpeakTychannel(epoch 40)
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40.att.telemetry_point_id = '3851';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40.att.mnemonic = 'TLM8_LaserdetectionpeakTychannel(epoch 40)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40.att.start_bit = '6032';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40.att.coeffs = '1.17014E-02 7.11662E-04 9.54457E-08 -1.34280E-10 4.97460E-14 -5.80664e-18';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40.att.description = 'Laser Detection Peak Ty Chan., Epoch 40';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40.dim = {'hk8_packet'};

    % id 3852: TLM8_LaserdetectionpeakTxchannel(epoch 40)
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40.att.telemetry_point_id = '3852';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40.att.mnemonic = 'TLM8_LaserdetectionpeakTxchannel(epoch 40)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40.att.start_bit = '6048';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40.att.coeffs = '1.17014E-02 7.11662E-04 9.54457E-08 -1.34280E-10 4.97460E-14 -5.80664e-18';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40.att.description = 'Laser Detection Peak Tx Chan., Epoch 40';
    g_metadata.packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40.dim = {'hk8_packet'};

    % id 3854: TLM8_PorchswingVelocity(sample 9 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{9} = '3854';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{9} = 'TLM8_PorchswingVelocity(sample 9 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{9} = '6064';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{9} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{9} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{9} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{9} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{9} = 'Porchswing Velocity, Sample 9 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3856: TLM8_DA-XTiltErr(sample 9 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{9} = '3856';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{9} = 'TLM8_DA-XTiltErr(sample 9 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{9} = '6080';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{9} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{9} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{9} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{9} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{9} = 'DA-X Tilt Error, Sample 9 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3858: TLM8_DA-YTiltErr(sample 9 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{9} = '3858';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{9} = 'TLM8_DA-YTiltErr(sample 9 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{9} = '6096';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{9} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{9} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{9} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{9} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{9} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{9} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{9} = 'DA-Y Tilt Error, Sample 9 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3860: TLM8_Porchswingposition(epoch 40)
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_40.att.telemetry_point_id = '3860';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_40.att.mnemonic = 'TLM8_Porchswingposition(epoch 40)';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_40.att.start_bit = '6112';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_40.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_40.att.signbit_loc = '0';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_40.att.coeffs = '-1.26894080E-02 3.87250E-07';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_40.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_40.att.description = 'Porchswing Position, Epoch 40';
    g_metadata.packets.instr_hk8.Porchswingposition_epoch_40.dim = {'hk8_packet'};

    % id 3862: TLM8_PorchswingpositionErr(epoch 40)
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_40.att.telemetry_point_id = '3862';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_40.att.mnemonic = 'TLM8_PorchswingpositionErr(epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_40.att.start_bit = '6128';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_40.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_40.att.signbit_loc = '16';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_40.att.coeffs = '0 3.87250E-07';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_40.att.num_bits = '16';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_40.att.description = 'Porchswing Position Error, Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingpositionErr_epoch_40.dim = {'hk8_packet'};

    % id 3863: TLM8_OpticalZPDoffset(epoch 40)
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.att.telemetry_point_id = '3863';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.att.mnemonic = 'TLM8_OpticalZPDoffset(epoch 40)';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.att.start_bit = '6144';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.att.signbit_loc = '16';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.att.coeffs = '0 3.87250E-07';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.att.num_bits = '16';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.att.units = 'Meters';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.att.description = 'Optical Zero Path Differential Offset, Epoch 40';
    g_metadata.packets.instr_hk8.OpticalZPDoffset_epoch_40.dim = {'hk8_packet'};

    % id 3865: TLM8_PorchswingVelocity(sample 10 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{10} = '3865';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{10} = 'TLM8_PorchswingVelocity(sample 10 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{10} = '6160';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{10} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{10} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{10} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{10} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{10} = 'Porchswing Velocity, Sample 10 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3867: TLM8_DA-XTiltErr(sample 10 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{10} = '3867';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{10} = 'TLM8_DA-XTiltErr(sample 10 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{10} = '6176';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{10} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{10} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{10} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{10} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{10} = 'DA-X Tilt Error, Sample 10 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3869: TLM8_DA-YTiltErr(sample 10 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{10} = '3869';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{10} = 'TLM8_DA-YTiltErr(sample 10 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{10} = '6192';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{10} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{10} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{10} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{10} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{10} = 'DA-Y Tilt Error, Sample 10 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3871: TLM8_PorchswingVelocity(sample 11 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{11} = '3871';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{11} = 'TLM8_PorchswingVelocity(sample 11 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{11} = '6208';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{11} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{11} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{11} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{11} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{11} = 'Porchswing Velocity, Sample 11 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3873: TLM8_DA-XTiltErr(sample 11 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{11} = '3873';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{11} = 'TLM8_DA-XTiltErr(sample 11 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{11} = '6224';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{11} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{11} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{11} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{11} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{11} = 'DA-X Tilt Error, Sample 11 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3875: TLM8_DA-YTiltErr(sample 11 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{11} = '3875';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{11} = 'TLM8_DA-YTiltErr(sample 11 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{11} = '6240';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{11} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{11} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{11} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{11} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{11} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{11} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{11} = 'DA-Y Tilt Error, Sample 11 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3876: TLM8_LaserdetectionpeakRchannel(epoch 40)
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40.att.telemetry_point_id = '3876';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40.att.mnemonic = 'TLM8_LaserdetectionpeakRchannel(epoch 40)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40.att.start_bit = '6256';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40.att.coeffs = '1.17014E-02 7.11662E-04 9.54457E-08 -1.34280E-10 4.97460E-14 -5.80664e-18';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40.att.description = 'Laser detection peakR Chan., Epoch 40';
    g_metadata.packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40.dim = {'hk8_packet'};

    % id 3877: TLM8_LaserdetectionpeakXchannel(epoch 40)
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40.att.telemetry_point_id = '3877';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40.att.mnemonic = 'TLM8_LaserdetectionpeakXchannel(epoch 40)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40.att.start_bit = '6272';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40.att.coeffs = '1.17014E-02 7.11662E-04 9.54457E-08 -1.34280E-10 4.97460E-14 -5.80664e-18';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40.att.description = 'Laser detection peakX Chan., Epoch 40';
    g_metadata.packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40.dim = {'hk8_packet'};

    % id 3878: TLM8_LaserdetectionpeakYchannel(epoch 40)
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40.att.telemetry_point_id = '3878';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40.att.mnemonic = 'TLM8_LaserdetectionpeakYchannel(epoch 40)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40.att.start_bit = '6288';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40.att.coeffs = '1.17014E-02 7.11662E-04 9.54457E-08 -1.34280E-10 4.97460E-14 -5.80664e-18';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40.att.description = 'Laser detection peakY Chan., Epoch 40';
    g_metadata.packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40.dim = {'hk8_packet'};

    % id 3879: TLM8_LaserdetectionpeakFchannel(epoch 40)
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40.att.telemetry_point_id = '3879';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40.att.mnemonic = 'TLM8_LaserdetectionpeakFchannel(epoch 40)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40.att.start_bit = '6304';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40.att.coeffs = '1.17014E-02 7.11662E-04 9.54457E-08 -1.34280E-10 4.97460E-14 -5.80664e-18';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40.att.description = 'Laser detection peakF Chan., Epoch 40';
    g_metadata.packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40.dim = {'hk8_packet'};

    % id 3880: TLM8_LaserdetectionpeakDchannel(epoch 40)
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40.att.telemetry_point_id = '3880';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40.att.mnemonic = 'TLM8_LaserdetectionpeakDchannel(epoch 40)';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40.att.start_bit = '6320';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40.att.coeffs = '1.17014E-02 7.11662E-04 9.54457E-08 -1.34280E-10 4.97460E-14 -5.80664e-18';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40.att.num_bits = '16';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40.att.units = 'Volts';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40.att.description = 'Laser detection peakD Chan., Epoch 40';
    g_metadata.packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40.dim = {'hk8_packet'};

    % id 3882: TLM8_PorchswingVelocity(sample 12 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.telemetry_point_id{12} = '3882';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.mnemonic{12} = 'TLM8_PorchswingVelocity(sample 12 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.start_bit{12} = '6336';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.signbit_loc{12} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.coeffs{12} = '0 4.89074084942387E-05';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.num_bits{12} = '16';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.units{12} = 'Sec/cm';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.att.description{12} = 'Porchswing Velocity, Sample 12 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingVelocity_epoch_40.dim = {'porchswing_velocity_sample', 'hk8_packet'};

    % id 3884: TLM8_DA-XTiltErr(sample 12 epoch 40)
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.telemetry_point_id{12} = '3884';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.mnemonic{12} = 'TLM8_DA-XTiltErr(sample 12 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.start_bit{12} = '6352';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.signbit_loc{12} = '11';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.coeffs{12} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.num_bits{12} = '16';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.units{12} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.att.description{12} = 'DA-X Tilt Error, Sample 12 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3886: TLM8_DA-YTiltErr(sample 12 epoch 40)
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.telemetry_point_id{12} = '3886';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.mnemonic{12} = 'TLM8_DA-YTiltErr(sample 12 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.start_bit{12} = '6368';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.data_type{12} = 'signed';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.signbit_loc{12} = '11';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.coeffs{12} = '0 1.14600E-01';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.num_bits{12} = '16';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.units{12} = 'uRadians';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.eu_type{12} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.att.description{12} = 'DA-Y Tilt Error, Sample 12 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YTiltErr_epoch_40.dim = {'da_tilt_err_sample', 'hk8_packet'};

    % id 3887: TLM8_Neondetectionpeak(epoch 40 - Spare)
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40_Spare.att.telemetry_point_id = '3887';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40_Spare.att.mnemonic = 'TLM8_Neondetectionpeak(epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40_Spare.att.start_bit = '6384';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40_Spare.att.description = 'Neon Detection Peak, Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40_Spare.dim = {'hk8_packet'};

    % id 3888: TLM8_Neondetectionpeak(epoch 40)
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40.att.telemetry_point_id = '3888';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40.att.mnemonic = 'TLM8_Neondetectionpeak(epoch 40)';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40.att.start_bit = '6386';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40.att.coeffs = '4.08887E-02 8.78407E-04 -3.30236E-07 2.52486E-10 -8.54538E-14 1.01124E-17';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40.att.units = 'Volts';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40.att.description = 'Neon Detection Peak, Epoch 40';
    g_metadata.packets.instr_hk8.Neondetectionpeak_epoch_40.dim = {'hk8_packet'};

    % id 3889: TLM8_DA-XMotorCurrent(sample 2 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.telemetry_point_id{2} = '3889';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.mnemonic{2} = 'TLM8_DA-XMotorCurrent(sample 2 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.start_bit{2} = '6400';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.att.description{2} = 'DA-X Motor Current, Sample 2 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3890: TLM8_DA-XMotorCurrent(sample 2 epoch 40)
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.telemetry_point_id{2} = '3890';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.mnemonic{2} = 'TLM8_DA-XMotorCurrent(sample 2 epoch 40)';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.start_bit{2} = '6402';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.coeffs{2} = '0 1.52587890625E-05';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.att.description{2} = 'DA-X Motor Current, Sample 2 Epoch 40';
    g_metadata.packets.instr_hk8.DA_XMotorCurrent_epoch_40.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3891: TLM8_DA-YMotorCurrent(sample 2 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.telemetry_point_id{2} = '3891';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.mnemonic{2} = 'TLM8_DA-YMotorCurrent(sample 2 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.start_bit{2} = '6416';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.att.description{2} = 'DA-Y Motor Current, Sample 2 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3892: TLM8_DA-YMotorCurrent(sample 2 epoch 40)
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.telemetry_point_id{2} = '3892';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.mnemonic{2} = 'TLM8_DA-YMotorCurrent(sample 2 epoch 40)';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.start_bit{2} = '6418';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.coeffs{2} = '0 1.52587890625E-05';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.att.description{2} = 'DA-Y Motor Current, Sample 2 Epoch 40';
    g_metadata.packets.instr_hk8.DA_YMotorCurrent_epoch_40.dim = {'da_motor_current_sample', 'hk8_packet'};

    % id 3893: TLM8_PorchswingMotorCurrent(sample 10 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.telemetry_point_id{10} = '3893';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.mnemonic{10} = 'TLM8_PorchswingMotorCurrent(sample 10 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.start_bit{10} = '6432';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.data_type{10} = 'unsigned';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.num_bits{10} = '2';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.att.description{10} = 'Porchswing Motor Current, Sample 10 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3894: TLM8_PorchswingMotorCurrent(sample 10 epoch 40)
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.telemetry_point_id{10} = '3894';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.mnemonic{10} = 'TLM8_PorchswingMotorCurrent(sample 10 epoch 40)';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.start_bit{10} = '6434';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.data_type{10} = 'signed';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.coeffs{10} = '0 1.52587890625E-04';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.num_bits{10} = '14';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.units{10} = 'Amps';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.eu_type{10} = 'polynomial';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.att.description{10} = 'Porchswing Motor Current, Sample 10 Epoch 40';
    g_metadata.packets.instr_hk8.PorchswingMotorCurrent_epoch_40.dim = {'porchswing_motor_current_sample', 'hk8_packet'};

    % id 3895: TLM8_+150VConverterInputCurrent(sample 1 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{1} = '3895';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.start_bit{1} = '6448';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3896: TLM8_+150VConverterInputCurrent(sample 1 epoch 4)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.telemetry_point_id{1} = '3896';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 4)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.start_bit{1} = '6450';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.coeffs{1} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 4';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3897: TLM8_QuietConverterInputCurrent(sample 1 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{1} = '3897';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.start_bit{1} = '6464';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3898: TLM8_QuietConverterInputCurrent(sample 1 epoch 4)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.telemetry_point_id{1} = '3898';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 4)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.start_bit{1} = '6466';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.coeffs{1} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 4';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3899: TLM8_DigitalConverterInputCurrent(sample 1 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{1} = '3899';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.start_bit{1} = '6480';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3900: TLM8_DigitalConverterInputCurrent(sample 1 epoch 4)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.telemetry_point_id{1} = '3900';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 4)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.start_bit{1} = '6482';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.coeffs{1} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 4';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3901: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.telemetry_point_id{1} = '3901';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.start_bit{1} = '6496';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3902: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 4)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.telemetry_point_id{1} = '3902';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 4)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.start_bit{1} = '6498';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.coeffs{1} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 4';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3903: TLM8_+150VConverterInputCurrent(sample 2 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{2} = '3903';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.start_bit{2} = '6512';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3904: TLM8_+150VConverterInputCurrent(sample 2 epoch 4)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.telemetry_point_id{2} = '3904';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 4)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.start_bit{2} = '6514';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.coeffs{2} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 4';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3905: TLM8_QuietConverterInputCurrent(sample 2 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{2} = '3905';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.start_bit{2} = '6528';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3906: TLM8_QuietConverterInputCurrent(sample 2 epoch 4)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.telemetry_point_id{2} = '3906';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 4)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.start_bit{2} = '6530';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.coeffs{2} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 4';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3907: TLM8_DigitalConverterInputCurrent(sample 2 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{2} = '3907';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.start_bit{2} = '6544';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3908: TLM8_DigitalConverterInputCurrent(sample 2 epoch 4)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.telemetry_point_id{2} = '3908';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 4)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.start_bit{2} = '6546';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.coeffs{2} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 4';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3909: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.telemetry_point_id{2} = '3909';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.start_bit{2} = '6560';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3910: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 4)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.telemetry_point_id{2} = '3910';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 4)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.start_bit{2} = '6562';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.coeffs{2} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 4';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3911: TLM8_+150VConverterInputCurrent(sample 3 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{3} = '3911';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.start_bit{3} = '6576';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3912: TLM8_+150VConverterInputCurrent(sample 3 epoch 4)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.telemetry_point_id{3} = '3912';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 4)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.start_bit{3} = '6578';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.coeffs{3} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 4';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3913: TLM8_QuietConverterInputCurrent(sample 3 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{3} = '3913';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.start_bit{3} = '6592';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3914: TLM8_QuietConverterInputCurrent(sample 3 epoch 4)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.telemetry_point_id{3} = '3914';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 4)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.start_bit{3} = '6594';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.coeffs{3} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 4';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3915: TLM8_DigitalConverterInputCurrent(sample 3 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{3} = '3915';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.start_bit{3} = '6608';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3916: TLM8_DigitalConverterInputCurrent(sample 3 epoch 4)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.telemetry_point_id{3} = '3916';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 4)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.start_bit{3} = '6610';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.coeffs{3} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 4';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3917: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.telemetry_point_id{3} = '3917';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.start_bit{3} = '6624';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3918: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 4)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.telemetry_point_id{3} = '3918';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 4)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.start_bit{3} = '6626';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.coeffs{3} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 4';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3919: TLM8_+150VConverterInputCurrent(sample 4 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{4} = '3919';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.start_bit{4} = '6640';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3920: TLM8_+150VConverterInputCurrent(sample 4 epoch 4)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.telemetry_point_id{4} = '3920';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 4)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.start_bit{4} = '6642';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.coeffs{4} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 4';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3921: TLM8_QuietConverterInputCurrent(sample 4 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{4} = '3921';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.start_bit{4} = '6656';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3922: TLM8_QuietConverterInputCurrent(sample 4 epoch 4)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.telemetry_point_id{4} = '3922';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 4)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.start_bit{4} = '6658';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.coeffs{4} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 4';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3923: TLM8_DigitalConverterInputCurrent(sample 4 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.telemetry_point_id{4} = '3923';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.start_bit{4} = '6672';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3924: TLM8_DigitalConverterInputCurrent(sample 4 epoch 4)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.telemetry_point_id{4} = '3924';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 4)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.start_bit{4} = '6674';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.coeffs{4} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 4';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_4.dim = {'input_current_sample', 'hk8_packet'};

    % id 3925: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 4 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.telemetry_point_id{4} = '3925';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 4 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.start_bit{4} = '6688';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 4 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3926: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 4)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.telemetry_point_id{4} = '3926';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 4)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.start_bit{4} = '6690';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.coeffs{4} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.units{4} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 4';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3927: TLM8_+150VConverterInputCurrent(sample 1 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{1} = '3927';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.start_bit{1} = '6704';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3928: TLM8_+150VConverterInputCurrent(sample 1 epoch 19)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.telemetry_point_id{1} = '3928';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 19)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.start_bit{1} = '6706';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.coeffs{1} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 19';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3929: TLM8_QuietConverterInputCurrent(sample 1 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{1} = '3929';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.start_bit{1} = '6720';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3930: TLM8_QuietConverterInputCurrent(sample 1 epoch 19)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.telemetry_point_id{1} = '3930';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 19)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.start_bit{1} = '6722';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.coeffs{1} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 19';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3931: TLM8_DigitalConverterInputCurrent(sample 1 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{1} = '3931';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.start_bit{1} = '6736';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3932: TLM8_DigitalConverterInputCurrent(sample 1 epoch 19)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.telemetry_point_id{1} = '3932';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 19)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.start_bit{1} = '6738';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.coeffs{1} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 19';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3933: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.telemetry_point_id{1} = '3933';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.start_bit{1} = '6752';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3934: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 19)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.telemetry_point_id{1} = '3934';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 19)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.start_bit{1} = '6754';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.coeffs{1} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 19';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3935: TLM8_+150VConverterInputCurrent(sample 2 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{2} = '3935';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.start_bit{2} = '6768';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3936: TLM8_+150VConverterInputCurrent(sample 2 epoch 19)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.telemetry_point_id{2} = '3936';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 19)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.start_bit{2} = '6770';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.coeffs{2} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 19';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3937: TLM8_QuietConverterInputCurrent(sample 2 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{2} = '3937';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.start_bit{2} = '6784';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3938: TLM8_QuietConverterInputCurrent(sample 2 epoch 19)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.telemetry_point_id{2} = '3938';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 19)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.start_bit{2} = '6786';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.coeffs{2} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 19';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3939: TLM8_DigitalConverterInputCurrent(sample 2 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{2} = '3939';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.start_bit{2} = '6800';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3940: TLM8_DigitalConverterInputCurrent(sample 2 epoch 19)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.telemetry_point_id{2} = '3940';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 19)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.start_bit{2} = '6802';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.coeffs{2} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 19';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3941: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.telemetry_point_id{2} = '3941';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.start_bit{2} = '6816';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3942: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 19)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.telemetry_point_id{2} = '3942';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 19)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.start_bit{2} = '6818';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.coeffs{2} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 19';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3943: TLM8_+150VConverterInputCurrent(sample 3 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{3} = '3943';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.start_bit{3} = '6832';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3944: TLM8_+150VConverterInputCurrent(sample 3 epoch 19)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.telemetry_point_id{3} = '3944';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 19)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.start_bit{3} = '6834';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.coeffs{3} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 19';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3945: TLM8_QuietConverterInputCurrent(sample 3 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{3} = '3945';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.start_bit{3} = '6848';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3946: TLM8_QuietConverterInputCurrent(sample 3 epoch 19)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.telemetry_point_id{3} = '3946';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 19)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.start_bit{3} = '6850';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.coeffs{3} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 19';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3947: TLM8_DigitalConverterInputCurrent(sample 3 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{3} = '3947';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.start_bit{3} = '6864';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3948: TLM8_DigitalConverterInputCurrent(sample 3 epoch 19)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.telemetry_point_id{3} = '3948';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 19)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.start_bit{3} = '6866';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.coeffs{3} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 19';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3949: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.telemetry_point_id{3} = '3949';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.start_bit{3} = '6880';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3950: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 19)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.telemetry_point_id{3} = '3950';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 19)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.start_bit{3} = '6882';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.coeffs{3} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 19';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3951: TLM8_+150VConverterInputCurrent(sample 4 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{4} = '3951';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.start_bit{4} = '6896';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3952: TLM8_+150VConverterInputCurrent(sample 4 epoch 19)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.telemetry_point_id{4} = '3952';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 19)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.start_bit{4} = '6898';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.coeffs{4} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 19';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3953: TLM8_QuietConverterInputCurrent(sample 4 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{4} = '3953';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.start_bit{4} = '6912';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3954: TLM8_QuietConverterInputCurrent(sample 4 epoch 19)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.telemetry_point_id{4} = '3954';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 19)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.start_bit{4} = '6914';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.coeffs{4} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 19';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3955: TLM8_DigitalConverterInputCurrent(sample 4 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.telemetry_point_id{4} = '3955';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.start_bit{4} = '6928';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3956: TLM8_DigitalConverterInputCurrent(sample 4 epoch 19)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.telemetry_point_id{4} = '3956';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 19)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.start_bit{4} = '6930';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.coeffs{4} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 19';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_19.dim = {'input_current_sample', 'hk8_packet'};

    % id 3957: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 19 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.telemetry_point_id{4} = '3957';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 19 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.start_bit{4} = '6944';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 19 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3958: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 19)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.telemetry_point_id{4} = '3958';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 19)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.start_bit{4} = '6946';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.coeffs{4} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.units{4} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 19';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3959: TLM8_+150VConverterInputCurrent(sample 1 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{1} = '3959';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.start_bit{1} = '6960';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3960: TLM8_+150VConverterInputCurrent(sample 1 epoch 33)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.telemetry_point_id{1} = '3960';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 33)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.start_bit{1} = '6962';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.coeffs{1} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 33';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3961: TLM8_QuietConverterInputCurrent(sample 1 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{1} = '3961';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.start_bit{1} = '6976';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3962: TLM8_QuietConverterInputCurrent(sample 1 epoch 33)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.telemetry_point_id{1} = '3962';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 33)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.start_bit{1} = '6978';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.coeffs{1} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 33';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3963: TLM8_DigitalConverterInputCurrent(sample 1 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{1} = '3963';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.start_bit{1} = '6992';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3964: TLM8_DigitalConverterInputCurrent(sample 1 epoch 33)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.telemetry_point_id{1} = '3964';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 33)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.start_bit{1} = '6994';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.coeffs{1} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 33';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3965: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.telemetry_point_id{1} = '3965';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.start_bit{1} = '7008';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3966: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 33)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.telemetry_point_id{1} = '3966';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 33)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.start_bit{1} = '7010';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.coeffs{1} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 33';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3967: TLM8_+150VConverterInputCurrent(sample 2 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{2} = '3967';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.start_bit{2} = '7024';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3968: TLM8_+150VConverterInputCurrent(sample 2 epoch 33)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.telemetry_point_id{2} = '3968';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 33)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.start_bit{2} = '7026';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.coeffs{2} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 33';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3969: TLM8_QuietConverterInputCurrent(sample 2 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{2} = '3969';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.start_bit{2} = '7040';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3970: TLM8_QuietConverterInputCurrent(sample 2 epoch 33)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.telemetry_point_id{2} = '3970';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 33)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.start_bit{2} = '7042';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.coeffs{2} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 33';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3971: TLM8_DigitalConverterInputCurrent(sample 2 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{2} = '3971';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.start_bit{2} = '7056';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3972: TLM8_DigitalConverterInputCurrent(sample 2 epoch 33)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.telemetry_point_id{2} = '3972';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 33)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.start_bit{2} = '7058';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.coeffs{2} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 33';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3973: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.telemetry_point_id{2} = '3973';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.start_bit{2} = '7072';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3974: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 33)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.telemetry_point_id{2} = '3974';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 33)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.start_bit{2} = '7074';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.coeffs{2} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 33';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3975: TLM8_+150VConverterInputCurrent(sample 3 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{3} = '3975';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.start_bit{3} = '7088';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3976: TLM8_+150VConverterInputCurrent(sample 3 epoch 33)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.telemetry_point_id{3} = '3976';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 33)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.start_bit{3} = '7090';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.coeffs{3} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 33';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3977: TLM8_QuietConverterInputCurrent(sample 3 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{3} = '3977';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.start_bit{3} = '7104';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3978: TLM8_QuietConverterInputCurrent(sample 3 epoch 33)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.telemetry_point_id{3} = '3978';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 33)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.start_bit{3} = '7106';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.coeffs{3} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 33';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3979: TLM8_DigitalConverterInputCurrent(sample 3 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{3} = '3979';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.start_bit{3} = '7120';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3980: TLM8_DigitalConverterInputCurrent(sample 3 epoch 33)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.telemetry_point_id{3} = '3980';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 33)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.start_bit{3} = '7122';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.coeffs{3} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 33';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3981: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.telemetry_point_id{3} = '3981';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.start_bit{3} = '7136';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3982: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 33)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.telemetry_point_id{3} = '3982';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 33)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.start_bit{3} = '7138';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.coeffs{3} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 33';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3983: TLM8_+150VConverterInputCurrent(sample 4 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{4} = '3983';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.start_bit{4} = '7152';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3984: TLM8_+150VConverterInputCurrent(sample 4 epoch 33)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.telemetry_point_id{4} = '3984';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 33)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.start_bit{4} = '7154';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.coeffs{4} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 33';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3985: TLM8_QuietConverterInputCurrent(sample 4 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{4} = '3985';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.start_bit{4} = '7168';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3986: TLM8_QuietConverterInputCurrent(sample 4 epoch 33)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.telemetry_point_id{4} = '3986';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 33)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.start_bit{4} = '7170';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.coeffs{4} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 33';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3987: TLM8_DigitalConverterInputCurrent(sample 4 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.telemetry_point_id{4} = '3987';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.start_bit{4} = '7184';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3988: TLM8_DigitalConverterInputCurrent(sample 4 epoch 33)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.telemetry_point_id{4} = '3988';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 33)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.start_bit{4} = '7186';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.coeffs{4} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 33';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_33.dim = {'input_current_sample', 'hk8_packet'};

    % id 3989: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 33 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.telemetry_point_id{4} = '3989';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 33 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.start_bit{4} = '7200';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 33 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3990: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 33)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.telemetry_point_id{4} = '3990';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 33)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.start_bit{4} = '7202';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.coeffs{4} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.units{4} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 33';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3991: TLM8_+150VConverterInputCurrent(sample 1 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{1} = '3991';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.start_bit{1} = '7216';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3992: TLM8_+150VConverterInputCurrent(sample 1 epoch 35)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.telemetry_point_id{1} = '3992';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 35)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.start_bit{1} = '7218';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.coeffs{1} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 35';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 3993: TLM8_QuietConverterInputCurrent(sample 1 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{1} = '3993';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.start_bit{1} = '7232';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3994: TLM8_QuietConverterInputCurrent(sample 1 epoch 35)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.telemetry_point_id{1} = '3994';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 35)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.start_bit{1} = '7234';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.coeffs{1} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 35';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 3995: TLM8_DigitalConverterInputCurrent(sample 1 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{1} = '3995';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.start_bit{1} = '7248';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 3996: TLM8_DigitalConverterInputCurrent(sample 1 epoch 35)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.telemetry_point_id{1} = '3996';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 35)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.start_bit{1} = '7250';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.coeffs{1} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 35';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 3997: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.telemetry_point_id{1} = '3997';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.start_bit{1} = '7264';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3998: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 35)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.telemetry_point_id{1} = '3998';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 35)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.start_bit{1} = '7266';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.coeffs{1} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 35';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 3999: TLM8_+150VConverterInputCurrent(sample 2 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{2} = '3999';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.start_bit{2} = '7280';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4000: TLM8_+150VConverterInputCurrent(sample 2 epoch 35)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.telemetry_point_id{2} = '4000';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 35)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.start_bit{2} = '7282';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.coeffs{2} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 35';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 4001: TLM8_QuietConverterInputCurrent(sample 2 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{2} = '4001';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.start_bit{2} = '7296';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4002: TLM8_QuietConverterInputCurrent(sample 2 epoch 35)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.telemetry_point_id{2} = '4002';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 35)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.start_bit{2} = '7298';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.coeffs{2} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 35';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 4003: TLM8_DigitalConverterInputCurrent(sample 2 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{2} = '4003';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.start_bit{2} = '7312';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4004: TLM8_DigitalConverterInputCurrent(sample 2 epoch 35)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.telemetry_point_id{2} = '4004';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 35)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.start_bit{2} = '7314';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.coeffs{2} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 35';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 4005: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.telemetry_point_id{2} = '4005';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.start_bit{2} = '7328';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4006: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 35)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.telemetry_point_id{2} = '4006';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 35)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.start_bit{2} = '7330';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.coeffs{2} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 35';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4007: TLM8_+150VConverterInputCurrent(sample 3 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{3} = '4007';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.start_bit{3} = '7344';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4008: TLM8_+150VConverterInputCurrent(sample 3 epoch 35)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.telemetry_point_id{3} = '4008';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 35)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.start_bit{3} = '7346';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.coeffs{3} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 35';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 4009: TLM8_QuietConverterInputCurrent(sample 3 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{3} = '4009';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.start_bit{3} = '7360';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4010: TLM8_QuietConverterInputCurrent(sample 3 epoch 35)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.telemetry_point_id{3} = '4010';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 35)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.start_bit{3} = '7362';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.coeffs{3} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 35';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 4011: TLM8_DigitalConverterInputCurrent(sample 3 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{3} = '4011';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.start_bit{3} = '7376';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4012: TLM8_DigitalConverterInputCurrent(sample 3 epoch 35)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.telemetry_point_id{3} = '4012';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 35)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.start_bit{3} = '7378';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.coeffs{3} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 35';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 4013: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.telemetry_point_id{3} = '4013';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.start_bit{3} = '7392';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4014: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 35)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.telemetry_point_id{3} = '4014';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 35)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.start_bit{3} = '7394';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.coeffs{3} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 35';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4015: TLM8_+150VConverterInputCurrent(sample 4 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{4} = '4015';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.start_bit{4} = '7408';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4016: TLM8_+150VConverterInputCurrent(sample 4 epoch 35)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.telemetry_point_id{4} = '4016';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 35)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.start_bit{4} = '7410';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.coeffs{4} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 35';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 4017: TLM8_QuietConverterInputCurrent(sample 4 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{4} = '4017';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.start_bit{4} = '7424';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4018: TLM8_QuietConverterInputCurrent(sample 4 epoch 35)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.telemetry_point_id{4} = '4018';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 35)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.start_bit{4} = '7426';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.coeffs{4} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 35';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 4019: TLM8_DigitalConverterInputCurrent(sample 4 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.telemetry_point_id{4} = '4019';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.start_bit{4} = '7440';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4020: TLM8_DigitalConverterInputCurrent(sample 4 epoch 35)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.telemetry_point_id{4} = '4020';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 35)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.start_bit{4} = '7442';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.coeffs{4} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 35';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_35.dim = {'input_current_sample', 'hk8_packet'};

    % id 4021: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 35 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.telemetry_point_id{4} = '4021';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.start_bit{4} = '7456';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4022: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 35)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.telemetry_point_id{4} = '4022';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 35)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.start_bit{4} = '7458';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.coeffs{4} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.units{4} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 35';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4023: TLM8_SWCh8AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{3} = '4023';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.mnemonic{3} = 'TLM8_SWCh8AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.start_bit{3} = '7472';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.description{3} = 'SW Chan. 8 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4024: TLM8_SWCh8AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.telemetry_point_id{3} = '4024';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.mnemonic{3} = 'TLM8_SWCh8AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.start_bit{3} = '7474';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.coeffs{3} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.description{3} = 'SW Chan. 8 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4025: TLM8_MWCh8AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{2} = '4025';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.mnemonic{2} = 'TLM8_MWCh8AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.start_bit{2} = '7488';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.description{2} = 'MW Chan. 8 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4026: TLM8_MWCh8AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.telemetry_point_id{2} = '4026';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.mnemonic{2} = 'TLM8_MWCh8AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.start_bit{2} = '7490';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.coeffs{2} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.description{2} = 'MW Chan. 8 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4027: TLM8_LWCh8AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{1} = '4027';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.mnemonic{1} = 'TLM8_LWCh8AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.start_bit{1} = '7504';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.att.description{1} = 'LW Chan. 8 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4028: TLM8_LWCh8AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.telemetry_point_id{1} = '4028';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.mnemonic{1} = 'TLM8_LWCh8AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.start_bit{1} = '7506';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.coeffs{1} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.att.description{1} = 'LW Chan. 8 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4029: TLM8_SWCh7AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{3} = '4029';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.mnemonic{3} = 'TLM8_SWCh7AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.start_bit{3} = '7520';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.description{3} = 'SW Chan. 7 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4030: TLM8_SWCh7AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.telemetry_point_id{3} = '4030';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.mnemonic{3} = 'TLM8_SWCh7AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.start_bit{3} = '7522';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.coeffs{3} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.description{3} = 'SW Chan. 7 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4031: TLM8_SWCh3AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{3} = '4031';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.mnemonic{3} = 'TLM8_SWCh3AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.start_bit{3} = '7536';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.description{3} = 'SW Chan. 3 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4032: TLM8_SWCh3AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.telemetry_point_id{3} = '4032';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.mnemonic{3} = 'TLM8_SWCh3AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.start_bit{3} = '7538';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.coeffs{3} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.description{3} = 'SW Chan. 3 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4033: TLM8_MWCh7AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{2} = '4033';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.mnemonic{2} = 'TLM8_MWCh7AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.start_bit{2} = '7552';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.description{2} = 'MW Chan. 7 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4034: TLM8_MWCh7AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.telemetry_point_id{2} = '4034';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.mnemonic{2} = 'TLM8_MWCh7AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.start_bit{2} = '7554';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.coeffs{2} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.description{2} = 'MW Chan. 7 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4035: TLM8_MWCh3AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{2} = '4035';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.mnemonic{2} = 'TLM8_MWCh3AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.start_bit{2} = '7568';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.description{2} = 'MW Chan. 3 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4036: TLM8_MWCh3AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.telemetry_point_id{2} = '4036';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.mnemonic{2} = 'TLM8_MWCh3AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.start_bit{2} = '7570';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.coeffs{2} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.description{2} = 'MW Chan. 3 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4037: TLM8_LWCh7AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{1} = '4037';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.mnemonic{1} = 'TLM8_LWCh7AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.start_bit{1} = '7584';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.att.description{1} = 'LW Chan. 7 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4038: TLM8_LWCh7AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.telemetry_point_id{1} = '4038';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.mnemonic{1} = 'TLM8_LWCh7AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.start_bit{1} = '7586';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.coeffs{1} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.att.description{1} = 'LW Chan. 7 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4039: TLM8_LWCh3AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{1} = '4039';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.mnemonic{1} = 'TLM8_LWCh3AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.start_bit{1} = '7600';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.att.description{1} = 'LW Chan. 3 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4040: TLM8_LWCh3AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.telemetry_point_id{1} = '4040';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.mnemonic{1} = 'TLM8_LWCh3AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.start_bit{1} = '7602';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.coeffs{1} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.att.description{1} = 'LW Chan. 3 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4041: TLM8_SWCh9AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{3} = '4041';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.mnemonic{3} = 'TLM8_SWCh9AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.start_bit{3} = '7616';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.description{3} = 'SW Chan. 9 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4042: TLM8_SWCh9AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.telemetry_point_id{3} = '4042';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.mnemonic{3} = 'TLM8_SWCh9AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.start_bit{3} = '7618';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.coeffs{3} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.description{3} = 'SW Chan. 9 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4043: TLM8_SWCh2AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{3} = '4043';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.mnemonic{3} = 'TLM8_SWCh2AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.start_bit{3} = '7632';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.description{3} = 'SW Chan. 2 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4044: TLM8_SWCh2AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.telemetry_point_id{3} = '4044';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.mnemonic{3} = 'TLM8_SWCh2AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.start_bit{3} = '7634';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.coeffs{3} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.description{3} = 'SW Chan. 2 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4045: TLM8_MWCh9AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{2} = '4045';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.mnemonic{2} = 'TLM8_MWCh9AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.start_bit{2} = '7648';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.description{2} = 'MW Chan. 9 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4046: TLM8_MWCh9AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.telemetry_point_id{2} = '4046';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.mnemonic{2} = 'TLM8_MWCh9AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.start_bit{2} = '7650';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.coeffs{2} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.description{2} = 'MW Chan. 9 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4047: TLM8_MWCh2AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{2} = '4047';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.mnemonic{2} = 'TLM8_MWCh2AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.start_bit{2} = '7664';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.description{2} = 'MW Chan. 2 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4048: TLM8_MWCh2AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.telemetry_point_id{2} = '4048';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.mnemonic{2} = 'TLM8_MWCh2AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.start_bit{2} = '7666';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.coeffs{2} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.description{2} = 'MW Chan. 2 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4049: TLM8_LWCh9AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{1} = '4049';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.mnemonic{1} = 'TLM8_LWCh9AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.start_bit{1} = '7680';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.att.description{1} = 'LW Chan. 9 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4050: TLM8_LWCh9AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.telemetry_point_id{1} = '4050';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.mnemonic{1} = 'TLM8_LWCh9AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.start_bit{1} = '7682';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.coeffs{1} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.att.description{1} = 'LW Chan. 9 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4051: TLM8_LWCh2AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{1} = '4051';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.mnemonic{1} = 'TLM8_LWCh2AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.start_bit{1} = '7696';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.att.description{1} = 'LW Chan. 2 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4052: TLM8_LWCh2AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.telemetry_point_id{1} = '4052';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.mnemonic{1} = 'TLM8_LWCh2AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.start_bit{1} = '7698';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.coeffs{1} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.att.description{1} = 'LW Chan. 2 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4053: TLM8_SWCh6AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{3} = '4053';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.mnemonic{3} = 'TLM8_SWCh6AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.start_bit{3} = '7712';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.description{3} = 'SW Chan. 6 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4054: TLM8_SWCh6AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.telemetry_point_id{3} = '4054';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.mnemonic{3} = 'TLM8_SWCh6AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.start_bit{3} = '7714';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.coeffs{3} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.description{3} = 'SW Chan. 6 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4055: TLM8_SWCh1AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{3} = '4055';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.mnemonic{3} = 'TLM8_SWCh1AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.start_bit{3} = '7728';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.description{3} = 'SW Chan. 1 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4056: TLM8_SWCh1AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.telemetry_point_id{3} = '4056';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.mnemonic{3} = 'TLM8_SWCh1AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.start_bit{3} = '7730';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.coeffs{3} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.description{3} = 'SW Chan. 1 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4057: TLM8_MWCh6AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{2} = '4057';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.mnemonic{2} = 'TLM8_MWCh6AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.start_bit{2} = '7744';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.description{2} = 'MW Chan. 6 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4058: TLM8_MWCh6AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.telemetry_point_id{2} = '4058';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.mnemonic{2} = 'TLM8_MWCh6AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.start_bit{2} = '7746';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.coeffs{2} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.description{2} = 'MW Chan. 6 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4059: TLM8_MWCh1AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{2} = '4059';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.mnemonic{2} = 'TLM8_MWCh1AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.start_bit{2} = '7760';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.description{2} = 'MW Chan. 1 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4060: TLM8_MWCh1AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.telemetry_point_id{2} = '4060';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.mnemonic{2} = 'TLM8_MWCh1AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.start_bit{2} = '7762';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.coeffs{2} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.description{2} = 'MW Chan. 1 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4061: TLM8_LWCh6AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{1} = '4061';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.mnemonic{1} = 'TLM8_LWCh6AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.start_bit{1} = '7776';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.att.description{1} = 'LW Chan. 6 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4062: TLM8_LWCh6AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.telemetry_point_id{1} = '4062';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.mnemonic{1} = 'TLM8_LWCh6AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.start_bit{1} = '7778';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.coeffs{1} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.att.description{1} = 'LW Chan. 6 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4063: TLM8_LWCh1AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{1} = '4063';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.mnemonic{1} = 'TLM8_LWCh1AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.start_bit{1} = '7792';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.att.description{1} = 'LW Chan. 1 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4064: TLM8_LWCh1AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.telemetry_point_id{1} = '4064';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.mnemonic{1} = 'TLM8_LWCh1AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.start_bit{1} = '7794';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.coeffs{1} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.att.description{1} = 'LW Chan. 1 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4065: TLM8_SWCh4AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{3} = '4065';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.mnemonic{3} = 'TLM8_SWCh4AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.start_bit{3} = '7808';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.description{3} = 'SW Chan. 4 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4066: TLM8_SWCh4AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.telemetry_point_id{3} = '4066';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.mnemonic{3} = 'TLM8_SWCh4AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.start_bit{3} = '7810';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.coeffs{3} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.description{3} = 'SW Chan. 4 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4067: TLM8_SWCh5AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{3} = '4067';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.mnemonic{3} = 'TLM8_SWCh5AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.start_bit{3} = '7824';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.description{3} = 'SW Chan. 5 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4068: TLM8_SWCh5AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.telemetry_point_id{3} = '4068';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.mnemonic{3} = 'TLM8_SWCh5AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.start_bit{3} = '7826';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.coeffs{3} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.description{3} = 'SW Chan. 5 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4069: TLM8_MWCh4AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{2} = '4069';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.mnemonic{2} = 'TLM8_MWCh4AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.start_bit{2} = '7840';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.description{2} = 'MW Chan. 4 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4070: TLM8_MWCh4AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.telemetry_point_id{2} = '4070';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.mnemonic{2} = 'TLM8_MWCh4AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.start_bit{2} = '7842';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.coeffs{2} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.description{2} = 'MW Chan. 4 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4071: TLM8_MWCh5AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{2} = '4071';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.mnemonic{2} = 'TLM8_MWCh5AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.start_bit{2} = '7856';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.description{2} = 'MW Chan. 5 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4072: TLM8_MWCh5AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.telemetry_point_id{2} = '4072';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.mnemonic{2} = 'TLM8_MWCh5AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.start_bit{2} = '7858';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.coeffs{2} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.description{2} = 'MW Chan. 5 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4073: TLM8_LWCh4AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{1} = '4073';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.mnemonic{1} = 'TLM8_LWCh4AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.start_bit{1} = '7872';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.att.description{1} = 'LW Chan. 4 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4074: TLM8_LWCh4AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.telemetry_point_id{1} = '4074';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.mnemonic{1} = 'TLM8_LWCh4AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.start_bit{1} = '7874';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.coeffs{1} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.att.description{1} = 'LW Chan. 4 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4075: TLM8_LWCh5AnalogTestPoint(epoch 35 - Spare)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.telemetry_point_id{1} = '4075';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.mnemonic{1} = 'TLM8_LWCh5AnalogTestPoint(epoch 35 - Spare)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.start_bit{1} = '7888';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.att.description{1} = 'LW Chan. 5 Analog Test Point, Epoch 35 - Spare';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare.dim = {'band', 'hk8_packet'};

    % id 4076: TLM8_LWCh5AnalogTestPoint(epoch 35)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.telemetry_point_id{1} = '4076';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.mnemonic{1} = 'TLM8_LWCh5AnalogTestPoint(epoch 35)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.start_bit{1} = '7890';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.coeffs{1} = '0 -0.000611574711923848';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.att.description{1} = 'LW Chan. 5 Analog Test Point, Epoch 35';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_35.dim = {'band', 'hk8_packet'};

    % id 4077: TLM8_+150VConverterInputCurrent(sample 1 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{1} = '4077';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.start_bit{1} = '7904';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4078: TLM8_+150VConverterInputCurrent(sample 1 epoch 36)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.telemetry_point_id{1} = '4078';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 36)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.start_bit{1} = '7906';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.coeffs{1} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 36';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4079: TLM8_QuietConverterInputCurrent(sample 1 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{1} = '4079';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.start_bit{1} = '7920';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4080: TLM8_QuietConverterInputCurrent(sample 1 epoch 36)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.telemetry_point_id{1} = '4080';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 36)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.start_bit{1} = '7922';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.coeffs{1} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 36';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4081: TLM8_DigitalConverterInputCurrent(sample 1 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{1} = '4081';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.start_bit{1} = '7936';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4082: TLM8_DigitalConverterInputCurrent(sample 1 epoch 36)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.telemetry_point_id{1} = '4082';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 36)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.start_bit{1} = '7938';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.coeffs{1} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 36';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4083: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.telemetry_point_id{1} = '4083';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.start_bit{1} = '7952';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4084: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 36)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.telemetry_point_id{1} = '4084';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 36)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.start_bit{1} = '7954';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.coeffs{1} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 36';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4085: TLM8_+150VConverterInputCurrent(sample 2 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{2} = '4085';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.start_bit{2} = '7968';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4086: TLM8_+150VConverterInputCurrent(sample 2 epoch 36)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.telemetry_point_id{2} = '4086';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 36)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.start_bit{2} = '7970';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.coeffs{2} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 36';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4087: TLM8_QuietConverterInputCurrent(sample 2 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{2} = '4087';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.start_bit{2} = '7984';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4088: TLM8_QuietConverterInputCurrent(sample 2 epoch 36)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.telemetry_point_id{2} = '4088';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 36)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.start_bit{2} = '7986';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.coeffs{2} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 36';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4089: TLM8_DigitalConverterInputCurrent(sample 2 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{2} = '4089';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.start_bit{2} = '8000';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4090: TLM8_DigitalConverterInputCurrent(sample 2 epoch 36)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.telemetry_point_id{2} = '4090';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 36)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.start_bit{2} = '8002';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.coeffs{2} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 36';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4091: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.telemetry_point_id{2} = '4091';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.start_bit{2} = '8016';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4092: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 36)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.telemetry_point_id{2} = '4092';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 36)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.start_bit{2} = '8018';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.coeffs{2} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 36';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4093: TLM8_+150VConverterInputCurrent(sample 3 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{3} = '4093';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.start_bit{3} = '8032';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4094: TLM8_+150VConverterInputCurrent(sample 3 epoch 36)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.telemetry_point_id{3} = '4094';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 36)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.start_bit{3} = '8034';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.coeffs{3} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 36';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4095: TLM8_QuietConverterInputCurrent(sample 3 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{3} = '4095';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.start_bit{3} = '8048';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4096: TLM8_QuietConverterInputCurrent(sample 3 epoch 36)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.telemetry_point_id{3} = '4096';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 36)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.start_bit{3} = '8050';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.coeffs{3} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 36';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4097: TLM8_DigitalConverterInputCurrent(sample 3 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{3} = '4097';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.start_bit{3} = '8064';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4098: TLM8_DigitalConverterInputCurrent(sample 3 epoch 36)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.telemetry_point_id{3} = '4098';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 36)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.start_bit{3} = '8066';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.coeffs{3} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 36';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4099: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.telemetry_point_id{3} = '4099';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.start_bit{3} = '8080';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4100: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 36)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.telemetry_point_id{3} = '4100';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 36)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.start_bit{3} = '8082';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.coeffs{3} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 36';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4101: TLM8_+150VConverterInputCurrent(sample 4 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{4} = '4101';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.start_bit{4} = '8096';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4102: TLM8_+150VConverterInputCurrent(sample 4 epoch 36)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.telemetry_point_id{4} = '4102';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 36)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.start_bit{4} = '8098';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.coeffs{4} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 36';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4103: TLM8_QuietConverterInputCurrent(sample 4 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{4} = '4103';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.start_bit{4} = '8112';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4104: TLM8_QuietConverterInputCurrent(sample 4 epoch 36)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.telemetry_point_id{4} = '4104';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 36)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.start_bit{4} = '8114';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.coeffs{4} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 36';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4105: TLM8_DigitalConverterInputCurrent(sample 4 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.telemetry_point_id{4} = '4105';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.start_bit{4} = '8128';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4106: TLM8_DigitalConverterInputCurrent(sample 4 epoch 36)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.telemetry_point_id{4} = '4106';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 36)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.start_bit{4} = '8130';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.coeffs{4} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 36';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_36.dim = {'input_current_sample', 'hk8_packet'};

    % id 4107: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 36 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.telemetry_point_id{4} = '4107';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 36 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.start_bit{4} = '8144';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 36 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4108: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 36)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.telemetry_point_id{4} = '4108';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 36)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.start_bit{4} = '8146';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.coeffs{4} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.units{4} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 36';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4109: TLM8_+150VConverterInputCurrent(sample 1 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{1} = '4109';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.start_bit{1} = '8160';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4110: TLM8_+150VConverterInputCurrent(sample 1 epoch 39)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.telemetry_point_id{1} = '4110';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 39)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.start_bit{1} = '8162';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.coeffs{1} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 39';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4111: TLM8_QuietConverterInputCurrent(sample 1 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{1} = '4111';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.start_bit{1} = '8176';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4112: TLM8_QuietConverterInputCurrent(sample 1 epoch 39)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.telemetry_point_id{1} = '4112';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 39)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.start_bit{1} = '8178';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.coeffs{1} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 39';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4113: TLM8_DigitalConverterInputCurrent(sample 1 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{1} = '4113';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.start_bit{1} = '8192';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4114: TLM8_DigitalConverterInputCurrent(sample 1 epoch 39)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.telemetry_point_id{1} = '4114';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 39)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.start_bit{1} = '8194';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.coeffs{1} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 39';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4115: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.telemetry_point_id{1} = '4115';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.start_bit{1} = '8208';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4116: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 39)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.telemetry_point_id{1} = '4116';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 39)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.start_bit{1} = '8210';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.coeffs{1} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 39';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4117: TLM8_StructureThermalControlSetpoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39_Spare.att.telemetry_point_id = '4117';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39_Spare.att.mnemonic = 'TLM8_StructureThermalControlSetpoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39_Spare.att.start_bit = '8224';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39_Spare.att.description = 'Structure Thermal Ctrl Setpoint, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4118: TLM8_StructureThermalControlSetpoint(epoch 39)
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39.att.telemetry_point_id = '4118';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39.att.mnemonic = 'TLM8_StructureThermalControlSetpoint(epoch 39)';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39.att.start_bit = '8226';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39.att.coeffs = '2.474285000E+01 -5.248439300E-03 1.986854800E-07 -1.996470200E-11';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39.att.description = 'Structure Thermal Ctrl Setpoint, Epoch 39';
    g_metadata.packets.instr_hk8.StructureThermalControlSetpoint_epoch_39.dim = {'hk8_packet'};

    % id 4119: TLM8_Stage1OperationalHeaterSetpoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39_Spare.att.telemetry_point_id = '4119';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39_Spare.att.mnemonic = 'TLM8_Stage1OperationalHeaterSetpoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39_Spare.att.start_bit = '8240';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39_Spare.att.description = 'Stage1 Operational Heater Setpoint, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4120: TLM8_Stage1OperationalHeaterSetpoint(epoch 39)
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39.att.telemetry_point_id = '4120';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39.att.mnemonic = 'TLM8_Stage1OperationalHeaterSetpoint(epoch 39)';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39.att.start_bit = '8242';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39.att.coeffs = '24.3222 0.030378';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39.att.units = '°K';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39.att.description = 'Stage1 Operational Heater Setpoint, Epoch 39';
    g_metadata.packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39.dim = {'hk8_packet'};

    % id 4121: TLM8_Stage3OperationalHeaterSetpoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39_Spare.att.telemetry_point_id = '4121';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39_Spare.att.mnemonic = 'TLM8_Stage3OperationalHeaterSetpoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39_Spare.att.start_bit = '8256';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39_Spare.att.description = 'Stage3 Operational Heater Setpoint, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4122: TLM8_Stage3OperationalHeaterSetpoint(epoch 39)
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39.att.telemetry_point_id = '4122';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39.att.mnemonic = 'TLM8_Stage3OperationalHeaterSetpoint(epoch 39)';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39.att.start_bit = '8258';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39.att.coeffs = '3.33441070E+01 9.85696510E-03';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39.att.units = '°K';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39.att.description = 'Stage3 Operational Heater Setpoint, Epoch 39';
    g_metadata.packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39.dim = {'hk8_packet'};

    % id 4123: TLM8_Stage4OperationalHeaterSetpoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39_Spare.att.telemetry_point_id = '4123';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39_Spare.att.mnemonic = 'TLM8_Stage4OperationalHeaterSetpoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39_Spare.att.start_bit = '8272';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39_Spare.att.description = 'Stage4 Operational Heater Setpoint, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4124: TLM8_Stage4OperationalHeaterSetpoint(epoch 39)
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39.att.telemetry_point_id = '4124';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39.att.mnemonic = 'TLM8_Stage4OperationalHeaterSetpoint(epoch 39)';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39.att.start_bit = '8274';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39.att.coeffs = '3.3483830E+01 7.29038720E-03';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39.att.units = '°K';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39.att.description = 'Stage4 Operational Heater Setpoint, Epoch 39';
    g_metadata.packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39.dim = {'hk8_packet'};

    % id 4125: TLM8_+150VConverterInputCurrent(sample 2 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{2} = '4125';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.start_bit{2} = '8288';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4126: TLM8_+150VConverterInputCurrent(sample 2 epoch 39)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.telemetry_point_id{2} = '4126';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 39)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.start_bit{2} = '8290';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.coeffs{2} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 39';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4127: TLM8_QuietConverterInputCurrent(sample 2 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{2} = '4127';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.start_bit{2} = '8304';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4128: TLM8_QuietConverterInputCurrent(sample 2 epoch 39)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.telemetry_point_id{2} = '4128';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 39)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.start_bit{2} = '8306';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.coeffs{2} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 39';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4129: TLM8_DigitalConverterInputCurrent(sample 2 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{2} = '4129';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.start_bit{2} = '8320';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4130: TLM8_DigitalConverterInputCurrent(sample 2 epoch 39)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.telemetry_point_id{2} = '4130';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 39)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.start_bit{2} = '8322';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.coeffs{2} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 39';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4131: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.telemetry_point_id{2} = '4131';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.start_bit{2} = '8336';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4132: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 39)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.telemetry_point_id{2} = '4132';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 39)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.start_bit{2} = '8338';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.coeffs{2} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 39';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4133: TLM8_PCEElectronicsModuleTemp#1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39_Spare.att.telemetry_point_id = '4133';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39_Spare.att.mnemonic = 'TLM8_PCEElectronicsModuleTemp#1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39_Spare.att.start_bit = '8352';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39_Spare.att.description = 'PCE Module Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4134: TLM8_PCEElectronicsModuleTemp#1(epoch 39)
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39.att.telemetry_point_id = '4134';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39.att.mnemonic = 'TLM8_PCEElectronicsModuleTemp#1(epoch 39)';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39.att.start_bit = '8354';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39.att.description = 'PCE Module Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39.dim = {'hk8_packet'};

    % id 4135: TLM8_PCEStructureHeaterTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39_Spare.att.telemetry_point_id = '4135';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39_Spare.att.mnemonic = 'TLM8_PCEStructureHeaterTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39_Spare.att.start_bit = '8368';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39_Spare.att.description = 'PCE Structure Heater Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4136: TLM8_PCEStructureHeaterTemp(epoch 39)
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39.att.telemetry_point_id = '4136';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39.att.mnemonic = 'TLM8_PCEStructureHeaterTemp(epoch 39)';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39.att.start_bit = '8370';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39.att.coeffs = '2.4742850E+01 -5.24843930E-03 1.98685480E-07 -1.99647020E-11';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39.att.description = 'PCE Structure Heater Temp, Epoch 39';
    g_metadata.packets.instr_hk8.PCEStructureHeaterTemp_epoch_39.dim = {'hk8_packet'};

    % id 4137: TLM8_PCEElectronicsModuleTemp#3(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39_Spare.att.telemetry_point_id = '4137';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39_Spare.att.mnemonic = 'TLM8_PCEElectronicsModuleTemp#3(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39_Spare.att.start_bit = '8384';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39_Spare.att.description = 'PCE Module Temp 3, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4138: TLM8_PCEElectronicsModuleTemp#3(epoch 39)
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39.att.telemetry_point_id = '4138';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39.att.mnemonic = 'TLM8_PCEElectronicsModuleTemp#3(epoch 39)';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39.att.start_bit = '8386';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39.att.description = 'PCE Module Temp 3, Epoch 39';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39.dim = {'hk8_packet'};

    % id 4139: TLM8_Stage1OutgasTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.telemetry_point_id{1} = '4139';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.mnemonic{1} = 'TLM8_Stage1OutgasTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.start_bit{1} = '8400';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.description{1} = 'Stage1 Outgas Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.dim = {'stage', 'hk8_packet'};

    % id 4140: TLM8_Stage1OutgasTemp(epoch 39)
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.telemetry_point_id{1} = '4140';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.mnemonic{1} = 'TLM8_Stage1OutgasTemp(epoch 39)';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.start_bit{1} = '8402';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.coeffs{1} = '3.45676220E+01 3.3764090E-02 4.80655720E-07 -1.22226460E-11';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.units{1} = '°K';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.description{1} = 'Stage1 Outgas Temp, Epoch 39';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.dim = {'stage', 'hk8_packet'};

    % id 4141: TLM8_PCEElectronicsModuleTemp#2(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39_Spare.att.telemetry_point_id = '4141';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39_Spare.att.mnemonic = 'TLM8_PCEElectronicsModuleTemp#2(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39_Spare.att.start_bit = '8416';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39_Spare.att.description = 'PCE Module Temp 2, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4142: TLM8_PCEElectronicsModuleTemp#2(epoch 39)
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39.att.telemetry_point_id = '4142';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39.att.mnemonic = 'TLM8_PCEElectronicsModuleTemp#2(epoch 39)';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39.att.start_bit = '8418';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39.att.description = 'PCE Module Temp 2, Epoch 39';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39.dim = {'hk8_packet'};

    % id 4143: TLM8_Stage3OutgasTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.telemetry_point_id{3} = '4143';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.mnemonic{3} = 'TLM8_Stage3OutgasTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.start_bit{3} = '8432';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.description{3} = 'Stage3 Outgas Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.dim = {'stage', 'hk8_packet'};

    % id 4144: TLM8_Stage3OutgasTemp(epoch 39)
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.telemetry_point_id{3} = '4144';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.mnemonic{3} = 'TLM8_Stage3OutgasTemp(epoch 39)';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.start_bit{3} = '8434';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.coeffs{3} = '3.45676220E+01 3.3764090E-02 4.80655720E-07 -1.22226460E-11';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.units{3} = '°K';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.description{3} = 'Stage3 Outgas Temp, Epoch 39';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.dim = {'stage', 'hk8_packet'};

    % id 4145: TLM8_PCEElectronicsModuleTemp#4(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39_Spare.att.telemetry_point_id = '4145';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39_Spare.att.mnemonic = 'TLM8_PCEElectronicsModuleTemp#4(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39_Spare.att.start_bit = '8448';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39_Spare.att.description = 'PCE Module Temp 4, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4146: TLM8_PCEElectronicsModuleTemp#4(epoch 39)
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39.att.telemetry_point_id = '4146';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39.att.mnemonic = 'TLM8_PCEElectronicsModuleTemp#4(epoch 39)';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39.att.start_bit = '8450';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39.att.description = 'PCE Module Temp 4, Epoch 39';
    g_metadata.packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39.dim = {'hk8_packet'};

    % id 4147: TLM8_Stage4OutgasTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.telemetry_point_id{4} = '4147';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.mnemonic{4} = 'TLM8_Stage4OutgasTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.start_bit{4} = '8464';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.description{4} = 'Stage4 Outgas Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.dim = {'stage', 'hk8_packet'};

    % id 4148: TLM8_Stage4OutgasTemp(epoch 39)
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.telemetry_point_id{4} = '4148';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.mnemonic{4} = 'TLM8_Stage4OutgasTemp(epoch 39)';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.start_bit{4} = '8466';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.coeffs{4} = '3.45676220E+01 3.3764090E-02 4.80655720E-07 -1.22226460E-11';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.units{4} = '°K';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.description{4} = 'Stage4 Outgas Temp, Epoch 39';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.dim = {'stage', 'hk8_packet'};

    % id 4149: TLM8_Stage2OutgasTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.telemetry_point_id{2} = '4149';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.mnemonic{2} = 'TLM8_Stage2OutgasTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.start_bit{2} = '8480';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.att.description{2} = 'Stage2 Outgas Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39_Spare.dim = {'stage', 'hk8_packet'};

    % id 4150: TLM8_Stage2OutgasTemp(epoch 39)
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.telemetry_point_id{2} = '4150';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.mnemonic{2} = 'TLM8_Stage2OutgasTemp(epoch 39)';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.start_bit{2} = '8482';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.coeffs{2} = '70.7661 0.0286777 0.00000033213 -0.0000000000380786 2.04113E-15 -4.20953E-20';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.units{2} = '°K';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.att.description{2} = 'Stage2 Outgas Temp, Epoch 39';
    g_metadata.packets.instr_hk8.OutgasTemp_epoch_39.dim = {'stage', 'hk8_packet'};

    % id 4151: TLM8_Stage1CoolerTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39_Spare.att.telemetry_point_id = '4151';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39_Spare.att.mnemonic = 'TLM8_Stage1CoolerTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39_Spare.att.start_bit = '8496';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39_Spare.att.description = 'Stage1 Cooler Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4152: TLM8_Stage1CoolerTemp(epoch 39)
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39.att.telemetry_point_id = '4152';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39.att.mnemonic = 'TLM8_Stage1CoolerTemp(epoch 39)';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39.att.start_bit = '8498';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39.att.coeffs = '2.5544758E+01 3.0142016E-02';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39.att.units = '°K';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39.att.description = 'Stage1 Cooler Temp, Epoch 39';
    g_metadata.packets.instr_hk8.Stage1CoolerTemp_epoch_39.dim = {'hk8_packet'};

    % id 4153: TLM8_Stage4CoolerTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39_Spare.att.telemetry_point_id = '4153';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39_Spare.att.mnemonic = 'TLM8_Stage4CoolerTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39_Spare.att.start_bit = '8512';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39_Spare.att.description = 'Stage4 Cooler Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4154: TLM8_Stage4CoolerTemp(epoch 39)
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39.att.telemetry_point_id = '4154';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39.att.mnemonic = 'TLM8_Stage4CoolerTemp(epoch 39)';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39.att.start_bit = '8514';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39.att.coeffs = '3.348383E+01 7.2903872E-03';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39.att.units = '°K';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39.att.description = 'Stage4 Cooler Temp, Epoch 39';
    g_metadata.packets.instr_hk8.Stage4CoolerTemp_epoch_39.dim = {'hk8_packet'};

    % id 4155: TLM8_Stage3CoolerTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39_Spare.att.telemetry_point_id = '4155';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39_Spare.att.mnemonic = 'TLM8_Stage3CoolerTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39_Spare.att.start_bit = '8528';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39_Spare.att.description = 'Stage3 Cooler Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4156: TLM8_Stage3CoolerTemp(epoch 39)
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39.att.telemetry_point_id = '4156';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39.att.mnemonic = 'TLM8_Stage3CoolerTemp(epoch 39)';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39.att.start_bit = '8530';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39.att.coeffs = '3.3344107E+01 9.8569651E-03';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39.att.units = '°K';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39.att.description = 'Stage3 Cooler Temp, Epoch 39';
    g_metadata.packets.instr_hk8.Stage3CoolerTemp_epoch_39.dim = {'hk8_packet'};

    % id 4157: TLM8_StructureModuleBaseplateTemp#2(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39_Spare.att.telemetry_point_id = '4157';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39_Spare.att.mnemonic = 'TLM8_StructureModuleBaseplateTemp#2(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39_Spare.att.start_bit = '8544';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39_Spare.att.description = 'Structure Module Baseplate Temp 2, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4158: TLM8_StructureModuleBaseplateTemp#2(epoch 39)
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39.att.telemetry_point_id = '4158';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39.att.mnemonic = 'TLM8_StructureModuleBaseplateTemp#2(epoch 39)';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39.att.start_bit = '8546';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39.att.description = 'Structure Module Baseplate Temp 2, Epoch 39';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39.dim = {'hk8_packet'};

    % id 4159: TLM8_StructureModuleBaseplateTemp#1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39_Spare.att.telemetry_point_id = '4159';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39_Spare.att.mnemonic = 'TLM8_StructureModuleBaseplateTemp#1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39_Spare.att.start_bit = '8560';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39_Spare.att.description = 'Structure Module Baseplate Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4160: TLM8_StructureModuleBaseplateTemp#1(epoch 39)
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39.att.telemetry_point_id = '4160';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39.att.mnemonic = 'TLM8_StructureModuleBaseplateTemp#1(epoch 39)';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39.att.start_bit = '8562';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39.att.description = 'Structure Module Baseplate Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39.dim = {'hk8_packet'};

    % id 4161: TLM8_StructureModuleBaseplateTemp#4(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39_Spare.att.telemetry_point_id = '4161';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39_Spare.att.mnemonic = 'TLM8_StructureModuleBaseplateTemp#4(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39_Spare.att.start_bit = '8576';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39_Spare.att.description = 'Structure Module Baseplate Temp 4, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4162: TLM8_StructureModuleBaseplateTemp#4(epoch 39)
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39.att.telemetry_point_id = '4162';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39.att.mnemonic = 'TLM8_StructureModuleBaseplateTemp#4(epoch 39)';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39.att.start_bit = '8578';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39.att.description = 'Structure Module Baseplate Temp 4, Epoch 39';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39.dim = {'hk8_packet'};

    % id 4163: TLM8_StructureModuleBaseplateTemp#3(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39_Spare.att.telemetry_point_id = '4163';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39_Spare.att.mnemonic = 'TLM8_StructureModuleBaseplateTemp#3(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39_Spare.att.start_bit = '8592';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39_Spare.att.description = 'Structure Module Baseplate Temp 3, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4164: TLM8_StructureModuleBaseplateTemp#3(epoch 39)
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39.att.telemetry_point_id = '4164';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39.att.mnemonic = 'TLM8_StructureModuleBaseplateTemp#3(epoch 39)';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39.att.start_bit = '8594';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39.att.description = 'Structure Module Baseplate Temp 3, Epoch 39';
    g_metadata.packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39.dim = {'hk8_packet'};

    % id 4165: TLM8_StructureModulePCETemp1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39_Spare.att.telemetry_point_id = '4165';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39_Spare.att.mnemonic = 'TLM8_StructureModulePCETemp1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39_Spare.att.start_bit = '8608';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39_Spare.att.description = 'Structure Module PCE Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4166: TLM8_StructureModulePCETemp1(epoch 39)
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39.att.telemetry_point_id = '4166';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39.att.mnemonic = 'TLM8_StructureModulePCETemp1(epoch 39)';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39.att.start_bit = '8610';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39.att.description = 'Structure Module PCE Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.StructureModulePCETemp1_epoch_39.dim = {'hk8_packet'};

    % id 4167: TLM8_ICTStructureTemp#1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39_Spare.att.telemetry_point_id = '4167';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39_Spare.att.mnemonic = 'TLM8_ICTStructureTemp#1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39_Spare.att.start_bit = '8624';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39_Spare.att.description = 'Internal Cal. Target Structure Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4168: TLM8_ICTStructureTemp#1(epoch 39)
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39.att.telemetry_point_id = '4168';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39.att.mnemonic = 'TLM8_ICTStructureTemp#1(epoch 39)';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39.att.start_bit = '8626';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39.att.description = 'Internal Cal. Target Structure Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.ICTStructureTemp_1_epoch_39.dim = {'hk8_packet'};

    % id 4169: TLM8_StructureModulePCETemp2(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39_Spare.att.telemetry_point_id = '4169';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39_Spare.att.mnemonic = 'TLM8_StructureModulePCETemp2(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39_Spare.att.start_bit = '8640';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39_Spare.att.description = 'Structure Module PCE Temp 2, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4170: TLM8_StructureModulePCETemp2(epoch 39)
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39.att.telemetry_point_id = '4170';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39.att.mnemonic = 'TLM8_StructureModulePCETemp2(epoch 39)';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39.att.start_bit = '8642';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39.att.description = 'Structure Module PCE Temp 2, Epoch 39';
    g_metadata.packets.instr_hk8.StructureModulePCETemp2_epoch_39.dim = {'hk8_packet'};

    % id 4171: TLM8_ICTStructureTemp#2(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39_Spare.att.telemetry_point_id = '4171';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39_Spare.att.mnemonic = 'TLM8_ICTStructureTemp#2(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39_Spare.att.start_bit = '8656';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39_Spare.att.description = 'Internal Cal. Target Structure Temp 2, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4172: TLM8_ICTStructureTemp#2(epoch 39)
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39.att.telemetry_point_id = '4172';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39.att.mnemonic = 'TLM8_ICTStructureTemp#2(epoch 39)';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39.att.start_bit = '8658';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39.att.description = 'Internal Cal. Target Structure Temp 2, Epoch 39';
    g_metadata.packets.instr_hk8.ICTStructureTemp_2_epoch_39.dim = {'hk8_packet'};

    % id 4173: TLM8_StructureModulePCETemp3(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39_Spare.att.telemetry_point_id = '4173';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39_Spare.att.mnemonic = 'TLM8_StructureModulePCETemp3(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39_Spare.att.start_bit = '8672';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39_Spare.att.description = 'Structure Module PCE Temp 3, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4174: TLM8_StructureModulePCETemp3(epoch 39)
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39.att.telemetry_point_id = '4174';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39.att.mnemonic = 'TLM8_StructureModulePCETemp3(epoch 39)';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39.att.start_bit = '8674';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39.att.description = 'Structure Module PCE Temp 3, Epoch 39';
    g_metadata.packets.instr_hk8.StructureModulePCETemp3_epoch_39.dim = {'hk8_packet'};

    % id 4175: TLM8_TelescopeTemp#1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39_Spare.att.telemetry_point_id = '4175';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39_Spare.att.mnemonic = 'TLM8_TelescopeTemp#1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39_Spare.att.start_bit = '8688';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39_Spare.att.description = 'Telescope Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4176: TLM8_TelescopeTemp#1(epoch 39)
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39.att.telemetry_point_id = '4176';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39.att.mnemonic = 'TLM8_TelescopeTemp#1(epoch 39)';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39.att.start_bit = '8690';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39.att.description = 'Telescope Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.TelescopeTemp_1_epoch_39.dim = {'hk8_packet'};

    % id 4177: TLM8_StructureModuleSSMTemp#1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39_Spare.att.telemetry_point_id = '4177';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39_Spare.att.mnemonic = 'TLM8_StructureModuleSSMTemp#1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39_Spare.att.start_bit = '8704';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39_Spare.att.description = 'Structure Module SSM Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4178: TLM8_StructureModuleSSMTemp#1(epoch 39)
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39.att.telemetry_point_id = '4178';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39.att.mnemonic = 'TLM8_StructureModuleSSMTemp#1(epoch 39)';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39.att.start_bit = '8706';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39.att.description = 'Structure Module SSM Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39.dim = {'hk8_packet'};

    % id 4179: TLM8_OpticalBenchTemp1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39_Spare.att.telemetry_point_id = '4179';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39_Spare.att.mnemonic = 'TLM8_OpticalBenchTemp1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39_Spare.att.start_bit = '8720';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39_Spare.att.description = 'Optical Bench Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4180: TLM8_OpticalBenchTemp1(epoch 39)
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39.att.telemetry_point_id = '4180';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39.att.mnemonic = 'TLM8_OpticalBenchTemp1(epoch 39)';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39.att.start_bit = '8722';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39.att.description = 'Optical Bench Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.OpticalBenchTemp1_epoch_39.dim = {'hk8_packet'};

    % id 4181: TLM8_StructureModuleSSMTemp#2(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39_Spare.att.telemetry_point_id = '4181';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39_Spare.att.mnemonic = 'TLM8_StructureModuleSSMTemp#2(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39_Spare.att.start_bit = '8736';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39_Spare.att.description = 'Structure Module SSM Temp 2, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4182: TLM8_StructureModuleSSMTemp#2(epoch 39)
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39.att.telemetry_point_id = '4182';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39.att.mnemonic = 'TLM8_StructureModuleSSMTemp#2(epoch 39)';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39.att.start_bit = '8738';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39.att.description = 'Structure Module SSM Temp 2, Epoch 39';
    g_metadata.packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39.dim = {'hk8_packet'};

    % id 4183: TLM8_OpticalBenchTemp2(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39_Spare.att.telemetry_point_id = '4183';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39_Spare.att.mnemonic = 'TLM8_OpticalBenchTemp2(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39_Spare.att.start_bit = '8752';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39_Spare.att.description = 'Optical Bench Temp 2, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4184: TLM8_OpticalBenchTemp2(epoch 39)
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39.att.telemetry_point_id = '4184';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39.att.mnemonic = 'TLM8_OpticalBenchTemp2(epoch 39)';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39.att.start_bit = '8754';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39.att.description = 'Optical Bench Temp 2, Epoch 39';
    g_metadata.packets.instr_hk8.OpticalBenchTemp2_epoch_39.dim = {'hk8_packet'};

    % id 4185: TLM8_PCEHousingTemp#1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39_Spare.att.telemetry_point_id = '4185';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39_Spare.att.mnemonic = 'TLM8_PCEHousingTemp#1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39_Spare.att.start_bit = '8768';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39_Spare.att.description = 'PCE Housing Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4186: TLM8_PCEHousingTemp#1(epoch 39)
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39.att.telemetry_point_id = '4186';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39.att.mnemonic = 'TLM8_PCEHousingTemp#1(epoch 39)';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39.att.start_bit = '8770';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39.att.description = 'PCE Housing Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.PCEHousingTemp_1_epoch_39.dim = {'hk8_packet'};

    % id 4187: TLM8_Spare1(epoch 39)
    g_metadata.packets.instr_hk8.Spare1_epoch_39.att.telemetry_point_id = '4187';
    g_metadata.packets.instr_hk8.Spare1_epoch_39.att.mnemonic = 'TLM8_Spare1(epoch 39)';
    g_metadata.packets.instr_hk8.Spare1_epoch_39.att.start_bit = '8784';
    g_metadata.packets.instr_hk8.Spare1_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Spare1_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Spare1_epoch_39.att.description = 'Spare bits';
    g_metadata.packets.instr_hk8.Spare1_epoch_39.dim = {'hk8_packet'};

    % id 4189: TLM8_PCEHousingTemp#2(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39_Spare.att.telemetry_point_id = '4189';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39_Spare.att.mnemonic = 'TLM8_PCEHousingTemp#2(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39_Spare.att.start_bit = '8800';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39_Spare.att.description = 'PCE Housing Temp 2, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4190: TLM8_PCEHousingTemp#2(epoch 39)
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39.att.telemetry_point_id = '4190';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39.att.mnemonic = 'TLM8_PCEHousingTemp#2(epoch 39)';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39.att.start_bit = '8802';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39.att.description = 'PCE Housing Temp 2, Epoch 39';
    g_metadata.packets.instr_hk8.PCEHousingTemp_2_epoch_39.dim = {'hk8_packet'};

    % id 4191: TLM8_Spare2(epoch 39)
    g_metadata.packets.instr_hk8.Spare2_epoch_39.att.telemetry_point_id = '4191';
    g_metadata.packets.instr_hk8.Spare2_epoch_39.att.mnemonic = 'TLM8_Spare2(epoch 39)';
    g_metadata.packets.instr_hk8.Spare2_epoch_39.att.start_bit = '8816';
    g_metadata.packets.instr_hk8.Spare2_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Spare2_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Spare2_epoch_39.att.description = 'Spare Bits';
    g_metadata.packets.instr_hk8.Spare2_epoch_39.dim = {'hk8_packet'};

    % id 4193: TLM8_PCEHousingTemp#3(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39_Spare.att.telemetry_point_id = '4193';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39_Spare.att.mnemonic = 'TLM8_PCEHousingTemp#3(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39_Spare.att.start_bit = '8832';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39_Spare.att.description = 'PCE Housing Temp 3, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4194: TLM8_PCEHousingTemp#3(epoch 39)
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39.att.telemetry_point_id = '4194';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39.att.mnemonic = 'TLM8_PCEHousingTemp#3(epoch 39)';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39.att.start_bit = '8834';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39.att.description = 'PCE Housing Temp 3, Epoch 39';
    g_metadata.packets.instr_hk8.PCEHousingTemp_3_epoch_39.dim = {'hk8_packet'};

    % id 4195: TLM8_Spare3(epoch 39)
    g_metadata.packets.instr_hk8.Spare3_epoch_39.att.telemetry_point_id = '4195';
    g_metadata.packets.instr_hk8.Spare3_epoch_39.att.mnemonic = 'TLM8_Spare3(epoch 39)';
    g_metadata.packets.instr_hk8.Spare3_epoch_39.att.start_bit = '8848';
    g_metadata.packets.instr_hk8.Spare3_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Spare3_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Spare3_epoch_39.att.description = 'Spare Bits';
    g_metadata.packets.instr_hk8.Spare3_epoch_39.dim = {'hk8_packet'};

    % id 4197: TLM8_150VConverterTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39_Spare.att.telemetry_point_id = '4197';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39_Spare.att.mnemonic = 'TLM8_150VConverterTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39_Spare.att.start_bit = '8864';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39_Spare.att.description = '150V Converter Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4198: TLM8_150VConverterTemp(epoch 39)
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39.att.telemetry_point_id = '4198';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39.att.mnemonic = 'TLM8_150VConverterTemp(epoch 39)';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39.att.start_bit = '8866';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39.att.description = '150V Converter Temp, Epoch 39';
    g_metadata.packets.instr_hk8.x150VConverterTemp_epoch_39.dim = {'hk8_packet'};

    % id 4199: TLM8_PCEStructureHeaterCurrent(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39_Spare.att.telemetry_point_id = '4199';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39_Spare.att.mnemonic = 'TLM8_PCEStructureHeaterCurrent(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39_Spare.att.start_bit = '8880';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39_Spare.att.description = 'PCE Structure Heater Current, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4200: TLM8_PCEStructureHeaterCurrent(epoch 39)
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39.att.telemetry_point_id = '4200';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39.att.mnemonic = 'TLM8_PCEStructureHeaterCurrent(epoch 39)';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39.att.start_bit = '8882';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39.att.coeffs = '0 0.000117828486969112';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39.att.units = 'Amps';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39.att.description = 'PCE Structure Heater Current, Epoch 39';
    g_metadata.packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39.dim = {'hk8_packet'};

    % id 4201: TLM8_IFCCCATemp#1(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39_Spare.att.telemetry_point_id = '4201';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39_Spare.att.mnemonic = 'TLM8_IFCCCATemp#1(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39_Spare.att.start_bit = '8896';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39_Spare.att.description = 'IFC CCA Temp 1, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4202: TLM8_IFCCCATemp#1(epoch 39)
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39.att.telemetry_point_id = '4202';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39.att.mnemonic = 'TLM8_IFCCCATemp#1(epoch 39)';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39.att.start_bit = '8898';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39.att.description = 'IFC CCA Temp 1, Epoch 39';
    g_metadata.packets.instr_hk8.IFCCCATemp_1_epoch_39.dim = {'hk8_packet'};

    % id 4203: TLM8_OutgasHeaterVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39_Spare.att.telemetry_point_id = '4203';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_OutgasHeaterVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39_Spare.att.start_bit = '8912';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39_Spare.att.description = 'Outgas Heater Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4204: TLM8_OutgasHeaterVoltage(epoch 39)
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39.att.telemetry_point_id = '4204';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39.att.mnemonic = 'TLM8_OutgasHeaterVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39.att.start_bit = '8914';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39.att.coeffs = '0 1.98480937E-02';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39.att.description = 'Outgas Heater Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.OutgasHeaterVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4205: TLM8_+150VConverterInputCurrent(sample 3 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{3} = '4205';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.start_bit{3} = '8928';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4206: TLM8_+150VConverterInputCurrent(sample 3 epoch 39)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.telemetry_point_id{3} = '4206';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 39)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.start_bit{3} = '8930';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.coeffs{3} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 39';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4207: TLM8_QuietConverterInputCurrent(sample 3 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{3} = '4207';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.start_bit{3} = '8944';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4208: TLM8_QuietConverterInputCurrent(sample 3 epoch 39)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.telemetry_point_id{3} = '4208';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 39)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.start_bit{3} = '8946';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.coeffs{3} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 39';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4209: TLM8_DigitalConverterInputCurrent(sample 3 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{3} = '4209';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.start_bit{3} = '8960';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4210: TLM8_DigitalConverterInputCurrent(sample 3 epoch 39)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.telemetry_point_id{3} = '4210';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 39)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.start_bit{3} = '8962';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.coeffs{3} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 39';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4211: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.telemetry_point_id{3} = '4211';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.start_bit{3} = '8976';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4212: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 39)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.telemetry_point_id{3} = '4212';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 39)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.start_bit{3} = '8978';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.coeffs{3} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 39';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4213: TLM8_DigitalConverterTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39_Spare.att.telemetry_point_id = '4213';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39_Spare.att.mnemonic = 'TLM8_DigitalConverterTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39_Spare.att.start_bit = '8992';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39_Spare.att.description = 'Digital Converter Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4214: TLM8_DigitalConverterTemp(epoch 39)
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39.att.telemetry_point_id = '4214';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39.att.mnemonic = 'TLM8_DigitalConverterTemp(epoch 39)';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39.att.start_bit = '8994';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39.att.description = 'Digital Converter Temp, Epoch 39';
    g_metadata.packets.instr_hk8.DigitalConverterTemp_epoch_39.dim = {'hk8_packet'};

    % id 4215: TLM8_Spare1
    g_metadata.packets.instr_hk8.Spare1.att.telemetry_point_id = '4215';
    g_metadata.packets.instr_hk8.Spare1.att.mnemonic = 'TLM8_Spare1';
    g_metadata.packets.instr_hk8.Spare1.att.start_bit = '9008';
    g_metadata.packets.instr_hk8.Spare1.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Spare1.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Spare1.att.description = 'Spare';
    g_metadata.packets.instr_hk8.Spare1.dim = {'hk8_packet'};

    % id 4216: TLM8_(Reserved1)
    g_metadata.packets.instr_hk8.Reserved1.att.telemetry_point_id = '4216';
    g_metadata.packets.instr_hk8.Reserved1.att.mnemonic = 'TLM8_(Reserved1)';
    g_metadata.packets.instr_hk8.Reserved1.att.start_bit = '9010';
    g_metadata.packets.instr_hk8.Reserved1.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Reserved1.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Reserved1.att.units = 'Volts';
    g_metadata.packets.instr_hk8.Reserved1.att.description = 'Reserved';
    g_metadata.packets.instr_hk8.Reserved1.dim = {'hk8_packet'};

    % id 4217: TLM8_QuietConverterTemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39_Spare.att.telemetry_point_id = '4217';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39_Spare.att.mnemonic = 'TLM8_QuietConverterTemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39_Spare.att.start_bit = '9024';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39_Spare.att.description = 'Quiet Converter Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4218: TLM8_QuietConverterTemp(epoch 39)
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39.att.telemetry_point_id = '4218';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39.att.mnemonic = 'TLM8_QuietConverterTemp(epoch 39)';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39.att.start_bit = '9026';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39.att.description = 'Quiet Converter Temp, Epoch 39';
    g_metadata.packets.instr_hk8.QuietConverterTemp_epoch_39.dim = {'hk8_packet'};

    % id 4219: TLM8_Spare2
    g_metadata.packets.instr_hk8.Spare2.att.telemetry_point_id = '4219';
    g_metadata.packets.instr_hk8.Spare2.att.mnemonic = 'TLM8_Spare2';
    g_metadata.packets.instr_hk8.Spare2.att.start_bit = '9040';
    g_metadata.packets.instr_hk8.Spare2.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Spare2.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Spare2.att.description = 'Spare';
    g_metadata.packets.instr_hk8.Spare2.dim = {'hk8_packet'};

    % id 4220: TLM8_(Reserved2)
    g_metadata.packets.instr_hk8.Reserved2.att.telemetry_point_id = '4220';
    g_metadata.packets.instr_hk8.Reserved2.att.mnemonic = 'TLM8_(Reserved2)';
    g_metadata.packets.instr_hk8.Reserved2.att.start_bit = '9042';
    g_metadata.packets.instr_hk8.Reserved2.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Reserved2.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Reserved2.att.units = 'Volts';
    g_metadata.packets.instr_hk8.Reserved2.att.description = 'Reserved';
    g_metadata.packets.instr_hk8.Reserved2.dim = {'hk8_packet'};

    % id 4221: TLM8_HousekeepingCCATemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39_Spare.att.telemetry_point_id = '4221';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39_Spare.att.mnemonic = 'TLM8_HousekeepingCCATemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39_Spare.att.start_bit = '9056';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39_Spare.att.description = 'HK CCA Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4222: TLM8_HousekeepingCCATemp(epoch 39)
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39.att.telemetry_point_id = '4222';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39.att.mnemonic = 'TLM8_HousekeepingCCATemp(epoch 39)';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39.att.start_bit = '9058';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39.att.description = 'HK CCA Temp, Epoch 39';
    g_metadata.packets.instr_hk8.HousekeepingCCATemp_epoch_39.dim = {'hk8_packet'};

    % id 4223: TLM8_Spare3
    g_metadata.packets.instr_hk8.Spare3.att.telemetry_point_id = '4223';
    g_metadata.packets.instr_hk8.Spare3.att.mnemonic = 'TLM8_Spare3';
    g_metadata.packets.instr_hk8.Spare3.att.start_bit = '9072';
    g_metadata.packets.instr_hk8.Spare3.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Spare3.att.num_bits = '2';
    g_metadata.packets.instr_hk8.Spare3.att.description = 'Spare';
    g_metadata.packets.instr_hk8.Spare3.dim = {'hk8_packet'};

    % id 4224: TLM8_(Reserved3)
    g_metadata.packets.instr_hk8.Reserved3.att.telemetry_point_id = '4224';
    g_metadata.packets.instr_hk8.Reserved3.att.mnemonic = 'TLM8_(Reserved3)';
    g_metadata.packets.instr_hk8.Reserved3.att.start_bit = '9074';
    g_metadata.packets.instr_hk8.Reserved3.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.Reserved3.att.num_bits = '14';
    g_metadata.packets.instr_hk8.Reserved3.att.units = 'Volts';
    g_metadata.packets.instr_hk8.Reserved3.att.description = 'Reserved';
    g_metadata.packets.instr_hk8.Reserved3.dim = {'hk8_packet'};

    % id 4225: TLM8_SignalProcessor#1Temp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39_Spare.att.telemetry_point_id = '4225';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39_Spare.att.mnemonic = 'TLM8_SignalProcessor#1Temp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39_Spare.att.start_bit = '9088';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39_Spare.att.description = 'Signal Processor 1 Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4226: TLM8_SignalProcessor#1Temp(epoch 39)
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39.att.telemetry_point_id = '4226';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39.att.mnemonic = 'TLM8_SignalProcessor#1Temp(epoch 39)';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39.att.start_bit = '9090';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39.att.description = 'Signal Processor 1 Temp, Epoch 39';
    g_metadata.packets.instr_hk8.SignalProcessor_1Temp_epoch_39.dim = {'hk8_packet'};

    % id 4227: TLM8_+1.5SWFPGACoreVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.telemetry_point_id{3} = '4227';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.mnemonic{3} = 'TLM8_+1.5SWFPGACoreVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.start_bit{3} = '9104';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.description{3} = '+1.5V SW FPGA Core Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4228: TLM8_+1.5SWFPGACoreVoltage(epoch 39)
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.telemetry_point_id{3} = '4228';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.mnemonic{3} = 'TLM8_+1.5SWFPGACoreVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.start_bit{3} = '9106';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.coeffs{3} = '0 0.00030517578125';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.description{3} = '+1.5V SW FPGA Core Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4229: TLM8_SignalProcessor#2Temp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39_Spare.att.telemetry_point_id = '4229';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39_Spare.att.mnemonic = 'TLM8_SignalProcessor#2Temp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39_Spare.att.start_bit = '9120';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39_Spare.att.description = 'Signal Processor 2 Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4230: TLM8_SignalProcessor#2Temp(epoch 39)
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39.att.telemetry_point_id = '4230';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39.att.mnemonic = 'TLM8_SignalProcessor#2Temp(epoch 39)';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39.att.start_bit = '9122';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39.att.description = 'Signal Processor 2 Temp, Epoch 39';
    g_metadata.packets.instr_hk8.SignalProcessor_2Temp_epoch_39.dim = {'hk8_packet'};

    % id 4231: TLM8_+1.5MWFPGACoreVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.telemetry_point_id{2} = '4231';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.mnemonic{2} = 'TLM8_+1.5MWFPGACoreVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.start_bit{2} = '9136';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.description{2} = '+1.5V MW FPGA Core Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4232: TLM8_+1.5MWFPGACoreVoltage(epoch 39)
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.telemetry_point_id{2} = '4232';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.mnemonic{2} = 'TLM8_+1.5MWFPGACoreVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.start_bit{2} = '9138';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.coeffs{2} = '0 0.00030517578125';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.description{2} = '+1.5V MW FPGA Core Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4233: TLM8_SignalProcessor#3Temp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39_Spare.att.telemetry_point_id = '4233';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39_Spare.att.mnemonic = 'TLM8_SignalProcessor#3Temp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39_Spare.att.start_bit = '9152';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39_Spare.att.description = 'Signal Processor 3 Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4234: TLM8_SignalProcessor#3Temp(epoch 39)
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39.att.telemetry_point_id = '4234';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39.att.mnemonic = 'TLM8_SignalProcessor#3Temp(epoch 39)';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39.att.start_bit = '9154';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39.att.coeffs = '0 1.220703125E-02';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39.att.description = 'Signal Processor 3 Temp, Epoch 39';
    g_metadata.packets.instr_hk8.SignalProcessor_3Temp_epoch_39.dim = {'hk8_packet'};

    % id 4235: TLM8_+1.5LWFPGACoreVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.telemetry_point_id{1} = '4235';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.mnemonic{1} = 'TLM8_+1.5LWFPGACoreVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.start_bit{1} = '9168';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.att.description{1} = '+1.5V LW FPGA Core Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4236: TLM8_+1.5LWFPGACoreVoltage(epoch 39)
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.telemetry_point_id{1} = '4236';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.mnemonic{1} = 'TLM8_+1.5LWFPGACoreVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.start_bit{1} = '9170';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.coeffs{1} = '0 0.00030517578125';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.att.description{1} = '+1.5V LW FPGA Core Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4237: TLM8_SpW(Spare)
    g_metadata.packets.instr_hk8.SpW_Spare.att.telemetry_point_id = '4237';
    g_metadata.packets.instr_hk8.SpW_Spare.att.mnemonic = 'TLM8_SpW(Spare)';
    g_metadata.packets.instr_hk8.SpW_Spare.att.start_bit = '9184';
    g_metadata.packets.instr_hk8.SpW_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpW_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SpW_Spare.att.description = 'SpaceWire, Spare';
    g_metadata.packets.instr_hk8.SpW_Spare.dim = {'hk8_packet'};

    % id 4238: TLM8_SpW(Spare2)
    g_metadata.packets.instr_hk8.SpW_Spare2.att.telemetry_point_id = '4238';
    g_metadata.packets.instr_hk8.SpW_Spare2.att.mnemonic = 'TLM8_SpW(Spare2)';
    g_metadata.packets.instr_hk8.SpW_Spare2.att.start_bit = '9186';
    g_metadata.packets.instr_hk8.SpW_Spare2.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.SpW_Spare2.att.num_bits = '14';
    g_metadata.packets.instr_hk8.SpW_Spare2.att.description = 'SpaceWire, Spare';
    g_metadata.packets.instr_hk8.SpW_Spare2.dim = {'hk8_packet'};

    % id 4239: TLM8_+2.5VHousekeepingVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39_Spare.att.telemetry_point_id = '4239';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+2.5VHousekeepingVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39_Spare.att.start_bit = '9200';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39_Spare.att.description = '+2.5V HK Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4240: TLM8_+2.5VHousekeepingVoltage(epoch 39)
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39.att.telemetry_point_id = '4240';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39.att.mnemonic = 'TLM8_+2.5VHousekeepingVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39.att.start_bit = '9202';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39.att.coeffs = '0 0.000380904586226852';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39.att.description = '+2.5V HK Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4241: TLM8_SpWCCATemp(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39_Spare.att.telemetry_point_id = '4241';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39_Spare.att.mnemonic = 'TLM8_SpWCCATemp(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39_Spare.att.start_bit = '9216';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39_Spare.att.description = 'SpaceWire CCA Temp, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4242: TLM8_SpWCCATemp(epoch 39)
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39.att.telemetry_point_id = '4242';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39.att.mnemonic = 'TLM8_SpWCCATemp(epoch 39)';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39.att.start_bit = '9218';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39.att.coeffs = '0 0.01220703125';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39.att.units = '°C';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39.att.description = 'SpaceWire CCA Temp, Epoch 39';
    g_metadata.packets.instr_hk8.SpWCCATemp_epoch_39.dim = {'hk8_packet'};

    % id 4243: TLM8_+2.5VIFCPPCCoreVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39_Spare.att.telemetry_point_id = '4243';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+2.5VIFCPPCCoreVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39_Spare.att.start_bit = '9232';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39_Spare.att.description = '+2.5V IFC PPC Core Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4244: TLM8_+2.5VIFCPPCCoreVoltage(epoch 39)
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39.att.telemetry_point_id = '4244';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39.att.mnemonic = 'TLM8_+2.5VIFCPPCCoreVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39.att.start_bit = '9234';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39.att.coeffs = '0 0.000380904586226852';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39.att.description = '+2.5V IFC PPC Core Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4245: TLM8_Spare4(epoch 39)
    g_metadata.packets.instr_hk8.Spare4_epoch_39.att.telemetry_point_id = '4245';
    g_metadata.packets.instr_hk8.Spare4_epoch_39.att.mnemonic = 'TLM8_Spare4(epoch 39)';
    g_metadata.packets.instr_hk8.Spare4_epoch_39.att.start_bit = '9248';
    g_metadata.packets.instr_hk8.Spare4_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Spare4_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Spare4_epoch_39.att.description = 'Spare Bits';
    g_metadata.packets.instr_hk8.Spare4_epoch_39.dim = {'hk8_packet'};

    % id 4247: TLM8_+2.5VIFCFPGACoreVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39_Spare.att.telemetry_point_id = '4247';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+2.5VIFCFPGACoreVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39_Spare.att.start_bit = '9264';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39_Spare.att.description = '+2.5V IFC FPGA Core Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4248: TLM8_+2.5VIFCFPGACoreVoltage(epoch 39)
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39.att.telemetry_point_id = '4248';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39.att.mnemonic = 'TLM8_+2.5VIFCFPGACoreVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39.att.start_bit = '9266';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39.att.coeffs = '0 0.000380904586226852';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39.att.description = '+2.5V IFC FPGA Core Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4249: TLM8_Spare5(epoch 39)
    g_metadata.packets.instr_hk8.Spare5_epoch_39.att.telemetry_point_id = '4249';
    g_metadata.packets.instr_hk8.Spare5_epoch_39.att.mnemonic = 'TLM8_Spare5(epoch 39)';
    g_metadata.packets.instr_hk8.Spare5_epoch_39.att.start_bit = '9280';
    g_metadata.packets.instr_hk8.Spare5_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Spare5_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Spare5_epoch_39.att.description = 'Spare Bits';
    g_metadata.packets.instr_hk8.Spare5_epoch_39.dim = {'hk8_packet'};

    % id 4251: TLM8_+3.3VDigitalSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4251';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+3.3VDigitalSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39_Spare.att.start_bit = '9296';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39_Spare.att.description = '+3.3V Digital Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4252: TLM8_+3.3VDigitalSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39.att.telemetry_point_id = '4252';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_+3.3VDigitalSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39.att.start_bit = '9298';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39.att.coeffs = '0 6.103515625E-04';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39.att.description = '+3.3V Digital Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4253: TLM8_Spare6(epoch 39)
    g_metadata.packets.instr_hk8.Spare6_epoch_39.att.telemetry_point_id = '4253';
    g_metadata.packets.instr_hk8.Spare6_epoch_39.att.mnemonic = 'TLM8_Spare6(epoch 39)';
    g_metadata.packets.instr_hk8.Spare6_epoch_39.att.start_bit = '9312';
    g_metadata.packets.instr_hk8.Spare6_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Spare6_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Spare6_epoch_39.att.description = 'Spare Bits';
    g_metadata.packets.instr_hk8.Spare6_epoch_39.dim = {'hk8_packet'};

    % id 4255: TLM8_+5VDigitalSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4255';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+5VDigitalSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39_Spare.att.start_bit = '9328';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39_Spare.att.description = '+5V Digital Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4256: TLM8_+5VDigitalSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39.att.telemetry_point_id = '4256';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_+5VDigitalSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39.att.start_bit = '9330';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39.att.coeffs = '0 0.000763321113681841';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39.att.description = '+5V Digital Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4257: TLM8_Spare7(epoch 39)
    g_metadata.packets.instr_hk8.Spare7_epoch_39.att.telemetry_point_id = '4257';
    g_metadata.packets.instr_hk8.Spare7_epoch_39.att.mnemonic = 'TLM8_Spare7(epoch 39)';
    g_metadata.packets.instr_hk8.Spare7_epoch_39.att.start_bit = '9344';
    g_metadata.packets.instr_hk8.Spare7_epoch_39.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Spare7_epoch_39.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Spare7_epoch_39.att.description = 'Spare Bits';
    g_metadata.packets.instr_hk8.Spare7_epoch_39.dim = {'hk8_packet'};

    % id 4259: TLM8_+12VDigitalSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4259';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+12VDigitalSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39_Spare.att.start_bit = '9360';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39_Spare.att.description = '+12V Digital Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4260: TLM8_+12VDigitalSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39.att.telemetry_point_id = '4260';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_+12VDigitalSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39.att.start_bit = '9362';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39.att.coeffs = '0 0.0018310546875';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39.att.description = '+12V Digital Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4261: TLM8_+3.3VInterferometerVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39_Spare.att.telemetry_point_id = '4261';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+3.3VInterferometerVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39_Spare.att.start_bit = '9376';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39_Spare.att.description = '+3.3V Interferometer Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4262: TLM8_+3.3VInterferometerVoltage(epoch 39)
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39.att.telemetry_point_id = '4262';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39.att.mnemonic = 'TLM8_+3.3VInterferometerVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39.att.start_bit = '9378';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39.att.coeffs = '0 6.103515625E-04';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39.att.description = '+3.3V Interferometer Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4263: TLM8_-12VDigitalSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4263';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_-12VDigitalSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39_Spare.att.start_bit = '9392';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39_Spare.att.description = '-12V Digital Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4264: TLM8_-12VDigitalSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39.att.telemetry_point_id = '4264';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_-12VDigitalSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39.att.start_bit = '9394';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39.att.coeffs = '0 0.0018310546875';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39.att.description = '-12V Digital Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4265: TLM8_+12VIFMQuietSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4265';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+12VIFMQuietSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.start_bit = '9408';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.description = '+12V IFM Quiet Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4266: TLM8_+12VIFMQuietSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39.att.telemetry_point_id = '4266';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_+12VIFMQuietSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39.att.start_bit = '9410';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39.att.coeffs = '0 0.0018310546875';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39.att.description = '+12V IFM Quiet Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4267: TLM8_+5VSignalProcessorSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4267';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+5VSignalProcessorSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.start_bit = '9424';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.description = '+5V Signal Processor Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4268: TLM8_+5VSignalProcessorSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39.att.telemetry_point_id = '4268';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_+5VSignalProcessorSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39.att.start_bit = '9426';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39.att.coeffs = '0 0.000674878779928483';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39.att.description = '+5V Signal Processor Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4269: TLM8_-12VIFMQuietSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4269';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_-12VIFMQuietSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.start_bit = '9440';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39_Spare.att.description = '-12V IFM Quiet Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4270: TLM8_-12VIFMQuietSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39.att.telemetry_point_id = '4270';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_-12VIFMQuietSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39.att.start_bit = '9442';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39.att.coeffs = '0 0.0018310546875';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39.att.description = '-12V IFM Quiet Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4271: TLM8_-5VSignalProcessorSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4271';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_-5VSignalProcessorSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.start_bit = '9456';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39_Spare.att.description = '-5V Signal Processor Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4272: TLM8_-5VSignalProcessorSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39.att.telemetry_point_id = '4272';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_-5VSignalProcessorSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39.att.start_bit = '9458';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39.att.coeffs = '0 0.000674878779928483';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39.att.description = '-5V Signal Processor Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4273: TLM8_+5VIFMDigitalSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4273';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+5VIFMDigitalSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39_Spare.att.start_bit = '9472';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39_Spare.att.description = '+5V IFM Digital Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4274: TLM8_+5VIFMDigitalSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39.att.telemetry_point_id = '4274';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_+5VIFMDigitalSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39.att.start_bit = '9474';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39.att.coeffs = '0 0.000763318083126551';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39.att.description = '+5V IFM Digital Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4275: TLM8_+5VHousekeepingLocalVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39_Spare.att.telemetry_point_id = '4275';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+5VHousekeepingLocalVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39_Spare.att.start_bit = '9488';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39_Spare.att.description = '+5V HK Local Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4276: TLM8_+5VHousekeepingLocalVoltage(epoch 39)
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39.att.telemetry_point_id = '4276';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39.att.mnemonic = 'TLM8_+5VHousekeepingLocalVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39.att.start_bit = '9490';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39.att.coeffs = '0 0.000763318083126551';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39.att.description = '+5V HK Local Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4277: TLM8_+12VIFMDigitalSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4277';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+12VIFMDigitalSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.start_bit = '9504';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.description = '+12V IFM Digital Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4278: TLM8_+12VIFMDigitalSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39.att.telemetry_point_id = '4278';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_+12VIFMDigitalSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39.att.start_bit = '9506';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39.att.coeffs = '0 0.0018310546875';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39.att.description = '+12V IFM Digital Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4279: TLM8_-5VHousekeepingLocalVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39_Spare.att.telemetry_point_id = '4279';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_-5VHousekeepingLocalVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39_Spare.att.start_bit = '9520';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39_Spare.att.description = '-5V HK Local Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4280: TLM8_-5VHousekeepingLocalVoltage(epoch 39)
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39.att.telemetry_point_id = '4280';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39.att.mnemonic = 'TLM8_-5VHousekeepingLocalVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39.att.start_bit = '9522';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39.att.coeffs = '0 0.000763318083126551';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39.att.description = '-5V HK Local Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4281: TLM8_-12VIFMDigitalSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4281';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_-12VIFMDigitalSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.start_bit = '9536';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39_Spare.att.description = '-12V IFM Digital Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4282: TLM8_-12VIFMDigitalSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39.att.telemetry_point_id = '4282';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_-12VIFMDigitalSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39.att.start_bit = '9538';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39.att.coeffs = '0 0.0018310546875';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39.att.description = '-12V IFM Digital Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4283: TLM8_+150VNEONLampSupplyVoltage(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39_Spare.att.telemetry_point_id = '4283';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39_Spare.att.mnemonic = 'TLM8_+150VNEONLampSupplyVoltage(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39_Spare.att.start_bit = '9552';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39_Spare.att.description = '+150V NEON Lamp Supply Voltage, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4284: TLM8_+150VNEONLampSupplyVoltage(epoch 39)
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39.att.telemetry_point_id = '4284';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39.att.mnemonic = 'TLM8_+150VNEONLampSupplyVoltage(epoch 39)';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39.att.start_bit = '9554';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39.att.coeffs = '0 1.97448817E-02';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39.att.units = 'Volts';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39.att.description = '+150V NEON Lamp Supply Voltage, Epoch 39';
    g_metadata.packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39.dim = {'hk8_packet'};

    % id 4285: TLM8_+150VConverterInputCurrent(sample 4 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{4} = '4285';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.start_bit{4} = '9568';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4286: TLM8_+150VConverterInputCurrent(sample 4 epoch 39)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.telemetry_point_id{4} = '4286';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 39)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.start_bit{4} = '9570';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.coeffs{4} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 39';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4287: TLM8_QuietConverterInputCurrent(sample 4 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{4} = '4287';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.start_bit{4} = '9584';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4288: TLM8_QuietConverterInputCurrent(sample 4 epoch 39)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.telemetry_point_id{4} = '4288';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 39)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.start_bit{4} = '9586';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.coeffs{4} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 39';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4289: TLM8_DigitalConverterInputCurrent(sample 4 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.telemetry_point_id{4} = '4289';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.start_bit{4} = '9600';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4290: TLM8_DigitalConverterInputCurrent(sample 4 epoch 39)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.telemetry_point_id{4} = '4290';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 39)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.start_bit{4} = '9602';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.coeffs{4} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 39';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_39.dim = {'input_current_sample', 'hk8_packet'};

    % id 4291: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 39 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.telemetry_point_id{4} = '4291';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.start_bit{4} = '9616';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4292: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 39)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.telemetry_point_id{4} = '4292';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 39)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.start_bit{4} = '9618';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.coeffs{4} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.units{4} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 39';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4293: TLM8_SWCh8AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{3} = '4293';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.mnemonic{3} = 'TLM8_SWCh8AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.start_bit{3} = '9632';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.description{3} = 'SW Chan. 8 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4294: TLM8_SWCh8AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.telemetry_point_id{3} = '4294';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.mnemonic{3} = 'TLM8_SWCh8AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.start_bit{3} = '9634';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.coeffs{3} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.description{3} = 'SW Chan. 8 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4295: TLM8_CoolerStage1HeaterCurrent(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39_Spare.att.telemetry_point_id = '4295';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39_Spare.att.mnemonic = 'TLM8_CoolerStage1HeaterCurrent(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39_Spare.att.start_bit = '9648';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39_Spare.att.description = 'Cooler Stage1 Heater Current, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4296: TLM8_CoolerStage1HeaterCurrent(epoch 39)
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39.att.telemetry_point_id = '4296';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39.att.mnemonic = 'TLM8_CoolerStage1HeaterCurrent(epoch 39)';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39.att.start_bit = '9650';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39.att.coeffs = '0 0.0000359030330882353';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39.att.units = 'Amps';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39.att.description = 'Cooler Stage1 Heater Current, Epoch 39';
    g_metadata.packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39.dim = {'hk8_packet'};

    % id 4297: TLM8_MWCh8AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{2} = '4297';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.mnemonic{2} = 'TLM8_MWCh8AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.start_bit{2} = '9664';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.description{2} = 'MW Chan. 8 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4298: TLM8_MWCh8AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.telemetry_point_id{2} = '4298';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.mnemonic{2} = 'TLM8_MWCh8AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.start_bit{2} = '9666';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.coeffs{2} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.description{2} = 'MW Chan. 8 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4299: TLM8_CoolerStage3HeaterCurrent(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39_Spare.att.telemetry_point_id = '4299';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39_Spare.att.mnemonic = 'TLM8_CoolerStage3HeaterCurrent(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39_Spare.att.start_bit = '9680';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39_Spare.att.description = 'Cooler Stage3 Heater Current, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4300: TLM8_CoolerStage3HeaterCurrent(epoch 39)
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39.att.telemetry_point_id = '4300';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39.att.mnemonic = 'TLM8_CoolerStage3HeaterCurrent(epoch 39)';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39.att.start_bit = '9682';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39.att.coeffs = '0 2.50144082991803E-06';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39.att.units = 'Amps';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39.att.description = 'Cooler Stage3 Heater Current, Epoch 39';
    g_metadata.packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39.dim = {'hk8_packet'};

    % id 4301: TLM8_LWCh8AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{1} = '4301';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.mnemonic{1} = 'TLM8_LWCh8AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.start_bit{1} = '9696';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.att.description{1} = 'LW Chan. 8 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4302: TLM8_LWCh8AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.telemetry_point_id{1} = '4302';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.mnemonic{1} = 'TLM8_LWCh8AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.start_bit{1} = '9698';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.coeffs{1} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.att.description{1} = 'LW Chan. 8 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch8AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4303: TLM8_CoolerStage4HeaterCurrent(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39_Spare.att.telemetry_point_id = '4303';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39_Spare.att.mnemonic = 'TLM8_CoolerStage4HeaterCurrent(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39_Spare.att.start_bit = '9712';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39_Spare.att.num_bits = '2';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39_Spare.att.description = 'Cooler Stage4 Heater Current, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39_Spare.dim = {'hk8_packet'};

    % id 4304: TLM8_CoolerStage4HeaterCurrent(epoch 39)
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39.att.telemetry_point_id = '4304';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39.att.mnemonic = 'TLM8_CoolerStage4HeaterCurrent(epoch 39)';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39.att.start_bit = '9714';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39.att.data_type = 'signed';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39.att.coeffs = '0 2.50144082991803E-06';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39.att.num_bits = '14';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39.att.units = 'Amps';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39.att.eu_type = 'polynomial';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39.att.description = 'Cooler Stage4 Heater Current, Epoch 39';
    g_metadata.packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39.dim = {'hk8_packet'};

    % id 4305: TLM8_SWCh7AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{3} = '4305';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.mnemonic{3} = 'TLM8_SWCh7AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.start_bit{3} = '9728';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.description{3} = 'SW Chan. 7 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4306: TLM8_SWCh7AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.telemetry_point_id{3} = '4306';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.mnemonic{3} = 'TLM8_SWCh7AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.start_bit{3} = '9730';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.coeffs{3} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.description{3} = 'SW Chan. 7 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4307: TLM8_SWCh3AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{3} = '4307';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.mnemonic{3} = 'TLM8_SWCh3AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.start_bit{3} = '9744';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.description{3} = 'SW Chan. 3 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4308: TLM8_SWCh3AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.telemetry_point_id{3} = '4308';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.mnemonic{3} = 'TLM8_SWCh3AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.start_bit{3} = '9746';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.coeffs{3} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.description{3} = 'SW Chan. 3 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4309: TLM8_MWCh7AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{2} = '4309';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.mnemonic{2} = 'TLM8_MWCh7AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.start_bit{2} = '9760';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.description{2} = 'MW Chan. 7 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4310: TLM8_MWCh7AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.telemetry_point_id{2} = '4310';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.mnemonic{2} = 'TLM8_MWCh7AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.start_bit{2} = '9762';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.coeffs{2} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.description{2} = 'MW Chan. 7 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4311: TLM8_MWCh3AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{2} = '4311';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.mnemonic{2} = 'TLM8_MWCh3AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.start_bit{2} = '9776';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.description{2} = 'MW Chan. 3 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4312: TLM8_MWCh3AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.telemetry_point_id{2} = '4312';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.mnemonic{2} = 'TLM8_MWCh3AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.start_bit{2} = '9778';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.coeffs{2} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.description{2} = 'MW Chan. 3 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4313: TLM8_LWCh7AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{1} = '4313';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.mnemonic{1} = 'TLM8_LWCh7AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.start_bit{1} = '9792';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.att.description{1} = 'LW Chan. 7 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4314: TLM8_LWCh7AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.telemetry_point_id{1} = '4314';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.mnemonic{1} = 'TLM8_LWCh7AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.start_bit{1} = '9794';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.coeffs{1} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.att.description{1} = 'LW Chan. 7 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch7AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4315: TLM8_LWCh3AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{1} = '4315';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.mnemonic{1} = 'TLM8_LWCh3AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.start_bit{1} = '9808';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.att.description{1} = 'LW Chan. 3 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4316: TLM8_LWCh3AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.telemetry_point_id{1} = '4316';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.mnemonic{1} = 'TLM8_LWCh3AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.start_bit{1} = '9810';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.coeffs{1} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.att.description{1} = 'LW Chan. 3 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch3AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4317: TLM8_SWCh9AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{3} = '4317';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.mnemonic{3} = 'TLM8_SWCh9AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.start_bit{3} = '9824';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.description{3} = 'SW Chan. 9 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4318: TLM8_SWCh9AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.telemetry_point_id{3} = '4318';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.mnemonic{3} = 'TLM8_SWCh9AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.start_bit{3} = '9826';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.coeffs{3} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.description{3} = 'SW Chan. 9 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4319: TLM8_SWCh2AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{3} = '4319';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.mnemonic{3} = 'TLM8_SWCh2AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.start_bit{3} = '9840';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.description{3} = 'SW Chan. 2 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4320: TLM8_SWCh2AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.telemetry_point_id{3} = '4320';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.mnemonic{3} = 'TLM8_SWCh2AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.start_bit{3} = '9842';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.coeffs{3} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.description{3} = 'SW Chan. 2 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4321: TLM8_MWCh9AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{2} = '4321';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.mnemonic{2} = 'TLM8_MWCh9AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.start_bit{2} = '9856';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.description{2} = 'MW Chan. 9 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4322: TLM8_MWCh9AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.telemetry_point_id{2} = '4322';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.mnemonic{2} = 'TLM8_MWCh9AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.start_bit{2} = '9858';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.coeffs{2} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.description{2} = 'MW Chan. 9 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4323: TLM8_MWCh2AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{2} = '4323';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.mnemonic{2} = 'TLM8_MWCh2AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.start_bit{2} = '9872';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.description{2} = 'MW Chan. 2 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4324: TLM8_MWCh2AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.telemetry_point_id{2} = '4324';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.mnemonic{2} = 'TLM8_MWCh2AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.start_bit{2} = '9874';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.coeffs{2} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.description{2} = 'MW Chan. 2 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4325: TLM8_LWCh9AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{1} = '4325';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.mnemonic{1} = 'TLM8_LWCh9AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.start_bit{1} = '9888';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.att.description{1} = 'LW Chan. 9 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4326: TLM8_LWCh9AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.telemetry_point_id{1} = '4326';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.mnemonic{1} = 'TLM8_LWCh9AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.start_bit{1} = '9890';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.coeffs{1} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.att.description{1} = 'LW Chan. 9 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch9AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4327: TLM8_LWCh2AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{1} = '4327';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.mnemonic{1} = 'TLM8_LWCh2AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.start_bit{1} = '9904';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.att.description{1} = 'LW Chan. 2 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4328: TLM8_LWCh2AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.telemetry_point_id{1} = '4328';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.mnemonic{1} = 'TLM8_LWCh2AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.start_bit{1} = '9906';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.coeffs{1} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.att.description{1} = 'LW Chan. 2 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch2AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4329: TLM8_SWCh6AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{3} = '4329';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.mnemonic{3} = 'TLM8_SWCh6AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.start_bit{3} = '9920';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.description{3} = 'SW Chan. 6 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4330: TLM8_SWCh6AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.telemetry_point_id{3} = '4330';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.mnemonic{3} = 'TLM8_SWCh6AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.start_bit{3} = '9922';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.coeffs{3} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.description{3} = 'SW Chan. 6 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4331: TLM8_SWCh1AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{3} = '4331';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.mnemonic{3} = 'TLM8_SWCh1AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.start_bit{3} = '9936';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.description{3} = 'SW Chan. 1 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4332: TLM8_SWCh1AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.telemetry_point_id{3} = '4332';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.mnemonic{3} = 'TLM8_SWCh1AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.start_bit{3} = '9938';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.coeffs{3} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.description{3} = 'SW Chan. 1 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4333: TLM8_MWCh6AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{2} = '4333';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.mnemonic{2} = 'TLM8_MWCh6AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.start_bit{2} = '9952';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.description{2} = 'MW Chan. 6 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4334: TLM8_MWCh6AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.telemetry_point_id{2} = '4334';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.mnemonic{2} = 'TLM8_MWCh6AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.start_bit{2} = '9954';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.coeffs{2} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.description{2} = 'MW Chan. 6 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4335: TLM8_MWCh1AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{2} = '4335';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.mnemonic{2} = 'TLM8_MWCh1AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.start_bit{2} = '9968';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.description{2} = 'MW Chan. 1 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4336: TLM8_MWCh1AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.telemetry_point_id{2} = '4336';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.mnemonic{2} = 'TLM8_MWCh1AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.start_bit{2} = '9970';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.coeffs{2} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.description{2} = 'MW Chan. 1 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4337: TLM8_LWCh6AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{1} = '4337';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.mnemonic{1} = 'TLM8_LWCh6AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.start_bit{1} = '9984';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.att.description{1} = 'LW Chan. 6 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4338: TLM8_LWCh6AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.telemetry_point_id{1} = '4338';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.mnemonic{1} = 'TLM8_LWCh6AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.start_bit{1} = '9986';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.coeffs{1} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.att.description{1} = 'LW Chan. 6 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch6AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4339: TLM8_LWCh1AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{1} = '4339';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.mnemonic{1} = 'TLM8_LWCh1AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.start_bit{1} = '10000';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.att.description{1} = 'LW Chan. 1 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4340: TLM8_LWCh1AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.telemetry_point_id{1} = '4340';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.mnemonic{1} = 'TLM8_LWCh1AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.start_bit{1} = '10002';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.coeffs{1} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.att.description{1} = 'LW Chan. 1 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch1AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4341: TLM8_SWCh4AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{3} = '4341';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.mnemonic{3} = 'TLM8_SWCh4AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.start_bit{3} = '10016';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.description{3} = 'SW Chan. 4 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4342: TLM8_SWCh4AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.telemetry_point_id{3} = '4342';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.mnemonic{3} = 'TLM8_SWCh4AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.start_bit{3} = '10018';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.coeffs{3} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.description{3} = 'SW Chan. 4 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4343: TLM8_SWCh5AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{3} = '4343';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.mnemonic{3} = 'TLM8_SWCh5AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.start_bit{3} = '10032';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.description{3} = 'SW Chan. 5 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4344: TLM8_SWCh5AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.telemetry_point_id{3} = '4344';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.mnemonic{3} = 'TLM8_SWCh5AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.start_bit{3} = '10034';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.coeffs{3} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.description{3} = 'SW Chan. 5 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4345: TLM8_MWCh4AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{2} = '4345';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.mnemonic{2} = 'TLM8_MWCh4AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.start_bit{2} = '10048';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.description{2} = 'MW Chan. 4 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4346: TLM8_MWCh4AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.telemetry_point_id{2} = '4346';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.mnemonic{2} = 'TLM8_MWCh4AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.start_bit{2} = '10050';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.coeffs{2} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.description{2} = 'MW Chan. 4 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4347: TLM8_MWCh5AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{2} = '4347';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.mnemonic{2} = 'TLM8_MWCh5AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.start_bit{2} = '10064';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.description{2} = 'MW Chan. 5 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4348: TLM8_MWCh5AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.telemetry_point_id{2} = '4348';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.mnemonic{2} = 'TLM8_MWCh5AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.start_bit{2} = '10066';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.coeffs{2} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.description{2} = 'MW Chan. 5 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4349: TLM8_LWCh4AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{1} = '4349';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.mnemonic{1} = 'TLM8_LWCh4AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.start_bit{1} = '10080';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.att.description{1} = 'LW Chan. 4 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4350: TLM8_LWCh4AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.telemetry_point_id{1} = '4350';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.mnemonic{1} = 'TLM8_LWCh4AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.start_bit{1} = '10082';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.coeffs{1} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.att.description{1} = 'LW Chan. 4 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch4AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4351: TLM8_LWCh5AnalogTestPoint(epoch 39 - Spare)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.telemetry_point_id{1} = '4351';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.mnemonic{1} = 'TLM8_LWCh5AnalogTestPoint(epoch 39 - Spare)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.start_bit{1} = '10096';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.att.description{1} = 'LW Chan. 5 Analog Test Point, Epoch 39 - Spare';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare.dim = {'band', 'hk8_packet'};

    % id 4352: TLM8_LWCh5AnalogTestPoint(epoch 39)
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.telemetry_point_id = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.telemetry_point_id{1} = '4352';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.mnemonic = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.mnemonic{1} = 'TLM8_LWCh5AnalogTestPoint(epoch 39)';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.start_bit = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.start_bit{1} = '10098';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.data_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.coeffs = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.coeffs{1} = '0 -6.11574711923848E-04';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.num_bits = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.eu_type = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.units = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.description = cell(3, 1);
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.att.description{1} = 'LW Chan. 5 Analog Test Point, Epoch 39';
    g_metadata.packets.instr_hk8.Ch5AnalogTestPoint_epoch_39.dim = {'band', 'hk8_packet'};

    % id 4353: TLM8_+150VConverterInputCurrent(sample 1 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{1} = '4353';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.start_bit{1} = '10112';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4354: TLM8_+150VConverterInputCurrent(sample 1 epoch 40)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.telemetry_point_id{1} = '4354';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.mnemonic{1} = 'TLM8_+150VConverterInputCurrent(sample 1 epoch 40)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.start_bit{1} = '10114';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.coeffs{1} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.description{1} = '+150V Converter Input Current, Sample 1 Epoch 40';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4355: TLM8_QuietConverterInputCurrent(sample 1 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{1} = '4355';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.start_bit{1} = '10128';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4356: TLM8_QuietConverterInputCurrent(sample 1 epoch 40)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.telemetry_point_id{1} = '4356';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.mnemonic{1} = 'TLM8_QuietConverterInputCurrent(sample 1 epoch 40)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.start_bit{1} = '10130';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.coeffs{1} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.description{1} = 'Quiet Converter Input Current, Sample 1 Epoch 40';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4357: TLM8_DigitalConverterInputCurrent(sample 1 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{1} = '4357';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.start_bit{1} = '10144';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4358: TLM8_DigitalConverterInputCurrent(sample 1 epoch 40)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.telemetry_point_id{1} = '4358';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.mnemonic{1} = 'TLM8_DigitalConverterInputCurrent(sample 1 epoch 40)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.start_bit{1} = '10146';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.coeffs{1} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.units{1} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.description{1} = 'Digital Converter Input Current, Sample 1 Epoch 40';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4359: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.telemetry_point_id{1} = '4359';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.start_bit{1} = '10160';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.data_type{1} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.num_bits{1} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4360: TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 40)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.telemetry_point_id = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.telemetry_point_id{1} = '4360';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.mnemonic = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.mnemonic{1} = 'TLM8_+28VSpacecraftBusVoltage(sample 1 epoch 40)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.start_bit = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.start_bit{1} = '10162';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.data_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.data_type{1} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.coeffs = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.coeffs{1} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.num_bits = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.num_bits{1} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.units = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.units{1} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.eu_type = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.eu_type{1} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.description = cell(4, 1);
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.description{1} = '+28V S/C Bus Voltage, Sample 1 Epoch 40';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4361: TLM8_+150VConverterInputCurrent(sample 2 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{2} = '4361';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.start_bit{2} = '10176';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4362: TLM8_+150VConverterInputCurrent(sample 2 epoch 40)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.telemetry_point_id{2} = '4362';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.mnemonic{2} = 'TLM8_+150VConverterInputCurrent(sample 2 epoch 40)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.start_bit{2} = '10178';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.coeffs{2} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.description{2} = '+150V Converter Input Current, Sample 2 Epoch 40';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4363: TLM8_QuietConverterInputCurrent(sample 2 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{2} = '4363';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.start_bit{2} = '10192';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4364: TLM8_QuietConverterInputCurrent(sample 2 epoch 40)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.telemetry_point_id{2} = '4364';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.mnemonic{2} = 'TLM8_QuietConverterInputCurrent(sample 2 epoch 40)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.start_bit{2} = '10194';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.coeffs{2} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.description{2} = 'Quiet Converter Input Current, Sample 2 Epoch 40';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4365: TLM8_DigitalConverterInputCurrent(sample 2 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{2} = '4365';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.start_bit{2} = '10208';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4366: TLM8_DigitalConverterInputCurrent(sample 2 epoch 40)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.telemetry_point_id{2} = '4366';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.mnemonic{2} = 'TLM8_DigitalConverterInputCurrent(sample 2 epoch 40)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.start_bit{2} = '10210';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.coeffs{2} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.units{2} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.description{2} = 'Digital Converter Input Current, Sample 2 Epoch 40';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4367: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.telemetry_point_id{2} = '4367';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.start_bit{2} = '10224';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.data_type{2} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.num_bits{2} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4368: TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 40)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.telemetry_point_id{2} = '4368';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.mnemonic{2} = 'TLM8_+28VSpacecraftBusVoltage(sample 2 epoch 40)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.start_bit{2} = '10226';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.data_type{2} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.coeffs{2} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.num_bits{2} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.units{2} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.eu_type{2} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.description{2} = '+28V S/C Bus Voltage, Sample 2 Epoch 40';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4369: TLM8_+150VConverterInputCurrent(sample 3 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{3} = '4369';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.start_bit{3} = '10240';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4370: TLM8_+150VConverterInputCurrent(sample 3 epoch 40)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.telemetry_point_id{3} = '4370';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.mnemonic{3} = 'TLM8_+150VConverterInputCurrent(sample 3 epoch 40)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.start_bit{3} = '10242';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.coeffs{3} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.description{3} = '+150V Converter Input Current, Sample 3 Epoch 40';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4371: TLM8_QuietConverterInputCurrent(sample 3 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{3} = '4371';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.start_bit{3} = '10256';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4372: TLM8_QuietConverterInputCurrent(sample 3 epoch 40)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.telemetry_point_id{3} = '4372';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.mnemonic{3} = 'TLM8_QuietConverterInputCurrent(sample 3 epoch 40)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.start_bit{3} = '10258';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.coeffs{3} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.description{3} = 'Quiet Converter Input Current, Sample 3 Epoch 40';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4373: TLM8_DigitalConverterInputCurrent(sample 3 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{3} = '4373';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.start_bit{3} = '10272';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4374: TLM8_DigitalConverterInputCurrent(sample 3 epoch 40)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.telemetry_point_id{3} = '4374';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.mnemonic{3} = 'TLM8_DigitalConverterInputCurrent(sample 3 epoch 40)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.start_bit{3} = '10274';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.coeffs{3} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.units{3} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.description{3} = 'Digital Converter Input Current, Sample 3 Epoch 40';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4375: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.telemetry_point_id{3} = '4375';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.start_bit{3} = '10288';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.data_type{3} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.num_bits{3} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4376: TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 40)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.telemetry_point_id{3} = '4376';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.mnemonic{3} = 'TLM8_+28VSpacecraftBusVoltage(sample 3 epoch 40)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.start_bit{3} = '10290';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.data_type{3} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.coeffs{3} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.num_bits{3} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.units{3} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.eu_type{3} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.description{3} = '+28V S/C Bus Voltage, Sample 3 Epoch 40';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4377: TLM8_+150VConverterInputCurrent(sample 4 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{4} = '4377';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.start_bit{4} = '10304';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4378: TLM8_+150VConverterInputCurrent(sample 4 epoch 40)
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.telemetry_point_id{4} = '4378';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.mnemonic{4} = 'TLM8_+150VConverterInputCurrent(sample 4 epoch 40)';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.start_bit{4} = '10306';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.coeffs{4} = '-2.012214E-02 3.057810E-04 1.166745E-07 -1.064175E-11';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.att.description{4} = '+150V Converter Input Current, Sample 4 Epoch 40';
    g_metadata.packets.instr_hk8.x150VConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4379: TLM8_QuietConverterInputCurrent(sample 4 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{4} = '4379';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.start_bit{4} = '10320';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4380: TLM8_QuietConverterInputCurrent(sample 4 epoch 40)
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.telemetry_point_id{4} = '4380';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.mnemonic{4} = 'TLM8_QuietConverterInputCurrent(sample 4 epoch 40)';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.start_bit{4} = '10322';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.coeffs{4} = '-5.476664E-02 3.682510E-04 1.198105E-07 -1.392482E-11';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.att.description{4} = 'Quiet Converter Input Current, Sample 4 Epoch 40';
    g_metadata.packets.instr_hk8.QuietConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4381: TLM8_DigitalConverterInputCurrent(sample 4 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.telemetry_point_id{4} = '4381';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.start_bit{4} = '10336';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare.dim = {'input_current_sample', 'hk8_packet'};

    % id 4382: TLM8_DigitalConverterInputCurrent(sample 4 epoch 40)
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.telemetry_point_id{4} = '4382';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.mnemonic{4} = 'TLM8_DigitalConverterInputCurrent(sample 4 epoch 40)';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.start_bit{4} = '10338';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.coeffs{4} = '0 6.10351563E-04';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.units{4} = 'Amps';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.att.description{4} = 'Digital Converter Input Current, Sample 4 Epoch 40';
    g_metadata.packets.instr_hk8.DigitalConverterInputCurrent_epoch_40.dim = {'input_current_sample', 'hk8_packet'};

    % id 4383: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 40 - Spare)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.telemetry_point_id{4} = '4383';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 40 - Spare)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.start_bit{4} = '10352';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.data_type{4} = 'unsigned';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.num_bits{4} = '2';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 40 - Spare';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4384: TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 40)
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.telemetry_point_id{4} = '4384';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.mnemonic{4} = 'TLM8_+28VSpacecraftBusVoltage(sample 4 epoch 40)';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.start_bit{4} = '10354';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.data_type{4} = 'signed';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.coeffs{4} = '0 8.45948112E-03';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.num_bits{4} = '14';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.units{4} = 'Volts';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.eu_type{4} = 'polynomial';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.att.description{4} = '+28V S/C Bus Voltage, Sample 4 Epoch 40';
    g_metadata.packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40.dim = {'spacecraft_bus_voltage_sample', 'hk8_packet'};

    % id 4385: TLM8_Zerofill2
    g_metadata.packets.instr_hk8.Zerofill2.att.telemetry_point_id = '4385';
    g_metadata.packets.instr_hk8.Zerofill2.att.mnemonic = 'TLM8_Zerofill2';
    g_metadata.packets.instr_hk8.Zerofill2.att.start_bit = '10368';
    g_metadata.packets.instr_hk8.Zerofill2.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.Zerofill2.att.num_bits = '16';
    g_metadata.packets.instr_hk8.Zerofill2.att.description = 'Zerofill2';
    g_metadata.packets.instr_hk8.Zerofill2.dim = {'hk8_packet'};

    % id 4386: TLM8_OnlneBitReg1(SSM Tele Err Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Err_Cntr.att.telemetry_point_id = '4386';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Err_Cntr.att.mnemonic = 'TLM8_OnlneBitReg1(SSM Tele Err Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Err_Cntr.att.start_bit = '10384';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Err_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Err_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Err_Cntr.att.description = 'Online BIT Reg. 1(SSM Tlm Error Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Err_Cntr.dim = {'hk8_packet'};

    % id 4387: TLM8_OnlneBitReg1(SSM Tele Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Cntr.att.telemetry_point_id = '4387';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Cntr.att.mnemonic = 'TLM8_OnlneBitReg1(SSM Tele Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Cntr.att.start_bit = '10392';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Cntr.att.description = 'Online BIT Reg. 1(SSM Tlm Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg1_SSM_Tele_Cntr.dim = {'hk8_packet'};

    % id 4388: TLM8_OnlneBitReg2(SSM OVR Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_OVR_Cntr.att.telemetry_point_id = '4388';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_OVR_Cntr.att.mnemonic = 'TLM8_OnlneBitReg2(SSM OVR Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_OVR_Cntr.att.start_bit = '10400';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_OVR_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_OVR_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_OVR_Cntr.att.description = 'Online BIT Reg. 2(SSM Overrun Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_OVR_Cntr.dim = {'hk8_packet'};

    % id 4389: TLM8_OnlneBitReg2(SSM Frame Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_Frame_Cntr.att.telemetry_point_id = '4389';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_Frame_Cntr.att.mnemonic = 'TLM8_OnlneBitReg2(SSM Frame Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_Frame_Cntr.att.start_bit = '10408';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_Frame_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_Frame_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_Frame_Cntr.att.description = 'Online BIT Reg. 2(SSM Frame Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg2_SSM_Frame_Cntr.dim = {'hk8_packet'};

    % id 4390: TLM8_OnlneBitReg3(SSM Par Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg3_SSM_Par_Cntr.att.telemetry_point_id = '4390';
    g_metadata.packets.instr_hk8.OnlneBitReg3_SSM_Par_Cntr.att.mnemonic = 'TLM8_OnlneBitReg3(SSM Par Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg3_SSM_Par_Cntr.att.start_bit = '10416';
    g_metadata.packets.instr_hk8.OnlneBitReg3_SSM_Par_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg3_SSM_Par_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg3_SSM_Par_Cntr.att.description = 'Online BIT Reg. 3(SSM Parity Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg3_SSM_Par_Cntr.dim = {'hk8_packet'};

    % id 4391: TLM8_OnlneBitReg3(Not Used)
    g_metadata.packets.instr_hk8.OnlneBitReg3_Not_Used.att.telemetry_point_id = '4391';
    g_metadata.packets.instr_hk8.OnlneBitReg3_Not_Used.att.mnemonic = 'TLM8_OnlneBitReg3(Not Used)';
    g_metadata.packets.instr_hk8.OnlneBitReg3_Not_Used.att.start_bit = '10424';
    g_metadata.packets.instr_hk8.OnlneBitReg3_Not_Used.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg3_Not_Used.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg3_Not_Used.att.description = 'Online BIT Reg. 3(Not Used)';
    g_metadata.packets.instr_hk8.OnlneBitReg3_Not_Used.dim = {'hk8_packet'};

    % id 4392: TLM8_OnlneBitReg4(IM Tele Err Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Err_Cntr.att.telemetry_point_id = '4392';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Err_Cntr.att.mnemonic = 'TLM8_OnlneBitReg4(IM Tele Err Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Err_Cntr.att.start_bit = '10432';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Err_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Err_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Err_Cntr.att.description = 'Online BIT Reg. 4(IFM Tlm Error Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Err_Cntr.dim = {'hk8_packet'};

    % id 4393: TLM8_OnlneBitReg4(IM Tele Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Cntr.att.telemetry_point_id = '4393';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Cntr.att.mnemonic = 'TLM8_OnlneBitReg4(IM Tele Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Cntr.att.start_bit = '10440';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Cntr.att.description = 'Online BIT Reg. 4(IFM Tlm Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg4_IM_Tele_Cntr.dim = {'hk8_packet'};

    % id 4394: TLM8_OnlneBitReg5(IM OVR Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_OVR_Cntr.att.telemetry_point_id = '4394';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_OVR_Cntr.att.mnemonic = 'TLM8_OnlneBitReg5(IM OVR Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_OVR_Cntr.att.start_bit = '10448';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_OVR_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_OVR_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_OVR_Cntr.att.description = 'Online BIT Reg. 5(IFM Overrun Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_OVR_Cntr.dim = {'hk8_packet'};

    % id 4395: TLM8_OnlneBitReg5(IM Frame Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_Frame_Cntr.att.telemetry_point_id = '4395';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_Frame_Cntr.att.mnemonic = 'TLM8_OnlneBitReg5(IM Frame Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_Frame_Cntr.att.start_bit = '10456';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_Frame_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_Frame_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_Frame_Cntr.att.description = 'Online BIT Reg. 5(IFM Frame Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg5_IM_Frame_Cntr.dim = {'hk8_packet'};

    % id 4396: TLM8_OnlneBitReg6(IM Par Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg6_IM_Par_Cntr.att.telemetry_point_id = '4396';
    g_metadata.packets.instr_hk8.OnlneBitReg6_IM_Par_Cntr.att.mnemonic = 'TLM8_OnlneBitReg6(IM Par Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg6_IM_Par_Cntr.att.start_bit = '10464';
    g_metadata.packets.instr_hk8.OnlneBitReg6_IM_Par_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg6_IM_Par_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg6_IM_Par_Cntr.att.description = 'Online BIT Reg. 6(IFM Parity Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg6_IM_Par_Cntr.dim = {'hk8_packet'};

    % id 4397: TLM8_OnlneBitReg6(Spare)
    g_metadata.packets.instr_hk8.OnlneBitReg6_Spare.att.telemetry_point_id = '4397';
    g_metadata.packets.instr_hk8.OnlneBitReg6_Spare.att.mnemonic = 'TLM8_OnlneBitReg6(Spare)';
    g_metadata.packets.instr_hk8.OnlneBitReg6_Spare.att.start_bit = '10472';
    g_metadata.packets.instr_hk8.OnlneBitReg6_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg6_Spare.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg6_Spare.att.description = 'Online BIT Reg. 6(Spare)';
    g_metadata.packets.instr_hk8.OnlneBitReg6_Spare.dim = {'hk8_packet'};

    % id 4398: TLM8_OnlneBitReg7(MW Tele Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg7_MW_Tele_Cntr.att.telemetry_point_id = '4398';
    g_metadata.packets.instr_hk8.OnlneBitReg7_MW_Tele_Cntr.att.mnemonic = 'TLM8_OnlneBitReg7(MW Tele Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg7_MW_Tele_Cntr.att.start_bit = '10480';
    g_metadata.packets.instr_hk8.OnlneBitReg7_MW_Tele_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg7_MW_Tele_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg7_MW_Tele_Cntr.att.description = 'Online BIT Reg. 7(MW Tlm Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg7_MW_Tele_Cntr.dim = {'hk8_packet'};

    % id 4399: TLM8_OnlneBitReg7(LW Tele Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg7_LW_Tele_Cntr.att.telemetry_point_id = '4399';
    g_metadata.packets.instr_hk8.OnlneBitReg7_LW_Tele_Cntr.att.mnemonic = 'TLM8_OnlneBitReg7(LW Tele Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg7_LW_Tele_Cntr.att.start_bit = '10488';
    g_metadata.packets.instr_hk8.OnlneBitReg7_LW_Tele_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg7_LW_Tele_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg7_LW_Tele_Cntr.att.description = 'Online BIT Reg. 7(LW Tlm Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg7_LW_Tele_Cntr.dim = {'hk8_packet'};

    % id 4400: TLM8_OnlneBitReg8(HK Tele Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg8_HK_Tele_Cntr.att.telemetry_point_id = '4400';
    g_metadata.packets.instr_hk8.OnlneBitReg8_HK_Tele_Cntr.att.mnemonic = 'TLM8_OnlneBitReg8(HK Tele Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg8_HK_Tele_Cntr.att.start_bit = '10496';
    g_metadata.packets.instr_hk8.OnlneBitReg8_HK_Tele_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg8_HK_Tele_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg8_HK_Tele_Cntr.att.description = 'Online BIT Reg. 8(HK Tlm Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg8_HK_Tele_Cntr.dim = {'hk8_packet'};

    % id 4401: TLM8_OnlneBitReg8(SW Tele Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg8_SW_Tele_Cntr.att.telemetry_point_id = '4401';
    g_metadata.packets.instr_hk8.OnlneBitReg8_SW_Tele_Cntr.att.mnemonic = 'TLM8_OnlneBitReg8(SW Tele Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg8_SW_Tele_Cntr.att.start_bit = '10504';
    g_metadata.packets.instr_hk8.OnlneBitReg8_SW_Tele_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg8_SW_Tele_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg8_SW_Tele_Cntr.att.description = 'Online BIT Reg. 8(SW Tlm Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg8_SW_Tele_Cntr.dim = {'hk8_packet'};

    % id 4402: TLM8_OnlneBitReg9(200ms Counter)
    g_metadata.packets.instr_hk8.OnlneBitReg9_200ms_Counter.att.telemetry_point_id = '4402';
    g_metadata.packets.instr_hk8.OnlneBitReg9_200ms_Counter.att.mnemonic = 'TLM8_OnlneBitReg9(200ms Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg9_200ms_Counter.att.start_bit = '10512';
    g_metadata.packets.instr_hk8.OnlneBitReg9_200ms_Counter.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg9_200ms_Counter.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg9_200ms_Counter.att.description = 'Online BIT Reg. 9(200ms Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg9_200ms_Counter.dim = {'hk8_packet'};

    % id 4403: TLM8_OnlneBitReg9(ECC Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg9_ECC_Cntr.att.telemetry_point_id = '4403';
    g_metadata.packets.instr_hk8.OnlneBitReg9_ECC_Cntr.att.mnemonic = 'TLM8_OnlneBitReg9(ECC Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg9_ECC_Cntr.att.start_bit = '10520';
    g_metadata.packets.instr_hk8.OnlneBitReg9_ECC_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg9_ECC_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg9_ECC_Cntr.att.description = 'Online BIT Reg. 9(Error Correction Ctrl Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg9_ECC_Cntr.dim = {'hk8_packet'};

    % id 4404: TLM8_OnlneBitReg10(Spare)
    g_metadata.packets.instr_hk8.OnlneBitReg10_Spare.att.telemetry_point_id = '4404';
    g_metadata.packets.instr_hk8.OnlneBitReg10_Spare.att.mnemonic = 'TLM8_OnlneBitReg10(Spare)';
    g_metadata.packets.instr_hk8.OnlneBitReg10_Spare.att.start_bit = '10528';
    g_metadata.packets.instr_hk8.OnlneBitReg10_Spare.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg10_Spare.att.num_bits = '16';
    g_metadata.packets.instr_hk8.OnlneBitReg10_Spare.att.description = 'Online BIT Reg. 10(Spare)';
    g_metadata.packets.instr_hk8.OnlneBitReg10_Spare.dim = {'hk8_packet'};

    % id 4406: TLM8_OnlneBitReg11(Err Detected on External 8 Sec Sync)
    g_metadata.packets.instr_hk8.OnlneBitReg11_Err_Detected_on_External_8_Sec_Sync.att.telemetry_point_id = '4406';
    g_metadata.packets.instr_hk8.OnlneBitReg11_Err_Detected_on_External_8_Sec_Sync.att.mnemonic = 'TLM8_OnlneBitReg11(Err Detected on External 8 Sec Sync)';
    g_metadata.packets.instr_hk8.OnlneBitReg11_Err_Detected_on_External_8_Sec_Sync.att.start_bit = '10544';
    g_metadata.packets.instr_hk8.OnlneBitReg11_Err_Detected_on_External_8_Sec_Sync.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg11_Err_Detected_on_External_8_Sec_Sync.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg11_Err_Detected_on_External_8_Sec_Sync.att.description = 'Online BIT Reg. 11(Error Detected on External 8 Sec Sync)';
    g_metadata.packets.instr_hk8.OnlneBitReg11_Err_Detected_on_External_8_Sec_Sync.dim = {'hk8_packet'};

    % id 4407: TLM8_OnlneBitReg11(TOD Cntr)
    g_metadata.packets.instr_hk8.OnlneBitReg11_TOD_Cntr.att.telemetry_point_id = '4407';
    g_metadata.packets.instr_hk8.OnlneBitReg11_TOD_Cntr.att.mnemonic = 'TLM8_OnlneBitReg11(TOD Cntr)';
    g_metadata.packets.instr_hk8.OnlneBitReg11_TOD_Cntr.att.start_bit = '10552';
    g_metadata.packets.instr_hk8.OnlneBitReg11_TOD_Cntr.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OnlneBitReg11_TOD_Cntr.att.num_bits = '8';
    g_metadata.packets.instr_hk8.OnlneBitReg11_TOD_Cntr.att.description = 'Online BIT Reg. 11(Time of Day Counter)';
    g_metadata.packets.instr_hk8.OnlneBitReg11_TOD_Cntr.dim = {'hk8_packet'};

    % id 4408: TLM8_OfflneBitReg1(Offline BIT Stat)
    g_metadata.packets.instr_hk8.OfflneBitReg1_Offline_BIT_Stat.att.telemetry_point_id = '4408';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Offline_BIT_Stat.att.mnemonic = 'TLM8_OfflneBitReg1(Offline BIT Stat)';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Offline_BIT_Stat.att.start_bit = '10560';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Offline_BIT_Stat.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Offline_BIT_Stat.att.num_bits = '1';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Offline_BIT_Stat.att.description = 'Offline BIT Reg. 1(Offline BIT Stat)';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Offline_BIT_Stat.dim = {'hk8_packet'};

    % id 4409: TLM8_OfflneBitReg1(SCC #1 Diag-offlinE-BIT Test)
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_1_Diag_offlinE_BIT_Test.att.telemetry_point_id = '4409';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_1_Diag_offlinE_BIT_Test.att.mnemonic = 'TLM8_OfflneBitReg1(SCC #1 Diag-offlinE-BIT Test)';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_1_Diag_offlinE_BIT_Test.att.start_bit = '10561';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_1_Diag_offlinE_BIT_Test.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_1_Diag_offlinE_BIT_Test.att.num_bits = '1';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_1_Diag_offlinE_BIT_Test.att.description = 'Offline BIT Reg. 1(Serial Comm Controller 1 Diag-offline - BIT)';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_1_Diag_offlinE_BIT_Test.dim = {'hk8_packet'};

    % id 4410: TLM8_OfflneBitReg1(SCC #2 Diag-offlinE-BIT Test)
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_2_Diag_offlinE_BIT_Test.att.telemetry_point_id = '4410';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_2_Diag_offlinE_BIT_Test.att.mnemonic = 'TLM8_OfflneBitReg1(SCC #2 Diag-offlinE-BIT Test)';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_2_Diag_offlinE_BIT_Test.att.start_bit = '10562';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_2_Diag_offlinE_BIT_Test.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_2_Diag_offlinE_BIT_Test.att.num_bits = '1';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_2_Diag_offlinE_BIT_Test.att.description = 'Offline BIT Reg. 1(Serial Comm Controller 2 Diag-offline - BIT)';
    g_metadata.packets.instr_hk8.OfflneBitReg1_SCC_2_Diag_offlinE_BIT_Test.dim = {'hk8_packet'};

    % id 4411: TLM8_OfflneBitReg1(Not Used)
    g_metadata.packets.instr_hk8.OfflneBitReg1_Not_Used.att.telemetry_point_id = '4411';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Not_Used.att.mnemonic = 'TLM8_OfflneBitReg1(Not Used)';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Not_Used.att.start_bit = '10563';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Not_Used.att.data_type = 'unsigned';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Not_Used.att.num_bits = '13';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Not_Used.att.description = 'Offline BIT Reg. 1(Not Used)';
    g_metadata.packets.instr_hk8.OfflneBitReg1_Not_Used.dim = {'hk8_packet'};

end     %if packet_idx == 1

% read packet
g_packets.instr_hk8.SubFrameCounter(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.PCEAppFswVer(packet_idx) = fread(fid, 1, '*ubit11');
g_packets.instr_hk8.InstrumentID(packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.MMInterStat_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.MMInterStat_Mem_Partinal_Create_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.MMInterStat_MQ_Create_Error(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.MMInterStat_Default_Case_Reached(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.MMInterStat_MM_Free_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.MMInterStat_MM_Alloc_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.MMInterStat_MQ_Rcv_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.MMInterStat_MQ_Send_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.MMInterStat_Two_Sec_Buff_Cap_Used(packet_idx) = fread(fid, 1, '*ubit4');
g_packets.instr_hk8.MMInterStat_Two_Sec_Buff_VF(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.MMInterStat_CmdQueue_Empty(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.MMInterStat_CmdQueue_VF(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SCInterStat_Spare(packet_idx) = fread(fid, 1, '*ubit4');
g_packets.instr_hk8.SCInterStat_VxWorks_watchdog_timer_failure(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SCInterStat_Spare2(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SCInterStat_CmdPktCRCFailure(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SCInterStat_S_C_to_CrIS_Invalid_Unrecog_Cmd(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SCInterStat_S_C_to_CrIS_Cmd_ID_Rcv(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SsmInterStat_Spare(packet_idx) = fread(fid, 1, '*ubit4');
g_packets.instr_hk8.SsmInterStat_Diag_Mode_Setting(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SsmInterStat_SSM_Tele_Valid_Bit_Tele_OK(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SsmInterStat_Failed_SSm_Cmd_Wd_at_PCE_SSM_Inter(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SsmInterStat_SSm_Tele_Cmd_Err_Cmd_not_Recog_by_SSM_PCE_tried_th(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SsmInterStat_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmInterStat_Spare(packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.IfmInterStat_Diag_Mode_Setting(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmInterStat_Possible_Porchswing_Sweep_Dir_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmInterStat_IFM_Tele_Valid_Bit_IFM_Tele_OK(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmInterStat_Failed_IFM_Wd_at_PCE_IFM_Inter(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.IfmInterStat_IFM_Tele_Cmd_Err_Cmd_not_Recog_by_IFM_PCE_tried_th(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmInterStat_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_Quiet_Converter_SP_Power_Side_Select_Pulsed_Command(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_Cooler_Door_Cmds_Software_Acknowledgement(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_PCE_Side_Sel(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_SSM_Prime_PW_Relay(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_Reserved(packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.SenStatReg1_Quiet_Conv_on_off(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_Spare(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_Signal_Proc_on_off(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_DetPwr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_Cooler_Door_28V_Actuator_PW_App(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_150V_Conv_on_off(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_Therm_Neon_Ctrl_PCE_PS_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_HK_Mux_Enable_Disable(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg1_Inferferometer_on_off_PCE_PS_stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_HK_200ms_Sync_Enabled_Disabled(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_Reserved1(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_Sig_Proc_200ms_Sync_Enabled_Disabled(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_Sig_Proc_8_Sec_Sync_Enabled_Disabled(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_Sig_Proc_3_Rst(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_Sig_Proc_2_Rst(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_Sig_Proc_1_Rst(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_HK_Rst(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_Reserved2(packet_idx) = fread(fid, 1, '*ubit4');
g_packets.instr_hk8.SenStatReg2_SCC2_DMA_Err_Intrpt(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_SCC1_DMA_Err_Intrpt(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Spur_Intrpt(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SenStatReg2_Aux_FPGA_Brdg_Invalid_Intrpt(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Cmd_Rejected(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Module_Not_Powered_On(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Cannot_Auton_Enter_Safe_Mode(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Sftw_UL_EN(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Sftw_UL_success(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Sftw_UL_CRC_Failed(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Aborted(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Sftw_UL_Img_Not_Pres(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_illegal_Neon_Calib_Time(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_En_Cooler_Door_Before_Releasing(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Invld_Cmd_Par(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_Default_Case_Reached(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_MQ_Rcv_Error(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_MQ_Snd_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg1_OS_Func_Call_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Sub_Patch_Temp_Thres_Monitor(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Patch_Temp_Thres_Monitor(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Sig_Proc_5V_OverVoltage_Thresh_Monitor(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_SwNotPettingWatchdog(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_SwTaskNotResponding(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_EEPROM_general_error(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_EEPROM_write_error(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Isr_Missing_8_Sec_int(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Isr_Early_8_Sec_int(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Isr_unexpected_int(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Isr_Invld_int(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Isr_Msg_Queue_Tx_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Free_Mem_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Alloc_Mem_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_Neon_Lmp_Calib(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg2_EEPROM_being_Accessed(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Sig_Proc_5V_OverVoltage_Thresh_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Diag_Mode_Setting(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Sub_Patch_Temp_Thresh_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Patch_Temp_Thresh_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_PCE_HK_Tele_Valid(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Cmd_Rejected(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_PCI_Config_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Init_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Too_Much_Tele_Sent(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Too_Few_Tele_Sent(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Invld_Cmd_Par(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Invld_Mem_Bank(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_Default_Case_Reached(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_MQ_Rcv_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_MQ_Snd_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_3_OS_Func_Call_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Threshold_Trip_(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Threshold_Trip_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_Porchswing_Current_Monitoring_Control(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_Porchswing_MPD_Monitoring_Control(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_SCC_write_error(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Succ(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_Msg_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_Wrong_Sz_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_IM_Cmd_Queue_OVR_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_Default_Case_Reached(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_MQ_Rcv_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_OS_Func_Call_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_4_SW_Upload_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_5_Spare(packet_idx) = fread(fid, 1, '*ubit6');
g_packets.instr_hk8.FswExErrStatReg_5_TaskIdForWatchdogFailure(packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.FswExErrStatReg_5_Free_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_5_Malloc_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_5_IM_Cmd_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_5_Cmd_Reject_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_5_IM_Rpt_Err_in_Tele(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_Spare(packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.FswExErrStatReg_6_Msg_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_OVR_err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_Parity_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_Frame_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_Wrong_Sz_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_EOF_Not_By_Scc_Reg_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_Queue_OVR_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_SCC_Write_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_Trans_to_SSM_Failed(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_Default_Case_Reached(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_MQ_Rcv_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_MQ_Snd_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg_6_OS_Func_Call_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_SPare(packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.FswExErrStatReg7_SW_Upload_Success(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_Cmd_Reject_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_SSM_Malloc_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_SSM_UL_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_SSM_Cmd_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_Written_EEPROm_CRC_Badr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_LVDS_Missing_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_STX_Missing_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_ETX_Missing_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_Chksum_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg7_Reported_Err_in_Tele(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Spare(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Pckt_Dropped(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Invld_Par_Len(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Invld_APID_type(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_Len(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Invld_CCSDS_Len(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Invld_Seg_Pckt_Rcv(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Invld_APID(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Invld_Chksum(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Invld_Cmd_ID(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Default_Case_Reached(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_MQ_Rcv_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_MQ_Snd_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_MM_Alloc_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg8_OS_Func_Call_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_PCI_Init_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_UnSupp_Config(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_Invld_Diag_Chan_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_No_Term_on_Tele_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_Invld_Tele_ID_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_Invld_Coef_Tbl_ID_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_Bit_Trim_Tbl_Indx_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_Impulse_Tbl_Indx_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_Invld_Module_ID(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_Config_Data_Ptr_Null_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_Rcv_Unknown_ID_Default_Case(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_Trans_Unknown_ID_Default_Case(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_MQ_Rcv_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_MQ_Snd_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg9_OS_Func_Call_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Taps_I_Coef_MisMatch(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Taps_Q_Coef_MisMatch(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Coef_Dat_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_4_min(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Config_Dat_Err_8_sec(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Persistant_Tbl_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Setup_Data_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Invld_Num_Coef_Entries(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Filter_Offset_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Run_Samples_Total_Samples(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Bit_Trim_Tbl_Start_Stop_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Coef_Mismatch(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Mem_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_PCI_Retry_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_Sig_Proc_in_Rst(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg10_SSM_Scn_Pos_Missing_Err_Invld(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_Wake_Up_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_DMA_Addr_Write_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_Mem_dmp_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_LRD_Num_FOVs_ERR(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Val_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_LRD_Mode_Sel_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_LRD_FOV_Repeat_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_Filt_Dec_Sample_Cnt_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_FOR_Upset_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_SEFI_Upset_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_PCI_Retry_Count_Too_Big_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_PCI_Config_Read_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_Device_Not_Found(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_Invalid_Param(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg11_Spare2(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_PCI_Init_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Unsupp_Config(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Invld_Diag_Chan_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_No_Term_on_Tele_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Invld_Tele_ID_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Invld_Coef_Tbl_ID_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Bit_Trim_Indx_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Impulse_Tbl_Index_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Invld_Module_ID(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Config_Data_Ptr_Null_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Rcv_Unknown_ID_Deflt_Case(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_Trans_Unknown_ID_Deflt_Case(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_MQ_Rcv_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_MQ_Snd_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg12_OS_Func_Call_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Taps_I_Coef_MisMatch(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Taps_Q_Coef_MisMatch(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Coef_Dat_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_4_min(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Config_Dat_Err_8_sec(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Persistant_Tbl_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Setup_Data_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Invld_Num_Coef_Entries(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Filter_Offset_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Run_Samples_Total_Samples(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Bit_Trim_Tbl_Start_Stop_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Coef_Mismatch(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Mem_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_PCI_Retry_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_Sig_Proc_in_Rst(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg13_SSM_Scn_Pos_Missing_Err_Invld(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_Wake_Up_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_DMA_Addr_Write_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_Mem_dmp_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_LRD_Num_FOVs_ERR(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Val_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_LRD_Mode_Sel_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_LRD_FOV_Repeat_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_Filtrd_Dec_Sample_Cnt_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_FOR_Upset_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_SEFI_Upset_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_PCI_Retry_Count_Too_Big_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_PCI_Config_Read_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_Device_Not_Found(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_Invalid_Param(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg14_Spare2(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_PCI_Init_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Unsupp_Config(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Invld_Diag_Chan_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Unsupp_Sci_Data_Len_Bit_Trim_Tbl_Dec_Rate_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_No_Term_on_Tele_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Invld_Tele_ID_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Invld_Coef_Tbl_ID_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Bit_Trim_Indx_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Impulse_Tbl_Index_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Invld_Module_ID(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Config_Data_Ptr_Null_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Rcv_Unknown_ID_Deflt_Case(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_Trans_Unknown_ID_Deflt_Case(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_MQ_Rcv_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_MQ_Snd_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg15_OS_Func_Call_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Taps_I_Coef_MisMatch(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Taps_Q_Coef_MisMatch(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Coef_Dat_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_4_min(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Config_Dat_Err_8_sec(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Persistant_Tbl_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Setup_Data_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Invld_Num_Coef_Entries(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Filter_Offset_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Run_Samples_Total_Samples(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Bit_Trim_Tbl_Start_Stop_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Coef_Mismatch(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Mem_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_PCI_Retry_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_Sig_Proc_in_Rst(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg16_SSM_Scn_Pos_Missing_Err_Invld(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_Wake_Up_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_DMA_Addr_Write_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_Mem_dmp_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_LRD_Num_FOVs_ERR(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Val_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_LRD_Mode_Sel_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_LRD_FOV_Repeat_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_Fltrd_Dec_Sample_Cnt_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_FOR_Upset_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_SEFI_Upset_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_PCI_Retry_Count_Too_Big_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_PCI_Config_Read_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_Dev_Not_Found(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_Invalid_Param(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.FswExErrStatReg17_Spare2(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg1_Link_Identifier(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SpWStatReg1_DisconnectErrCntrRolloverFlag(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg1_ParityErrCntrRolloverFlag(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg1_RecPktAboveMaxNumBytesCntrRolloverFlag(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg1_SpWTransmitErrCntrRolloverFlag(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg1_Spare(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg1_ActivePortChangeRolloverFlag(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg1_NumActivePortChanges(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg2_DisconnectErrCntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg2_ParityErrCntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg3_RecPktsGreaterThanMaxBytesCntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg3_TransmitErrCntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg4_SpWCreditErrCounter(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg4_EscapeErrorCounter(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg5_NumMissedTODs_ToInitSafeMode(packet_idx) = fread(fid, 1, '*ubit6');
g_packets.instr_hk8.SpWStatReg5_RecEEPonRecSpWPkt(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg5_UserPktErrCntrRolloverFlag(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg5_UserPktErrCntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg6_CCSDSInvalidCmdsRcvd(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg6_CCSDSCmdInvalidRolloverFlag(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg6_Spare(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg6_AutonomousTransitiontoSafeModeIndctr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg6_NumMissedTODs_ToInitLinkRecovery(packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SpWStatReg7_Reserved(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SpWStatReg7_JTAG_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_Clock_and_Test_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_RIF0_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_RIF1_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_PCI0_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_PCI1_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_Misc_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_UART_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_DMA_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_SRAM0_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_SRAM1_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_OCB_CM_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_Mem_Controller_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg7_EMC_CritErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_NLL(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCR(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DCR(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_LinkState(packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_EE(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PEC(packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_DEC(packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCU(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_FCO(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg8_ASICRtr_PortStat_PTE(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res3(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ParityErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_TxOCB_ReDataErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res2(packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ParityErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_RxOCB_ReDataErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AddressPhaseParityErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_WrDataParityErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_AccessErr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg9_ASIC_RIFStat_Res(packet_idx) = fread(fid, 1, '*ubit4');
g_packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_Res(packet_idx) = fread(fid, 1, '*ubit4');
g_packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_PCIcmd(packet_idx) = fread(fid, 1, '*ubit4');
g_packets.instr_hk8.SpWStatReg10_ASIC_PCIBusErrStatReg_CurrBusOwner(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg11_Missed_TOD_cntr_rollover_flag(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg11_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SpWStatReg11_EnableDisable_TODSafeModeCntr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg11_EnableDisable_LinkAB_TODCntr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg11_TODmissed(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg11_SpW_fault_log_full(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg11_SpW_fault_log_not_empty(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MinorVersion(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWStatReg12_SpW_CCASftw_MajorVersion(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SpWModeStatReg_Test_Pkt(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_Online_BIT(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_LowRateDataAlg(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SpWModeStatReg_ZPD_alg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_AutoNeonCal(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_Boot_EEPROM_Img_Executing(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_Thermal_Cntrl(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_InstMode_Outgas(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_InstMode_Operational(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_InstMode_Diagnostic(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_InstMode_Safe(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_Spare2(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_SpW_POST_Results(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_PCE_POST_Results(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SpWModeStatReg_Spare(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.Telem_command_success_count_MSW(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.Telem_command_success_count_LSW(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.IfmStatFlg_spare1(packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.IfmStatFlg_Infererom_Mode_Stat(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.IfmStatFlg_spare2(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Dir(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmStatFlg_Porchswing_Sweep_Lck(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmStatFlg_Loss_PCE_Frame_Sync_Pulse_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmStatFlg_Porchswing_MPD_Switch_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmStatFlg_Porchswing_ZPD_Switch_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmStatFlg_DA_Servo_Status(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmStatFlg_DA_Y_servo_locked(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IfmStatFlg_DA_X_servo_locked(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_CT_Over_Speed_Trip(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_Spare(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_Redundant_Drv_Relay_Fault(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_Loss_8_Sec_Sync_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_IT_Vel_Compen_Act_Idle(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_CT_Axis_Motor_Winding_Temp_Go_NoGo(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_IT_Axis_Motor_Winding_Temp_Go_NoGo(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_Primary_PW_Current_Monitor_Go_NoGo(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_SSm_Mode_Stat(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SSMStatWrd_Motion_Compen_Active_Idle(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_CT_Motor_Drv_OvLoad_Trip(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_IT_Motor_Drv_OvLoad_Trip(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_Loss_200ms_Sync_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_Motor_Drives_on_off(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SSMStatWrd_CT_Encoder_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Internal_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Rst_Detected(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Protocol_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_SERR_Detected(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Bus_Addr_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbiter_TO(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Dat_Phase_TO(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Arbitration_Laten_TO(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_PERR_Rcv(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Dat_Par_Err_Detected(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Initiator_Rdy_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_Mem_Spc_Overlap_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_PERR_Rcv(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Dat_Par_Err_Detected(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_1_PCI_Target_Rdy_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Detected_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Signalled_Sys_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Master_Abort(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Rcv_Target_Abort(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Sig_Target_Abort(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_Res(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Master_Dat_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Read_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Master_Dat_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Write_Buff_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_BE_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Slv_Dat_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Access(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_Invld_OCB_Addr(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_2_PCI_OCB_Addr_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_3_Spare(packet_idx) = fread(fid, 1, '*ubit11');
g_packets.instr_hk8.IFC_Interrupt_Reg_3_OCB_MCP_Error(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_3_60x_MCP_Error(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_3_Power_PCI_Internal_Bus_Error(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_3_Address_out_of_range(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_3_Memory_control_interface_error(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Request_on_Mem_Req_I_F_Write(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Par_Err_on_Mem_Config_Interface(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Dat_Par_Err_on_Mem_Config_Interface_Write(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Byte_En_Par_Err_on_Mem_Config_I_F_Write(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Invalid_Addr_on_Mem_Config_Interface(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Invld_Cmd_on_Mem_Config_Interface(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Refresh_OVF(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_ROM_Write_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Addr_Out_of_Bounds(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Uncorrectable_Addr_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Reserved(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Nibble_Correctable_ECC_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Single_Bit_Correctable_ECC_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Mem_Init_Complete(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_Scrub_Loop_Complete(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_4_SDRAM_Self_Refresh_Cmd_Complete(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Spare(packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Not_Empty(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_ECC_Error_Log_Full(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_CATErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_CATErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_CATErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_CATErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_MiscErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_MiscErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_MiscErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Out_of_Range_EMCErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Data_Parity_Error_EMCErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Addr_Phase_Parity_Error_EMCErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_5_Write_Access_Error_EMCErrInterStatReg(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.IFC_Interrupt_Reg_6_Spare(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.IFC_Interrupt_Reg_6_Num_IFC_Err_Det_During_PwrUp_BIT(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved(1, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1(1, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode(1, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2(1, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode(1, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1(1, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used(1, packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved(1, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps(1, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used(1, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte(1, packet_idx) = fread(fid, 1, '*ubit15');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used(1, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay(1, packet_idx) = fread(fid, 1, '*ubit11');
g_packets.instr_hk8.cPCIRetryReg(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.Chan2PGASetting(1, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan1PGASetting(1, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan4PGASetting(1, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan3PGASetting(1, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan6PGASetting(1, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan5PGASetting(1, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan8PGASetting(1, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan7PGASetting(1, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.DspHwCtrlSettingBits_Not_Used(1, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.DspHwCtrlSettingBits_Reserved(1, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode(1, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable(1, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.Chan9PGASetting(1, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.CoefTblIUpperChkSum(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.CoefTblILowerChkSum(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.CoefTblQUpperChkSum(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.CoefTblQLowerChkSum(1, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved(2, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1(2, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode(2, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2(2, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode(2, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1(2, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used(2, packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved(2, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps(2, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used(2, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte(2, packet_idx) = fread(fid, 1, '*ubit15');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used(2, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay(2, packet_idx) = fread(fid, 1, '*ubit11');
g_packets.instr_hk8.cPCIRetryReg(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.Chan2PGASetting(2, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan1PGASetting(2, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan4PGASetting(2, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan3PGASetting(2, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan6PGASetting(2, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan5PGASetting(2, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan8PGASetting(2, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan7PGASetting(2, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.DspHwCtrlSettingBits_Not_Used(2, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.DspHwCtrlSettingBits_Reserved(2, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode(2, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable(2, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.Chan9PGASetting(2, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.CoefTblIUpperChkSum(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.CoefTblILowerChkSum(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.CoefTblQUpperChkSum(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.CoefTblQLowerChkSum(2, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Tst_Sig_Sel(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Reserved(3, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode_Chan_Sel_Default_1(3, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Diag_Mode(3, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Not_Used2(3, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Byte_Swap_Mode(3, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg1_Decimation_Rate_Default_1(3, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Not_Used(3, packet_idx) = fread(fid, 1, '*ubit3');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Reserved(3, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg1_Num_of_Taps(3, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Not_Used(3, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg2_Offset_Samples_to_Strt_of_Filte(3, packet_idx) = fread(fid, 1, '*ubit15');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg2_Total_Num_of_Samples(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg4_Not_Used(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg4_Num_of_Raw_A_D_Samples_to_Acq(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg5_Not_Used(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg5_Num_of_Decimated_Samples_to_Acq(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterUpperCtrlReg6_Not_Used(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Not_Used(3, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.SigProcFIRFilterLowerCtrlReg6_Phase_Delay_Adjust_Phase_Delay(3, packet_idx) = fread(fid, 1, '*ubit11');
g_packets.instr_hk8.cPCIRetryReg(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.Chan2PGASetting(3, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan1PGASetting(3, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan4PGASetting(3, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan3PGASetting(3, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan6PGASetting(3, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan5PGASetting(3, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan8PGASetting(3, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.Chan7PGASetting(3, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.DspHwCtrlSettingBits_Not_Used(3, packet_idx) = fread(fid, 1, '*ubit5');
g_packets.instr_hk8.DspHwCtrlSettingBits_Reserved(3, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.DspHwCtrlSettingBits_Scene_Select_Mode(3, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.DspHwCtrlSettingBits_FilterEnable(3, packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.Chan9PGASetting(3, packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.CoefTblIUpperChkSum(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.CoefTblILowerChkSum(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.CoefTblQUpperChkSum(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.CoefTblQLowerChkSum(3, packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.EpochNumReg_Not_Used(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.EpochNumReg_epoch_x(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(5, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(5, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(6, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(6, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(7, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(7, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(8, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(8, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(9, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(9, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(10, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(10, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(11, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(11, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(12, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(12, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(1, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(1, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(2, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(2, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00043573 + 3.2213;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(3, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00013306 + 0.9757;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(3, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(4, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(4, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(5, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(5, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(6, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(6, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(7, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(7, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(8, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(8, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(9, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(9, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(10, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(10, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(11, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(11, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(12, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(12, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.Cross_Trackposition_Lower_epoch_x(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.Cross_Trackposition_Upper_epoch_x(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(13, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00043573 + 3.2213;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(13, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00013306 + 0.9757;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(14, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(14, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(15, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(15, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(16, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(16, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(17, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(17, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SSMScanmirrorbaffleTemp1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006363 + 29.356386;
g_packets.instr_hk8.ICTPRT3_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.ICTPRT3_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006272868 + 19.196;
g_packets.instr_hk8.SSMstructureTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.SSMstructureTemp_epoch_39(packet_idx) = (scaled_value^4 * 3.9652E-16) + (scaled_value^3 * 3.6732E-11) + (scaled_value^2 * 3.3086E-08) + (scaled_value * 4.9024E-03) + 23.47; %FIXME: need to verify unscaling
g_packets.instr_hk8.SSMelectronicsboardTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.SSMelectronicsboardTemp_epoch_39(packet_idx) = (scaled_value^4 * 3.9652E-16) + (scaled_value^3 * 3.6732E-11) + (scaled_value^2 * 3.3086E-08) + (scaled_value * 4.9024E-03) + 23.47; %FIXME: need to verify unscaling
g_packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.Cross_TrackMotorwindingTemp_epoch_39(packet_idx) = (scaled_value^4 * 3.9652E-16) + (scaled_value^3 * 3.6732E-11) + (scaled_value^2 * 3.3086E-08) + (scaled_value * 4.9024E-03) + 23.47; %FIXME: need to verify unscaling
g_packets.instr_hk8.epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.InTrackMotorwindingTemp_epoch_39(packet_idx) = (scaled_value^4 * 3.9652E-16) + (scaled_value^3 * 3.6732E-11) + (scaled_value^2 * 3.3086E-08) + (scaled_value * 4.9024E-03) + 23.47; %FIXME: need to verify unscaling
g_packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x2_5VDCASICcorevoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 3.6853E-04 + 0;
g_packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x3_3VDCsecondaryvoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 5.083E-04 + 0;
g_packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x5_0VDCsecondaryvoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 7.639E-04 + 0;
g_packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.plus12VDCsecondaryvoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.776E-03 + 0;
g_packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.minus12VDCsecondaryvoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.776E-03 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(18, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(18, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(19, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(19, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.ScanIntrptlocation_epoch_x(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 9.58700E+01 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x(20, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x(20, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fi(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_epoch_4_33_else_Zero_fill(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.CommandedinTrackAxisposition_epoch_x(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.In_Trackposition_epoch_x(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00043573 + 3.2213;
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00013306 + 0.9757;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_Spare(13, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x(13, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(5, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(5, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(6, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(6, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(7, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(7, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(8, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(8, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(9, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(9, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(10, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(10, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(11, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(11, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(12, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(12, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(1, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(1, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(2, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(2, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00043573 + 3.2213;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(3, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00013306 + 0.9757;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(3, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(4, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(4, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(5, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(5, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(6, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(6, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(7, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(7, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(8, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(8, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(9, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(9, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(10, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(10, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(11, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(11, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(12, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(12, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Commandedcross_Trackposition_Lower_epoch_x_1(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.Commandedcross_Trackposition_Upper_epoch_x_1(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.Cross_Trackposition_Lower_epoch_x_1(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.Cross_Trackposition_Upper_epoch_x_1(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(13, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00043573 + 3.2213;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(13, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00013306 + 0.9757;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(14, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(14, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(15, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(15, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(16, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(16, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(17, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(17, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(18, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(18, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(19, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(19, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.ScanIntrptlocation_epoch_x_1(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 9.58700E+01 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_epoch_x_1(20, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_epoch_x_1(20, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.Cross_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 2.996 + 0;
g_packets.instr_hk8.In_TrackServoErr_sample_21_Only_if_x_1_epoch_4_33_else_Zero_fil(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.CommandedinTrackAxisposition_epoch_x_1(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.In_Trackposition_epoch_x_1(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 0.564 + 0;
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.CrossTrackAxisMotorCurrent_epoch_x_1(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00043573 + 3.2213;
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.In_TrackAxisMotorCurrent_epoch_x_1(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.00013306 + 0.9757;
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1_Spare(13, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSSMBusCurrent_epoch_x_1(13, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0007673 + -3.0662;
g_packets.instr_hk8.Zerofill1(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.HKIOReg0_Bi_Level_Par_Bit(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal(packet_idx) = fread(fid, 1, '*ubit14');
g_packets.instr_hk8.HKIOReg0_Bi_Level_Tele_Input_Signal_Cooler_Door_Status(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg1_Spare(packet_idx) = fread(fid, 1, '*ubit4');
g_packets.instr_hk8.HKIOReg1_TLM_Dat_1(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg1_TLM_Dat_0(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg1_Loaded_Tele_Addr_Par_Err(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg1_HK_Sampling_Mode(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg1_DAC_Update_Rate_Sample_strt_cnt(packet_idx) = fread(fid, 1, '*ubit7');
g_packets.instr_hk8.HKIOReg1_Automatic_DAC_Update(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg2_DAC_Chan_B_PCE_Struct_Heater_Therm_Ctrl(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.HKIOReg2_DAC_Chan_A_Cooler_Stage_1_Therm_Ctrl(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.HKIOReg3_Dac_Chan_D_Cooler_Stage_4_Therm_Ctrl(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.HKIOReg3_DAC_Chan_C_Cooler_Stage_3_Therm_Ctrl(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.HKIOReg4_Spare(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg4_SRAM_Tele_Addr_Cnt(packet_idx) = fread(fid, 1, '*ubit15');
g_packets.instr_hk8.HKIOReg5_Spare(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg5_HK_SRAM_Tele_Mux_Setting_Start_Addr(packet_idx) = fread(fid, 1, '*ubit15');
g_packets.instr_hk8.HKIOReg6_Spare(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg6_Tele_Dat1_Start_Addr(packet_idx) = fread(fid, 1, '*ubit15');
g_packets.instr_hk8.HKIOReg7_Spare(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.HKIOReg7_Tele_Dat0_Start_Addr(packet_idx) = fread(fid, 1, '*ubit15');
g_packets.instr_hk8.HKIOReg8_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.HKIOReg8_Number_Tele_Values_Collected(packet_idx) = fread(fid, 1, '*ubit14');
g_packets.instr_hk8.HKIOReg9_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.HKIOReg9_Number_Tele_Addr_Processed(packet_idx) = fread(fid, 1, '*ubit14');
g_packets.instr_hk8.PorchswingMotorTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorTemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006297897 + 20.009;
g_packets.instr_hk8.DAMotorTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DAMotorTemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006282453 + 19.279;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000152587890625 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare(5, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39(5, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare(6, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39(6, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare(7, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39(7, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare(8, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39(8, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DA_XMotorCurrent_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0000152587890625 + 0;
g_packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DA_YMotorCurrent_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0000152587890625 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.0000489074084942387 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare(9, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39(9, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(4, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(4, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(4, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(5, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(5, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(5, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(6, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(6, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(6, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(7, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(7, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(7, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(8, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(8, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(8, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.LaserdetectionpeakTychannel_epoch_39(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 6.072707E-04 + 0;
g_packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_39(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 6.074279E-04 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(9, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(9, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(9, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.LaserDiodeCurrent_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.LaserDiodeCurrent_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0000030517578125 + 0.035;
g_packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.ThermoelectriccoolerCurrent_epoch_39(packet_idx) = (scaled_value^2 * 5.176685570E-09) + (scaled_value * 3.124595960E-04) + 1.558271740E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.Porchswingposition_epoch_39(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 3.87250E-07 + -1.26894080E-02;
g_packets.instr_hk8.PorchswingpositionErr_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.00000038725 + 0;
g_packets.instr_hk8.OpticalZPDoffset_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 0.00000038725 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(10, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(10, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(10, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.IECCAcalibrationresistorTemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006341245 + 19.453;
g_packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.EquivalentTemperaturelowrangecalres_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006296006 + 19.778;
g_packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.EquivalentTemperaturehighrangecalres_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006296006 + 19.778;
g_packets.instr_hk8.ApproximateICTTemp_1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.ApproximateICTTemp_1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006318255 + 21.047;
g_packets.instr_hk8.ApproximateICTTemp_2_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.ApproximateICTTemp_2_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.00630489 + 20.4908;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(11, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(11, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(11, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.LaserDiodeTempAve_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.LaserDiodeTempAve(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006293041 + 19.630;
g_packets.instr_hk8.BeamsplitterTemp_1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.BeamsplitterTemp_1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.00627938 + 19.168;
g_packets.instr_hk8.OMAstructureinputTemp_1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.OMAstructureinputTemp_1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006294378 + 19.826;
g_packets.instr_hk8.OMAstructureinputTemp_duplicate_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.OMAstructureinputTemp_duplicate(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.006294378 + 19.826;
g_packets.instr_hk8.LaserdetectionpeakRchannel_epoch_39(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 5.755372E-04 + 0;
g_packets.instr_hk8.LaserdetectionpeakXchannel_epoch_39(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 5.753506E-04 + 0;
g_packets.instr_hk8.LaserdetectionpeakYchannel_epoch_39(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 5.752540E-04 + 0;
g_packets.instr_hk8.LaserdetectionpeakFchannel_epoch_39(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 5.436496E-04 + 0;
g_packets.instr_hk8.LaserdetectionpeakDchannel_epoch_39(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 5.445093E-04 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_39(12, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_39(12, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_39(12, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.Neondetectionpeak_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Neondetectionpeak_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.007112E-03 + 0;
g_packets.instr_hk8.DA_XMotorCurrent_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DA_XMotorCurrent_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-05 + 0;
g_packets.instr_hk8.DA_YMotorCurrent_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DA_YMotorCurrent_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-05 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39_Spare(10, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_39(10, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.LaserOpticalPower_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.LaserOpticalPower_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.95409047702289E-06 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare(5, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40(5, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare(6, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40(6, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare(7, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40(7, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare(8, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40(8, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DA_XMotorCurrent_epoch_40(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-05 + 0;
g_packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DA_YMotorCurrent_epoch_40(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-05 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_40(1, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(1, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(1, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare(9, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40(9, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_40(2, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(2, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(2, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_40(3, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(3, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(3, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_40(4, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(4, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(4, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_40(5, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(5, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(5, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_40(6, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(6, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(6, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_40(7, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(7, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(7, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_40(8, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(8, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(8, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
scaled_value = cast(fread(fid, 1, '*ubit16'), 'double');
g_packets.instr_hk8.LaserdetectionpeakTychannel_epoch_40(packet_idx) = (scaled_value^5 * -5.80664e-18) + (scaled_value^4 * 4.97460E-14) + (scaled_value^3 * -1.34280E-10) + (scaled_value^2 * 9.54457E-08) + (scaled_value * 7.11662E-04) + 1.17014E-02; %FIXME: need to verify unscaling
scaled_value = cast(fread(fid, 1, '*ubit16'), 'double');
g_packets.instr_hk8.LaserdetectionpeakTxchannel_epoch_40(packet_idx) = (scaled_value^5 * -5.80664e-18) + (scaled_value^4 * 4.97460E-14) + (scaled_value^3 * -1.34280E-10) + (scaled_value^2 * 9.54457E-08) + (scaled_value * 7.11662E-04) + 1.17014E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.PorchswingVelocity_epoch_40(9, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(9, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(9, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.Porchswingposition_epoch_40(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 3.87250E-07 + -1.26894080E-02;
g_packets.instr_hk8.PorchswingpositionErr_epoch_40(packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 3.87250E-07 + 0;
g_packets.instr_hk8.OpticalZPDoffset_epoch_40(packet_idx) = cast(fread(fid, 1, '*ubit16'), 'double') * 3.87250E-07 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_40(10, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(10, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(10, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.PorchswingVelocity_epoch_40(11, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(11, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(11, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
scaled_value = cast(fread(fid, 1, '*ubit16'), 'double');
g_packets.instr_hk8.LaserdetectionpeakRchannel_epoch_40(packet_idx) = (scaled_value^5 * -5.80664e-18) + (scaled_value^4 * 4.97460E-14) + (scaled_value^3 * -1.34280E-10) + (scaled_value^2 * 9.54457E-08) + (scaled_value * 7.11662E-04) + 1.17014E-02; %FIXME: need to verify unscaling
scaled_value = cast(fread(fid, 1, '*ubit16'), 'double');
g_packets.instr_hk8.LaserdetectionpeakXchannel_epoch_40(packet_idx) = (scaled_value^5 * -5.80664e-18) + (scaled_value^4 * 4.97460E-14) + (scaled_value^3 * -1.34280E-10) + (scaled_value^2 * 9.54457E-08) + (scaled_value * 7.11662E-04) + 1.17014E-02; %FIXME: need to verify unscaling
scaled_value = cast(fread(fid, 1, '*ubit16'), 'double');
g_packets.instr_hk8.LaserdetectionpeakYchannel_epoch_40(packet_idx) = (scaled_value^5 * -5.80664e-18) + (scaled_value^4 * 4.97460E-14) + (scaled_value^3 * -1.34280E-10) + (scaled_value^2 * 9.54457E-08) + (scaled_value * 7.11662E-04) + 1.17014E-02; %FIXME: need to verify unscaling
scaled_value = cast(fread(fid, 1, '*ubit16'), 'double');
g_packets.instr_hk8.LaserdetectionpeakFchannel_epoch_40(packet_idx) = (scaled_value^5 * -5.80664e-18) + (scaled_value^4 * 4.97460E-14) + (scaled_value^3 * -1.34280E-10) + (scaled_value^2 * 9.54457E-08) + (scaled_value * 7.11662E-04) + 1.17014E-02; %FIXME: need to verify unscaling
scaled_value = cast(fread(fid, 1, '*ubit16'), 'double');
g_packets.instr_hk8.LaserdetectionpeakDchannel_epoch_40(packet_idx) = (scaled_value^5 * -5.80664e-18) + (scaled_value^4 * 4.97460E-14) + (scaled_value^3 * -1.34280E-10) + (scaled_value^2 * 9.54457E-08) + (scaled_value * 7.11662E-04) + 1.17014E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.PorchswingVelocity_epoch_40(12, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 4.89074084942387E-05 + 0;
g_packets.instr_hk8.DA_XTiltErr_epoch_40(12, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.DA_YTiltErr_epoch_40(12, packet_idx) = cast(fread(fid, 1, '*bit16'), 'double') * 1.14600E-01 + 0;
g_packets.instr_hk8.Neondetectionpeak_epoch_40_Spare(packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.Neondetectionpeak_epoch_40(packet_idx) = (scaled_value^5 * 1.01124E-17) + (scaled_value^4 * -8.54538E-14) + (scaled_value^3 * 2.52486E-10) + (scaled_value^2 * -3.30236E-07) + (scaled_value * 8.78407E-04) + 4.08887E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DA_XMotorCurrent_epoch_40_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DA_XMotorCurrent_epoch_40(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-05 + 0;
g_packets.instr_hk8.DA_YMotorCurrent_epoch_40_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DA_YMotorCurrent_epoch_40(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-05 + 0;
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40_Spare(10, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PorchswingMotorCurrent_epoch_40(10, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.52587890625E-04 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_4(1, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_4(1, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_4(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_4(2, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_4(2, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_4(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_4(3, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_4(3, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_4(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_4_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_4(4, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_4_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_4(4, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_4_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_4(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_4(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_19(1, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_19(1, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_19(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_19(2, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_19(2, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_19(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_19(3, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_19(3, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_19(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_19_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_19(4, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_19_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_19(4, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_19_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_19(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_19(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_33(1, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_33(1, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_33(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_33(2, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_33(2, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_33(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_33(3, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_33(3, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_33(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_33_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_33(4, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_33_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_33(4, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_33_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_33(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_33(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_35(1, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_35(1, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_35(2, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_35(2, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_35(3, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_35(3, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_35_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_35(4, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_35_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_35(4, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_35_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_35(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_35(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_35(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_35(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_35_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_35(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -0.000611574711923848 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_36(1, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_36(1, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_36(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_36(2, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_36(2, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_36(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_36(3, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_36(3, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_36(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_36_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_36(4, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_36_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_36(4, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_36_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_36(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_36(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_39(1, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_39(1, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.StructureThermalControlSetpoint_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.StructureThermalControlSetpoint_epoch_39(packet_idx) = (scaled_value^3 * -1.996470200E-11) + (scaled_value^2 * 1.986854800E-07) + (scaled_value * -5.248439300E-03) + 2.474285000E+01; %FIXME: need to verify unscaling
g_packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Stage1OperationalHeaterSetpoint_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.030378 + 24.3222;
g_packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Stage3OperationalHeaterSetpoint_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 9.85696510E-03 + 3.33441070E+01;
g_packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Stage4OperationalHeaterSetpoint_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 7.29038720E-03 + 3.3483830E+01;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_39(2, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_39(2, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PCEElectronicsModuleTemp_1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.PCEStructureHeaterTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.PCEStructureHeaterTemp_epoch_39(packet_idx) = (scaled_value^3 * -1.99647020E-11) + (scaled_value^2 * 1.98685480E-07) + (scaled_value * -5.24843930E-03) + 2.4742850E+01; %FIXME: need to verify unscaling
g_packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PCEElectronicsModuleTemp_3_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.OutgasTemp_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.OutgasTemp_epoch_39(1, packet_idx) = (scaled_value^3 * -1.22226460E-11) + (scaled_value^2 * 4.80655720E-07) + (scaled_value * 3.3764090E-02) + 3.45676220E+01; %FIXME: need to verify unscaling
g_packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PCEElectronicsModuleTemp_2_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.OutgasTemp_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.OutgasTemp_epoch_39(3, packet_idx) = (scaled_value^3 * -1.22226460E-11) + (scaled_value^2 * 4.80655720E-07) + (scaled_value * 3.3764090E-02) + 3.45676220E+01; %FIXME: need to verify unscaling
g_packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PCEElectronicsModuleTemp_4_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.OutgasTemp_epoch_39_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.OutgasTemp_epoch_39(4, packet_idx) = (scaled_value^3 * -1.22226460E-11) + (scaled_value^2 * 4.80655720E-07) + (scaled_value * 3.3764090E-02) + 3.45676220E+01; %FIXME: need to verify unscaling
g_packets.instr_hk8.OutgasTemp_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.OutgasTemp_epoch_39(2, packet_idx) = (scaled_value^5 * -4.20953E-20) + (scaled_value^4 * 2.04113E-15) + (scaled_value^3 * -0.0000000000380786) + (scaled_value^2 * 0.00000033213) + (scaled_value * 0.0286777) + 70.7661; %FIXME: need to verify unscaling
g_packets.instr_hk8.Stage1CoolerTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Stage1CoolerTemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 3.0142016E-02 + 2.5544758E+01;
g_packets.instr_hk8.Stage4CoolerTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Stage4CoolerTemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 7.2903872E-03 + 3.348383E+01;
g_packets.instr_hk8.Stage3CoolerTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Stage3CoolerTemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 9.8569651E-03 + 3.3344107E+01;
g_packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.StructureModuleBaseplateTemp_2_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.StructureModuleBaseplateTemp_1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.StructureModuleBaseplateTemp_4_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.StructureModuleBaseplateTemp_3_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.StructureModulePCETemp1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.StructureModulePCETemp1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.ICTStructureTemp_1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.ICTStructureTemp_1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.StructureModulePCETemp2_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.StructureModulePCETemp2_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.ICTStructureTemp_2_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.ICTStructureTemp_2_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.StructureModulePCETemp3_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.StructureModulePCETemp3_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.TelescopeTemp_1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.TelescopeTemp_1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.StructureModuleSSMTemp_1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.OpticalBenchTemp1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.OpticalBenchTemp1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.StructureModuleSSMTemp_2_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.OpticalBenchTemp2_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.OpticalBenchTemp2_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.PCEHousingTemp_1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PCEHousingTemp_1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.Spare1_epoch_39(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.PCEHousingTemp_2_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PCEHousingTemp_2_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.Spare2_epoch_39(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.PCEHousingTemp_3_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PCEHousingTemp_3_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.Spare3_epoch_39(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.x150VConverterTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x150VConverterTemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.PCEStructureHeaterCurrent_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000117828486969112 + 0;
g_packets.instr_hk8.IFCCCATemp_1_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.IFCCCATemp_1_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.OutgasHeaterVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.OutgasHeaterVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.98480937E-02 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_39(3, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_39(3, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.DigitalConverterTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterTemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.Spare1(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Reserved1(packet_idx) = fread(fid, 1, '*bit14');
g_packets.instr_hk8.QuietConverterTemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.QuietConverterTemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.Spare2(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Reserved2(packet_idx) = fread(fid, 1, '*bit14');
g_packets.instr_hk8.HousekeepingCCATemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.HousekeepingCCATemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.Spare3(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Reserved3(packet_idx) = fread(fid, 1, '*bit14');
g_packets.instr_hk8.SignalProcessor_1Temp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SignalProcessor_1Temp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.00030517578125 + 0;
g_packets.instr_hk8.SignalProcessor_2Temp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SignalProcessor_2Temp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.00030517578125 + 0;
g_packets.instr_hk8.SignalProcessor_3Temp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SignalProcessor_3Temp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.220703125E-02 + 0;
g_packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x1_5FPGACoreVoltage_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.00030517578125 + 0;
g_packets.instr_hk8.SpW_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SpW_Spare2(packet_idx) = fread(fid, 1, '*bit14');
g_packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x2_5VHousekeepingVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000380904586226852 + 0;
g_packets.instr_hk8.SpWCCATemp_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.SpWCCATemp_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.01220703125 + 0;
g_packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x2_5VIFCPPCCoreVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000380904586226852 + 0;
g_packets.instr_hk8.Spare4_epoch_39(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x2_5VIFCFPGACoreVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000380904586226852 + 0;
g_packets.instr_hk8.Spare5_epoch_39(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x3_3VDigitalSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.103515625E-04 + 0;
g_packets.instr_hk8.Spare6_epoch_39(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.plus5VDigitalSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000763321113681841 + 0;
g_packets.instr_hk8.Spare7_epoch_39(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.plus12VDigitalSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0018310546875 + 0;
g_packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x3_3VInterferometerVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.103515625E-04 + 0;
g_packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.minus12VDigitalSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0018310546875 + 0;
g_packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.plus12VIFMQuietSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0018310546875 + 0;
g_packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.plus5VSignalProcessorSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000674878779928483 + 0;
g_packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.minus12VIFMQuietSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0018310546875 + 0;
g_packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.minus5VSignalProcessorSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000674878779928483 + 0;
g_packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.plus5VIFMDigitalSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000763318083126551 + 0;
g_packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.plus5VHousekeepingLocalVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000763318083126551 + 0;
g_packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.plus12VIFMDigitalSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0018310546875 + 0;
g_packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.minus5VHousekeepingLocalVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.000763318083126551 + 0;
g_packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.minus12VIFMDigitalSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0018310546875 + 0;
g_packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x150VNEONLampSupplyVoltage_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 1.97448817E-02 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_39_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_39(4, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_39_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_39(4, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_39_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_39(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_39(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.CoolerStage1HeaterCurrent_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 0.0000359030330882353 + 0;
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.CoolerStage3HeaterCurrent_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 2.50144082991803E-06 + 0;
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch8AnalogTestPoint_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39_Spare(packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.CoolerStage4HeaterCurrent_epoch_39(packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 2.50144082991803E-06 + 0;
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch7AnalogTestPoint_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch3AnalogTestPoint_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch9AnalogTestPoint_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch2AnalogTestPoint_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch6AnalogTestPoint_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch1AnalogTestPoint_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_39(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_39(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch4AnalogTestPoint_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_39_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.Ch5AnalogTestPoint_epoch_39(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * -6.11574711923848E-04 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_40(1, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_40(1, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_40(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare(1, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40(1, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_40(2, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_40(2, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_40(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare(2, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40(2, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_40(3, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_40(3, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_40(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare(3, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40(3, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_40_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.x150VConverterInputCurrent_epoch_40(4, packet_idx) = (scaled_value^3 * -1.064175E-11) + (scaled_value^2 * 1.166745E-07) + (scaled_value * 3.057810E-04) + -2.012214E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_40_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
scaled_value = cast(fread(fid, 1, '*bit14'), 'double');
g_packets.instr_hk8.QuietConverterInputCurrent_epoch_40(4, packet_idx) = (scaled_value^3 * -1.392482E-11) + (scaled_value^2 * 1.198105E-07) + (scaled_value * 3.682510E-04) + -5.476664E-02; %FIXME: need to verify unscaling
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_40_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.DigitalConverterInputCurrent_epoch_40(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 6.10351563E-04 + 0;
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40_Spare(4, packet_idx) = fread(fid, 1, '*ubit2');
g_packets.instr_hk8.x28VSpacecraftBusVoltage_epoch_40(4, packet_idx) = cast(fread(fid, 1, '*bit14'), 'double') * 8.45948112E-03 + 0;
g_packets.instr_hk8.Zerofill2(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.OnlneBitReg1_SSM_Tele_Err_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg1_SSM_Tele_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg2_SSM_OVR_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg2_SSM_Frame_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg3_SSM_Par_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg3_Not_Used(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg4_IM_Tele_Err_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg4_IM_Tele_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg5_IM_OVR_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg5_IM_Frame_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg6_IM_Par_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg6_Spare(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg7_MW_Tele_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg7_LW_Tele_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg8_HK_Tele_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg8_SW_Tele_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg9_200ms_Counter(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg9_ECC_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg10_Spare(packet_idx) = fread(fid, 1, '*ubit16');
g_packets.instr_hk8.OnlneBitReg11_Err_Detected_on_External_8_Sec_Sync(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OnlneBitReg11_TOD_Cntr(packet_idx) = fread(fid, 1, '*ubit8');
g_packets.instr_hk8.OfflneBitReg1_Offline_BIT_Stat(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.OfflneBitReg1_SCC_1_Diag_offlinE_BIT_Test(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.OfflneBitReg1_SCC_2_Diag_offlinE_BIT_Test(packet_idx) = fread(fid, 1, '*ubit1');
g_packets.instr_hk8.OfflneBitReg1_Not_Used(packet_idx) = fread(fid, 1, '*ubit13');

